<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.controller' );

class EjoshopControllerEjoshop extends EjoshopController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'apply'  , 'save' );
		// Register Extra tasks
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function allmaps()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}


	function edit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	

	function add()
	{
		JRequest::setVar( 'view', 'ejoshop' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
	
		$model = $this->getModel('ejoshop');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSADDNEW' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORADDNEW' );
	
		}
			$link = 'index.php?option=com_ejoshop';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	function apply()
	{
	
		$model = $this->getModel('map');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR' );
		}
		$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
	
		$link = 'index.php?option=com_mapyandex&view=map&layout=form&id='. $id;
		$this->setRedirect($link, $msg);

	}
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('mapyandex');
		if ($model->delete($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSDELETE' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORDELETE' );
		}

		$this->setRedirect( 'index.php?option=com_mapyandex', $msg );
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'COM_EJOSHOP_CANCEL' );
		$this->setRedirect( 'index.php?option=com_mapyandex', $msg );
	}
	
}