<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controlleradmin');

class EjoshopControllerEjoshopCategories extends JControllerAdmin
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'apply'  , 'save' );
		$this->registerTask( 'editchanges'  , 'editchanges' );
		$this->registerTask( 'saveorder'  , 'saveorder' );
		$this->registerTask( 'publishedcat'  , 'publishedcat' );
		$this->registerTask( 'notpublishedcat'  , 'publishedcat' );
		// Register Extra tasks
		
	}


	
	/**
	 * Proxy for getModel
	 *
	 * @param	string	$name	The model name. Optional.
	 * @param	string	$prefix	The class prefix. Optional.
	 *
	 * @return	object	The model.
	 * @since	1.6
	 */
	function getModel($name = 'EjoshopCategory', $prefix = 'EjoshopModel', $config = array('ignore_request' => true))
	{
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
	/** Deletes and returns correctly.
 	 *
 	 * @return	void
 	 * @since	2.5.12
 	 */
 	public function delete()
 	{
 		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
 		
 		// Get items to remove from the request.
 		$cid = JRequest::getVar('cid', array(), '', 'array');
 		$extension = JRequest::getVar('extension', null);

 		if (!is_array($cid) || count($cid) < 1)
 		{
 			JError::raiseWarning(500, JText::_($this->text_prefix . '_NO_ITEM_SELECTED'));
 		}
 		else
 		{
 			// Get the model.
 			$model = $this->getModel();

 			// Make sure the item ids are integers
 			jimport('joomla.utilities.arrayhelper');
 			JArrayHelper::toInteger($cid);
 
 			// Remove the items.
 			if ($model->delete($cid))
 			{
 				$this->setMessage(JText::plural($this->text_prefix . '_N_ITEMS_DELETED', count($cid)));

 			}
 			else
 			{
 				$this->setMessage($model->getError());

 			}
 		}
 
 		$this->setRedirect(JRoute::_('index.php?option=com_ejoshop&view=ejoshopcategories', false));
 	} 	
	/**
	 * display the edit form
	 * @return void
	 */
	function allmaps()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}


	function edit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	function ajaxit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	

	function add()
	{
		$link = 'index.php?option=com_ejoshop&view=ejoshopcategories&layout=form';
		$this->setRedirect($link);
	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
	
		$model = $this->getModel('ejoshopcategories');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSADDNEWGAL' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORADDNEWGAL' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=ejoshopcategories';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function saveorder()
	{
	
		$model = $this->getModel('ejoshopcategory');
		
		if ($model->saveorder($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSADDNEWGAL' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORADDNEWGAL' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=ejoshopcategories';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}
	
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function publishedcat()
	{
		
		$task = $this->getTask();
		$model = parent::getModel($name = 'EjoshopCategories', $prefix = 'EjoshopModel', $config = array('ignore_request' => true));	
		$mainframe = JFactory::getApplication();
		if($task == 'publishedcat') {
			$f = 1;
		} else {
			$f = 0;
		} 
		
		$mainframe->setUserState('filter.published',$f);
		$published = $mainframe->getUserState('filter.published');

		$link = 'index.php?option=com_ejoshop&view=ejoshopcategories';
		
		$this->setRedirect($link, $msg);
	
	

	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function editchanges()
	{
	
		$model = $this->getModel('ejoshopcategories');
		
		if ($model->edit($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS_EDIT' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR_EDIT' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=ejoshopcategories';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	function apply()
	{
	
		$model = $this->getModel('map');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR' );
		}
		$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
	
		$link = 'index.php?option=com_ejoshop&controller=map&task=edit&cid[]='. $id;
		$this->setRedirect($link, $msg);

	}


	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'COM_EJOSHOP_CANCEL' );
		$this->setRedirect( 'index.php?option=com_ejoshop&view=ejoshopcategories', $msg );
	}
	
}