<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controlleradmin');

/**
 * Articles list controller class.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_ejoshop
 * @since	1.6
 */
class EjoshopControllerEjoshopConfig extends JControllerAdmin
{
	/**
	 * Constructor.
	 *
	 * @param	array	$config	An optional associative array of configuration settings.

	 * @return	ContentControllerArticles
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array())
	{

		parent::__construct();
		
		$this->registerTask('clearcache',	'clearcache');
		$this->registerTask('clearcacheall',	'clearcacheall');

		
	}


	/**
	 * Method to show Updates info for Ejoshop
	 *
	 * @return	void
	 * @since	1.6
	 */
	 
	function clearcache()
	{

		
		$type	= JRequest::getVar( 'type', '');
		$html = ($type == 'ajax') ? 'row' : 'html';
	
        $view = $this->getView('EjoshopConfig',$html,'EjoshopView');
		$vName		= JRequest::getCmd('view', 'EjoshopConfig');
		$model = $this->getModel($vName);
		$view->setModel($model, true);
		
		$lName		= JRequest::getCmd('layout', 'clearcache');
		if($type == 'ajax') {
			$model->deleteStyle();
		}
		$view->setLayout($lName);
		$view->display();
		
		
		/*
		$model->clearAllCache();
		
		$link = 'index.php?option=com_ejoshop&view=ejoshopconfig';
		//$this->setRedirect($link, 'Cache was cleared');
		
		parent::display();
		*/

	}
	


	/**
	 * Method to show Updates info for Ejoshop
	 *
	 * @return	void
	 * @since	1.6
	 */
	 
	function clearcacheall()
	{
		$vName	= JRequest::getCmd('view', 'EjoshopConfig');
		$model  = $this->getModel($vName);
		$model->clearAllCache();
		
		$link = 'index.php?option=com_ejoshop&view=ejoshopconfig';
		$this->setRedirect($link, JText::_('COM_EJ_CACHE_WAS_CLEARED'));
	}
	
	
	/**
	 * Proxy for getModel.
	 *
	 * @param	string	$name	The name of the model.
	 * @param	string	$prefix	The prefix for the PHP class name.
	 *
	 * @return	JModel
	 * @since	1.6
	 */
	 
	public function getModel($name = 'EjoshopConfig', $prefix = 'EjoshopModel', $config = array('ignore_request' => true))
	{
	
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}	

}
