<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controlleradmin');

/**
 * Articles list controller class.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_ejoshop
 * @since	1.6
 */
class EjoshopControllerEjoshopFields extends JControllerAdmin
{
	/**
	 * Constructor.
	 *
	 * @param	array	$config	An optional associative array of configuration settings.

	 * @return	ContentControllerArticles
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array())
	{
	
		// Articles default form can come from the articles or featured view.
		// Adjust the redirect view on the value of 'view' in the request.
		if (JRequest::getCmd('view') == 'featured') {
			$this->view_list = 'featured';
		}
		parent::__construct($config);

		
		$this->registerTask('delete',	'delete');
		$this->registerTask('deleteitem',	'deleteitem');
		$this->registerTask('ejoshopfield.addfield',	'addfield');

		
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function addfield()
	{
		$link = 'index.php?option=com_ejoshop&view=ejoshopfield&layout=addfield';
		$this->setRedirect($link, $msg);
	}
	
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function delete()
	{
		$model = $this->getModel('ejoshopfield');

		if($model->delete_field($id)) {
			
			$link = 'index.php?option=com_ejoshop&view=ejoshopfields';
			$this->setRedirect($link, JTEXT::_('COM_EJOSHOP_N_ITEMS_DELETED'));

		}
		
	}
	
	
	

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function cancel()
	{
		$link = 'index.php?option=com_ejoshop&view=ejoshopfields&layout=imagestyles';
		$this->setRedirect($link, $msg);
	}
	


	

}
