<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class EjoshopControllerEjoshopGlobalSettings extends EjoshopController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'apply'  , 'save' );
		$this->registerTask('unpublish', 'publish');
		$this->registerTask('publish', 'publish');
		$this->registerTask('switchpayments', 'switchpayments');
		
	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function switchpayments()
	{
		$task = JRequest::getVar('task');
		$value = JRequest::getVar('value');
		$type = JRequest::getVar('type');
		
		// var_dump($value);
		// Get the params and set the new values
	
		$params = JComponentHelper::getParams('com_ejoshop');
		$params->set($type, $value);
		if($type == 'switchpayments') {
			$params->set('switchyandexmoney', $value);
			$params->set('switchwebmoney', $value);
			$params->set('switchpaypal', $value);
			$params->set('switchanet', $value);
			$params->set('switchpost', $value);
			$params->set('switchwritebill', $value);
		}
		
		// Get a new database query instance
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		
		// Build the query
		$query->update('#__extensions AS a');
		$query->set('a.params = ' . $db->quote((string)$params));
		$query->where('a.element = "com_ejoshop"');
		
		// Execute the query
		$db->setQuery($query);
		$db->query();
		
		if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
		} else {
			
			JRequest::setVar( 'view', 'ejoshopglobalsettings' );
			JRequest::setVar( 'layout', 'ajax'  );
			//JRequest::setVar('hidemainmenu', 1);

			parent::display();
		}
	

	}
	
	
	public function publish()
	{
		JSession::checkToken() or die(JText::_('JINVALID_TOKEN'));

		$cid = JRequest::getVar('cid', array(), '', 'array');
		$data = array('publish' => 1, 'unpublish' => 0);
		$task = $this->getTask();
		$value = JArrayHelper::getValue($data, $task, 0, 'int');

		if (empty($cid))
		{
		JError::raiseWarning(500, JText::_('COM_EJOSHOP_NO_ITEM_SELECTED'));
		}
		else
		{
		$model = $this->getModel('EjoshopPhotos');
		JArrayHelper::toInteger($cid);
		if (!$model->publish($cid, $value))
		{
		JError::raiseWarning(500, $model->getError());
		}
		else
		{
		if ($value == 1)
		{
		$ntext = JText::_('COM_EJOSHOP_ITEMS_PUBLISHED');
		}
		elseif ($value == 0)
		{
		$ntext = JText::_('COM_EJOSHOP_ITEMS_UNPUBLISHED');
		}
		$this->setMessage(JText::plural($ntext, count($cid)));
		}
		}
		$this->setRedirect(JRoute::_('index.php?option=com_ejoshop&view=ejoshopphotos', false));
	}
	
	
	/**
	 * display the edit form
	 * @return void
	 */
	function allmaps()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}


	function edit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	function ajaxit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	

	function add()
	{
			$link = 'index.php?option=com_ejoshop&view=ejoshopphotos&layout=addphotos';
			$this->setRedirect($link, $msg);
	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
	
		$model = $this->getModel('mapyandexallmaps');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSADDNEW' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORADDNEW' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=mapyandexallmaps';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function photoedit()
	{
	
		$model = $this->getModel('ejoshopphotos');
		
		if ($model->photoedit($post)) {
			$msg = JText::_( 'COM_EJOSHOP_S_EDIT_PHOTO' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_E_EDIT_PHOTO' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=ejoshopphotos';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function photoapply()
	{
	
		$model = $this->getModel('ejoshopphotos');
		
		if ($model->photoedit($post)) {
			$msg = JText::_( 'COM_EJOSHOP_S_EDIT_PHOTO' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_E_EDIT_PHOTO' );
	
		}
			$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
			$link = 'index.php?option=com_ejoshop&view=ejoshopphotos&layout=photoedit&id='.$id;
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	function apply()
	{
	
		$model = $this->getModel('map');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR' );
		}
		$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
	
		$link = 'index.php?option=com_ejoshop&controller=map&task=edit&cid[]='. $id;
		$this->setRedirect($link, $msg);

	}
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('ejoshopphotos');
		$post = JRequest::get( 'post' );
		
		if ($model->delete($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS_DELETE' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR_DELETE' );
		}
		$link = 'index.php?option=com_ejoshop&view=ejoshopphotos';
		$this->setRedirect($link, $msg);

	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'COM_EJOSHOP_CANCEL' );
		$this->setRedirect( 'index.php?option=com_ejoshop&view=mapyandexallmaps', $msg );
	}
	
}