<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru, ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controlleradmin');

/**
 * Articles list controller class.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_ejoshop
 * @since	1.6
 */
class EjoshopControllerEjoshopInfo extends JControllerAdmin
{
	/**
	 * Constructor.
	 *
	 * @param	array	$config	An optional associative array of configuration settings.

	 * @return	ContentControllerArticles
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array())
	{

		parent::__construct();

		$this->registerTask('updates',	'updates');
		$t = JRequest::getVar('task');
		
		if(strpos($t,'doc-') !== FALSE) {
			
			$this->registerTask($t,	'redirectTodeveloper');
		}
		
	}


	/**
	 * Method to show Updates info for Ejoshop
	 *
	 * @return	void
	 * @since	1.6
	 */
	function updates()
	{
		
		$link = 'index.php?option=com_ejoshop&view=ejoshopinfo&layout=updates';
		
		$this->setRedirect($link);
		
		parent::display();

	}

	/**
	 * Method to show Updates info for Ejoshop
	 *
	 * @return	void
	 * @since	1.6
	 */
	function redirectTodeveloper()
	{
		$task = $this->getTask();
		$post = str_replace('doc-','',$task);
		$link = 'http://ermakovshop.com/'.$post.'/';
		
		$this->setRedirect($link, '');
		
		parent::display();

	}

	/**
	 * Method to add new Menu
	 *
	 * @return	void
	 * @since	1.6
	 */
	function ajax()
	{
		

		$mlid = JRequest::getVar('jform');
		$task = $this->getTask();

		$model = $this->getModel();
		if($model->menu_links_update()) {
			$link = 'index.php?option=com_ejoshop&view=ejoshopmenu';
				
			echo json_encode(array('success'=>1));
			exit;
		}
		
		JRequest::setVar( 'view', 'ejoshopmenu');
		JRequest::setVar( 'layout', 'ajax');
		JRequest::setVar( 'format', 'row');
		
		parent::display();	
	}

	/**
	 * Method to add new Menu
	 *
	 * @return	void
	 * @since	1.6
	 */
	function Menuadd()
	{

		JRequest::setVar( 'view', 'ejoshopMenu');
		JRequest::setVar( 'layout', 'addMenu');
	
		parent::display();	
	}
	
	
	/**
	 * Method to select a list of items with some categories.
	 *
	 * @return	void
	 * @since	1.6
	 */
	 
	function cancel()
	{
		$link = 'index.php?option=com_ejoshop&view=ejoshopMenu';
			
		$this->setRedirect($link, $msg);
	}


	/**
	 * Delete one or several menu links.
	 *
	 * @param $mlid
	 *   A valid menu link mlid or NULL. If NULL, $path is used.
	 * @param $path
	 *   The path to the menu items to be deleted. $mlid must be NULL.
	 */
	function deleteitem($data = array())
	{
	
		$mlid = JRequest::getVar('jform');
		$task = $this->getTask();
		$mlid = $mlid['mlid'];
		$model = $this->getModel();
		$status = $model->menu_link_delete($mlid);
		if($status) {
			$link = 'index.php?option=com_ejoshop&view=ejoshopmenu&layout=edit';
			$message = 'Item was deleted!';
			if($status == 'system') $message = 'System item can not be deleted!';	
			$this->setRedirect($link, $message);
		}

	}
	
	
	/**
	 * Delete one or several menu links.
	 *
	 * @param $mlid
	 *   A valid menu link mlid or NULL. If NULL, $path is used.
	 * @param $path
	 *   The path to the menu items to be deleted. $mlid must be NULL.
	 */
	function addlink($data = array())
	{

		$mlid = JRequest::getVar('jform');
		$task = $this->getTask();
		$mlid = $mlid['mlid'];
		$model = $this->getModel();
		//$model->menu_link_delete($mlid);

	}
		
	
	public function getModel($name = 'EjoshopMenu', $prefix = 'EjoshopModel', $config = array('ignore_request' => true))
	{
	
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}
	

}
