<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.controlleradmin' );

class EjoshopControllerEjoshopPayments extends JControllerAdmin
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'apply'  , 'save' );
		$this->registerTask('unpublish', 'publish');
		$this->registerTask('publish', 'publish');
		$this->registerTask('cancel', 'cancel');
		
		$task = JRequest::getVar('task', 0);
	
		$redirect = array('paypal','webmoney','yandexmoney','paywithpost','paywithbill','anet');
		if(in_array($task,$redirect)) {
			$this->registerTask( $task  , 'typepayments' );
		}
	}
	
	public function typepayments()
	{
		$task = $this->getTask();
		switch($task) {
			case 'paypal':
			$p = 2;
			break;
			case 'webmoney':
			$p = 3;
			break;
			case 'yandexmoney':
			$p = 1;
			break;
			case 'paywithpost':
			$p = 6;
			break;
			case 'paywithbill':
			$p = 4;
			break;
			case 'anet':
			$p = 5;
			break;
		}

		$this->setRedirect(JRoute::_('index.php?option=com_ejoshop&view=ejoshoppayments&layout=edit&id='.$p, false));

	}
	
	
	public function publish()
	{
		JSession::checkToken() or die(JText::_('JINVALID_TOKEN'));

		$cid = JRequest::getVar('cid', array(), '', 'array');
		$data = array('publish' => 1, 'unpublish' => 0);
		$task = $this->getTask();
		$value = JArrayHelper::getValue($data, $task, 0, 'int');
		/* 		
		var_dump($value);
		die(); 
		 */
		if (empty($cid))
		{
		JError::raiseWarning(500, JText::_('COM_EJOSHOP_NO_ITEM_SELECTED'));
		}
		else
		{
		$model = $this->getModel('ejoshoppayments');
		JArrayHelper::toInteger($cid);
		if (!$model->publish($cid, $value))
		{
		JError::raiseWarning(500, $model->getError());
		}
		else
		{
		if ($value == 1)
		{
		$ntext = JText::_('COM_EJOSHOP_ITEMS_PUBLISHED');
		}
		elseif ($value == 0)
		{
		$ntext = JText::_('COM_EJOSHOP_ITEMS_UNPUBLISHED');
		}
		$this->setMessage(JText::plural($ntext, count($cid)));
		}
		}
		$this->setRedirect(JRoute::_('index.php?option=com_ejoshop&view=ejoshoppayments', false));
	}
	
	
	/**
	 * display the edit form
	 * @return void
	 */
	function allmaps()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}


	function edit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	function ajaxit()
	{
		JRequest::setVar( 'view', 'map' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	

	function add()
	{
			$link = 'index.php?option=com_ejoshop&view=ejoshoppayments&layout=addphotos';
			$this->setRedirect($link, $msg);
	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
	
		$model = $this->getModel('mapyandexallmaps');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESSADDNEW' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERRORADDNEW' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=mapyandexallmaps';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function photoedit()
	{
		
		$model = $this->getModel('ejoshoppayments');
		
		if ($model->photoedit($post)) {
			$msg = JText::_( 'COM_EJOSHOP_S_EDIT_PHOTO' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_E_EDIT_PHOTO' );
	
		}
			$link = 'index.php?option=com_ejoshop&view=ejoshoppayments';
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function photoapply()
	{
	

		$model = $this->getModel('ejoshoppayments');
		
		if ($model->photoedit($post)) {
			$msg = JText::_( 'COM_EJOSHOP_S_EDIT_PHOTO' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_E_EDIT_PHOTO' );
	
		}
			$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
			$link = 'index.php?option=com_ejoshop&view=ejoshoppayments&layout=edit&id='.$id;
			$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}

	function apply()
	{
	
		$model = $this->getModel('map');
		
		if ($model->store($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR' );
		}
		$id = JRequest::getVar( 'id', '', 'post','string', JREQUEST_ALLOWRAW );
	
		$link = 'index.php?option=com_ejoshop&controller=map&task=edit&cid[]='. $id;
		$this->setRedirect($link, $msg);

	}
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('ejoshoppayments');
		$post = JRequest::get( 'post' );
		
		if ($model->delete($post)) {
			$msg = JText::_( 'COM_EJOSHOP_SUCCESS_DELETE' );
		} else {
			$msg = JText::_( 'COM_EJOSHOP_ERROR_DELETE' );
		}
		$link = 'index.php?option=com_ejoshop&view=ejoshoppayments';
		$this->setRedirect($link, $msg);

	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'COM_EJOSHOP_CANCEL' );

		$this->setRedirect( 'index.php?option=com_ejoshop&view=ejoshoppayments', $msg );
	}
	
	
	
}