<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controlleradmin');

/**
 * Articles list controller class.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_ejoshop
 * @since	1.6
 */
class EjoshopControllerEjoshopStyles extends JControllerAdmin
{
	/**
	 * Constructor.
	 *
	 * @param	array	$config	An optional associative array of configuration settings.

	 * @return	ContentControllerArticles
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array())
	{

		// Articles default form can come from the articles or featured view.
		// Adjust the redirect view on the value of 'view' in the request.
		if (JRequest::getCmd('view') == 'featured') {
			$this->view_list = 'featured';
		}
		parent::__construct($config);

		
		$this->registerTask('delete',	'delete');
		$this->registerTask('deleteitem',	'deleteitem');
		$this->registerTask('add',	'Menuadd');
		$this->registerTask('cancel',	'cancel');
		$this->registerTask('ajax',	'ajax');
		$this->registerTask('ajaxmenulink',	'ajaxmenulink');
		$this->registerTask('imagestyles',	'imagestyles');
		$this->registerTask( 'apply'  , 'save' );
		$this->registerTask( 'processimages'  , 'processimages' );
		$this->registerTask( 'deletestyle'  , 'deletestyle' );
		
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function deletestyle()
	{
	
		$type	= JRequest::getVar( 'type', '');
		$html = ($type == 'ajax') ? 'row' : 'html';
	
        $view = $this->getView('EjoshopStyles',$html,'EjoshopView');
		$vName		= JRequest::getCmd('view', 'EjoshopStyles');
		$model = $this->getModel($vName);
		$view->setModel($model, true);
		
		$lName		= JRequest::getCmd('layout', 'deletestyle');
		if($type == 'ajax') {
			$model->deleteStyle();
		}
		$view->setLayout($lName);
		$view->display();
	}
	
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function processimages()
	{

		$type	= JRequest::getVar( 'type', '');
		$model = $this->getModel('ejoshopstyles');
		//$model->processimages($post);
                // set default view if not set
				
		if($type == 'ajax') {
			
			$model->processimages($post = '');
		}
		
		$html = ($type == 'ajax') ? 'row' : 'html';
	
        $view = $this->getView('EjoshopStyles',$html,'EjoshopView');
		$vName		= JRequest::getCmd('view', 'EjoshopStyles');
		$model = $this->getModel($vName);
		$view->setModel($model, true);
		
		$lName		= JRequest::getCmd('layout', 'processimages');
	
		$view->setLayout($lName);
		$view->display();
		
		
		if (isset($id)) {
			$msg = JText::_( 'COM_EJOSHOP_STYLES_EDIT_SUCCESS' );

		} else {
			$msg = JText::_( 'COM_EJOSHOP_STYLES_EDIT_ERROR' );
	
		}
			//$link = 'index.php?option=com_ejoshop&view=ejoshopstyles&layout=imagestylesedit&id='.$id;
			//$this->setRedirect($link, $msg);
		

	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function cancel()
	{
		$link = 'index.php?option=com_ejoshop&view=ejoshopstyles&layout=imagestyles';
		$this->setRedirect($link, $msg);
	}
	
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	 
	function save()
	{
		$data = JRequest::get('post');
		$model = $this->getModel('ejoshopstyles');
		$data_validate  = $this->input->post->get('jform', array(), 'array');
		$app   = JFactory::getApplication();
		// Validate the posted data.
		// Sometimes the form needs some posted data, such as for plugins and modules.
		$form = $model->getForm($data_validate, false);
		

		$validData = $model->validate($form, $data_validate);
		
		// Check for validation errors.
		if ($validData === false && !isset($data['jform']['cart_foncolor_th']))
		{
		$errors = $model->getErrors();
			// Push up to three validation messages out to the user.
			for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++)
			{
				if ($errors[$i] instanceof Exception)
				{
					$app->enqueueMessage($errors[$i]->getMessage(), 'warning');
				}
				else
				{
					$app->enqueueMessage($errors[$i], 'warning');
				}
			}
			
			// Redirect back to the edit screen.
			$this->setRedirect('index.php?option=com_ejoshop&view=ejoshopstyles&layout=imagestyles');
			return false;
		}
		
		$id = $model->save($post = '');


		if(!empty($data['jform']['name_imagestyle'])) {
			if ($id) {
				$msg = JText::_( 'COM_EJOSHOP_STYLES_EDIT_SUCCESS' );
			} else {
				$msg = JText::_( 'COM_EJOSHOP_STYLES_EDIT_ERROR' );
		
			}
		
			$link = 'index.php?option=com_ejoshop&view=ejoshopstyles&layout=imagestylesedit&id='.$data['jform']['id'];
		} else {
			if ($id) {
				$msg = JText::_( 'COM_EJOSHOP_SUCCESS' );
			} else {
				$msg = JText::_( 'COM_EJOSHOP_ERROR' );
		
			}
			$link = 'index.php?option=com_ejoshop&view=ejoshopstyles';
			
		}
		$this->setRedirect($link, $msg);
		// Check the table in so it can be edited.... we are done with it anyway

	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function imagestyles()
	{
		
		$task = $this->getTask();
		$model = parent::getModel($name = 'EjoshopStyles', $prefix = 'EjoshopModel', $config = array('ignore_request' => true));	
		$mainframe = JFactory::getApplication();
		if($task == 'publishedcat') {
			$f = 1;
		} else {
			$f = 0;
		} 
		

		$link = 'index.php?option=com_ejoshop&view=ejoshopstyles&layout=imagestyles';
		
		$this->setRedirect($link, $msg);
	
	

	}
	

	

}
