<?php
/*
 * @package		Joomla.Framework
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 *
 * @component
 * @copyright
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License version 2 or later;
 */
defined('_JEXEC') or die;
jimport('joomla.client.ftp');

class EjoshopHelper
{

	public static function canWrite()
	{
		$user	= JFactory::getUser();
		$result['perms'] = 0;
		$params = JComponentHelper::getParams( 'com_ejoshop' );	
				$userpath = $params->get('userpathtoimg');
				
				if(empty($userpath)) {

					$userpath = '/images/ejoshop/yandexmarkerimg/';
				}
			
				
				if(is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {


	
					//var_dump($ftp->mkdir($config->get('ftp_root').$userpath.'555'));


					
					$jp = JPath::getPermissions($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
					$ch = JPath::canChmod($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
					$jp = str_split($jp, 3);
			
				
					if(!is_writable($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
						$result['notperms'] = JText::sprintf('COM_EJOSHOP_NO_PERMS',$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
					}
				
					if(!$jp) {
						$result['notperms'] = JText::sprintf('COM_EJOSHOP_NO_PERMS',$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
					}
					
					
					if(strpos($jp[0],'w') && is_writable($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
					
						$result['perms'] = 1;
						
						
					} else {
						
						$result['notperms'] = JText::sprintf('COM_EJOSHOP_NO_PERMS',$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
						
					}
				} else {
					
					$result['notperms'] = JText::sprintf('COM_EJOSHOP_NO_PERMS',$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
				
				}

				if(JRequest::getVar('task') == 'add') {
					if(!empty($result['notperms'])) {
						$config = JFactory::getConfig($_SERVER['DOCUMENT_ROOT'].JURI::root(true).'configuration.php');
						$ftp = new JFtp();
						$ftp->connect($config->get('ftp_host'),$config->get('ftp_port'));
						
						$l = $ftp->login($config->get('ftp_user'),$config->get('ftp_pass'));
						if($l && $ftp->isConnected()) {
							$result['isconnectedftp'] = $ftp->isConnected();
						} else {
							$result['isconnectedftp']= false;	
							$result['noftp'] = JText::sprintf('COM_EJOSHOP_NO_FTP',$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
						}
						
						$ftp->quit();

					}
				}

		return $result;
	}
	
/**
	 * Configure the Submenu links.
	 *
	 * @param	string	The extension being used for the categories.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public static function addSubmenu($extension)
	{
		// Avoid nonsense situation.
		if ($extension == 'com_categories') {
			return;
		}

		$parts = explode('.', $extension);
		$component = $parts[0];

		if (count($parts) > 1) {
			$section = $parts[1];
		}

		// Try to find the component helper.
		$eName	= str_replace('com_', '', $component);
		$file	= JPath::clean(JPATH_ADMINISTRATOR.'/components/'.$component.'/helpers/'.$eName.'.php');

		if (file_exists($file)) {
			require_once $file;

			$prefix	= ucfirst(str_replace('com_', '', $component));
			$cName	= $prefix.'Helper';

			if (class_exists($cName)) {

				if (is_callable(array($cName, 'addSubmenu'))) {
					$lang = JFactory::getLanguage();
					// loading language file from the administrator/language directory then
					// loading language file from the media/*extension*/language directory
						$lang->load($component, JPATH_BASE, null, false, false)
					||	$lang->load($component, JPath::clean(JPATH_ADMINISTRATOR.'/components/'.$component), null, false, false)
					||	$lang->load($component, JPATH_BASE, $lang->getDefault(), false, false)
					||	$lang->load($component, JPath::clean(JPATH_ADMINISTRATOR.'/components/'.$component), $lang->getDefault(), false, false);
 					call_user_func(array($cName, 'addSubmenu'), 'categories'.(isset($section)?'.'.$section:''));
				}
			}
		}
	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @param	string	$extension	The extension.
	 * @param	int		$categoryId	The category ID.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions($extension = '', $categoryId = 0)
	{
		$user		= JFactory::getUser();
		$result		= new JObject;
		$parts		= explode('.', $extension);
		$component	= $parts[0];
		
		if (empty($categoryId)) {
			$assetName = $component;
			$level = 'component';
		}
		else {
			$assetName = $component.'.category.'.(int) $categoryId;
			$level = 'category';
		}

		$actions = JAccess::getActions($component, $level);

		foreach ($actions as $action) {
			$result->set($action->name, $user->authorise($action->name, $assetName));
		}

		return $result;
	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @param	string	$extension	The extension.
	 * @param	int		$categoryId	The category ID.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getProductsActions($id = 0)
	{
		$user		= JFactory::getUser();
		$result		= new JObject;
		
		$component	= 'com_ejoshop';
		
		if (empty($id)) {
			$assetName = 'com_ejoshop';
			$level = 'component';
		}
		else {
			$assetName = $component.'.ejoshopphoto.'.(int) $id;
			$level = 'ejoshopphoto';
		}
		
		$parent_actions = JAccess::getActions($component, 'component');
		
		$actions = JAccess::getActions($component, $level);
		
		foreach ($parent_actions as $action) {
			$result->set($action->name, $user->authorise($action->name, 'com_ejoshop'));
		}
	
		
		foreach ($actions as $action) {
			$result->set($action->name, $user->authorise($action->name, $assetName));
		}
		//EjoshopDeveloper::DebugPrint($result);
		return $result;
	}
	
	public function  admin_menu_links_menu($tree) {
	  $links = array();
	  if(empty($tree)) return array();
	  foreach ($tree as $data) {
		// Skip items that are inaccessible, invisible, or link to their parent.
		// (MENU_DEFAULT_LOCAL_TASK), and MENU_CALLBACK-alike items that should only
		// appear in the breadcrumb.
		
		if (!$data['link']['access'] || $data['link']['type'] & MENU_LINKS_TO_PARENT || $data['link']['type'] == MENU_VISIBLE_IN_BREADCRUMB || $data['link']['hidden'] == 1) {
		  continue;
		}
		// Hide 'Administer' and make child links appear on this level.
		// @todo Make this configurable.
		if ($data['link']['router_path'] == 'admin') {
		  if ($data['below']) {
			$links = array_merge($links, $this->admin_menu_links_menu($data['below']));
		  }
		  continue;
		}
		// Omit alias lookups.
		$data['link']['localized_options']['alias'] = TRUE;
		// Remove description to prevent mouseover tooltip clashes.
		unset($data['link']['localized_options']['attributes']['title']);

		// Make action links (typically "Add ...") appear first in dropdowns.
		// They might appear first already, but only as long as there is no link
		// that comes alphabetically first (e.g., a node type with label "Ad").
		if ($data['link']['type'] & MENU_IS_LOCAL_ACTION) {
		  $data['link']['weight'] -= 1000;
		}

		$links[$data['link']['href']] = array(
		  '#title' => $data['link']['title'],
		  '#href' => $data['link']['href'],
		  '#options' => $data['link']['localized_options'],
		  '#weight' => $data['link']['weight'],
		  '#mlid' => $data['link']['mlid'],
		  '#depth' => $data['link']['depth'],
		  '#view' => $data['link']['view'],
		  '#task' => $data['link']['task'],
		);

		// Recurse to add any child links.
		$children = array();
		if ($data['below']) {
		  $children = $this->admin_menu_links_menu($data['below']);
		  $links[$data['link']['href']] += $children;
		}

		// Handle links pointing to category/overview pages.
		if ($data['link']['page_callback'] == 'system_admin_menu_block_page' || $data['link']['page_callback'] == 'system_admin_config_page') {
		  // Apply a marker for others to consume.
		  $links[$data['link']['href']]['#is_category'] = TRUE;
		  // Automatically hide empty categories.
		  // Check for empty children first for performance. Only when non-empty
		  // (typically 'admin/config'), check whether children are accessible.
		  if (empty($children) || !$this->element_get_visible_children($children)) {
			$links[$data['link']['href']]['#access'] = FALSE;
		  }
		}
	  }
	  return $links;
	}
	
		function theme($theme,$variables = array()) {
	
		  // If a renderable array is passed as $variables, then set $variables to
		  // the arguments expected by the theme function.
		  if (isset($variables['#theme']) || isset($variables['#theme_wrappers'])) {
		  $info['render element'] = 'elements';
		
			$element = $variables;
			$variables = array();
			if (isset($info['variables'])) {
			  foreach (array_keys($info['variables']) as $name) {
				if (isset($element["#$name"])) {
				  $variables[$name] = $element["#$name"];
				}
			  }
			}
			else {
			  $variables[$info['render element']] = $element;
			}
		  }
				$theme = 'theme_'.$theme;
				$variables = $this->$theme($variables);
				//var_dump($children);
				return $variables;

			
		
		}
		
		function drupal_render(&$elements, $render = TRUE) {
			
		  // Early-return nothing if user does not have access.
		  if (empty($elements) || (isset($elements['#access']) && !$elements['#access'])) {
			return;
		  }

		  // Do not print elements twice.
		  if (!empty($elements['#printed'])) {
			return;
		  }

		  // Try to fetch the element's markup from cache and return.
		 /* if (isset($elements['#cache'])) {
			$cached_output = drupal_render_cache_get($elements);
			if ($cached_output !== FALSE) {
			  return $cached_output;
			}
		  }
		*/


		  // If #markup is set, ensure #type is set. This allows to specify just #markup
		  // on an element without setting #type.
		  if (isset($elements['#markup']) && !isset($elements['#type'])) {
			$elements['#type'] = 'markup';
		  }

		  // If the default values for this element have not been loaded yet, populate
		  // them.
		  if (isset($elements['#type']) && empty($elements['#defaults_loaded'])) {
			$elements += element_info($elements['#type']);
		  }

		  // Make any final changes to the element before it is rendered. This means
		  // that the $element or the children can be altered or corrected before the
		  // element is rendered into the final text.
		  if (isset($elements['#pre_render'])) {
			foreach ($elements['#pre_render'] as $function) {
			  if (function_exists($function)) {
				$elements = $function($elements);
			  }
			}
		  }

		  // Allow #pre_render to abort rendering.
		  if (!empty($elements['#printed'])) {
			return;
		  }
		  // сортируются по весу
		  $children = $this->element_children($elements, TRUE);
		  // Get the children of the element, sorted by weight.
		  $children = array('menu','select');


		  // Initialize this element's #children, unless a #pre_render callback already
		  // preset #children.
		  if (!isset($elements['#children'])) {
			$elements['#children'] = '';
		  }
		  // Call the element's #theme function if it is set. Then any children of the
		  // element have to be rendered there.
		  if (isset($elements['#theme'])) {

			$elements['#children'] = $this->theme($elements['#theme'], $elements);
		  }
	
	

		  // If #theme was not set and the element has children, render them now.
		  // This is the same process as drupal_render_children() but is inlined
		  // for speed.
		  if ($elements['#children'] == '') {

			foreach ($children as $key) {
	
			  $elements['#children'] .= $this->drupal_render($elements[$key], $render);

			  
			}
		  }

		  // Let the theme functions in #theme_wrappers add markup around the rendered
		  // children.
		  if (isset($elements['#theme_wrappers'])) {
			foreach ($elements['#theme_wrappers'] as $theme_wrapper) {
			
			  $elements['#children'] = $this->theme($theme_wrapper, $elements);
			}
		  }

		  // Filter the outputted content and make any last changes before the
		  // content is sent to the browser. The changes are made on $content
		  // which allows the output'ed text to be filtered.
		  if (isset($elements['#post_render'])) {
		  

			foreach ($elements['#post_render'] as $function) {
			  if (function_exists($function)) {
				$elements['#children'] = $function($elements['#children'], $elements);
			  }
			}
		  }

		  // Add any JavaScript state information associated with the element.
		  if (!empty($elements['#states'])) {
			drupal_process_states($elements);
		  }

		  // Add additional libraries, CSS, JavaScript an other custom
		  // attached data associated with this element.
		  if (!empty($elements['#attached'])) {
			drupal_process_attached($elements);
		  }

		  $prefix = isset($elements['#prefix']) ? $elements['#prefix'] : '';
		  $suffix = isset($elements['#suffix']) ? $elements['#suffix'] : '';
		  $output = $prefix . $elements['#children'] . $suffix;

		  // Cache the processed element if #cache is set.
		  if (isset($elements['#cache'])) {
			drupal_render_cache_set($output, $elements);
		  }

		  $elements['#printed'] = TRUE;
			

		  if($render) {
			echo $output;
		  } else {
			return $output;
		  }
		}
/**
 * Render a themed list of links.
 *
 * @param $variables
 *   - elements: A renderable array of links using the following keys:
 *     - #attributes: Optional array of attributes for the list item, processed
 *       via drupal_attributes().
 *     - #title: Title of the link, passed to l().
 *     - #href: Optional path of the link, passed to l(). When omitted, the
 *       element's '#title' is rendered without link.
 *     - #description: Optional alternative text for the link, passed to l().
 *     - #options: Optional alternative text for the link, passed to l().
 *     The array key of each child element itself is passed as path for l().
 */
function theme_admin_menu_links($variables) {
  //$destination = &drupal_static('admin_menu_destination');
  $elements = $variables['elements'];



	
  if (!isset($destination)) {
    $destination = '';
   
  }

  // The majority of items in the menu are sorted already, but since modules
  // may add or change arbitrary items anywhere, there is no way around sorting
  // everything again. element_sort() is not sufficient here, as it
  // intentionally retains the order of elements having the same #weight,
  // whereas menu links are supposed to be ordered by #weight and #title.
  uasort($elements, array($this,'element_sort'));
  $elements['#sorted'] = TRUE;

  $output = '';
  foreach ($this->element_children($elements) as $path) {

    if ($path == 'admin/tasks') {
   
      continue;
    }

    if ($path == 'admin/index') {
		$elements[$path]['#title'] = '<span>' . JTEXT::_('Home') . '</span>';
		$elements[$path]['#attributes']['class'][] = 'admin-menu-toolbar-category';
		$elements[$path]['#attributes']['class'][] = 'admin-menu-icon';
    }
	
    // Early-return nothing if user does not have access.
    if (isset($elements[$path]['#access']) && !$elements[$path]['#access']) {
      continue;
    }
    $elements[$path] += array(
      '#attributes' => array(),
      '#options' => array(),
    );
	 
    // Render children to determine whether this link is expandable.
    if (isset($elements[$path]['#type']) || isset($elements[$path]['#theme']) || isset($elements[$path]['#pre_render'])) {
      $elements[$path]['#children'] = $this->drupal_render($elements[$path]);
    }
    else {
      $elements[$path]['#children'] = $this->theme('admin_menu_links', array('elements' => $elements[$path]));
      if (!empty($elements[$path]['#children'])) {
        $elements[$path]['#attributes']['class'][] = 'expandable';
      }
      if (isset($elements[$path]['#attributes']['class'])) {
        $elements[$path]['#attributes']['class'] = $elements[$path]['#attributes']['class'];
      }
    }

    $link = '';
    // Handle menu links.
    if (isset($elements[$path]['#href'])) {
      // Strip destination query string from href attribute and apply a CSS class
      // for our JavaScript behavior instead.
      if (isset($elements[$path]['#options']['query']['destination']) && $elements[$path]['#options']['query']['destination'] == $destination) {
        unset($elements[$path]['#options']['query']['destination']);
        $elements[$path]['#options']['attributes']['class'][] = 'admin-menu-destination';
      }
	  $componentpath = JURI::root(true).'/administrator/index.php?option=com_ejoshop';
	  $task = (!empty($elements[$path]['#task'])) ? '&task='.$elements[$path]['#task'] : '';	
	  $href = $componentpath.'&view='.$elements[$path]['#view'] . $task;
	  // default path - component path
	  if(empty($elements[$path]['#task']) && empty($elements[$path]['#view'])) {
		 $href = $componentpath;
	  }
	  
      $link = '<a href="'.$href.'">'.$elements[$path]['#title'].'</a>';
    }
    // Handle plain text items, but do not interfere with menu additions.
    elseif (!isset($elements[$path]['#type']) && isset($elements[$path]['#title'])) {
      if (!empty($elements[$path]['#options']['html'])) {
        $title = $elements[$path]['#title'];
      }
      else {
        $title = $elements[$path]['#title'];
      }
      $attributes = '';
      if (isset($elements[$path]['#options']['attributes'])) {
        $attributes = $this->drupal_attributes($elements[$path]['#options']['attributes']);
      }
      $link = '<span' . $attributes . '>' . $title . '</span>';
    }

    $output .= '<li' . $this->drupal_attributes($elements[$path]['#attributes']) . '>';
    $output .= $link . $elements[$path]['#children'];
    $output .= '</li>';
  }
  // @todo #attributes probably required for UL, but already used for LI.
  // @todo Use $element['#children'] here instead.
  if ($output) {
    $elements['#wrapper_attributes']['class'][] = 'dropdown';
    $attributes = $this->drupal_attributes($elements['#wrapper_attributes']);
    $output = "\n" . '<ul' . $attributes . '>' . $output . '</ul>';
  }
  return $output;
}


function theme_admin_menu_select($variables) {
  //$destination = &drupal_static('admin_menu_destination');
  $elements = $variables['elements'];

  if (!isset($destination)) {
    $destination = '';
   
  }

  // The majority of items in the menu are sorted already, but since modules
  // may add or change arbitrary items anywhere, there is no way around sorting
  // everything again. element_sort() is not sufficient here, as it
  // intentionally retains the order of elements having the same #weight,
  // whereas menu links are supposed to be ordered by #weight and #title.
  uasort($elements, array($this,'element_sort'));
  $elements['#sorted'] = TRUE;

  $output = '';
  foreach ($this->element_children($elements) as $path) {
  	  
    // Early-return nothing if user does not have access.
    if (isset($elements[$path]['#access']) && !$elements[$path]['#access']) {
      continue;
    }
    $elements[$path] += array(
      '#attributes' => array(),
      '#options' => array(),
    );
	 
    // Render children to determine whether this link is expandable.
    if (isset($elements[$path]['#type']) || isset($elements[$path]['#theme']) || isset($elements[$path]['#pre_render'])) {
      $elements[$path]['#children'] = $this->drupal_render($elements[$path]);
    }
    else {
      $elements[$path]['#children'] = $this->theme('admin_menu_select', array('elements' => $elements[$path]));
      if (!empty($elements[$path]['#children'])) {
        $elements[$path]['#attributes']['class'][] = 'expandable';
      }
      if (isset($elements[$path]['#attributes']['class'])) {
        $elements[$path]['#attributes']['class'] = $elements[$path]['#attributes']['class'];
      }
    }

    $link = '';
    // Handle menu links.
    if (isset($elements[$path]['#href'])) {
      // Strip destination query string from href attribute and apply a CSS class
      // for our JavaScript behavior instead.
      if (isset($elements[$path]['#options']['query']['destination']) && $elements[$path]['#options']['query']['destination'] == $destination) {
        unset($elements[$path]['#options']['query']['destination']);
        $elements[$path]['#options']['attributes']['class'][] = 'admin-menu-destination';
      }

      $link = '<a href="'.$elements[$path]['#href'].'">'.$elements[$path]['#title'].'</a>';
    }
    // Handle plain text items, but do not interfere with menu additions.
    elseif (!isset($elements[$path]['#type']) && isset($elements[$path]['#title'])) {
      if (!empty($elements[$path]['#options']['html'])) {
        $title = $elements[$path]['#title'];
      }
      else {
        $title = $elements[$path]['#title'];
      }
      $attributes = '';
      if (isset($elements[$path]['#options']['attributes'])) {
        $attributes = $this->drupal_attributes($elements[$path]['#options']['attributes']);
      }
      $link = '<span' . $attributes . '>' . $title . '</span>';
    }
	
    $output .= '<option value="'.$elements[$path]['#mlid'].'" ' . $this->drupal_attributes($elements[$path]['#attributes']) . '>';
    $output .= str_repeat('- ', $elements[$path]['#depth']) . $link . $elements[$path]['#children'];
    $output .= '</option>';
  }
  // @todo #attributes probably required for UL, but already used for LI.
  // @todo Use $element['#children'] here instead.
  if ($output) {
    $elements['#wrapper_attributes']['class'][] = 'dropdown';
    $attributes = $this->drupal_attributes($elements['#wrapper_attributes']);
  
  }
  return $output;
}


function drupal_attributes(array $attributes = array()) {
  foreach ($attributes as $attribute => &$data) {
    $data = implode(' ', (array) $data);
    $data = $attribute . '="' . $data . '"';
  }
  return $attributes ? ' ' . implode(' ', $attributes) : '';
}
		
	/**
	 * Function used by uasort to sort structured arrays by #weight AND #title.
	 */
	public function element_sort($a, $b) {

	  // @see element_sort()
	  $a_weight = isset($a['#weight']) ? $a['#weight'] : 0;
	  $b_weight = isset($b['#weight']) ? $b['#weight'] : 0;
	  if ($a_weight == $b_weight) {
		// @see element_sort_by_title()
		$a_title = isset($a['#title']) ? $a['#title'] : '';
		$b_title = isset($b['#title']) ? $b['#title'] : '';
		return strnatcasecmp($a_title, $b_title);
	  }
	  return ($a_weight < $b_weight) ? -1 : 1;
	}	
		
/**
 * Identifies the children of an element array, optionally sorted by weight.
 *
 * The children of a element array are those key/value pairs whose key does
 * not start with a '#'. See drupal_render() for details.
 *
 * @param $elements
 *   The element array whose children are to be identified.
 * @param $sort
 *   Boolean to indicate whether the children should be sorted by weight.
 *
 * @return
 *   The array keys of the element's children.
 */
function element_children(&$elements, $sort = FALSE) {
  // Do not attempt to sort elements which have already been sorted.
  $sort = isset($elements['#sorted']) ? !$elements['#sorted'] : $sort;

  // Filter out properties from the element, leaving only children.
  $children = array();
  $sortable = FALSE;
  foreach ($elements as $key => $value) {
    if ($key === '' || $key[0] !== '#') {
      $children[$key] = $value;
      if (is_array($value) && isset($value['#weight'])) {
        $sortable = TRUE;
      }
    }
  }
  // Sort the children if necessary.
  if ($sort && $sortable) {
    uasort($children,array($this, 'element_sort'));
    // Put the sorted children back into $elements in the correct order, to
    // preserve sorting if the same element is passed through
    // element_children() twice.
    foreach ($children as $key => $child) {
      unset($elements[$key]);
      $elements[$key] = $child;
    }
    $elements['#sorted'] = TRUE;
  }

  return array_keys($children);
}

/**
 * Returns the visible children of an element.
 *
 * @param $elements
 *   The parent element.
 *
 * @return
 *   The array keys of the element's visible children.
 */
function element_get_visible_children(array $elements) {
  $visible_children = array();

  foreach ($this->element_children($elements) as $key) {
    $child = $elements[$key];

    // Skip un-accessible children.
    if (isset($child['#access']) && !$child['#access']) {
      continue;
    }

    // Skip value and hidden elements, since they are not rendered.
    if (isset($child['#type']) && in_array($child['#type'], array('value', 'hidden'))) {
      continue;
    }

    $visible_children[$key] = $child;
  }

  return array_keys($visible_children);
}
	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @param	string	$extension	The extension.
	 * @param	int		$categoryId	The category ID.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public function getSubMenu($site = '', $categoryId = 0)
	{
		
		$document = JFactory::getDocument();
		$document->addStylesheet(JURI::root(true).'/media/com_ejoshop/assets/admin_menu.css');
		$document->addStylesheet(JURI::root(true).'/media/com_ejoshop/assets/admin_menu_toolbar.css');
		$document->addStylesheet(JURI::root(true).'/media/com_ejoshop/assets/shortcut.css');

			$params = JComponentHelper::getParams('com_ejoshop') ;
			$toolbaron= $params->get('toolbaron');
			
			if($site) {
				$extension = 'com_ejoshop'; // optional
				$basePath = JPATH_ADMINISTRATOR; // optional
				$lang = JFactory::getLanguage();

				$lang = $lang->getName();
				JFactory::getLanguage()->load($extension, $basePath);
				$document->addStylesheet(JURI::root(true).'/media/com_ejoshop/assets/admin_menu_site.css');

			} 
			
		
		require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'libraries'.DS.'ejoshop/menu/menu.php');
		
		
		
		// Get a reference to the global cache object.
		
		//$cache->clean('menu');
		$sfile = new JCacheStorageFile(array('cachebase'=>JPATH_ROOT.DS.'tmp'.DS));
		if($sfile->test()) {

		// Run the test without caching.
		//$profiler = new JProfiler();
		
		//echo $profiler->mark( ' without caching' );
		

		//$data = $cache->getStores();
		//echo $sfile->_lifetime; ///index.php?option=com_config
		if($cache = $sfile->get('ejoomenu','ejoshop',TRUE)) {
			$tree = unserialize($cache);
		} else {
			$tree = menu_build_tree('management');
			if(!$sfile->store( 'ejoomenu' , 'ejoshop', serialize($tree) )) {
				$tree = menu_build_tree('management');
			}
		}
		
		
		//echo $profiler->mark( ' with caching' );
		} else {
		
			$tree = menu_build_tree('management');
		}
		
			/*
			print '<pre>';
			print_r($tree);
			print '</pre>';
			die(); 
					// $output = "\n" . '<select' . $attributes . '>' . $output . '</select>';
			*/
	 	
        $content['menu'] = $this->admin_menu_links_menu($tree);
		/*
		$select['select'] =  $content['menu'];
		$select['select']['#prefix'] = '<div id="admin-menu-select" rel="myjoomart" class="' . $classes . '"><div id="admin-menu-wrapper"><select id="menu-select">';
		$select['select']['#suffix'] = '</select></div></div>';
		$select['select']['#theme'] = 'admin_menu_select';
		$select['select']['#wrapper_attributes']['id'] = 'admin-menu-menu';
		$html_select = $this->drupal_render($select);
		*/

		
		
		$content['menu']['#prefix'] = '<div id="admin-menu" rel="myjoomart" class=""><div id="admin-menu-wrapper">';
		$content['menu']['#suffix'] = '</div></div>';
        $content['menu']['#theme'] = 'admin_menu_links';
        $content['menu']['#wrapper_attributes']['id'] = 'admin-menu-menu';
		$return = TRUE;
		if($site){
			$return = FALSE;
		}
		
		$html = $this->drupal_render($content,$return);
		if($site){
			return $html;
		}
	}
	
	
	/*
	
		Parameters

		$item: An array representing a menu link item. The only mandatory keys are link_path and link_title. Possible keys are:

			menu_name: Default is navigation.
			weight: Default is 0.
			expanded: Whether the item is expanded.
			options: An array of options, see l() for more.
			mlid: Set to an existing value, or 0 or NULL to insert a new link.
			plid: The mlid of the parent.
			router_path: The path of the relevant router item.

		Return value

		The mlid of the saved menu link, or FALSE if the menu link could not be saved.

	*/
	public static function load_menu() {
		
			$_SERVER['HTTP_X_REQUESTED_WITH'] = (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) ? $_SERVER['HTTP_X_REQUESTED_WITH'] : FALSE;
			/* AJAX CHECK we are stop output menu in ajax query */
			if(empty($_SERVER['HTTP_X_REQUESTED_WITH']) 
				&& strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest'
				&& strpos($_SERVER['HTTP_ACCEPT'],'application/json') === FALSE
				) {
				/* ajax not here */
				$analitycs	= JRequest::getVar( 'getlang', 0);
				$view	= JRequest::getVar( 'view', '');
				$format	= JRequest::getVar( 'format' , 'html');
				$layout	= JRequest::getVar( 'layout');
				if(!$analitycs && $format != 'row' && $view != 'ejoshopmaps' && $layout != 'modal') {
					JHtml::stylesheet( JURI::root(true).'media/com_ejoshop/assets/ejoshop.css' );
					require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'helpers'.DS.'ejoshop.php');
						
					$helper = new EjoshopHelper();

					$helper->getSubMenu();	
				}
			}


			// set default view if not set
			JRequest::setVar('view', JRequest::getCmd('view', 'Ejoshop'));
	}
	
	function add_link(&$item) {

	
	  require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'libraries'.DS.'ejoshop/menu/menu.php');
	
	  menu_link_save($item);

	}


}

	/**
	 * Utility class for the submenu.
	 *
	 * @package		Joomla.Administrator
	 */
	class MySubMenuHelper
	{
		/**
		 * Method to add a menu item to submenu.
		 *
		 * @param	string	$name	Name of the menu item.
		 * @param	string	$link	URL of the menu item.
		 * @param	bool	True if the item is active, false otherwise.
		 */
		public static function addEntry()
		{
			require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'helpers'.DS.'ejoshop.php');
			
			$helper = new EjoshopHelper();

			$helper->getSubMenu();	
			
		}
	}