<?php
 
/*
 * @package EjoshopComments
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
/**
 * The maximum depth of a menu links tree - matches the number of p columns.
 */
 
define('MENU_MAX_PARTS', 9);
define('MENU_MAX_DEPTH', 9);

/**
 * Class for comments
 *
 * @package EjoshopComments  
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */
 

class EjoshopComments {

	function __construct (){
	
		
	}

	function menu_link_save(&$item) {

		$idmap = JRequest::getVar('idmap');
		$db		= JFactory::getDBO();
		/**
		 * The maximum depth of a menu links tree - matches the number of p columns.
		 */

  	 

		  // Load defaults.
		  $item += array(
			'comment_name' => 'allcomment',
			'weight' => 0,
			'link_title' => '',
			'hidden' => 0,
			'has_children' => 0,
			'expanded' => 0,
			'options' => array(),
			'module' => 'menu',
			'customized' => 0,
			'updated' => 0,
		  );
		  

		
	  if (isset($item['mlid'])) {
		if (!$existing_item) {
		 // $existing_item = db_query('SELECT * FROM {menu_links} WHERE mlid = :mlid', array('mlid' => $item['mlid']))->fetchAssoc();
		 $db->setQuery(sprintf("SELECT * FROM #__ejoshop_comments WHERE mlid = %d", $item['mlid']));
		 $existing_item = $db->loadAssoc();		  
		}
		if ($existing_item) {
		  $existing_item['options'] = unserialize($existing_item['options']);
		}
	  }
	  else {
		$existing_item = FALSE;
	  }
	  		
	
 
		// Try to find a parent link. If found, assign it and derive its menu.
	  $parent = $this->_menu_link_find_parent($item, $parent_candidates);


	  if($parent['depth'] >= MENU_MAX_DEPTH ) {
		return false;
	  }
	
	  if (!empty($parent['mlid'])) {
		$item['plid'] = $parent['mlid'];
		$item['comment_name'] = $parent['comment_name'];
	  }
	  // If no corresponding parent link was found, move the link to the top-level.
	  else {

		$item['plid'] = 0;

	  }
	
	  $comment_name = $item['comment_name'];



		  if (!$existing_item) {

		  /*
			db_query("INSERT INTO {menu_links} (
			   comment_name, plid, link_path,
			  hidden, external, has_children,
			  expanded, weight,
			  module, link_title, options,
			  customized, updated) VALUES (
			  '%s', %d, '%s',
			  %d, %d, %d,
			  %d, %d,
			  '%s', '%s', '%s', %d, %d)", $item['comment_name'], $item['plid'], $item['link_path'], $item['hidden'], $item['_external'], $item['has_children'], $item['expanded'], $item['weight'], $item['module'], $item['link_title'], serialize($item['options']), $item['customized'], $item['updated']);
			$item['mlid'] = db_last_insert_id('menu_links', 'mlid');
			*/
		
			  $db->setQuery(sprintf("INSERT INTO #__ejoshop_comments (
			   comment_name, plid, link_path,
			  hidden, external, has_children,
			  expanded, weight,
			  module, link_title, options,
			  customized, updated, username,useremail, comment, pid, created) VALUES (
			  '%s', %d, '%s',
			  %d, %d, %d,
			  %d, %d,
			  '%s', '%s', '%s', %d, %d,'%s', '%s','%s',%d,%s)", $item['comment_name'], $item['plid'], $item['link_path'], $item['hidden'], $item['_external'], $item['has_children'], $item['expanded'], $item['weight'], $item['module'], $item['link_title'], serialize($item['options']), $item['customized'], $item['updated'], $item['username'], $item['useremail'], $item['comment'], $item['pid'],'now()'));
			  $db->query();
			  $item['mlid'] = $db->insertid();
			 
			 
		  }
	
	  // Directly fill parents for top-level links.
	  if ($item['plid'] == 0) {
		$item['p1'] = $item['mlid'];
		for ($i = 2; $i <= MENU_MAX_DEPTH; $i++) {
		  $item["p$i"] = 0;
		}
		$item['depth'] = 1;
	
	  }
	  // Otherwise, ensure that this link's depth is not beyond the maximum depth
	  // and fill parents based on the parent link.
	  else {
	  
		if ($item['has_children'] && $existing_item) {
		  $limit = MENU_MAX_DEPTH - $this->menu_link_children_relative_depth($existing_item) - 1;
		}
		else {
		  $limit = MENU_MAX_DEPTH - 1;
		}

		if ($parent['depth'] > $limit) {
		  return FALSE;
		}

		if($item['depth'] == 2) {
			$item['depth'] = $parent['depth'];
		} else {
			$item['depth'] = $parent['depth'] + 1;
		}
		
		$this->_menu_link_parents_set($item, $parent);
		
	
	  }
	   

	   
		  // Need to check both plid and comment_name, since plid can be 0 in any menu.
		  if ($existing_item) {

			$this->_menu_link_move_children($item, $existing_item);
		  }
		  // Find the callback. During the menu update we store empty paths to be
		  // fixed later, so we skip this.
		  if (!isset($_SESSION['system_update_6021']) && (empty($item['router_path']) || !$existing_item || ($existing_item['link_path'] != $item['link_path']))) {
			if ($item['_external']) {
			  $item['router_path'] = '';
			}
			else {
			  // Find the router path which will serve this path.
			  $item['parts'] = explode('/', $item['link_path'], MENU_MAX_PARTS);
			  $item['router_path'] = '';
			}
		  }

		 if (!$existing_item || (array_intersect_key($item, $existing_item) != $existing_item)) {
		  
		
			$db->setQuery(sprintf("UPDATE #__ejoshop_comments SET comment_name = '%s', plid = %d, link_path = '%s',
			router_path = '%s', hidden = %d, external = %d, has_children = %d,
			expanded = %d, weight = %d, depth = %d,
			p1 = %d, p2 = %d, p3 = %d, p4 = %d, p5 = %d, p6 = %d, p7 = %d, p8 = %d, p9 = %d,
			module = '%s', link_title = '%s', options = '%s', customized = %d WHERE mlid = %d", $item['comment_name'], $item['plid'], $item['link_path'], $item['router_path'], $item['hidden'], $item['_external'], $item['has_children'], $item['expanded'], $item['weight'], $item['depth'], $item['p1'], $item['p2'], $item['p3'], $item['p4'], $item['p5'], $item['p6'], $item['p7'], $item['p8'], $item['p9'], $item['module'], $item['link_title'], serialize($item['options']), $item['customized'], $item['mlid']));
			
			$db->query();
			$this->_menu_update_parental_status($item);
			 // Check the has_children status of the parent.

			 /* menu_cache_clear($comment_name);
			  if ($existing_item && $comment_name != $existing_item['comment_name']) {
				menu_cache_clear($existing_item['comment_name']);
			  }

			  _menu_clear_page_cache();
			  */
			}
			  

	  return $item['mlid'];
	}
	
	/**
	 * Sets the p1 through p9 values for a menu link being saved.
	 */
	function _menu_link_parents_set(&$item, $parent) {
	  $i = 1;
	  			

	  while ($i < $item['depth']) {
		$p = 'p' . $i++;
		$item[$p] = $parent[$p];
	  }

	  $p = 'p' . $i++;
	  // The parent (p1 - p9) corresponding to the depth always equals the mlid.
	  $item[$p] = $item['mlid'];
	  while ($i <= MENU_MAX_DEPTH) {
		$p = 'p' . $i++;
		$item[$p] = 0;
	  }

	}
	
	
	
/**
 * Finds the depth of an item's children relative to its depth.
 *
 * For example, if the item has a depth of 2, and the maximum of any child in
 * the menu link tree is 5, the relative depth is 3.
 *
 * @param $item
 *   An array representing a menu link item.
 *
 * @return
 *   The relative depth, or zero.
 *
 */
function menu_link_children_relative_depth($item) {

	$db	   = JFactory::getDBO();
  /*	 
  $query = db_select('menu_links');
  $query->addField('menu_links', 'depth');
  $query->condition('comment_name', $item['comment_name']);
  $query->orderBy('depth', 'DESC');
  $query->range(0, 1);
  */
/*
SELECT menu_links.depth AS depth FROM {menu_links} menu_links WHERE (comment_name = :db_condition_placeholder_0) AND (p1 = :db_condition_placeholder_1) AND (p2 = :db_condition_placeholder_2) AND (p3 = :db_condition_placeholder_3) AND (p4 = :db_condition_placeholder_4) ORDER BY depth DESC LIMIT 1 OFFSET 0
*/
  $i = 1;
  $p = 'p1';
  while ($i <= MENU_MAX_DEPTH && $item[$p]) {
    $query = " AND ($p=$item[$p])";
    //$query->condition($p, $item[$p]);
    $p = 'p' . ++$i;
  }

  $db->setQuery(sprintf("SELECT depth FROM #__ejoshop_comments WHERE (comment_name = %d) $query ORDER BY depth DESC LIMIT 1 OFFSET 0", $item['comment_name']));
  $max_depth = $db->loadResult();
  
  //$max_depth = $query->execute()->fetchField();

  return ($max_depth > $item['depth']) ? $max_depth - $item['depth'] : 0;
}
	
/**
 * Updates the children of a menu link that is being moved.
 *
 * The menu name, parents (p1 - p6), and depth are updated for all children of
 * the link, and the has_children status of the previous parent is updated.
 */
function _menu_link_move_children($item, $existing_item) {
  //$query = db_update('menu_links');
	$db	   = JFactory::getDBO();

			
  //$query->fields(array('comment_name' => $item['comment_name']));

  $p = 'p1';
  $expressions = array();
  for ($i = 1; $i <= $item['depth']; $p = 'p' . ++$i) {
    $expressions[] = array($p, $item[$p]);
  }
  $j = $existing_item['depth'] + 1;
  while ($i <= MENU_MAX_DEPTH && $j <= MENU_MAX_DEPTH) {
    $expressions[] = array('p' . $i++, 'p' . $j++, array());
  }
  while ($i <= MENU_MAX_DEPTH) {
    $expressions[] = array('p' . $i++, 0, array());
  }

		
  $shift = $item['depth'] - $existing_item['depth'];
  if ($shift > 0) {
    // The order of expressions must be reversed so the new values don't
    // overwrite the old ones before they can be used because "Single-table
    // UPDATE assignments are generally evaluated from left to right"
    // see: http://dev.mysql.com/doc/refman/5.0/en/update.html
    $expressions = array_reverse($expressions);
  }

	/*
	UPDATE {menu_links} SET p1=:p_1, p2=:p_2, p3=:p_3, p4=p5, p5=p6, p6=p7, p7=p8, p8=p9, p9=0, depth=depth + :depth, comment_name=:db_update_placeholder_0
WHERE  (comment_name = :db_condition_placeholder_0) AND (p1 = :db_condition_placeholder_1) AND (p2 = :db_condition_placeholder_2) AND (p3 = :db_condition_placeholder_3) AND (p4 = :db_condition_placeholder_4)
	*/
	
	$exp = '';
  foreach ($expressions as $expression) {
    $exp .= $this->expression( $expression[0], $expression[1], $expression[2] );
  }

  $exp .= 'depth = depth + '.$shift;

  //$query->condition('comment_name', $existing_item['comment_name']);
  $p = 'p1';
  $and = '';

  for ($i = 1; $i <= MENU_MAX_DEPTH && $existing_item[$p]; $p = 'p' . ++$i) {
   // $query->condition($p, $existing_item[$p]);
   $and .= " AND ($p = $existing_item[$p])";
   
  }
  

	
    $db->setQuery(sprintf("UPDATE #__ejoshop_comments SET ".$exp.", comment_name = '%s' WHERE (comment_name = '".$existing_item['comment_name']."') ".$and."",$item['comment_name']));
 
	$db->query();
  //$query->execute();

  // Check the has_children status of the parent, while excluding this item.
   $this->_menu_update_parental_status($existing_item, TRUE);
}

	/**
	 * implode array as expression in drupal style
	 */
	function expression($e1,$e2,$e3) {
	
		$exp = '';
		$exp = $e1.'='.$e2.',';
		return $exp;
	}
/**
 * Finds a possible parent for a given menu link.
 *
 * Because the parent of a given link might not exist anymore in the database,
 * we apply a set of heuristics to determine a proper parent:
 *
 *  - use the passed parent link if specified and existing.
 *  - else, use the first existing link down the previous link hierarchy
 *  - else, for system menu links (derived from hook_menu()), reparent
 *    based on the path hierarchy.
 *
 * @param $menu_link
 *   A menu link.
 * @param $parent_candidates
 *   An array of menu links keyed by mlid.
 *
 * @return
 *   A menu link structure of the possible parent or FALSE if no valid parent
 *   has been found.
 */
function _menu_link_find_parent($menu_link, $parent_candidates = array()) {
  $parent = FALSE;
  $db	  = JFactory::getDBO();

  // This item is explicitely top-level, skip the rest of the parenting.
 /*
 if (isset($menu_link['plid']) && empty($menu_link['plid'])) {
    return $parent;
  }
*/
  // If we have a parent link ID, try to use that.
  $candidates = array();
  if (isset($menu_link['plid'])) {
    $candidates[] = $menu_link['plid'];
  }

  // Else, if we have a link hierarchy try to find a valid parent in there.
  if (!empty($menu_link['depth']) && $menu_link['depth'] > 1) {
    for ($depth = $menu_link['depth'] - 1; $depth >= 1; $depth--) {
      $candidates[] = $menu_link['p' . $depth];
	  
    }
  }
  

  $candidates = array_unique($candidates);
  
  foreach ($candidates as $mlid) {
    if (isset($parent_candidates[$mlid])) {
      $parent = $parent_candidates[$mlid];
    }
    else {
	  //$parent = db_query("SELECT * FROM {menu_links} WHERE mlid = :mlid", array(':mlid' => $mlid))->fetchAssoc();
	 $db->setQuery(sprintf("SELECT * FROM #__ejoshop_comments WHERE mlid = %d", $mlid));
	 $parent = $db->loadAssoc();		
    

    }

    if ($parent) {
      return $parent;
    }
  }

  // If everything else failed, try to derive the parent from the path
  // hierarchy. This only makes sense for links derived from menu router
  // items (ie. from hook_menu()).
  if ($menu_link['module'] == 'system') {
    $query = db_select('menu_links');
    $query->condition('module', 'system');
    // We always respect the link's 'comment_name'; inheritance for router items is
    // ensured in _menu_router_build().
    $query->condition('comment_name', $menu_link['comment_name']);

    // Find the parent - it must be unique.
    $parent_path = $menu_link['link_path'];
    do {
      $parent = FALSE;
      $parent_path = substr($parent_path, 0, strrpos($parent_path, '/'));
      $new_query = clone $query;
      $new_query->condition('link_path', $parent_path);
      // Only valid if we get a unique result.
      if ($new_query->countQuery()->execute()->fetchField() == 1) {
        $parent = $new_query->fields('menu_links')->execute()->fetchAssoc();
      }
    } while ($parent === FALSE && $parent_path);
  }

  return $parent;
}	


/**
 * Checks and updates the 'has_children' status for the parent of a link.
 */
function _menu_update_parental_status($item, $exclude = FALSE) {

  // If plid == 0, there is nothing to update.
  if ($item['plid']) {
    // Check if at least one visible child exists in the table.
    /*
	$query = db_select('menu_links');
    $query->addField('menu_links', 'mlid');
    $query->condition('comment_name', $item['comment_name']);
    $query->condition('hidden', 0);
    $query->condition('plid', $item['plid']);
    $query->range(0, 1);
    if ($exclude) {
      $query->condition('mlid', $item['mlid'], '<>');
    }
    $parent_has_children = ((bool) $query->execute()->fetchField()) ? 1 : 0;
	*/

	$condition = '';
	if ($exclude) {
      $condition = ' AND (mlid <> '.$item['mlid'].')';
    }
	$db		= JFactory::getDBO();
	$db->setQuery("SELECT mlid FROM #__ejoshop_comments WHERE comment_name = '".$item['comment_name']."' AND  plid = '".$item['plid']."' AND hidden = 0 ".$condition." LIMIT 0, 1");
	$parent_has_children = $db->loadResult();
	$parent_has_children = ($parent_has_children) ? 1 : 0;

	
   /*
    db_update('menu_links')
      ->fields(array('has_children' => $parent_has_children))
      ->condition('mlid', $item['plid'])
      ->execute();
	 */
		$db->setQuery("UPDATE #__ejoshop_comments SET has_children = '".$parent_has_children."' WHERE mlid = '".$item['plid']."'");
		
		$db->query();
	  
  }
  
  
}

/**
 * Deletes all links for a menu.
 *
 * @param $comment_name
 *   The name of the menu whose links will be deleted.
 */
function menu_delete_links($comment_name) {
  $links = $this->menu_load_links($comment_name);
  foreach ($links as $link) {
    // To speed up the deletion process, we reset some link properties that
    // would trigger re-parenting logic in _menu_delete_item() and
    // _menu_update_parental_status().
    $link['has_children'] = FALSE;
    $link['plid'] = 0;
    $this->_menu_delete_item($link);
  }
}

/**
 * Delete one or several menu links.
 *
 * @param $mlid
 *   A valid menu link mlid or NULL. If NULL, $path is used.
 * @param $path
 *   The path to the menu items to be deleted. $mlid must be NULL.
 */
function menu_link_delete($mlid, $path = NULL) {
  if (isset($mlid)) {
	
	$db		= JFactory::getDBO();
	$db->setQuery(sprintf("SELECT * FROM #__ejoshop_comments WHERE mlid = %d", $mlid));
	$item = $db->loadAssoc();	
	

    $this->_menu_delete_item($item);
  }
  else {
    $result = db_query("SELECT * FROM {menu_links} WHERE link_path = :link_path", array(':link_path' => $path));
    foreach ($result as $link) {
     $this->_menu_delete_item($link);
    }
  }
}

/**
 * Deletes a single menu link.
 *
 * @param $item
 *   Item to be deleted.
 * @param $force
 *   Forces deletion. Internal use only, setting to TRUE is discouraged.
 *
 * @see menu_link_delete()
 */
function _menu_delete_item($item, $force = FALSE) {
  $item = is_object($item) ? get_object_vars($item) : $item;
  $db		= JFactory::getDBO();

  if ($item && ($item['module'] != 'system' || $item['updated'] || $force)) {

    // Children get re-attached to the item's parent.
    if ($item['has_children']) {
		
		$db->setQuery(sprintf("SELECT * FROM #__ejoshop_comments WHERE plid = %d", $item['mlid']));
		$result = $db->loadObjectList();	
		
	
     // $result = db_query("SELECT mlid FROM {menu_links} WHERE plid = :plid", array(':plid' => $item['mlid']));
      foreach ($result as $m) {
        $child = $this->menu_link_load($m->mlid);
		
	
        $child['plid'] = $item['plid'];
 		
        $this->menu_link_save($child);
      }
    }

	$db->setQuery(sprintf("DELETE FROM #__ejoshop_comments WHERE mlid = %d", $item['mlid']));
	$db->query();
	
	/*
    db_delete('menu_links')->condition('mlid', $item['mlid'])->execute();

    // Update the has_children status of the parent.
	*/
    $this->_menu_update_parental_status($item);
    /*
	menu_cache_clear($item['comment_name']);
    _menu_clear_page_cache();
	*/
  }
  if ($item && ($item['module'] == 'system')) {
	return 'system';
  }
}
/**
 * Gets a translated, access-checked menu link that is ready for rendering.
 *
 * This function should never be called from within node_load() or any other
 * function used as a menu object load function since an infinite recursion may
 * occur.
 *
 * @param $mlid
 *   The mlid of the menu item.
 *
 * @return
 *   A menu link, with $item['access'] filled and link translated for
 *   rendering.
 */
function menu_link_load($mlid) {
  if (is_numeric($mlid)) {
 	$db		= JFactory::getDBO();
	$db->setQuery(sprintf("SELECT *, weight as link_weight FROM #__ejoshop_comments WHERE mlid = %d", $mlid));

	
    if ($item = $db->loadAssoc()) {
      $item['weight'] = $item['link_weight'];
     // _menu_link_translate($item);
      return $item;
    }
  }
  return FALSE;
}
}
?>