<?php 

/*
 * @package EjoshopFields
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Fields class based on drupal fields class
 *
 * @package EjoshopFields  
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */


class EjoshopFields {

	var $htmlfields;
	
	/*
	 * 
	 * возвращает список других товаров из #__ejoshop_shop_order, приобретённых вместе
	 * с просматриваемым товаром
	 */
	 
	public function getfilterfields()
	{
		$fields = array();
		$db		= JFactory::getDBO();
		$query = "SELECT fc . *
		FROM #__ejoshop_field_config fc
		WHERE fc.active = 1 AND fc.type = 'list_text' AND fc.storage_active = 1";

		$db->setQuery($query);
		$fields = $db->loadAssocList();
		foreach($fields as $key => $field) {

			$this->get_list_text($field,$wrapli = '<div>');

		}
		
		return $this->htmlfields;
	
		
	}

	/*
	 * 
	 * возвращает список других товаров из #__ejoshop_shop_order, приобретённых вместе
	 * с просматриваемым товаром
	 */	
	
	public function getFieldsForJoin()
	{
		$result = array();
		$db		= JFactory::getDBO();
		$query = "SELECT fc . *
		FROM #__ejoshop_field_config fc
		WHERE fc.active = 1 AND fc.widget_type != 'options_buttons'";
		$config = new JConfig();
		
		$db->setQuery($query);
		$result = $db->loadAssocList();
		foreach($result as $key => $field) {
			$result[$key]['field_table_name'] = $config->dbprefix . 'ejoshop_field_data_'.$field['field_name'];
		}
		return $result;
		
		
	}
	/*
	 * 
	 * 
	 * get all existing fields
	 */
	 
	public function get_field_info($ids = array())
	{
		$result = array();
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('fields.*');
		$query->from('#__ejoshop_field_config AS fields');

	
		
		if(is_array($ids) && !empty($ids)) {
			$query->where("fields.id IN(".implode(',',$ids).")");
		}
		$config = new JConfig();
		
		$db->setQuery($query);
		$result = $db->loadAssocList();
		foreach($result as $key => $field) {
			$result[$key]['field_table_name'] = $config->dbprefix . 'ejoshop_field_data_'.$field['field_name'];
		}		
		return $result;
	}
	
	/*
	 * 
	 * 
	 * get all existing fields
	 */
	 
	public function delete_field($field)
	{
	
		$config = new JConfig();
 
		$db	= JFactory::getDBO();
		$db->setQuery(
			'DROP TABLE IF EXISTS `'.$field['field_table_name'].'`'
		);
		
		if (!$db->query()) {
			throw new Exception($db->getErrorMsg());
		} else {
				$db->setQuery(
					'DELETE FROM #__ejoshop_field_config' .
					' WHERE id = '.$field['id'].' LIMIT 1'
				);
				if (!$db->query()) {
					throw new Exception($db->getErrorMsg());
				} else {
					return true;
				}
		}
	
	}
	
	
	/*
	 * 
	 * get all existing fields with value for site part
	 */
	 
	public function getAllFields($item)
	{
		$result = array();
		$db		= JFactory::getDBO();
		$query = "SELECT fc . *
		FROM #__ejoshop_field_config fc
		WHERE fc.active = 1 AND fc.storage_active = 1";
		$config = new JConfig();
		

		$db->setQuery($query);
		$result = $db->loadAssocList();
		foreach($result as $key => $field) {
			$result[$key]['field_table_name'] = $config->dbprefix . 'ejoshop_field_data_'.$field['field_name'];
		}

		foreach($result as $key => $fieldset) {
			if(!empty($fieldset['field_table_name'])) {
				$val = $this->get_field($fieldset['field_table_name'],$fieldset['field_name'],$item->id);
				if(!empty($val)) $val += $fieldset;
				
				$data = unserialize($val['data']);
				if(!empty($data['settings']['allowedvalues'])) {
					$textvalue = $data['settings']['allowedvalues'];
				} else {
					$textvalue = array();
				}	
				if($textvalue) {
				foreach($textvalue as $valkeys) {
					
						if($val[$fieldset['field_name'] . '_value'] == $valkeys[0]) {
							$item->fields[$fieldset['field_name']]['labeltext'] = $valkeys[1];
				
						}
					}
				}
				
				
				
				if($val) {
					
					$item->fields[$fieldset['field_name']]['value'] = $val[$fieldset['field_name'] . '_value'];
					if(isset($item->fields[$fieldset['field_name']]['value'])) {
						$item->fields[$fieldset['field_name']]['label'] = $this->getLabel($val);
					}
				}
			}
			
		
		}
		


		return $item;
		
		
	}
	
	public function get_field($field_table_name,$field_name,$id)
	{

		
		$field = array();
		$db		= JFactory::getDBO();
		$query = "SELECT ".$field_name . "_value
		FROM ".$field_table_name." field
		WHERE field.entity_id = '".$id."' AND field.deleted = 0";
		
		$db->setQuery($query);
		$field = $db->loadAssoc();
		
		return $field;
	}
	
	public function add_field($field_table_name,$field_name, $value, $entity_id )
	{
		$db = $this->getDBO();
		$query	= $db->getQuery(true);
		$query->select('fields.*');
		$query->from('`'.$field_table_name.'` AS fields');

	
		$query->where("fields.entity_id = '".$entity_id."'");
		
		$query = $db->setQuery( $query);
		$fields = $db->loadAssoc();
		if(empty($fields)) {

			$query = "INSERT INTO ".$field_table_name
			." (`entity_type`,`bundle`,`deleted`,`entity_id`,`".$field_name."_value`) 
			VALUES ('product','product','0','".$entity_id."','".$value."');";
			

		} else {
			$query = "UPDATE " . $field_table_name ."
				SET `entity_type` = 'product',`bundle` = 'product',`deleted` = '0',`".$field_name."_value` = '".$value."' WHERE `entity_id` = '".$entity_id."' LIMIT 1;";
		}
		$db->setQuery($query);
		if (!$db->query()) {
		
			echo $db->getErrorMsg();
			return false;
		}
			
	}
	
	/*
	 * Custom fields select with option
	 *
	 */
	
	function get_number_integer($result)
	{
		$label = $this->getLabel($result);
		$this->htmlfields .= '<div><label style="width:15%;" title="" for="field_data_'.$result['field_name'].'">' . $label .'</label><input value="'.$result['#value'][0].'" name="field_data_'.$result['field_name'].'"></input></div>';
		return $this->htmlfields;
	}

	function get_number_decimal($result)
	{
		$label = $this->getLabel($result);
		$this->htmlfields .= '<div class="controls"><label style="width:15%;" title="" for="field_data_'.$result['field_name'].'">'.$label.'</label><input value="'.$result['#value'][0].'" name="field_data_'.$result['field_name'].'"></input><div class="controls">';
		return $this->htmlfields;
	}
	/*
	 * Custom fields text output
	 *
	 */
	
	function get_text($result)
	{
		
		$label = $this->getLabel($result);
		$this->htmlfields .= '<div class="controls"><label style="width:10%;" title="" for="field_data_'.$result['field_name'].'">'.$label.'</label><textarea name="field_data_'.$result['field_name'].'">'.$result['#value'][0].'</textarea><div class="controls">';
		return $this->htmlfields;
	}
	
	/*
	 * Custom fields long text output
	 *
	 */
	
	
	function get_text_long($result) {
		$label = '';
		$label = $this->getLabel($result);
		
		if(!empty($label)) $label = '<label style="width:10%;" title="" for="field_data_'.$result['field_name'].'">'.$label.'</label>';
		if(empty($result['#value'][0])) {
			$result['#value'][0] = '';
		}
			$this->htmlfields .= '<div>'.$label.'<textarea name="field_data_'.$result['field_name'].'">'.$result['#value'][0].'</textarea></div>';
		
		return $this->htmlfields;
	}
	
	
	
	/*
	 * Custom fields select with option
	 *
	 */
	
	function getWidgetName($widget)
	{
		switch ($widget) {
		
			case 'options_buttons' :
			  return JTEXT::_('COM_EJ_CHECKBOX');	
			  break;

			case 'options_select' :
			  return JTEXT::_('COM_EJ_SELECT');	
			  break;
		  
		}
		
		$this->get_list_text($result,$wrapel = '<div>');
	}
	
	/**
	 * return all settings or named
	 */
	
	public function getFieldssettings($field,$settings = null)
	{

	
		if(!empty($field[0]['data']) || !empty($field['data'])) {
			$field[0]['data'] = (empty($field[0]['data'])) ? $field['data'] : 0;
			$uns = unserialize($field[0]['data']);
				
			if(!empty($settings)) return $uns['settings'][$settings];
			else return $uns;
		} else {
			return array();
		}
	}
	
	/*
	 * Custom fields select with option
	 *
	 */
	
	function get_list_integer($result,$wrapel = '<div>')
	{
		return $this->get_list_text($result,$wrapel = '<div>');
	}
	
	function get_list_text($result,$wrapel = '<div>')
	{
	
		/*
			print '<pre>';
			print_r($result);
			print '</pre>';
		*/
		
		$label = $this->getLabel($result);	
		$result['values'] = unserialize($result['data']);
		
		$result['allowedvalues'] = $result['values']['settings']['allowedvalues'];
		$result['allowedvaluesstring'] = '';
		if(!empty($result['allowedvalues'])) {
		
			foreach($result['allowedvalues'] as $val) {
			
					$result['allowedvaluesstring'] .= $val[0].'|'.$val[1]."\r";
				
			}			
			
			$result['allowedvalues'] = $result['allowedvaluesstring'];
		
		//var_dump($result->values['settings']['allowedvalues']);
		$element = array();

	    $cfieldfilter = JRequest::getVar('select_custom_filter_name',0);
		$cfieldfilter_value = JRequest::getVar('select_custom_filter_value',0);
		$customfilter_clear = (int) JRequest::getVar('select_custom_filter_clear',0);

		if( !$cfieldfilter && !$customfilter_clear) {
			$cfieldfilter = !empty($_SESSION['cfieldfilter']) ? $_SESSION['cfieldfilter'] : '';
			$cfieldfilter_value = !empty($_SESSION['cfieldfilter_value']) ? $_SESSION['cfieldfilter_value'] : '';
		} else {
			$_SESSION['cfieldfilter'] = $cfieldfilter;
			$_SESSION['cfieldfilter_value'] = $cfieldfilter_value;
		}
		

		if($result['field_name'] == str_replace('field_data_','',$cfieldfilter)) {
			$element['#value'] = $cfieldfilter_value;
		} else {
			if(!empty($result['#value'])) {
				$element['#value'] = $result['#value'];
			}
		}
		

	
		
		
			foreach($result['values']['settings']['allowedvalues'] as $key => $val) {
				
				
				$element[$val[0]] = $val[1];
				
				
			}
			
			
	
			
			
			if(!empty($element)) {
				EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
				//$model = EjoshopModel::getInstance('updatesmigration', 'VirtueMartModel');
				$model = EjoshopModel::getInstance('EjoshopField', 'EjoshopModel');
				
				if($wrapel) $wrapel . $this->htmlfields .'</div>';
				if($result['widget_type'] == 'options_select' || !$result['widget_type']) {
					$this->htmlfields .= $wrapel.'<label style="width:15%;" title="" for="field_data_'.$result['field_name'].'">'.$label.'</label><select autocomplete="off" class="custom_field" name="field_data_'.$result['field_name'].'">' .  $this->form_select_options($element) . '</select>'.str_replace('<','</',$wrapel);
				} else if($result['widget_type']  == 'options_buttons') {
				
					$this->htmlfields .= $wrapel.'<label style="width:30%;" title="" for="field_data_'.$result['field_name'].'">'.$label.'</label>'.$this->theme_checkbox($element,$result['field_name']).str_replace('<','</',$wrapel);
				}
				
			}
		}
		
		return $this->htmlfields;
	}

	
	function theme_checkbox($element,$field_name) {
	  
	  if (!isset($choices)) {
		$choices = $element;
	  }
	  
	  $value_valid = isset($element['#value']) || array_key_exists('#value', $element);
	  $value_is_array = $value_valid && is_array($element['#value']);
	  
	  $options = '';
	  foreach ($choices as $key => $choice) {
	    if($key!='#value') {
		  $checked = '';
		  if($value_is_array && in_array($key, $element['#value']) ) $checked = 'checked="checked"';
	      $options .= '<div> <label style="width:10%;" title="" for="field_data_'.$field_name.'">'.$choice.'</label>
		  <input autocomplete="off" value="'.$key.'" type="checkbox" '. $checked.' name="field_data_'.$field_name.'[]" /></div>';
	    }
	  }
	  
	  return $options;
	}	
	
	
	function form_select_options($element, $choices = NULL) {
	  if (!isset($choices)) {
		$choices = $element;
	  }
	  /* on site add default not selected option */
	  $app = JFactory::getApplication();
	  $view = JRequest::getVar('view');
	  
		$newchoice = array();
		
		 array_unshift($choices,JText::_('COM_EJ_NOT_SELECT'));
		 $i = 0;
		 foreach($choices as $key => $val) {
			++$i;
			if($i == 1) {
			
				$newchoice['notselected'] = $choices[$key];
				unset($choices[$key]);
			} else {
				$newchoice[$key] = $choices[$key];
			}
			
		 }
		 $choices = $newchoice;
	  
	  
	  // array_key_exists() accommodates the rare event where $element['#value'] is NULL.
	  // isset() fails in this situation.
	  $value_valid = isset($element['#value']) || array_key_exists('#value', $element);
	  $value_is_array = $value_valid && is_array($element['#value']);

	  
	  $options = '';
	  foreach ($choices as $key => $choice) {
		if (is_array($choice) && !$element['#value']) {
		  $options .= '<optgroup label="' . $key . '">';
		  $options .= $this->form_select_options($element, $choice);
		  $options .= '</optgroup>';
		}
		elseif (is_object($choice)) {
		  $options .= $this->form_select_options($element, $choice->option);
		}
		else {

		
		  $key = (string) $key;
		  if ($value_valid && (!$value_is_array && (string) $element['#value'] === $key || ($value_is_array && in_array($key, $element['#value'])))) {
			$selected = ' selected="selected"';
		  }
		  else {
			$selected = '';
		  }
		  
		  if($key != '#value'){
			$options .= '<option value="' . $this->check_plain($key) . '"' . $selected . '>' . $this->check_plain($choice) . '</option>';
		  }
		}
	  }
	  
	  return $options;
	}
	
	function check_plain($text) {
		return htmlspecialchars($text, ENT_QUOTES, 'UTF-8');
	}

	
	function checkTable($table) {
		$result = array();
		$db		= JFactory::getDBO();
	
		
		$query = "SHOW TABLES LIKE '".$table."';";
		
		$config = new JConfig();
		
		$db->setQuery($query);
		$result = $db->loadResult();
	
		return $result;
		
	}

	function getLabel($field) {
		$sd = unserialize($field['data']);
		$this->params = JComponentHelper::getParams('com_ejoshop');
		$fields_show_label = $this->params->get('fields_show_label', 0);
		$mainframe = JFactory::getApplication();
		$label = (!empty($fields_show_label) || $mainframe->isAdmin()) ? (!empty($sd['settings']['label'])) ? $sd['settings']['label'] : $field['field_name'] : '';
		
		$label .= !empty($fields_show_label) ? ':' : '';
		return $label;
	}

	function checkvalue( $type, $val )
	{
		$validete = 'validete_'.$type;
		if($this->$validete($val)) {
			return true;
		} else {
			throw new Exception('Error validate for type: ' . $type);
		}
	}

	
	function validete_list_text( $val )
	{
		return true;
	}

	function validete_list_integer( $val )
	{	
		return !empty($val);
	}
	
	function validete_number_decimal( $val )
	{

		return is_numeric( $val );
		
	}
	
	function validete_number_float( $val )
	{
		return true;
	}
	
	function validete_number_integer( $val )
	{
		return true;
	}
	function validete_text( $val )
	{
		return true;
	}
	function validete_text_long( $val )
	{
		return true;
	}

	function is_decimal( $val )
	{
		return is_numeric( $val ) && floor( $val ) != $val;
	}
} 
?>