<?php 

/*
 * Class for with product items and it photos
 *
 * @package EjoshopViewPhotos
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
ejoshopimport('ejoshop.render.rendermap');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.render.renderjquery');
ejoshopimport('ejoshop.fields.fields');
JLoader::register('EjoshopView', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'views'.DS.'view.php');

/**
 * Class for with product items and it photos
 *
 * @package EjoshopViewPhotos  
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

class EjoshopViewPhotos extends EjoshopView { 

	var $_id;
	function __construct($id = null)
	{
		$this->_id = $id;
		
	}
	/**
	 * 
	 * возвращает список других товаров из #__ejoshop_shop_order, приобретённых вместе
	 * с просматриваемым товаром
	 */

	function displayconfig($tpl = null)
	{
		$app = JFactory::getApplication(); 


		$document = JFactory::getDocument();
		$tmpl = array();

		$this->params = $app->getParams();
		$this->photo = $this->getPhotos();
		if(!$this->photo) return '';
		$params = JComponentHelper::getParams('com_ejoshop');
		$this->photo = $this->photo[0];
		
		$this->photo = $this->processItems($this->photo,0,$params);
		$c = json_decode($this->photo->color);

	
				
		$this->photo->allimg = '';
		if(!empty($c)) {
			foreach($c as $color) {
				$this->photo->allimg .= JHTML::_('image', JURI::root(true).'/media/com_ejoshop/assets/color/'.$color.'.jpg','','style="width:19px; height:20px; margin: 0px 0 -5px 2px;"');
			}
		}
		

		$tplphoto = $this->photo->tplonephoto;
		if(empty($tplphoto)) $tplphoto = 'photo1';
		$this->setLayout($tplphoto);
		
		

		if(empty($this->photo->name)) $this->photo->name = $this->photo->category_name;

		if(empty($this->photo->description) && !empty($this->photo->catdescription)) $this->photo->description = $this->photo->catdescription;
		if(empty($this->photo->keywords)  && !empty($this->photo->catdescription)) $this->photo->keywords = $this->photo->catdescription;

		
		if($this->photo->showmap) {
			$this->map = new EjoshopRenderMap();
			$this->htmlmap=$this->map->createMap($this->photo->id,$this->photo->maptype,$this->photo->latitude.','.$this->photo->longitude);
		}
		
		
		$jsite	= new JSite();
		$menus 	= $jsite->getMenu();
		$menu	= $menus->getActive();
		
		$this->addTemplatePath( "components".DS."com_ejoshop".DS."views".DS."detail".DS."tmpl" );
		$this->photo->price_with_currency = preg_replace('@([a-z0-9]+)\$@si','\\1', $this->photo->price_with_currency);		
		$t = $this->loadTemplate();
		return $t;
		//return parent::display($tpl);
	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPhotos($catid = 0)
	{
		if(empty($catid)) {
			$catid = JRequest::getVar('id', 0, '', 'int');
		}
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select('photos.*');
		

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name,cat.id as category_id,cat.alias as catalias,fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		
		// Add the list ordering clause.
		$orderCol	= 'photos.id';
		$orderDirn	= 'DESC';

		if(isset($this->_id)) {
	
			$query->where('photos.id = '.(int) $this->_id.' AND photos.state = 1');
		}
		
	
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->photos = $db->loadObjectList();

		return $this->photos;

	}



	function processItems($item,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');

		$FieldsClass = new EjoshopFields();
		
		$auto_convert_currency = $params->get('convert_currency');
		$defcurrency = $params->get('currency');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		$item->currency = ($item->currency == -1) ? $defcurrency : $item->currency;
		

		
		if($item->currency != $sitecuurecny && $auto_convert_currency) {
		
			$item->price = $CurencyClass->currency(strtoupper($item->currency),strtoupper($sitecuurecny),$item->price);
		
		} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */
				
			$item->price = $CurencyClass->getValue($item->price,$item->currency);
						
		} else if($items->currency == $sitecuurecny && $auto_convert_currency){
			$item->price = $CurencyClass->currency(strtoupper($item->currency),strtoupper($sitecuurecny),$item->price);
		}


		if($auto_convert_currency && !$exloadIntl)  {
			$item->price_with_currency = $CurencyClass->getCurrencyName($sitecuurecny,$item->price);
		} else if(!$auto_convert_currency && !$exloadIntl) {
			$item->price_with_currency = $CurencyClass->getCurrencyName($item->currency,$item->price);
		} else {
			$item->price_with_currency = $item->price; // за нас всё сделал NumberFormatter
		}		
	
		$item = $this->getPhotooutput($item);
		$item = $this->getOtherPhoto($item);
		/* add fields */
		if($this->params) {
			if($this->params->get('fields_show')) {
				$item = $FieldsClass->getAllFields($item);
			}
		}
	
		$item->price_with_currency =  str_replace('$','\$',$item->price_with_currency);
		return $item; 
	}
	
	
	/*
	 * Pperforming data (photo, price, currency) to outout
	 *
	 */

	 function processAllItems ($items,$sub = false,$params){
		if(!$items) return false;
		
		$CurencyClass = new EjoshopRenderCurrency();
		$cart = new EjoshopRenderCart();
		$auto_convert_currency = $params->get('convert_currency');
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecurrency = $CurencyClass->getCurrencyAbbr();
		} 
		/* if vaailable only one currency */
		$site_available_currencies = $CurencyClass->getAvailableCurrencies();
		if(count($site_available_currencies) == 1) {
	
			$_SESSION['usercurrency'] = $site_available_currencies[0]['currency_code'];
			$sitecurrency = $_SESSION['usercurrency'];
		}
		
		if(!empty($_SESSION['usercurrency'])) {
			$sitecurrency = $_SESSION['usercurrency'];
			$auto_convert_currency = true;
			// Anet accept only USD
			if($this->task == 'anet') {
				$_SESSION['anetusercurrency'] = $_SESSION['usercurrency'];
				$sitecurrency = $_SESSION['usercurrency'] = 'USD';
				
			}
		} else { // default currency settings
			$sitecurrency = $params->get('currency');
		}
	

		
		/* глобальные настройки если не указны отдельные настройки */
						
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecurrency);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {

					$items[$i]->currencyl = '';
				}

				$items[$i]->decimalprice = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price,false);
				
				/* валюта продукта не соответсвует валюте польователя и включена опция авконвертирования */
				if($items[$i]->currency != $sitecurrency && $auto_convert_currency) {


					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */

					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecurrency && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
				}

			
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_(JURI::base().'index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_(JURI::base().'index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}

			$items[$i]->photoproduct = $cart->getImageForCartItems($items[$i]);
		}	
		return $items; 
	}
	
	
	/** 
	 * Process photo for product 
	 *
	 * @return object item product with new variable photooutput
	 *
	 */
		
	function getPhotooutput($item, $onlyimage = false) {

		$uri = $item->uri;
		$path = JURI::root(true).$uri;
		$path_parts = pathinfo($path.$item->filename);
		$thumb_s = $path_parts['filename'].'_s.'.$path_parts['extension'];
		$op = $item->sizethumb;
		
		$newfileimgsrc = $path.'_s.png';
	
		if(!empty($op)) {
		
			$thumb = $path.$op;
		} else {
			$thumb = $path.$thumb_s;
		}
		
		$imgsrc = $path.$item->filename;
		$a = '';
		$aend = '';
		if(!$onlyimage) {
			$a = '<a rel="colorbox" href="'.$imgsrc.'">';
			$aend = '</a>';
		}
		/* detail photo */
		
		if(is_file(JPATH_ROOT.DS.$uri.$op)) {
			$item->photooutput = $a . '<img src="'.$thumb.'">' . $aend;
		/* thumb photo */	
		} else if(is_file(JPATH_ROOT.DS.$uri.$thumb_s)) { 
			$item->photooutput = $a . '<img src="'.$thumb.'">' . $aend;
		/* no photo */	
		} else {
			$item->photooutput = $a . '<img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png">' . $aend;
		}
		
		return $item;
	}

	function getOtherPhoto($p) {
		JModelLegacy::addIncludePath(JPATH_ROOT . '/components/com_ejoshop/models');
		$model = JModelLegacy::getInstance('Detail', 'EjoshopModel');
	
		$OtherPhotos = $model->getOtherPhotos($p->id);
		//EjoshopDeveloper::debugPrint($OtherPhotos);
		if($OtherPhotos) {
		foreach($OtherPhotos as $item) {
			
			$uri = $item->uri;
			$path = JURI::root(false).substr($uri,1);
			$path_parts = pathinfo(JPATH_ROOT.DS.$uri.$item->filename);
			$thumb_s = $path_parts['filename'].'_s.'.$path_parts['extension'];
			
			
			$newfileimgsrc = $path.'_s.png';
	
			$thumb = $path.$thumb_s;
				
			$item->morephoto = '';
			$imgsrc = $path.$item->filename;
			/* detail photo */
			if(is_file(JPATH_ROOT.DS.$uri.$thumb_s)) { 
				$p->morephoto .= '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
			/* no photo */	
			} else {
				$p->morephoto .= '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a>';
			}
		}
		}
		
		return $p;
	}
	
} 
?>