<?php
/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 *
 * @package Render  
 * @subpackage EjoshopRenderAdmin
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

class EjoshopRenderAdmin
{
	public function renderExternalLink($extLink) {
	
		$extLinkArray	= explode("|", $extLink, 4);
		if (!isset($extLinkArray[0])) {$extLinkArray[0] = '';}
		if (!isset($extLinkArray[1])) {$extLinkArray[1] = '';}
		if (!isset($extLinkArray[2])) {$extLinkArray[2] = '_self';}
		if (!isset($extLinkArray[3])) {$extLinkArray[3] = 1;}
	
		return $extLinkArray;
	}
	
	public  function quickIconButton( $link, $image, $text ) {
		
		$lang	= JFactory::getLanguage();
		$button = '';
		if ($lang->isRTL()) {
			$button .= '<div class="icons-wrapper">';
		} else {
			$button .= '<div class="icons-wrapper">';
		}
		
		$button .=	'<div class="icon">'
				   .'<a href="'.$link.'">'
				   .JHTML::_('image', 'media/com_ejoshop/assets/images/'.$image, $text )
				   .'<span>'.$text.'</span></a>'
				   .'</div>';
		$button .= '</div>';

		return $button;
	}
	
	

	
	function CategoryTreeOption($data, $tree, $id=0, $text='', $currentId) {		
	
		foreach ($data as $key) {	
			$show_text =  $text . $key->text;
			
			if ($key->parentid == $id && $currentId != $id && $currentId != $key->value) {
				$tree[$key->value] 			= new JObject();
				$tree[$key->value]->text 	= $show_text;
				$tree[$key->value]->value 	= $key->value;
				$tree = EjoshopRenderAdmin::CategoryTreeOption($data, $tree, $key->value, $show_text . " - ", $currentId );	
			}	
		}
		
		return($tree);
	}
	
	public function approved( &$row, $i, $imgY = 'tick.png', $imgX = 'publish_x.png', $prefix='' )
	{
		$img 	= $row->approved ? $imgY : $imgX;
		$task 	= $row->approved ? 'disapprove' : 'approve';
		$alt 	= $row->approved ? JText::_( 'COM_EJOSHOPAPPROVED' ) : JText::_( 'COM_EJOSHOPNOT_APPROVED' );
		$action = $row->approved ? JText::_( 'COM_EJOSHOPNOT_APPROVE_ITEM' ) : JText::_( 'COM_EJOSHOPAPPROVE_ITEM' );

		$href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $prefix.$task .'\')" title="'. $action .'">
		<img src="images/'. $img .'" border="0" alt="'. $alt .'" /></a>'
		;

		return $href;
	}
	public function renderIeCssLink($cond = 0) {
		
		$condOutput = '[if IE]';
		
		switch ($cond) {
			case 1:
			$condOutput = '[if lt IE 8]';
			break;
			
			case 0:
			default:
			$condOutput = '[if IE]';
		}
		
		return " <!--".$condOutput.">\n"
			 ." <link rel=\"stylesheet\" href=\"".JURI::root(true)."/media/com_ejoshop/assets/ejoshopie.css\" type=\"text/css\" />\n"
			 ." <![endif]-->\n";
	}
}
?>