<?php
/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Class with functions for work with cart data
 *
 * @package Render  
 * @subpackage EjoshopRenderCart
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

class EjoshopRenderCart {

	/**
	 * return list of cart items 
	 *
	 * @return return list of cart items
	 */

	function getCurrentUserCart()
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'pid' );
		}
		JError::$legacy = true;
		$user = JFactory::getUser(); // it's important to set the "0" otherwise your admin user information will be loaded

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);

		
				
		if($user->id > 0 && !empty($_SESSION['cartid']) && $user->id != $_SESSION['cartid']) {
			$userID = $user->id;
		} else {
		
			$userID = $_SESSION['cartid'];	
		}
	

		
				
		$query->select('uci.*');
		$query->from('`#__ejoshop_userinfo_cart` AS uci');
			

		if(isset($userID)) {

				$query->where("uci.uid = '".$userID."'");
			
		} else {
			return false;	
		}


		$query = $db->setQuery( $query );

		try {
				
			$result = $db->query();
		} catch(Exception $e) {
			print $e->getMessage();	
		}
		JError::$legacy = false;
		return $db->loadObject();
		
	}

	/**
	 * 
	 * @return возвращает список других товаров, приобретённых вместе
	 * с просматриваемым товаром
	 */
	 
	static function flushCart()
	{
		unset($_SESSION['cartid']);
		unset($_SESSION['cart']);
	}
	

	/**
	 * 
	 * @return возвращает список других товаров, приобретённых вместе
	 * с просматриваемым товаром
	 */
	 
	static function isCartEmpty()
	{

		return (count($_SESSION['cart']) == 0) ? true : false ;	

	}
		
	/*
	*
	* update user owner in cart
	*/
	function updatecartuser($type = 'login',$credentials = 0)
	{	
		JError::$legacy = false;
		$db	  = JFactory::getDBO();
		if($type != 'logout' && $type != 'login') {
			$user = JFactory::getUser(); 
		} else {
			$user = (object)$credentials; 
		}

		if($type == 'logout') {
			$_SESSION['cartid'] = $credentials['id'];
		} else {
			if($user->id > 0 && !empty($_SESSION['cartid']) && $user->id != $_SESSION['cartid']) {
					$userID = $user->id;
	
				/*$query = " SELECT * "
						. " FROM ".$db->quoteName('#__ejoshop_shop_order') ." WHERE created_by='".$userID."' AND TO_DAYS(NOW()) - TO_DAYS(created) > 1;";*/
				/*$query = " SELECT * "
						. " FROM ".$db->quoteName('#__ejoshop_shop_order') ." WHERE created_by='".$userID."';";		*/
						
				$query = "UPDATE ".$db->quoteName('#__ejoshop_shop_order') ." SET `created_by` = '".$userID."' WHERE created_by='".$_SESSION['cartid']."';";
				
				try {
					$query = $db->setQuery( $query );
					$db->query();
					$_SESSION['cartid'] = $userID;
				} catch (RuntimeException $e) {
					print $e->getMessage();	
				}
			}
			/*
			$this->useritemsid = $db->loadObject();
			$created = $this->useritemsid->created;
			$s = strtotime($created);
			var_dump($this->useritemsid);
			$strftime = strftime("%Y-%m-%d %H:%M:%S",$s);
			*/
		}
		}
		/**
		 * 
		 * возвращает список других товаров, приобретённых вместе
		 * с просматриваемым товаром
		 */
		 
		public function getImageForCartItems($item)
		{
			if(is_array($item)) {
				foreach($item as $key => $val) {
					$item[$key] = $this->imageProcess($val,true);
				}
				
			} else {
					$item = $this->imageProcess($item);
			}
			
			return $item;
		}

		
		
		/*
		* уведомляем о новом заказе
		* send email about new order
		*/
		public static function sendEmail() {

			$params = JComponentHelper::getParams('com_ejoshop');
			$send_email_after_buy = $params->get('send_email_after_buy',0);
			
			if(!$send_email_after_buy) return false;
			
			$bodyletter = $params->get('bodyletter','no');
			$recipient = $params->get('recipient','');
			$sender = $params->get('sender','');
	
			$mailer = JFactory::getMailer();
				
			if(!empty($recipient)) {
				
				$user = JFactory::getUser($recipient);
				
			} 
			if(!empty($sender)) {
				
				$sender_user = JFactory::getUser($sender);
				
			} 
			$recipient = $user->email;
			
			$mailer->setSender($sender_user->email);
			$recipient = (empty($recipient)) ? $_SERVER['SERVER_ADMIN'] : $recipient;
			
			$mailer->addRecipient($recipient);
			$mailer->setSubject(JTEXT::_('COM_EJ_YOU_HAVE_NEW_ORDER'));

			$body = '<h2>'.JTEXT::_('COM_EJ_YOU_HAVE_NEW_ORDER').'</h2>';
			$mailer->isHTML(true);
			$mailer->Encoding = 'base64';
			$mailer->setBody($body);
			

			
			$send = $mailer->Send();
			if ( $send !== true ) {
				//echo 'Error sending email: ' . $send->message;
			} else {
				//echo 'Mail sent'.$sender_user->email;
			}
		}
		
		
		public static function getCartCountWithText($title = '') {
			$item = new stdClass();
			$item->title = '';
			$all = array();
			$_SESSION['cart'] = empty($_SESSION['cart']) ? array() : $_SESSION['cart'];
			$i = 0;
			$cart = array();
			if(!empty($_SESSION['cart'])) {
			
				$cart = json_decode($_SESSION['cart']);
			} else {
				
			}
			if($cart) {
				foreach($cart as $val) {
					++$i;
						$all[] = $val;
			
					
				}
			} else {
				$all = array();
			}	
			
			$c = count(array_unique($all));
			
			switch($c) {
				case 1:
				$t = JText::_('COM_EJ_CART_T');
				break;
				case in_array($c,array(2,3,4)):
				$t = JText::_('COM_EJ_CART_TRUS');
				break;
				case $c > 1:
				$t = JText::_('COM_EJ_CART_TS');
				break;
			}
			
			if($c) {
				$item->title = JText::_('COM_EJ_CART_S');
				$item->title = $item->title . ' ('.$c.' '.JText::_('COM_EJ_CART_ITEM').''.$t.')';					
			} else {
					$item->title = JText::_('COM_EJ_CART_WITHOUT_S');
					$item->title = $item->title . ' ('.JText::_('COM_EJ_CART_EMPTY').')';					
			}
			
			return $item->title;
		}
		
		
		public function imageProcess($item,$o = FALSE) {
		
					$path = JURI::root(true).$item->uri;
					$path_parts = pathinfo($path.$item->filename);
					$ext = $path_parts['extension'];
					
					$newfileimgsrc = $path.'_s.'.$ext;
					$thumb = $path.$path_parts['filename'].'_s.'.$ext;
					
					$imgsrc = $path.$item->filename;
					if(is_file(JPATH_ROOT.DS.$item->uri.$path_parts['filename'].'_s.'.$ext)) {
						$product = '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
					} else {
						$product = '<a rel="colorbox" href="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"><img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a>';
					}
					if($o) {
						$item->photoproduct = $product;	
						return $item;
					} else {
						return $product;	
					}
		}
		
		public function getTotalCostOfCartItems($withtax = FALSE) {
		
			require_once(__DIR__ . DS . 'rendercurrency.php');
			require_once(__DIR__ . DS . '../photos/viewphotos.php');
			require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS. 'models'.DS. 'model.php');
			EjoshopModel::addIncludePath(JPATH_SITE .DS.'components'.DS.'com_ejoshop'.DS.  'models');
			$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');
			$params		= JComponentHelper::getParams('com_ejoshop');
			$this->sumpriceItem = 0;
			$this->sumprice = 0;
			$checkcur = array();
			$this->cartitems = $model->getCartItem();

			if(!$this->cartitems) return false;
			
			$currency = new EjoshopRenderCurrency();

			$viewphoto = new EjoshopViewPhotos();
			$this->cartitems = $viewphoto->processAllItems($this->cartitems,false, $params);
			$isIntl = $currency->is_extension_loaded('intl'); /* used as default method to parse money value */
		
			if($isIntl) {
				$fmt = new NumberFormatter( $this->tag, NumberFormatter::DECIMAL );
			}	


			for($i = 0; $i < count($this->cartitems); $i++) {
				$checkcur[] = $this->cartitems[$i]->currency;

				if($isIntl) {
					
					$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * $this->cartitems[$i]->qty);	
					//$this->sumpriceItem += ($fmt->parse($this->cartitems[$i]->decimalprice) * $this->cartitems[$i]->qty);	
				} else {
					$this->cartitems[$i]->decimalprice = $currency->toInt($this->cartitems[$i]->decimalprice);
					$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * (int)$this->cartitems[$i]->qty);	
				}
			
				$this->sumprice = $this->sumpriceItem;
			}
		/* если все элементы корзины имеют одну валюту */
		if(count(array_unique($checkcur)) == 1 || !empty($_SESSION['usercurrency'])) {
			
			$defcur = $checkcur[0];
			
			if(!empty($_SESSION['usercurrency'])) {
				$defcur = $_SESSION['usercurrency'];
			} else {
				 $_SESSION['usercurrency'] = $defcur; 
			}
			
			$this->sumpricetoshow = $currency->getValue($this->sumprice,$defcur); // for user not to payment
			
			//ejoshopimport('ejoshop.developer.developer');
			//EjoshopDeveloper::debugPrint($this->cartitems);
			$this->currencylshow = $_SESSION['usercurrency'];
			
		
		} else {
			$this->selectcurrency = TRUE;
			$this->sumpricetoshow = '';
			$this->currencylshow = '';
		}

			if($withtax) {
				$price_to_show = $currency->getWithTax($this->sumpricetoshow);
			} else {
				$price_to_show = $this->sumpricetoshow;
			}
			return $price_to_show;
		}
		
	
} ?>