<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

/*
 * The Analytics class. 
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */


/**
 * Class using method for operations with currency 
 *
 * @package Render 
 * @subpackage EjoshopRenderCurrency
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */
 
class EjoshopRenderCurrency
{
		var $currencyCache = array();
		var $id      		= "euro";		// string ID related with the currency (ex : language)
		var $symbol    		= "&euro;";	// Printable symbol
		var $nbDecimal 		= 2;	// Number of decimals past colon (or other)
		var $decimal   		= ".";	// Decimal symbol ('.', ',', ...)
		var $thousands 		= ","; 	// Thousands separator ('', ' ', ',')
		var $positivePos	= 1;	// Currency symbol position with Positive values :
									// 0 = '00Symb'
									// 1 = '00 Symb'
									// 2 = 'Symb00'
									// 3 = 'Symb 00'
		var $negativePos	= 8;	// Currency symbol position with Negative values :
									// 0 = '(Symb00)'
									// 1 = '-Symb00'
									// 2 = 'Symb-00'
									// 3 = 'Symb00-'
									// 4 = '(00Symb)'
									// 5 = '-00Symb'
									// 6 = '00-Symb'
									// 7 = '00Symb-'
									// 8 = '-00 Symb'
									// 9 = '-Symb 00'
									// 10 = '00 Symb-'
									// 11 = 'Symb 00-'
									// 12 = 'Symb -00'
									// 13 = '00- Symb'
									// 14 = '(Symb 00)'
									// 15 = '(00 Symb)'
		var $tag;
		var $curl;
		var $exloadIntl = array();

	
   /**
	* Used for define view and Joomla language tag and language name
	*/
	
	function __construct() {
		$lang = JFactory::getLanguage();
		
		$this->curl = $lang->getName();
		$this->tag = $lang->getTag();
		
		$this->view =  JRequest::getVar('view', '');
		//$this->tag = 'ja_JP';
	}

	/**
	* Check extentions intl, json, curl
	* @param string $string A string that is contain name of extension
	* @return bool
	*/

	public function is_extension_loaded($string){
		
		//$this->exloadIntl['intl'] = 0;
		$this->exloadIntl['intl'] = extension_loaded($string);
		$this->exloadIntl['json'] = function_exists($string);
		$this->exloadIntl['curl'] = function_exists($string);

		return $this->exloadIntl[$string];
	}

   /**
	* Looks for unquoted keys in a json string and fixes them ie: {a:"b"} => {"a":"b"}
	* @param string $string A json string that is suspect
	* @return string A valid json string
	*/

	public function fix_json($string){

		// (no qupte) (word) (no quote) (semicolon)
		$regex = '/(?<!")([a-zA-Z0-9_]+)(?!")(?=:)/i';

		$s =  preg_replace($regex, '"$1"', $string);

		return $s;
	}
	
	/**
	* Return currency name in iso standart
	* @param  string $string
	* @return string
	*
	*/
	
	public function getSwitchNameCurrency($items,$price){
		
		if(!$price) $price = '';
		if($items < 0)  {
			$params = JComponentHelper::getParams('com_ejoshop') ;
			$items= $params->get('currency');
		}

		
		if($this->is_extension_loaded('intl')) {
			
			$formatter = new NumberFormatter($this->tag, NumberFormatter::CURRENCY);
			$currencyl = $formatter->getSymbol(NumberFormatter::INTL_CURRENCY_SYMBOL);
			//$currencyl = $formatter->formatCurrency(1234567.891234567890000, "RUR")."\n";
			return $currencyl;
			
		} else {

			
			$bc = substr($items,0,2); // Set this to your country
			
			$currency_before = '';
			$currency_after = '';
			
			if( $bc == 'GB' || $bc == 'IE' || $bc == 'CY' ) $currency_before = '&pound;';
			if( $bc == 'AT' || $bc == 'BE' || $bc == 'FI' || $bc == 'FR' ||
			$bc == 'DE' || $bc == 'GR' || $bc == 'GP' || $bc == 'IT' ||
			$bc == 'LU' || $bc == 'NL' || $bc == 'PT' || $bc == 'SI' ||
			$bc == 'ES' || $bc == 'EU') $currency_before = '&euro;';
			if( $bc == 'BR' ) $currency_before = 'R$';
			if( $bc == 'CN' || $bc == 'JP' ) $currency_before = '&yen;';
			if( $bc == 'CR' ) $currency_before = '&cent;';
			if( $bc == 'HR' ) $currency_after = ' kn';
			if( $bc == 'CZ' ) $currency_after = ' kc';
			if( $bc == 'DK' ) $currency_before = 'DKK ';
			if( $bc == 'EE' ) $currency_after = ' EEK';
			if( $bc == 'HK' ) $currency_before = 'HK$';
			if( $bc == 'HU' ) $currency_after = ' Ft';
			if( $bc == 'IS' || $bc == 'SE' ) $currency_after = ' kr';
			if( $bc == 'IN' ) $currency_before = 'Rs. ';
			if( $bc == 'ID' ) $currency_before = 'Rp. ';
			if( $bc == 'IL' ) $currency_after = ' NIS';
			if( $bc == 'LV' ) $currency_before = 'Ls ';
			if( $bc == 'LT' ) $currency_after = ' Lt';
			if( $bc == 'MY' ) $currency_before = 'RM';
			if( $bc == 'MT' ) $currency_before = 'Lm';
			if( $bc == 'NO' ) $currency_before = 'kr ';
			if( $bc == 'PH' ) $currency_before = 'PHP';
			if( $bc == 'PL' ) $currency_after = ' z';
			if( $bc == 'RO' ) $currency_after = ' lei';
			if( $bc == 'RU' ) $currency_before = JText::_( 'COM_EJOSHOP_RUBLES_M' );
			if( $bc == 'SK' ) $currency_after = ' Sk';
			if( $bc == 'ZA' ) $currency_before = 'R ';
			if( $bc == 'KR' ) $currency_before = 'W';
			if( $bc == 'CH' ) $currency_before = 'SFr. ';
			if( $bc == 'SY' ) $currency_after = ' SYP';
			if( $bc == 'TH' ) $currency_after = ' Bt';
			if( $bc == 'TT' ) $currency_before = 'TT$';
			if( $bc == 'TR' ) $currency_after = ' TL';
			if( $bc == 'AE' ) $currency_before = 'Dhs. ';
			if( $bc == 'VE' ) $currency_before = 'Bs. ';
			if( $bc == 'UA' ) $currency_after = ' UAH';
			 
			if( $currency_before == '' && $currency_after == '' ) $currency_before = '$';
			
			return $currency_before . $price . $currency_after;
			
			/*
			switch($items) {
				case 'rub':
				$currencyl = $price . ' ' . JText::_( 'COM_EJOSHOP_RUBLES_M' );
				break;
				case 'usd':
				$currencyl = JText::_( 'COM_EJOSHOP_DOLLARS' ) . $price;
				break;
				case 'eur':
				$currencyl = $price . ' ' . JText::_( 'COM_EJOSHOP_EURO' );
				break;
				case 'gbp':
				$currencyl = $price . ' ' .JText::_( 'COM_EJOSHOP_GBP' );
				break;
				case 'cny':
				$currencyl = $price . ' ' .JText::_( 'COM_EJOSHOP_CHINESE' );
				break;
				case 'jpy':
				$currencyl = $price . ' ' . JText::_( 'COM_EJOSHOP_JPY' );
				break;
				default:
				$currencyl = $price;				
				break;
			}		
			*/
		}
		
	}
	
	
   /**
	* Get currrency name
	* @param  string $string
	* @param  string $price
	* @return mixed
	*/
	
	public function getCurrencyName($items,$price = false){
			
		/*
		$params = JComponentHelper::getParams('com_ejoshop') ;
		$auto_convert_currency = $params->get('convert_currency');
		var_dump($auto_convert_currency);
		if($auto_convert_currency)  {
				
		}
		*/
		

		
		if(is_array($items)) {
			foreach($items as $key => $item) {
				$items[$key]->currency = $this->getSwitchNameCurrency($item->currency,$price);
			}
		
		} else {
			$items = $this->getSwitchNameCurrency($items,$price);
		}
			return $items;

	}
	

   /**
	* Determine currency code from Joomla localization
	* @return string
	*/
	
	public function getCurrencyAbbr(){
	


		
		if($this->is_extension_loaded('intl')) {
			$formatter = new NumberFormatter($this->tag, NumberFormatter::CURRENCY);
			$currency = $formatter->getTextAttribute(NumberFormatter::CURRENCY_CODE);
			//echo $formatter->formatCurrency(123456789, 'JPY');
			
			//$s = $formatter->getSymbol(NumberFormatter::INTL_CURRENCY_SYMBOL); // got USD 
			
			//var_dump($currency);
			return $currency;
		}
		$languages = array('Russian','English (United Kingdom)','English (USA)','Ukraina','Українська','Chinese Traditional','Japan','German','Italy');
			//English (United Kingdom) 
			//Russian
			//English (USA) 
			//Українська (Україна) 
			
		foreach($languages as $lng) {

			$pos = strpos($this->curl,$lng);
	
				if ($pos === false) {

				} else {
							
					$lng = $lng;
						
					break;
				}
		}	
		if(!empty($lng)) {
			if(strpos($lng,'USA') !== false) {
				$currency = 'USD';
			} else if(strpos($lng,'United') !== false) {
				$currency = 'GBP';
			} else if(strpos($lng,'Russian') !== false) {
				$currency = 'RUB';
			} else if(strpos($lng,'Українська') !== false) {
				$currency = 'UAH';
			} else if(strpos($lng,'Chinese') !== false) {
				$currency = 'CNY';
			} else if(strpos($lng,'Russian') !== false) {
				$currency = 'RUB';
			} else if(strpos($lng,'German') !== false) {
				$currency = 'EUR';
			} else if(strpos($lng,'Japan') !== false) {
				$currency = 'JPY';
			} else if(strpos($lng,'Indian') !== false) {
				$currency = 'INR';
			} else if(strpos($lng,'Italy') !== false) {
				$currency = 'EUR';
			} else if(strpos($lng,'Spain') !== false) {
				$currency = 'EUR';
			} else {
				$currency = 'USD';
			}
			
		}			
		return $currency;
	}
 
	/**
	* Change one currency into another using different currency convertor
	* @param string $fromCurrency The currency you are starting with
	* @param string $toCurrency The currency you want to calculate
	* @param float $amount The amount of money you want to check
	* @param bool $useformater Force to use NumberFormatter class
	* @return float The amount in a new currency
	*/
	
	function currency($fromCurrency,$toCurrency,$amount,$useformater = true) {
		//var_dump($fromCurrency,$toCurrency,$amount);
		if(!$toCurrency) {
			$toCurrency = $this->getCurrencyName($this->curl);
		}
		$params = JComponentHelper::getParams('com_ejoshop') ;
		$convert_api= $params->get('convert_api','yahoo');
		$xchangekey = $params->get('xchangeonline_key','');

			
		$key = $fromCurrency.'-'.$toCurrency;
		$devmode = $params->get('developer_mode',0);
		if($devmode) {
			ejoshopimport('ejoshop.developer.developer');
		
		}

		$rawdata = true;
		if ( !array_key_exists($key, $this->currencyCache) && $fromCurrency != $toCurrency ) {
					
				if($convert_api == 'xchangeonline')  {
					$rawdata = $this->getXchangeonlineFinanceConvertor($fromCurrency,$toCurrency,$amount,$xchangekey);
					
				}

				if($convert_api == 'yahoo')  {
			
					$rawdata = $this->getYahooFinanceConvertor($fromCurrency,$toCurrency,$amount);
					if($devmode) {
						EjoshopDeveloper::debugPrint('Using YahooFinance Convertor!');
						
					}
				}


				if($convert_api == 'ecb' || empty($rawdata))  {
	

					if($devmode) {
						EjoshopDeveloper::debugPrint('YahooFinance Convertor very slowly. Using ECB Convertor!');
					}
		
					if($fromCurrency != 'EUR') {
						$fixfromCurrency = 	$this->getECBFinanceConvertor('EUR',$fromCurrency,1,$json = false);
						$fixtoCurrency = 	($toCurrency != 'EUR') ? $this->getECBFinanceConvertor('EUR',$toCurrency,1,$json = false) : 1;
				
						$rawdata = json_encode(array('rhs' => $fixtoCurrency / $fixfromCurrency));
				
					} else {
						
						$rawdata = 	$this->getECBFinanceConvertor($fromCurrency,$toCurrency,$amount);
					}
				}
				
				/* Webservicex */
				if(!$rawdata)  {
					if($devmode) {
						EjoshopDeveloper::debugPrint('Using WebservicexConvertor Convertor!');
						
					}
					$rawdata = $this->getWebservicexConvertor($fromCurrency,$toCurrency,$amount);
				}

			
				//since google is returning invalid json, add the quotes back in
			
				$data = $this->fix_json($rawdata);
				$data = json_decode($data, true);
				
				if(!$rawdata)  {
					
					$this->currencyCache[$key] = $amount;
					$app = JFactory::getApplication(); 
					$app->enqueueMessage(JText::_('COM_CURRENCY_SERVICE_ERROR'), 'error');
				} else {
					$this->currencyCache[$key] = $data['rhs'];
				}
		}
		/* if value euqals, we do not want convert it*/
		if($fromCurrency == $toCurrency ) {
			$this->currencyCache[$key] = 1;
		}
	
		
		$round = round($amount * $this->currencyCache[$key], 2);
	
		if(!$useformater) return $round;
		if($this->is_extension_loaded('intl')) {
	
			$formatter = new NumberFormatter($this->tag, NumberFormatter::CURRENCY);
			$currency = $formatter->getTextAttribute(NumberFormatter::CURRENCY_CODE);
			
			if(!empty($_SESSION['usercurrency']) && $this->view == 'cart') $currency = $_SESSION['usercurrency'];
			if(!$rawdata)  {
		
				$currency = $fromCurrency;
				$_SESSION['usercurrency'] = $fromCurrency;
				
			}
			$p = $formatter->formatCurrency($round, $currency);
			
			//$s = $formatter->getSymbol(NumberFormatter::INTL_CURRENCY_SYMBOL); // got USD 
			
			$endprice = $p;
		} else {
			
			$endprice = $this->getValue($round);
		
		 }
		return $endprice;
	}

	/**
	* Change one currency into another using ECB finance convertor
	* @param string $fromCurrency The currency you are starting with
	* @param string $toCurrency The currency you want to calculate
	* @param float $amount The amount of money you want to check
	* @param bool $json Set format json of returned data
	* @return float The amount in a new currency
	*/
		
	function getECBFinanceConvertor($fromCurrency,$toCurrency,$amount,$json = true) {

		//This is a PHP(4/5) script example on how eurofxref-daily.xml can be parsed
		//Read eurofxref-daily.xml file in memory 
		//For this command you will need the config option allow_url_fopen=On (default)
		$XMLContent = @file("http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml");
		//the file is updated daily between 2.15 p.m. and 3.00 p.m. CET
		$XMLContent = (empty($XMLContent)) ? array() : $XMLContent;	
		foreach($XMLContent as $line){
			
			if(preg_match("/currency='($toCurrency)'/",$line,$cur)){
				if(preg_match("/rate='([[:graph:]]+)'/",$line,$rate)){
					//Output the value of 1EUR for a currency code
					if($json) {
						return json_encode(array('rhs'=>$rate[1]));
					} else {
						return $rate[1];
					}
					//--------------------------------------------------
					//Here you can add your code for inserting
					//$rate[1] and $currencyCode[1] into your database
					//--------------------------------------------------
				}
			}
		}
	}
	
	/**
	* Change one currency into another using Xchangeonline finance convertor
	* @param string $fromCurrency The currency you are starting with
	* @param string $toCurrency The currency you want to calculate
	* @param float $amount The amount of money you want to check
	* @param string $apikey Api key
	* @return float The amount in a new currency
	*/
	
	function getXchangeonlineFinanceConvertor($fromCurrency,$toCurrency,$amount,$apikey = '') {
	
		$amount = urlencode($amount);
		$fromCurrency = urlencode($fromCurrency);
		$toCurrency = urlencode($toCurrency);
	
		$url    = "http://www.xchangeonline.com/convert/$amount/$fromCurrency/$toCurrency/$apikey/";
	
		$ch = curl_init();
		$timeout = 3;
		curl_setopt ($ch, CURLOPT_URL, $url);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT , "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1)");
		curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$rawdata = curl_exec($ch);

		// Проверяем наличие ошибок
		if(!curl_errno($ch))
		{
		 $info = curl_getinfo($ch);
	
			if($info['http_code'] == 302 || $info['http_code'] == 404 || $info['http_code'] == 403 || $rawdata == -2) {
				return $this->getYahooFinanceConvertor($fromCurrency,$toCurrency,$amount);
			}
		}
		
		curl_close($ch);
		if(!empty($rawdata)) return json_encode(array('rhs'=>$rawdata));
		
	}

	/**
	* Change one currency into another using Webservicex finance convertor
	* @param string $fromCurrency The currency you are starting with
	* @param string $toCurrency The currency you want to calculate
	* @param float $amount The amount of money you want to check
	* @return float The amount in a new currency
	*/
	
	function getWebservicexConvertor($fromCurrency,$toCurrency,$amount) {
	
		$amount = urlencode($amount);
		$fromCurrency = urlencode($fromCurrency);
		$toCurrency = urlencode($toCurrency);
		$url = 'http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency=' . $fromCurrency . '&ToCurrency=' . $toCurrency;
		
		
	
		$ch = curl_init();
		$timeout = 0;
		curl_setopt ($ch, CURLOPT_URL, $url);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT , "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1)");
		$params = JComponentHelper::getParams('com_ejoshop') ;
	
		if($params->curlopt_connecttimeout) {
				curl_setopt($curl, CURLOPT_CONNECTTIMEOUT ,10); 
				curl_setopt($curl, CURLOPT_TIMEOUT, 60); //timeout in seconds
		}
		
		$rawdata = curl_exec($ch);
		
		// Проверяем наличие ошибок
		if(!curl_errno($ch))
		{
		 $info = curl_getinfo($ch);
		
			if($info['http_code'] == 302 || $info['http_code'] == 404 || $info['http_code'] == 403) {
				return $this->getYahooFinanceConvertor($fromCurrency,$toCurrency,$amount);
			}
		}
		curl_close($ch);
	
		if($newrawdata[1])	return json_encode(array('rhs'=>$newrawdata[1]));
		
	}
	
	/**
	* Change one currency into another using Yahoo Finance Convertor finance convertor
	* all request using curl extention
	* @param string $fromCurrency The currency you are starting with
	* @param string $toCurrency The currency you want to calculate
	* @param float $amount The amount of money you want to check
	* @return float The amount in a new currency
	*/
	
	function getYahooFinanceConvertor($fromCurrency,$toCurrency,$amount) {
		
		$params = JComponentHelper::getParams('com_ejoshop');

		$curlopt_connecttimeout = $params->get('curlopt_connecttimeout',0);
		$fopen_or_curl = $params->get('fopen_or_curl', 0);
		$curlopt_connecttimeout_value = $params->get('curlopt_connecttimeout_value',3);
		
		if( ini_get('allow_url_fopen') && !$fopen_or_curl) {

			$url = "http://download.finance.yahoo.com/d/quotes.csv?s=".$fromCurrency.$toCurrency."=X&f=sl1d1t1n&e=.csv";
			if($f = @fopen($url, 'r')) {
			$data = fgetcsv($f);
				
			return json_encode(array('rhs'=>$data[1]));
			} else {
				return false;
			}
		} else {
			$url = "http://download.finance.yahoo.com/d/quotes.csv?s=".$fromCurrency.$toCurrency."=X&f=sl1d1t1n&e=.csv";
			$f = fopen('php://temp', 'w+');
			
			$curl = curl_init();
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_FILE, $f);

			
			
			if($curlopt_connecttimeout) {
				curl_setopt($curl, CURLOPT_CONNECTTIMEOUT ,$curlopt_connecttimeout_value); 
				curl_setopt($curl, CURLOPT_TIMEOUT, $curlopt_connecttimeout_value); //timeout in seconds
			}
			
			curl_exec($curl);
			curl_close($curl);

			rewind($f);

			$line = fgetcsv($f);
			fclose($f);
			if(!empty($line[1])) {
				return json_encode(array('rhs'=>$line[1]));
			} else {
				return false;
			}
		}	
	
	
	}		

	/**
	* Replace comma to dot, and remove all not numeric symbols (0-9) 
	* @param string $str The currency you are starting with
	* @return float The amount in a new currency
	*/
	
	public function toInt($str)
	{
		$str = preg_replace("/,/i", ".", $str);
		
		$str = preg_replace("/[^0-9\.]/i", "", $str);
	
        return (float)$str;
	}
	
	/**
	* @param Currency to display
	* @return
	*/
	
	public function CurrencyDisplay(	$id			="euro",
								$symbol		="&euro;",
								$nbDecimal	= 2,
								$decimal   	= ",",
								$thousands 	= " ",
								$positivePos= 1,
								$negativePos= 8){
		$this->id		 = $id;
		$this->symbol    = $symbol;
		$this->nbDecimal = $nbDecimal;
		$this->decimal   = $decimal;
		$this->thousands = $thousands;
		$this->positivePos = $positivePos;
		$this->negativePos = $negativePos;
	}

	/**
	* Return currency symbol 
	* @return string Return currency symbol
	*/
	
	public function getSymbol(){
		return($this->symbol);
	}


	/**
	* Return id
	* @return id The id
	*/
	
	public function getId(){
		return($this->id);
	}
	
	
	/**
	* Return currency that was formatted with NumberFormatter if NumberFormatter available
	* @param string $nb The currency
	* @param string $defaultcurrency The default currency of user in $_SESSION
	* @return string The amount in a new currency
	*/
	
	public function getValue($nb,$defaultcurrency = false){
		
		/*
		$req     = $this->tag;
		$fmt     = numfmt_create( $req,  NumberFormatter::DECIMAL);
		$res_val = numfmt_get_locale( $fmt, Locale::VALID_LOCALE );
		$res_act = numfmt_get_locale( $fmt, Locale::ACTUAL_LOCALE );
		printf( "Requested locale name: %s\nValid locale name: %s\nActual locale name: %s\n",
         $req, $res_val, $res_act );		
		 */
		if($this->is_extension_loaded('intl')) {
			//$this->tag = 'en-US';
			$this->tag = str_replace('-','_',$this->tag);
			
			$formatter = new NumberFormatter($this->tag, NumberFormatter::CURRENCY);
			$currency = $formatter->getLocale(Locale::VALID_LOCALE);
			$currency = (!empty($defaultcurrency)) ? $defaultcurrency : $formatter->getTextAttribute(NumberFormatter::CURRENCY_CODE);
	
			$p = $formatter->formatCurrency($nb, $currency);

			
				/*
				$f = new NumberFormatter("en", NumberFormatter::SPELLOUT);
				echo $f->format($nb);
				*/

			$res = $p;
		} else {
		
				$res = "";		
				// Warning ! number_format function performs implicit rounding
				// Rounding is not handled in this DISPLAY class
				// that's why you have to use the right decimal value.
				// Workaround :number_format accepts either 1, 2 or 4 parameters.
				// this cause problem when no thousands separator is given : in this
				// case, an unwanted ',' is displayed.
				// That's why we have to do the work ourserlve.
				// Note : when no decimal il given (i.e. 3 parameters), everything works fine
				if ($this->thousands != ''){
			
					$res=number_format($nb,$this->nbDecimal,$this->decimal,$this->thousands);
					
				} else {
					// If decimal is equal to defaut thousand separator, apply a trick
					if ($this->decimal==','){
						$res=number_format($nb,$this->nbDecimal,$this->decimal,'|');
						$res=str_replace('|','',$res);			
					} else {
						// Else a simple substitution is enough
						$res=number_format($nb,$this->nbDecimal,$this->decimal,$this->thousands);
						$res=str_replace(',','',$res);
					}
				}
			}
		
			return($res);
		}

	/**
	* Return currency that was formatted with NumberFormatter if NumberFormatter available
	* @param string $nb The currency
	* @return float The amount in a new currency
	*/
	
	public function getFullValue($nb){
	
		if($this->is_extension_loaded('intl')) {

			$formatter = new NumberFormatter($tag, NumberFormatter::CURRENCY);
			$currencyl = $formatter->getSymbol(NumberFormatter::INTL_CURRENCY_SYMBOL);
			//$currencyl = $formatter->formatCurrency(1234567.891234567890000, "RUR")."\n";
			return $currencyl;
			
		} else {
			$res = "";
			// Currency symbol position
			if ($nb == abs($nb)){
				$res=$this->getValue($nb);
				// Positive number
				switch ($this->positivePos){
				case 0:
					// 0 = '00Symb'
					$res=$res.$this->symbol;
				break;
				case 2:
					// 2 = 'Symb00'
					$res=$this->symbol.$res;
				break;
				case 3:
					// 3 = 'Symb 00'
					$res=$this->symbol.' '.$res;
				break;
				case 1:
				default :
					// 1 = '00 Symb'
					$res=$res.' '.$this->symbol;
				break;
				}
			} else {
				// Negative number
				$res=$this->getValue(abs($nb));
				switch ($this->negativePos){
				case 0:
					// 0 = '(Symb00)'
					$res='('.$this->symbol.$res.')';
				break;
				case 1:
					// 1 = '-Symb00'
					$res='-'.$this->symbol.$res;
				break;
				case 2:
					// 2 = 'Symb-00'
					$res=$this->symbol.'-'.$res;
				break;
				case 3:
					// 3 = 'Symb00-'
					$res=$this->symbol.$res.'-';
				break;
				case 4:
					// 4 = '(00Symb)'
					$res='('.$res.$this->symbol.')';
				break;
				case 5:
					// 5 = '-00Symb'
					$res='-'.$res.$this->symbol;
				break;
				case 6:
					// 6 = '00-Symb'
					$res=$res.'-'.$this->symbol;
				break;
				case 7:
					// 7 = '00Symb-'
					$res=$res.$this->symbol.'-';
				break;
				case 9:
					// 9 = '-Symb 00'
					$res='-'.$this->symbol.' '.$res;
				break;
				case 10:
					// 10 = '00 Symb-'
					$res=$res.' '.$this->symbol.'-';
				break;
				case 11:
					// 11 = 'Symb 00-'
					$res=$this->symbol.' '.$res.'-';
				break;
				case 12:
					// 12 = 'Symb -00'
					$res=$this->symbol.' -'.$res;
				break;
				case 13:
					// 13 = '00- Symb'
					$res=$res.'- '.$this->symbol;
				break;
				case 14:
					// 14 = '(Symb 00)'
					$res='('.$this->symbol.' '.$res.')';
				break;
				case 15:
					// 15 = '(00 Symb)'
					$res='('.$res.' '.$this->symbol.')';
				break;
				case 8:
				default :
					// 8 = '-00 Symb'
					$res='-'.$res.' '.$this->symbol;
				break;
				}
			}
			return($res);
		}
		
	}

	/**
	* Returns the description and original name of the payment system 
	* based on it system name stored in db
	* @param string $MoneySystem The system name
	* @return string Payment system description and name
	*/	
	
	public function getMoneySystem($MoneySystem) {
			switch($MoneySystem) {
				case 'paypal':
				$lng = 'PyPal Express Checkout';
				break;
				case 'webmoney':
				$lng = 'Webmoney';
				break;
				case 'yandexmoney':
				$lng = 'Yandex money';
				break;
				case 'anet':
				$lng = 'Authorize.net';
				break;
				default:
				$lng = '';
				break;
			}
			
			return $lng;
	}

	/**
	* Calculate amount with tax
	* @param int $price The price amount
	* @param int $catid The category id (not used yet)
	* @return int Amount with tax
	*/	
	
	public function getWithTax($price,$catid = FALSE) {
		$curprice = $price;
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select('tax.*');
		$query->from('`#__ejoshop_taxes` AS tax');
				
		// Add the list ordering clause.
		$orderCol	= 'tax.id';
		$orderDirn	= 'DESC';

		if(!empty($catid)) {
			$query->where('tax.catid = '.(int) $pid);
		}
		
		$return_price = 0;
		$query->order($db->escape($orderCol.' '.$orderDirn));
			
		$query = $db->setQuery( $query );
		$tax = $query->loadObjectList();
		foreach($tax as $t) {
				
			if($t->typetaxvalue  == 2) {
				$price = $price + $t->perc;
			} else {
				$price = $price + ($curprice / 100) * $t->perc;
			}
		}
		
		
		return $price;
	}
	
	/**
	 * Returns only tax amount without item price
	 *
	 * @param int  $amount Amount without tax
	 * @param int  $amountwithtax Amount with tax
	 * @return int $amountwtax only tax
	 */

	public function getTaxAmount($amount,$amountwithtax) {
		$amountwtax = $amountwithtax - $amount;

		return $amountwtax;
	}

	/**
	 * Returns total of taxes
	 *
	 * @return int number of taxes 
	 */
	 
	public function getAvailableCurrencies() {
		
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM '.$db->quoteName('#__ejoshop_currency').' AS c WHERE c.state =1;';
		$db->setQuery( $query );
		$currencies = $db->loadAssocList();
		return $currencies;
	}
	
	/**
	 * Returns total of taxes
	 *
	 * @return int number of taxes 
	 */
	 
	public function countTaxes() {
	
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select('COUNT(*) as total');
		$query->from('`#__ejoshop_taxes` AS tax');
		$query->where('state = 1');


			
		$query = $db->setQuery( $query );
		$tax = $query->loadResult();

		
		if($tax > 0) {
			return true;
		} else {
			return false;
		}
	}
}
?>