<?php
/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Class for render detail info
 *
 * @package Render  
 * @subpackage EjoshopRenderDetail
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

class EjoshopRenderDetail
{
	
    /**
     * Update product hit.
     * 
     * Required $pid
     *
     * @param int $pid The id of product
     *
     * @return bool
     */
	 
	function updateHit($pid)
	{	
		if (!$pid) return false;
		$db	  = JFactory::getDBO();
		$query = "UPDATE ".$db->quoteName('#__ejoshop_photos') ." SET `hits` = hits+1 WHERE id='".$pid."';";
				
		try {
			$query = $db->setQuery( $query );
			$db->query();
		} catch (RuntimeException $e) {
			print $e->getMessage();	
		}
		return true;
	}
	
	
	
    /**
     * Output proudct.
     * 
     * Required $pid
     *
     * @param int $pid The id of product
     *
     * @return bool
     */
	 
	function getProducts($payid = 0,$limit = 0, $module = false,$exclude_items)
	{

		if(empty($payid) && !$module) {
			$payid = JRequest::getVar( 'id' );
		}

	

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		
				
		$query->select('cat.title as category_name, cat.id as cid, p.*,p.id as pid,fm.*');
				

		$query->from('`#__ejoshop_photos` as p');

		$query->join('LEFT', '#__ejoshop_categories AS cat ON (p.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (fm.fid = p.filename)');		
		if(!empty($exclude_items)) {
			$noitems = explode(',',$exclude_items);
			if(is_array($noitems)) {
				$query->where('p.id NOT IN('.implode(',',$noitems).')');
			}
		}
		
		// Add the list ordering clause.
		//$orderCol	= $this->state->get('shoporders.ordering','shoporders.pid');
		//$orderDirn	= $this->state->get('shoporders.direction','DESC');

		
		$query->order($db->escape('pid DESC'));
		//$query->group('shoporders.payid');
		//var_dump($query->__toString());
		$query = $db->setQuery( $query, 0 ,$limit );
		
		try {
				
			if(!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch(Exception $e) {
			$app->enqueueMessage($e->getMessage(), 'error');
		}
		$this->photos = $db->loadObjectList();
		/*
		if (!$db->query()) {
			
			
			// Include the JLog class.
			jimport('joomla.log.log');
			
			// Add the logger.
			JLog::addLogger(
				 // Pass an array of configuration options
				array(
						// Set the name of the log file
						
						// (optional) you can change the directory
						'text_file' => 'com_ejoshop.log.php',
						JLog::ALL,
					   //Chooses a category name
		   				'com_ejoshop'
				 )
			);
			
			// start logging...
			
  			JLog::add($this->_db->getErrorMsg(), JLog::WARNING);
		
				return false;
		}
		*/

			
		return $this->photos;

	}

	
    /**
     * Output proudct.
     * 
     * Required $pid
     *
     * @param int $pid The id of product
     *
     * @return bool
     */
	 
	function getPopularProducts($payid = 0,$limit = 0, $module = false,$exclude_items)
	{

		if(empty($payid) && !$module) {
			$payid = JRequest::getVar( 'id' );
		}

	

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		
				
		$query->select('cat.title as category_name, cat.id as cid, p.*,p.id as pid,fm.*');
				

		$query->from('`#__ejoshop_photos` as p');

		$query->join('LEFT', '#__ejoshop_categories AS cat ON (p.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (fm.fid = p.filename)');

		if(!empty($exclude_items)) {
			$noitems = explode(',',$exclude_items);
			if(is_array($noitems)) {
				$query->where('p.id NOT IN('.implode(',',$noitems).')');
			}
		}
		$query->where('p.state = 1');
		// Add the list ordering clause.
		//$orderCol	= $this->state->get('shoporders.ordering','shoporders.pid');
		//$orderDirn	= $this->state->get('shoporders.direction','DESC');

		
		$query->order($db->escape('hits DESC'));
		//$query->group('shoporders.payid');
		//var_dump($query->__toString());
		$query = $db->setQuery( $query, 0 ,$limit );
		
		try {
				
			if(!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch(Exception $e) {
			$app->enqueueMessage($e->getMessage(), 'error');
		}
		$this->photos = $db->loadObjectList();
		/*
		if (!$db->query()) {
			
			
			// Include the JLog class.
			jimport('joomla.log.log');
			
			// Add the logger.
			JLog::addLogger(
				 // Pass an array of configuration options
				array(
						// Set the name of the log file
						
						// (optional) you can change the directory
						'text_file' => 'com_ejoshop.log.php',
						JLog::ALL,
					   //Chooses a category name
		   				'com_ejoshop'
				 )
			);
			
			// start logging...
			
  			JLog::add($this->_db->getErrorMsg(), JLog::WARNING);
		
				return false;
		}
		*/

			
		return $this->photos;

	}

    /**
     * Output proudct.
     * 
     * Required $pid
     *
     * @param int $pid The id of product
     *
     * @return bool
     */
	 
	function getPopularSlider($items)
	{

		if(empty($payid) && !$module) {
			$payid = JRequest::getVar( 'id' );
		}

	

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		
				
		$query->select('cat.title as category_name, cat.id as cid, p.*,p.id as pid,fm.*');
				

		$query->from('`#__ejoshop_photos` as p');

		$query->join('LEFT', '#__ejoshop_categories AS cat ON (p.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (fm.fid = p.filename)');
		$query->where('p.id IN('.implode(',',$items).')');
		$query->where('p.state = 1');
		// Add the list ordering clause.
		//$orderCol	= $this->state->get('shoporders.ordering','shoporders.pid');
		//$orderDirn	= $this->state->get('shoporders.direction','DESC');

		
		$query->order($db->escape('hits DESC'));
		//$query->group('shoporders.payid');
		//var_dump($query->__toString());
		$query = $db->setQuery( $query, 0 ,$limit );
		
		try {
				
			if(!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch(Exception $e) {
			$app->enqueueMessage($e->getMessage(), 'error');
		}
		$this->product = $db->loadObjectList();
		
			
		return $this->product;

	}
}
?>