<?php
/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Class for add jquery and js method
 *
 * @package Render  
 * @subpackage EjoshopRenderJquery
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

class EjoshopRenderJquery
{
	var $params;	
	var $system_jquery_cdn;	

	function __construct ()	{
		$this->params = JComponentHelper::getParams('com_ejoshop');
		$this->system_jquery_cdn = $this->params->get('system_jquery_cdn', 1);
	
		
	}
	
	function addJsColorbox( )
	{
		$document = JFactory::getDocument();

		if($this->system_jquery_cdn) {
			
			$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js');
		} else {
			
			$document->addScript(JURI::root(true).'/media/com_ejoshop/assets/js/jquery-1.7.2.min.js');
		}
		$document->addStyleSheet(JURI::root(true).'/media/com_ejoshop/colorbox/colorbox.css');
		$document->addScript(JURI::root(true).'/media/com_ejoshop/colorbox/jquery.colorbox-min.js');
	}
	
	
	function addjQuery(  )
	{
		$document = JFactory::getDocument();
		if($this->system_jquery_cdn) {
			$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js');
		} else {
			$document->addScript(JURI::root(true).'/media/com_ejoshop/assets/js/jquery-1.7.2.min.js');
		}
		
	}

	
	function addJsAddComments(  )
	{
		$document = JFactory::getDocument();
		
		$script = '';

		$script .= 'EjoshopUi.Comments();';
		

		$script .= '
		<!-- start Ejoshop javascript and CSS links -->
		var com_ej_comment_comment_title = "'.JText::_( 'COM_EJOSHOP_COMMENTS' ).'";
		var com_ej_comment_was_add = "'.JText::_( 'COM_EJOSHOP_COMMENT_WAS_ADD_RELOAD_PAGE_TO_SEE_IT' ).'";
		var com_ej_comment_max_depth_error_title = "'.JText::_( 'COM_EJ_COMMENT_MAX_DEPTH_ERROR_TITLE' ).'";
		var com_ej_comment_max_depth_error = "'.JText::_( 'COM_EJ_COMMENT_MAX_DEPTH_ERROR' ).'";
		var com_ej_comment_show_all = "'.JText::_( 'COM_EJ_COMMENT_SHOW_ALL' ).'";
		var com_ej_comment_show_only_tree = "'.JText::_( 'COM_EJ_LINK' ).'";
		
		';
		$script .= "\n\t\t<!-- end Ejoshop javascript params -->\n";
	
				

		$document->addScriptDeclaration($script);
	}
	
	
	function addEjoshopParams( )
	{

		$document = JFactory::getDocument();

		
		$params = JComponentHelper::getParams('com_ejoshop');
		$adjust_screen = $params->get('adjust_screen', 1);
		$opacity = $params->get('opacity', '0.8');
		$scrolling = $params->get('scrolling', 1);
		$transition = $params->get('transition', 'none');
		$as = '';
		
	
		if($adjust_screen) $as = 'maxWidth:$j(window).height(), maxHeight:$j(window).height(),';
		if($opacity) $opacity = 'opacity:'.$opacity;
		if($scrolling) $scrolling = ',scrolling:true';
		if($transition) $transition = ',transition:'.'"'.$transition.'"';
		
		$colorbox_settings = '
		<!-- start Ejoshop javascript params -->
		$j = jQuery;
		var colorbx_settings = {'.$as.$opacity.$scrolling.$transition.'};
		var com_ejoshop_add_to_car = "'.JText::_( 'COM_EJOSHOP_ITEM_ADD_TO_CART' ).'";
		var com_ejoshop_add_tocart = "'.JText::_( 'COM_EJOSHOP_ADD_TOCART' ).'";
		var com_ejoshop_you_should_login = "'.JText::_( 'COM_EJOSHOP_YOU_SHOULD_LOGIN' ).'";
		var com_ejoshop_cart = "'.JText::_( 'COM_EJOSHOP_CART' ).'";
		var juriroot = "'.JURI::root(true).'";

		';
		$colorbox_settings .= "\n\t\t<!-- end Ejoshop javascript params -->\n";
				
		$document->addScriptDeclaration($colorbox_settings);
	}

	
	function EjoshopUiInit( $noconflict = TRUE,$safe = '',$addtohead = TRUE)
	{
		$document = JFactory::getDocument();

		
		$params = JComponentHelper::getParams('com_ejoshop');
		$adjust_screen = $params->get('adjust_screen', 1);
		$opacity = $params->get('opacity', '0.8');
		$scrolling = $params->get('scrolling', 1);
		$transition = $params->get('transition', 'none');
		$as = '';
		
	
		if($adjust_screen) $as = 'maxWidth:$j(window).height(), maxHeight:$j(window).height(),';
		if($opacity) $opacity = 'opacity:'.$opacity;
		if($scrolling) $scrolling = ',scrolling:true';
		if($transition) $transition = ',transition:'.'"'.$transition.'"';
		
		$colorbox_settings = '
		<!-- start Ejoshop javascript and CSS links -->
		$j = jQuery;
		var colorbx_settings = {'.$as.$opacity.$scrolling.$transition.'};
		var com_ejoshop_add_to_car = "'.JText::_( 'COM_EJOSHOP_ITEM_ADD_TO_CART' ).'";
		var com_ejoshop_add_tocart = "'.JText::_( 'COM_EJOSHOP_ADD_TOCART' ).'";
		var com_ejoshop_you_should_login = "'.JText::_( 'COM_EJOSHOP_YOU_SHOULD_LOGIN' ).'";
		var com_ejoshop_cart = "'.JText::_( 'COM_EJOSHOP_CART' ).'";
		var juriroot = "'.JURI::root(true).'";

		';
		
		$script = '';

		$script .= $colorbox_settings;
		$script .= 'EjoshopUi.init();';
		$script .= "\n\t\t<!-- end Ejoshop javascript and CSS links -->\n";
				
		$document->addScriptDeclaration($script);
		
		$document->addStyleSheet(JURI::root(true).'/media/com_ejoshop/colorbox/colorbox.css');
		$document->addScript(JURI::root(true).'/media/com_ejoshop/colorbox/jquery.colorbox-min.js');
		$document->addScript(JURI::root(true).'/media/com_ejoshop/assets/js/ejoshop.js');
	}
	
	
	static function hoverItemsForAdmin() {
		$user = JFactory::getUser();
		$authorise = $user->authorise('core.edit', 'com_contact');
		
		$params = JComponentHelper::getParams('com_ejoshop');
		$quiqkedit = $params->get('quiqkedit');
		if($authorise && $quiqkedit) {
			$document = JFactory::getDocument();
			$style = '.goodBox,.phototplphoto1 {
				
					
			}';
			$document->addStyleDeclaration($style);

			$script = 'EjoshopUi.hoverItemsForAdmin();';
			$document->addScriptDeclaration($script);
		}
	}
	
	static function hoverPhotoForAdmin() {
	
		$document = JFactory::getDocument();
		$script = 'EjoshopUi.hoverPhotoForAdmin();';
		$document->addScriptDeclaration($script);
		
	}
	
	
	function addJsRemoveItemCart( $noconflict=false,$safe = false,$addtohead=false )
	{
		$document = JFactory::getDocument();
		
		if($addtohead) {
			if($this->system_jquery_cdn) {
				$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js');
			} else {
					$document->addScript(JURI::root(true).'/media/com_ejoshop/assets/js/jquery-1.7.2.min.js');
			}
		}
		$conf = '';
		if($noconflict) {
			$conf = 'jQuery.noConflict();';
		} else {
			$conf = '$j = jQuery;';
		}
		

		$script = '';
		$script .= $conf;
		$script .= 'EjoshopUi.RemoveFromCartInit();';
		$document->addScriptDeclaration($script);
		$document->addScript(JURI::root(true).'/media/com_ejoshop/assets/js/ejoshop.js');
		
	}
	function addCssForItemsCartTable(  )
	{
		$document = JFactory::getDocument();
		//$document->addStyleSheet(JURI::root(true).'/media/com_ejoshop/table.css');
	}

	function EjoshopRenderStyle( $type = 'category' )
	{
		
		$params = JComponentHelper::getParams('com_ejoshop');
		$detail_cpb = $params->get('detail_color_photo_border', 'EEEEEE');
		$detail_cct = $params->get('detail_color_cart_table',   'EEEEEE');
		$detail_ccb = $params->get('detail_color_cart_button',  'D1D1D1');
		$detail_ccbo = $params->get('detail_color_cart_border',  'EEEEEE');
		
		$round_border = $params->get('round_border', 0);
		
		$cart_cpb = $params->get('cart_color_photo_border', 'EEEEEE');
		$cart_cct = $params->get('cart_color_cart_table',   'EEEEEE');
		$cart_ccb = $params->get('cart_color_cart_button',  'EEEEEE');
		$cart_ccbo =$params->get('cart_color_cart_border',  'EEEEEE');
		$cart_cfth =$params->get('cart_foncolor_th',  'E8EAEB');
                
		$category_cpb = $params->get('category_color_photo_border', 'EEEEEE');
		$category_cg = $params->get('category_color_goodbox',   'FFF');
		$category_ccb = $params->get('category_color_cart_button',  'EEEEEE');
		$category_ch =$params->get('category_color_h',  'EEEEEE');
		
		$document = JFactory::getDocument();
		$r = '';
		if($round_border) {
			$r = 'border-radius:3px;';
		}
		$style = '';
		if($type == 'category') {
		
		$style = '
			p.photo a.cboxElement img, div.photo a.cboxElement img {
				background: none repeat scroll 0 0 #FFFFFF;
				border: 2px solid #'.$category_cpb.';
				margin: 5px;
				padding: 5px;
			}
			
			.egfifty .addtocart, .egfifty .gotodetail {
				background: #'.$category_ccb.';

			}
	
			.goodBox h2,#main .goodBox h2 {
				color: #'.$category_ch.';
			}
			';
		}
		
		if($type == 'detail') {
		

		$style = '
			p.photo a.cboxElement img, div.photo a.cboxElement img {
				background: none repeat scroll 0 0 #FFFFFF;
				border: 2px solid #'.$detail_cpb.';
				margin: 5px;
				padding: 5px;
			}
			html body ul#producti li a.addtocart,html body a.egnext, html body a.addcomment-button {
				background: #'.$detail_ccb.';
				'.$r.'

			}
			.goodBox,#egcontent .egfifty {
				border-bottom: 1px solid #'.$detail_cpb.';
				margin-right: 0;
				overflow: hidden;
				background: none repeat scroll 0 0 #'.$category_cg.';
			}
			#detail-page h2 {
				color: #'.$category_ch.';
			}
			';
		}
		
		if($type == 'cart') {
		
		$style = '
			p.photo a.cboxElement img, div.photo a.cboxElement img {
				background: none repeat scroll 0 0 #FFFFFF;
				border: 2px solid #'.$cart_cpb.';
				margin: 5px;
				padding: 5px;
			}
			.goodBox {
				border-bottom: 1px solid #CCCCCC;
				margin-right: 0;
				overflow: hidden;
			}
			html body a.egnext,input.egnext,a.gotodetail {
				background: -moz-linear-gradient(center top , #'.$cart_ccb.', #CCCCCC) repeat scroll 0 0 rgba(0, 0, 0, 0);

			}
			#cart table {
			
				border: 1px solid #'.$cart_cct.';
		
			}
			#cart table tr,#cart table td {
				border: 1px solid #'.$cart_cct.';
			}
			#cart table th {
				background: -moz-linear-gradient(100% 20% 90deg, #'.$cart_cfth.', #EDEDED) repeat scroll 0 0 rgba(0, 0, 0, 0);
			}
			';
		}
		$success = $params->get('success',  '#EEEEEE');
		$error = $params->get('error',  '#EEEEEE');
		
		$info = $params->get('info',  '#EEEEEE');
		$style .= '
			.egmessage, .egerror {
				animation: 5s linear 0s normal none infinite animate-bg;
				background-image: linear-gradient(135deg, rgba(255, 255, 255, 0.05) 25%, rgba(0, 0, 0, 0) 25%, rgba(0, 0, 0, 0) 50%, rgba(255, 255, 255, 0.05) 50%, rgba(255, 255, 255, 0.05) 75%, rgba(0, 0, 0, 0) 75%, rgba(0, 0, 0, 0));
				background-size: 40px 40px;
				border: 1px solid;
				box-shadow: 0 -1px 0 rgba(255, 255, 255, 0.4) inset;
				color: #FFFFFF;
				padding: 15px;
				text-shadow: 0 1px 0 rgba(0, 0, 0, 0.5);
			}
			.egerror {
				background-color: '.$error.';
				border-color: '.$error.';
			}
			.success {
				background-color: '.$success.';
				border-color: '.$success.';
			}
		';
		
		
		$document->addStyleDeclaration($style);
	}
	
	

}
?>