<?php
/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * Google Maps Version 3
 *
 * @package Render  
 * @subpackage EjoshopRenderMap
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */
 
class EjoshopRenderMap
{
	var $_id		= 'phocaMap';


	
	
	function __construct() {
		
	}
	

	function createMap($id = '', $map = '', $latlng = '', $options = '', $tst = '', $tstint = '') {
		$this->_id		= $id;
		$this->_map 	= $map;
		$this->_latlng 	= $latlng;
		$this->_options = $options;
		$this->_tst 	= $tst;
		$this->_tstint 	= $tstint;
		
		
		$document	= JFactory::getDocument();
		if($this->_map == 'yandex') {
			$document->addScript('http://api-maps.yandex.ru/2.0.10/?load=package.full&lang=ru-RU');
			$map = $this->getYandexMap();
			$document->addScriptDeclaration($map);
			$div = '<div id="YMapsID'.$this->_id.'" style="margin:0;padding:0;width:100%;height:500px;margin-bottom:5px;"></div>';
		}
		
		if($this->_map == 'google') {
		
			$document->addScript('http://www.google.com/jsapi');
			$map = $this->getGoogleMap();
			$document->addScriptDeclaration($map);
			$div = '<div align="center" style="margin:0;padding:0"><div id="phocaMap'.$this->_id.'" style="margin:0;padding:0;width:620px;height:540px"></div></div>';
		}
		
		
		return $div;
	}
	
	function getYandexMap() {

		$map = '
		var map'.$this->_id.', placemark;
		var properties = {
        	balloonContent: "",
			iconContent: "",
        	hintContent: ""


    	};
		
		
		var element = window;
		if (element.addEventListener) {
			element.addEventListener("load", init'.$this->_id.', false);
		} else if (element.attachEvent) {
			element.attachEvent("onload", init'.$this->_id.');
		}


            	function init'.$this->_id.' () {
		
					map'.$this->_id.' = new ymaps.Map("YMapsID'.$this->_id.'", {
						// Центр карты
						center: ['.$this->_latlng.'],
						// Коэффициент масштабирования
						zoom: 15
			
					}
				);	
				
				map'.$this->_id.'.controls.add("zoomControl");
				

				myGeoObject = new ymaps.GeoObject({
					// Описываем геометрию типа "Точка".
					geometry: {
						type: "Point",
						coordinates: ['.$this->_latlng.']
					},
					// Описываем данные геообъекта.
					properties: properties
				}
				);
				// Добавляем геообъект на карту.
				map'.$this->_id.'.geoObjects.add(myGeoObject);
           
				
			}
			';
			
		return $map;
	}
	
	function getGoogleMap() {
		$map = '
		
google.load("maps", "3.x", {
    "other_params": "sensor=false"
});

var tstPhocaMap'.$this->_id.';
var tstIntPhocaMap'.$this->_id.';
var mapPhocaMap'.$this->_id.';

function CancelEventPhocaMap'.$this->_id.'(event) {
    var e = event;
    if (typeof e.preventDefault == "function") e.preventDefault();
    if (typeof e.stopPropagation == "function") e.stopPropagation();
    if (window.event) {
        window.event.cancelBubble = true; /* for IE */
        window.event.returnValue = false; /* for IE */
    }
}

function CheckPhocaMap'.$this->_id.'() {
    if (tstPhocaMap'.$this->_id.') {
        if (tstPhocaMap'.$this->_id.'.offsetWidth != tstPhocaMap'.$this->_id.'.getAttribute("oldValue")) {
            tstPhocaMap'.$this->_id.'.setAttribute("oldValue", tstPhocaMap'.$this->_id.'.offsetWidth);
            if (tstPhocaMap'.$this->_id.'.getAttribute("refreshMap") == 0) {
                if (tstPhocaMap'.$this->_id.'.offsetWidth > 0) {
                    clearInterval(tstIntPhocaMap'.$this->_id.');
                    getPhocaMap'.$this->_id.'();
                    tstPhocaMap'.$this->_id.'.setAttribute("refreshMap", 1);
                }
            }
        }
    }
}

function getPhocaMap'.$this->_id.'() {
    if (tstPhocaMap'.$this->_id.'.offsetWidth > 0) {
        var phocaLatLng = new google.maps.LatLng('.$this->_latlng.');
        var phocaOptions = {
            zoom: 13,
            center: phocaLatLng,
            mapTypeControl: true,
            mapTypeControlOptions: {
                style: google.maps.MapTypeControlStyle.DEFAULT
            },
            navigationControl: true,
            navigationControlOptions: {
                style: google.maps.NavigationControlStyle.DEFAULT
            },
            scaleControl: true,
            scrollwheel: true,
            disableDoubleClickZoom: false,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };
        var mapPhocaMap'.$this->_id.' = new google.maps.Map(document.getElementById("phocaMap'.$this->_id.'"), phocaOptions);
        var phocaStartZoom = 13;
        var egZoom = null;
        google.maps.event.addListener(mapPhocaMap'.$this->_id.', "zoom_changed", function (phocaStartZoom, egZoom) {
            egZoom = mapPhocaMap'.$this->_id.'.getZoom();
            //if (window.parent) window.parent.phocaSelectMap_jform_zoom(egZoom);
        });
        var phocaPoint1 = new google.maps.LatLng('.$this->_latlng.');
        var markerPhocaMarker1 = new google.maps.Marker({
            position: phocaPoint1,
            map: mapPhocaMap'.$this->_id.',
            draggable: true
        });
        var infoPhocaWindow1 = new google.maps.InfoWindow({
            content: markerPhocaMarker1.getPosition().toUrlValue(6)
        });
        google.maps.event.addListener(markerPhocaMarker1, "dragend", function () {
            var phocaPointTmp = markerPhocaMarker1.getPosition();
            markerPhocaMarker1.setPosition(phocaPointTmp);
            closeMarkerInfo1();
            exportPoint1(phocaPointTmp);
        });
        google.maps.event.addListener(mapPhocaMap'.$this->_id.', "click", function (event) {
            var phocaPointTmp2 = event.latLng;
            markerPhocaMarker1.setPosition(phocaPointTmp2);
            closeMarkerInfo1();
            exportPoint1(phocaPointTmp2);
        });
        google.maps.event.addListener(markerPhocaMarker1, "click", function (event) {
            openMarkerInfo1();
        });

        function openMarkerInfo1() {
            infoPhocaWindow1.content = markerPhocaMarker1.getPosition().toUrlValue(6);
            infoPhocaWindow1.open(mapPhocaMap'.$this->_id.', markerPhocaMarker1);
        }

        function closeMarkerInfo1() {
            infoPhocaWindow1.close(mapPhocaMap'.$this->_id.', markerPhocaMarker1);
        }

        function exportPoint1(phocaPointTmp3) {
		   // TO DO as yandex map for search address
           // document.getElementById("coords").value = phocaPointTmp3.lng();
           //  document.getElementById("coords2").value = phocaPointTmp3.lat();

            window.top.document.forms.adminForm.getElementById("longitude").value = phocaPointTmp3.lng();
            window.top.document.forms.adminForm.getElementById("latitude").value = phocaPointTmp3.lat();
14.423332214355469
        }50.086776271666096
        google.maps.event.addDomListener(tstPhocaMap'.$this->_id.', "DOMMouseScroll", CancelEventPhocaMap'.$this->_id.');
        google.maps.event.addDomListener(tstPhocaMap'.$this->_id.', "mousewheel", CancelEventPhocaMap'.$this->_id.');
    }
}

function initialize'.$this->_id.'() {

	tstPhocaMap'.$this->_id.' = document.getElementById("phocaMap'.$this->_id.'");
	
    tstPhocaMap'.$this->_id.'.setAttribute("oldValue", 0);
    tstPhocaMap'.$this->_id.'.setAttribute("refreshMap", 0);
    tstIntPhocaMap'.$this->_id.' = setInterval("CheckPhocaMap'.$this->_id.'()", 500);
}
google.setOnLoadCallback(initialize'.$this->_id.');';
			
		return $map;
	}
}
?>