<?php 
defined( '_JEXEC' ) or die( 'Restricted access' );

/*
 * @package Render
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */


/**
 * Class using method for operations with currency 
 *
 * @package Render  
 * @subpackage EjoshopRenderPayd
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */


class EjoshopRenderPayd { 


	/**
	 * 
	 * возвращает список других товаров из #__ejoshop_shop_order, приобретённых вместе
	 * с просматриваемым товаром
	 */
	function getOrderInfo($pids = 0,$curpid = 0, $group = '')
	{
		if(empty($pids)) {
			$pid = JRequest::getVar( 'pid' );
		}
		ejoshopimport('ejoshop.render.rendercart');

		JError::$legacy = true;
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->from('`#__ejoshop_shop_order` AS orders');
		$query->select('userinfo_cart.*,cat.title as category_name,orders.*,photos.*,orders.created_by as orderuser,userinfo_cart.name as username,UNIX_TIMESTAMP(orders.created)  as ordertime, payd.*,orders.payid as op');
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.id = orders.photo_id)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (cat.id = photos.catid)');
		$query->join('LEFT', '#__ejoshop_userinfo_cart AS userinfo_cart ON (userinfo_cart.id = orders.created_by)');
		$query->join('LEFT', '#__ejoshop_payd AS payd ON (payd.payid = orders.payid)');
		
		
	
		if(isset($pids)) {
			if(is_array($pids)) {
				$index = array_search($pid,$pids);
	
				if(!empty($pid)) {			
					unset($pids[$index]);
				}
		
				$query->where('orders.payid IN ('.implode(',', $pids).')');
			} else {
				$query->where('orders.payid = '.(int) $pids);
			}
		}
		if(!empty($curpid)) {
			$query->where('orders.pid != '.(int) $curpid);
		}
		if(!empty($group)) {
			$query->group('orders.'.$group);
		} else {
			$query->group('orders.pid');	
		}
		//var_dump($query->__toString());
		$query = $db->setQuery( $query );
		
		try {
				
			$result = $db->query();
		} catch(Exception $e) {
			print $e->getMessage();	
		}
		JError::$legacy = false;
		$this->photos = $db->loadObjectList();
		$cart = new EjoshopRenderCart();

		$this->photos = $cart->getImageForCartItems($this->photos);
		
		return $this->photos;
		
	}
	

	/**
	 *
	 * update order in table ejoshopPayd - only pids
	 * 
	 **/
	function checkItemInUsedOrders($pids)
	{
		
		JError::$legacy = true;

		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('orders.*');
		$query->from('`#__ejoshop_shop_order` AS orders');

		if(isset($pids)) {
			$query->where('orders.photo_id 	 IN (' .  implode(',', $pids) . ')');
		}
		$query = $db->setQuery( $query);
		$photos = $db->loadObjectList();	
		
		JError::$legacy = false;
		$used = array();
		
		foreach($photos as $item) {
			$used[] = $item->photo_id;
		}
		return $used;	
			
	}


	/**
	 *
	 * update order in table ejoshopPayd - only pids
	 * 
	 **/
	function updateOrders($data)
	{
		JError::$legacy = true;
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'tables');
		$table = JTable::getInstance('ejoshopPayd', 'Table');

		//$table = $this->getTable('ejoshopPayd');

	
		// Bind the form fields to the hello table
		try {
				$table->bind($data);
				$table->store();
		} catch (RuntimeException $e) {
				print $e->getMessage();
		}

		JError::$legacy = false;
		return true;	
			
	}

} ?>