<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.render.renderpayd' );
ejoshopimport( 'ejoshop.imageeditor.phpimageeditor') ;
ejoshopimport( 'ejoshop.developer.developer' );
jimport('joomla.html.pagination');
ejoshopimport('ejoshop.fields.fields');
ejoshopimport('ejoshop.comments.comments');

class EjoshopModelEjoshopComments extends EjoshopModel
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'mlid', 'c.mlid',
				'title', 'c.name',
				'alias', 'c.alias',
				'checked_out', 'c.checked_out',
				'publish_up', 'c.publish_up',
				'publish_down', 'c.publish_down',
			);
		}

		parent::__construct($config);
	}


    function publish()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');
        foreach ($cid as $id)
        {
        	$row = JTable::getInstance('EjoshopComments', 'Table');
            $row->load($id);
            $row->publish($id, 1);
        }
        JPluginHelper::importPlugin('finder');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.comments', $cid, 1));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopcomments');
    }
	
    function unpublish()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');
		
        foreach ($cid as $id)
        {
		
        	$row = JTable::getInstance('EjoshopComments', 'Table');
            $row->load($id);
		
            $row->publish($id, 0);
        }
        JPluginHelper::importPlugin('finder');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.comments', $cid, 0));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopcomments');
    }
	
	
    function remove()
    {
		$comments = new EjoshopComments();
        $cid = JRequest::getVar('cid');
		foreach ($cid as $mlid)
        {
			$comments->menu_link_delete($mlid);
		}
		$mainframe = JFactory::getApplication();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopcomments');
	}
	
    function trash()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');
        foreach ($cid as $id)
        {
        	$row = JTable::getInstance('EjoshopComments', 'Table');
            $row->load($id);
            $row->trash($id, -2);
        }
    
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.comments', $cid, 1));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopcomments');
    }
	
	function getCat()
	{
		$tableCode = EjoshopModel::getInstance('EjoshopModelEjoshopCategory', '');

		return $tableCode;
	}
	
	function getListQuery()
	{
		$where = '';

		$id = JRequest::getVar( 'id' );
		if(!empty($id)) {	
			$where = 'AND c.mlid = '.$id ;
		}

		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();

		
		$filtersearch = $this->getState('filter.search');
		
		if(!empty($filtersearch)) {
			$where .= ' AND c.comment LIKE \'%'.$filtersearch.'%\'' ;
		}
		$limitstr = '';
		$limit = JRequest::getVar('limit',20,$hash = 'default', 'int');
		$limitstart = JRequest::getVar('limitstart', 0,$hash = 'default', 'int');
		$limitstr = ' LIMIT '.$limitstart.', '.$limit;
		
		if(!$limit && !$limitstart) $limitstr = '';

		// Add the list ordering clause.
		$orderCol	= $this->getState('filter.filter_order','c.tree');
		$orderDirn	= $this->getState('filter.filter_order_Dir','');
		$orderDirn .= ','; 
		if($orderCol == 'c.tree') {
			$orderCol	= '';
			$orderDirn = '';
		}

		
		$query = ('SELECT c . *
				FROM #__ejoshop_comments c
				WHERE (
				c.comment_name = \'allcomment\' '.$where.'
				) 
				ORDER BY  '.$orderCol.' '.$orderDirn.' p1 ASC , p2 ASC , p3 ASC , p4 ASC , p5 ASC , p6 ASC , p7 ASC , p8 ASC , p9 ASC '.$limitstr.'');
				

		$query = $db->setQuery( $query );
		
		$this->comments = $db->loadObjectList();
		
		$this->comments = empty($this->comments) ? array() : $this->comments;
		if(!empty($this->comments)) {
			foreach($this->comments as $key => $comment) {
				$this->comments[$key]->gravatar = $this->get_gravatar($comment->useremail);
			}
		}
		return $this->comments;
	}
	
	function get_gravatar( $email, $s = 20, $d = 'mm', $r = 'g', $img = true, $atts = array()) {
		
		
		$url = 'http://www.gravatar.com/avatar/';
		$url .= md5( strtolower( trim( $email ) ) );
		$url .= "?s=$s&d=$d&r=$r";
		if ( $img ) {
			$url = '<img src="' . $url . '"';
			foreach ( $atts as $key => $val )
				$url .= ' ' . $key . '="' . $val . '"';
			$url .= ' />';
		}
		
		
		

		return $url;
	}
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication();
        $option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		// Load the filter state.
		

		$orderCol	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order');
		$orderDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir');
		$this->setState('filter.filter_order', $orderCol);
		$this->setState('filter.filter_order_Dir', $orderDirn);
		
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		
		$search = $app->getUserStateFromRequest($option.$view.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$access = $app->getUserStateFromRequest($option.$view.'.filter.access', 'filter_access', 0, 'int');
		$this->setState('filter.access', $access);

		$authorId = $app->getUserStateFromRequest($option.$view.'.filter.author_id', 'filter_author_id');
		$this->setState('filter.author_id', $authorId);

		$published = $app->getUserStateFromRequest($option.$view.'.filter.published', 'filter_published', '');
		$this->setState('filter.published', $published);

		$categoryId = $app->getUserStateFromRequest($option.$view.'.filter.category_id', 'filter_category_id');
		$this->setState('filter.category_id', $categoryId);

		$level = $app->getUserStateFromRequest($option.$view.'.filter.level', 'filter_level', 0, 'int');
		$this->setState('filter.level', $level);


		$language = $app->getUserStateFromRequest($option.$view.'.filter.language', 'filter_language', '');
		$this->setState('filter.language', $language);


		// List state information.
		parent::populateState('c.tree', '');
	}


	
	var $_foobar;

	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}

	/**
	 * Method to get a list of articles.
	 * Overridden to add a check for access levels.
	 *
	 * @return	mixed	An array of data items on success, false on failure.
	 * @since	1.6.1
	 */
	public function getItems()
	{
		$items	= $this->getListQuery();

		return $items;
	}
	

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getComments($pid = 0,$limit = 0)
	{
		
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'comments.*'
			)
		);
		
				

		$query->from('`#__ejoshop_comments` AS comments');
		$query->select('cat.title as category_name');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (comments.catid = cat.id)');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','comments.id');
		$orderDirn	= $this->state->get('list.direction','DESC');

		if(isset($pid)) {
			$query->where('comments.id = '.(int) $pid);
		}
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		//var_dump($query->__toString());
		$query = $db->setQuery( $query, $limitstart, $limit );
		
		
		
		$this->comments = $db->loadObjectList();
		//var_dump($this->comments);
		return $this->comments;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getFoobar()
	{

	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');
	if($data['task'] !== 'add') {
	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select('a.*');
		$query->from('`#__ejoshop_categories` AS a');
		$search = $this->getState('filter.search');
		
		if (!empty($search))
		{
	
			if (stripos($search, 'id:') === 0) {
				$query->where('a.cat = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( a.name LIKE '.$search.')');
			}
		}
		
		$query->order('id DESC');
	
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->_foobar = $db->loadObjectList();
		
	}
	else {
	
		$query = ' SELECT * '
			. ' FROM #__ejoshop_categories ORDER BY id DESC';
			$query = $db->setQuery( $query);
		$this->_foobar = $db->loadObjectList();
		}
		return $this->_foobar;
	}

	
	function getCommentsPager()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_comments";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_comments";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	

	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n", '<br />',$text); 

		return $text;
	}
	
	function getFile($fid)
	{
 		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

        //CHANGE THIS QUERY AS YOU NEED...
        $query->select('f.*');
		$query->from('#__ejoshop_file_managed AS f');

		$query->where("f.fid = '$fid'");
		$query = $db->setQuery( $query );
	
		$file = $db->loadArray();
		return $file;
	}
	
	
	function store()
	{

		$data = JRequest::get( 'post' );
		$data = $data['jform'];
		$catid = $data['catid'];
		$name = $data['name'];
		$articul = $data['articul'];
		$imagestyle = $data['imagestyle'];
		$dpath = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).'/media/com_ejoshop/files/tmp/';
		$filename = '';
		$userpath = '';
		//$tmp_path = '/media/com_ejoshop/files/tmp/'; / tmp folder need create temporary image
		
		/* *** New image **** */
		$imgsrc	= JRequest::getVar('imgsrc',0);
		$fid	= JRequest::getVar('fid',0);
		if(!empty($imgsrc)) {
			$path = $imgsrc;
			$path_parts = pathinfo($path);
			$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
			$tmpthumbnail = $dpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
			if(!empty($fid)) {
				$filefromdb = $this->getFile($fid);
				if($filefromdb['imagestyle'] != $imagestyle) {
					$ni = new EjoshopPHPImageEditor($path,$tmpthumbnail,'thumbnail',$imagestyle,FALSE);
				}
			}
			
			
			$filename = $path_parts['filename'].'.'.$path_parts['extension'];
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
			//$model = EjoshopModel::getInstance('updatesmigration', 'VirtueMartModel');
			$model = EjoshopModel::getInstance('Ajaxupload', 'EjoshopModel');
			$pid = $model->save($path_parts['filename'],$dpath,$pid);
			$userpath = '/media/com_ejoshop/files/'.$catid.'/'.$pid.'/';

			if(!is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
				JFolder::create(JPATH_ROOT.$userpath);
			}
			
			if(copy($path,$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath.$filename)) {
				unlink($path);
			}
			if(copy($tmpthumbnail,$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'])) {
				unlink($dpath.$path_parts['filename'].'_s.'.$path_parts['extension']);
			}
		}

		
		/* *** New image **** */
		
		if(!empty($data['alias'])) {
			$data['alias'] = JFilterOutput::stringURLSafe($data['alias']); 
		} else {
			$data['alias'] = JFilterOutput::stringURLSafe($data['name']); 
		}
		if(!$data['state']) $data['state'] = 0;

			$date = gmdate("Y-m-d H:i:s", time());
			$db = $this->getDBO();
			
			if(!empty($pid)) {
	
				$query = "UPDATE " . $db->quoteName('#__ejoshop_comments') ."
				SET `uri` = '".$userpath."',`filename` = '".$filename."',`name` = '".$name."',`alias` = '".$data['alias']."',`catid` = '".$catid."',`articul` = '".$articul."',`price` = '".$data['price']."',`state` = '".$data['state']."',`imagestyle` = '".$data['imagestyle']."' WHERE " . $db->quoteName('#__ejoshop_comments') .".`id` = '".$pid."' LIMIT 1 ;";
			} else {
				$query = "INSERT INTO ".$db->quoteName('#__ejoshop_comments') 
				." (`name`,`alias`,`catid`,`articul`,`price`,`created`,`currency`,`state`,`imagestyle`) VALUES ('".$name."','".$data['alias']."','".$catid."','".$articul."','".$data['price']."','".$date."','-1','".$data['state']."','".$data['imagestyle']."');";
			}

			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return (empty($pid)) ? $db->insertid() : $pid;
	}

	
	function createFields($fieldsname,$fieldsvalue)
	{
		$o = array();
		foreach($fieldsname as $key => $val) {
		
			$o[$key] = array($val,$fieldsvalue[$key]);
			
		}
		
		$r = serialize($o);


		return $r;

	}	
	
	public function getAllFields()
	{
		$results = array();
		$db		= JFactory::getDBO();
		$query = "SELECT fc . *
		FROM #__ejoshop_field_config fc
		WHERE fc.active = 1 AND fc.storage_active = 1";
		$config = new JConfig();


		$db->setQuery($query);
		$results = $db->loadAssocList();
		
		foreach($results as $key => $field) {
			$results[$key]['field_table_name'] = $config->dbprefix . 'ejoshop_field_data_'.$field['field_name'];
		}
		return $results;
	}
	
	
	public function add_field_ordelete_field($field_table_name,$field_name, $value, $entity_id)
	{

		$db = $this->getDBO();
		$query	= $db->getQuery(true);
		$query->select('fields.*');
		$query->from('`'.$field_table_name.'` AS fields');


		
		$query->where("fields.entity_id = '".$entity_id."'");
		
		$query = $db->setQuery( $query);
		$fields = $db->loadAssoc();
		if(empty($fields) && $value != 'notselected') {

			if(is_array($value)) {
			++$i;
				foreach($value as $key => $insert) {
					$query = "INSERT INTO ".$field_table_name
					." (`entity_type`,`bundle`,`deleted`,`delta`,`entity_id`,`".$field_name."_value`) 
					VALUES ('product','product','0','".$i."','".$entity_id."','".$insert."');";
				}
			} else {
					$query = "INSERT INTO " .$field_table_name
					." (`entity_type`,`bundle`,`deleted`,`entity_id`,`".$field_name."_value`) 
					VALUES ('product','product','0','".$entity_id."','".$value."');";
			}

			

		} else {
			if(is_array($value)) {
				
				$query = "DELETE FROM " . $field_table_name ." WHERE `entity_id` = '".$entity_id."';";
				$db->setQuery($query);
				if (!$db->query()) {
				
					throw new Exception($db->getErrorMsg());
				}
				$i = 0;
				$query = 'INSERT INTO '.$field_table_name
					.' (`entity_type`,`bundle`,`deleted`,`delta`,`entity_id`,`'.$field_name.'_value`) VALUES';
					
				foreach($value as $key => $insert) {
					++$i;
					
					$query .= " ('product','product','0', '".$i."','".$entity_id."','".$insert."'),";
					
				}
				$query = substr($query,0,-1).';';
			
			} else if($value == 'notselected'){
				$query = "DELETE FROM " . $field_table_name ." WHERE `entity_id` = '".$entity_id."';";
				$db->setQuery($query);
				if (!$db->query()) {
				
					throw new Exception($db->getErrorMsg());
				}
				
			} else {
				$query = "UPDATE " . $field_table_name ."
				SET `".$field_name."_value` = '".$value."' WHERE `entity_id` = '".$entity_id."' LIMIT 1;";
			}
		}
	
		$db->setQuery($query);
	
		if (!$db->query()) {
		
			throw new Exception(__LINE__ . $db->getErrorMsg());
		}
			
	}
	
	
	public function commentedit($post)
	{
		$row = $this->getTable('ejoshopcategories');
		$app = JFactory::getApplication(); 
		$db = $this->getDBO();
		$data = JRequest::get( 'post' );
	
		$query = "UPDATE ".$db->quoteName('#__ejoshop_comments') 
		." set ".$db->quoteName('username')." = '".$data['jform']['username']
		."', ".$db->quoteName('useremail')." = '".$data['jform']['useremail']
		."', ".$db->quoteName('comment')." = '".$data['jform']['comment']
		."' WHERE ".$db->quoteName('mlid')." =".$data['mlid'];
		
		$db->setQuery($query);
		
		if (!$db->query()) {
			$this->setError($db->getErrorMsg());
			print $db->getErrorMsg();
			die();
			return false;
		
		}
	
			

		return true;
	}
	
	
	
	function updateProductTable($data) {
	
		$pk = (!empty($data['id'])) ? (int)$data['id'] : 0;
	
			$table = $this->getTable();
			

			$isNew = FALSE;
			
			// Load the row if saving an existing taxs.
			if ($pk > 0)
			{
				$table->load($pk);
				$isNew = false;
			}
			// Bind the data.
			if (!$table->bind($data))
			{
				$this->setError($table->getError());
				return false;

			}
			

			// Check the data.
			if (!$table->check())
			{

				$this->setError($table->getError());
				return false;
			}
			// Store the data.
			if (!$table->store())
			{
			
				$this->setError($table->getError());
				return false;
				
			}
				
			return true;
	}
	
	/* удаление товаров и всего, что с ними связано */
	function delete(&$post)
	{
		
		$post = JRequest::get( 'post' );
		$cids = $post['cid'];

		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('comments.*');
		$query->from('`#__ejoshop_comments` AS comments');

		if(isset($cids)) {
			$query->where('comments.id IN (' .  implode(',', $cids) . ')');
		}
		$query = $db->setQuery( $query);
		$comments = $db->loadObjectList();	
		

	

		$orderclass = new EjoshopRenderPayd();
		$isUsed = $orderclass->checkItemInUsedOrders($cids); // check if item used in orders
		
		
		if(count($isUsed) > 0) {
			

	
		}
		
		
		foreach($comments as $comment) {
			
	
			if(in_array($comment->id,$isUsed)) {
				JError::raiseWarning( 500, JText::plural('COM_EJOSHOP_ITEM_IS_USED', $comment->id));
				continue;
			}

			$prevcomment = $comment;
			$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevcomment->uri;
			$path_parts = pathinfo($path.$prevcomment->filename);
			$newfileimgsrc = $path.'_s.png';
			$thumb = $path.$path_parts['filename'].'_s.png';
			if(!empty($prevcomment->sizethumb)) {
					$sizethumb = $path.$prevcomment->sizethumb;
			}

			if(is_file($path.$prevcomment->filename)) {	
				if(!JFILE::delete($path.$prevcomment->filename)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
			if(is_file($thumb)) {	
				if(!JFILE::delete($thumb)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
			if(is_file($sizethumb)) {
				if(!JFILE::delete($sizethumb)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
		}
				

		if (count( $cids )) {
			foreach($cids as $cid) {
				if(in_array($cid,$isUsed)) {
					continue;
				}
				$query = 'DELETE FROM #__ejoshop_comments'
				. ' WHERE id = ' .$cid;
					$db->setQuery( $query );
					if (!$db->query()) {
						JError::raiseWarning( 500, $db->getError() );
					}
			}
		}
		return true;
	}
	


}
