<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.render.renderpayd' );

class  EjoshopModelEjoshopCurrency extends JModelList
{
	protected	$option 		= 'com_ejoshop';
	protected $text_prefix = 'com_ejoshop';
	protected $_tbl_key = 'id';
	protected $_tbl = '#__ejoshop_currency';
	public function __construct($config = array())
	{
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'id', 'c.id',
				'name', 'c.currency_name',
				'state', 'c.state',
				'code', 'c.currency_code'
			);
		}

		parent::__construct($config);
	}


	protected function getListQuery()
	{
	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');

	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select(
			$this->getState(
				'list.select',
				'c.*'
			)
		);
		$query->from('`#__ejoshop_currency` AS c');
		$search = $this->getState('filter.search');
		$direction = $this->getState('list.direction');
		
		
		if (!empty($search))
		{
			if (stripos($search, 'id:') === 0) {
				$query->where('c.id = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( c.currency_name LIKE '.$search.' OR c.currency_country LIKE '.$search.')');
			}
		}

						
		$query->where('(c.state = 0 OR c.state = 1)');

		//$query->order('c.name');

		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','id');
		$orderDirn	= $this->state->get('list.direction','ASC');
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		//var_dump($query->__toString());
	
		
		return $query;
	}
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');

		// Load the filter state.
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$access = $this->getUserStateFromRequest($this->context.'.filter.access', 'filter_access', 0, 'int');
		$this->setState('filter.access', $access);

		$authorId = $app->getUserStateFromRequest($this->context.'.filter.author_id', 'filter_author_id');
		$this->setState('filter.author_id', $authorId);

		$published = $this->getUserStateFromRequest($this->context.'.filter.published', 'filter_published', '');
		$this->setState('filter.published', $published);

		$categoryId = $this->getUserStateFromRequest($this->context.'.filter.category_id', 'filter_category_id');
		$this->setState('filter.category_id', $categoryId);

		$level = $this->getUserStateFromRequest($this->context.'.filter.level', 'filter_level', 0, 'int');
		$this->setState('filter.level', $level);


		$language = $this->getUserStateFromRequest($this->context.'.filter.language', 'filter_language', '');
		$this->setState('filter.language', $language);


		// List state information.
		parent::populateState('c.id', 'desc');
	}


	
	var $_foobar;

	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}

	/**
	 * Method to get a list of articles.
	 * Overridden to add a check for access levels.
	 *
	 * @return	mixed	An array of data items on success, false on failure.
	 * @since	1.6.1
	 */
	public function getItems()
	{
		$items	= parent::getItems();

	
		$app	= JFactory::getApplication();
		if ($app->isSite()) {
			$user	= JFactory::getUser();
			$groups	= $user->getAuthorisedViewLevels();

			for ($x = 0, $count = count($items); $x < $count; $x++) {
				//Check the access level. Remove articles the user shouldn't see
				if (!in_array($items[$x]->access, $groups)) {
					unset($items[$x]);
				}
			}
		}
		return $items;
	}
	

	function getReviews()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_currency";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_currency";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		if (!class_exists('JPagination')) {
			jimport('joomla.html.pagination');
		}
		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	

	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
	
	
	function store($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$galid = $data['galid'];
		$catid = $data['id'];

			
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_currency') 
			." (`galid`, `id`, `params`) VALUES ('".$galid."', '".$catid."', '');";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}

	
	function createFields($fieldsname,$fieldsvalue)
	{
		$o = array();
		foreach($fieldsname as $key => $val) {
		
			$o[$key] = array($val,$fieldsvalue[$key]);
			
		}
		
		$r = serialize($o);


		return $r;

	}	
	function photoedit($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$latitude = $data['latitude'];
		$longitude = $data['longitude'];
		$description = $data['intro'];
		$coords = $data['coords'];
		$catid= $data['jform']['catid'];
		$catid = (empty($catid)) ? 0 : $catid;
		$articul = $data['jform']['articul'];	

		$allcoolor = array();
		if($data['color']) {
			foreach($data['color'] as $al) {
				$allcoolor[] = $al;
			}		
		}
		
		
		$fieldsname = $data['fieldsname'];
		$fieldsvalue = $data['fieldsvalue'];
		if(!empty($fieldsname)) {
			$jsonfields = $this->createFields($fieldsname,$fieldsvalue);
		}

						
		$color = json_encode($allcoolor);
		$data['phototext'] = JRequest::getVar('phototext', '', 'post', 'string', JREQUEST_ALLOWRAW);

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$data["parent_category"] = (empty($data["parent_category"])) ? 0 : $data["parent_category"];
		

		$date = gmdate("Y-m-d H:i:s", time());
		$this->photo = $this->getPhotos($data['id']);
		$this->photo = $this->photo[0];	
		$data['tplonephoto'] = !empty($data['tplonephoto']) ? $data['tplonephoto'] : $this->photo->tplonephoto;
		// Store the web link table to the database
			$db = $this->getDBO();
			
			$query = "UPDATE ".$db->quoteName('#__ejoshop_currency') 
			." set ".$db->quoteName('latitude')." = '".$this->textnl($latitude)
			."', ".$db->quoteName('longitude')." = '".$this->textnl($longitude)
			."', ".$db->quoteName('name')." = '".$this->textnl($data['name'])
			."', ".$db->quoteName('articul')." = '".$articul
			."', ".$db->quoteName('intro')." = '".$this->textnl($data['intro'])
			."', ".$db->quoteName('maptype')." = '".$this->textnl($data['coords'])
			."', ".$db->quoteName('showmap')." = '".$this->textnl($data['showmap'])
			."', ".$db->quoteName('alias')." = '".$data['alias']
			."', ".$db->quoteName('catid')." = '".$catid
			."', ".$db->quoteName('galid')." = '".$this->textnl($data['gallery'])
			."', ".$db->quoteName('price')." = '".$data['price']
			."', ".$db->quoteName('showprice')." = '".$this->textnl($data['showprice'])
			."', ".$db->quoteName('currency')." = '".$this->textnl($data['currency'])
			."', ".$db->quoteName('created')." = '".$date
			."', ".$db->quoteName('description')." = '".$this->textnl($data['description'])
			."', ".$db->quoteName('keywords')." = '".$this->textnl($data['keywords'])
			."', ".$db->quoteName('tplonephoto')." = '".$data['tplonephoto']
			."', ".$db->quoteName('showquanity')." = '".$this->textnl($data['showquanity'])
			."', ".$db->quoteName('quanity')." = '".$this->textnl($data['quanity'])
			."', ".$db->quoteName('phototext')." = '".$data['phototext']
			."', ".$db->quoteName('show_phototext')." = '".$data['show_phototext']
			."', ".$db->quoteName('showcolor')." = '".$this->textnl($data['showcolor'])
			."', ".$db->quoteName('created_by')." = '".$this->textnl($data['created_by'])
			."', ".$db->quoteName('sizethumb')." = '".$data['sizethumb']
			."', ".$db->quoteName('color')." = '".$this->textnl($color)
			."', ".$db->quoteName('addtocartshow')." = '".$data['addtocartshow']
			."', ".$db->quoteName('fields')." = '".$jsonfields
			."' WHERE ".$db->quoteName('id')." =".$data['id'];
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				//print $this->_db->getErrorMsg();
				//die();
				return false;
			
			}

			/* pre generate mini thumb */
			
		
	
				if($this->photo) {
				
					$prevphoto = $this->photo;
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri.$this->photo->filename;
					$path_parts = pathinfo($path);
					$thumb = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri.$path_parts['filename'].'_'.$this->photo->sizethumb.'_s.png';
				}

			
			if(!empty($data['sizethumb']) && $data['sizethumb'] != $this->photo->sizethumb || !is_file($path) || !is_file($thumb)) {
			
				/* delete if photo exist*/
				if($this->photo) {
				
					$prevphoto = $this->photo;
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
					$path_parts = pathinfo($path.$prevphoto->filename);
					$newfileimgsrc = $path.'_s.'.$path_parts['extension'];
					$thumb = $path.$path_parts['filename'].'_'.$this->photo->sizethumb.'_s.'.$path_parts['extension'];
					if(is_file($thumb)) {
						JFILE::delete($thumb);
					}

				}
				/* delete if photo exist*/

				
						$sizethumb = explode('x',$data['sizethumb']);
						/* if no photo */
						if(sizeof($sizethumb) == 1 || empty($sizethumb)) {
								$sizethumb = array(50,50);
						}
						/* if no photo */
						

						$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$this->photo->uri;
						$targetDir = $path;
						$path_parts = pathinfo($path.$this->photo->filename);
						
						
						$newfileimgsrc = $path.'_s.'.$path_parts['extension'];

						$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
						$imgsrc = $path.$this->photo->filename;
					
						if(is_file($path.$this->photo->filename)) {
							$image = new JImage();
						 $path = $endpath;
						 //загружаем исходный файл

						 $image->loadFile($targetDir.$this->photo->filename);

						$sourceWidth = $image->getWidth();
						$sourceHeight = $image->getHeight();

						$targetWidth = $sizethumb[0];
						$targetHeight = $sizethumb[1];

						$sourceRatio = $sourceWidth / $sourceHeight;
						$targetRatio = $targetWidth / $targetHeight;

						if ( $sourceRatio < $targetRatio ) {
							$scale = $sourceWidth / $targetWidth;
						} else {
							$scale = $sourceHeight / $targetHeight;
						}

						$resizeWidth = (int)($sourceWidth / $scale);
						$resizeHeight = (int)($sourceHeight / $scale);

						$cropLeft = (int)(($resizeWidth - $targetWidth) / 2);
						$cropTop = (int)(($resizeHeight - $targetHeight) / 2);

						$newimg = $image->resize($resizeWidth, $resizeHeight, true, JImage::SCALE_OUTSIDE);
						$newimg =  $newimg->crop($targetWidth, $targetHeight, $cropLeft, $cropTop, true);
						//уменьшаем размеры в 2 раза
						$new_width = $sizethumb[0];
						$new_height = $sizethumb[1];
						//задаем размеры для нового изображения.
						//параметр "true" означает, что данный метод вернет новый объект JImage уже с измененным изображением
						
						//сохраняем изображение в новый файл
						$path_parts = pathinfo($imgsrc);

						/*
							echo $path_parts['dirname'], "\n";
							echo $path_parts['basename'], "\n";
							echo $path_parts['extension'], "\n";
							echo $path_parts['filename'], "\n"; // начиная с PHP 5.2.0
						*/

						$newfileimgsrc = $targetDir.$path_parts['filename'].'_'.$data['sizethumb'].'_s.'.$path_parts['extension'];
						$newimg->toFile($newfileimgsrc, IMAGETYPE_PNG);
						chmod($newfileimgsrc,0775);
		
				} else {
				
				
				}
			}

		return true;
	}

	/* удаление товаров и всего, что с ними связано */
	function delete(&$post)
	{
		
		$post = JRequest::get( 'post' );
		$cids = $post['cid'];

		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('photos.*');
		$query->from('`#__ejoshop_currency` AS photos');

		if(isset($cids)) {
			$query->where('photos.id IN (' .  implode(',', $cids) . ')');
		}
		$query = $db->setQuery( $query);
		$photos = $db->loadObjectList();	
		

	

		$orderclass = new EjoshopRenderPayd();
		$isUsed = $orderclass->checkItemInUsedOrders($cids); // check if item used in orders
		
		
		if(count($isUsed) > 0) {
			
			JError::raiseWarning( 500, JText::plural('COM_EJOSHOP_ITEM_IS_USED', count($isUsed)));
			$link = 'index.php?option=com_ejoshop&view=ejoshopphotos';
			$app = JFactory::getApplication();
			$app->redirect($link);
			return false;
		}
		
		
		foreach($photos as $photo) {
			


			$prevphoto = $photo;
			$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
			$path_parts = pathinfo($path.$prevphoto->filename);
			$newfileimgsrc = $path.'_s.png';
			$thumb = $path.$path_parts['filename'].'_s.png';
			if(!empty($prevphoto->sizethumb)) {
					$sizethumb = $path.$path_parts['filename'].'_'.$prevphoto->sizethumb.'_s.png';
			}

			if(!JFILE::delete($path.$prevphoto->filename)) {
				JError::raiseWarning( 500, 'Ошибка при удалении файла!');
			}
			if(!JFILE::delete($thumb)) {
				JError::raiseWarning( 500, 'Ошибка при удалении файла!');
			}
			if(is_file($sizethumb)) {
				if(!JFILE::delete($sizethumb)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
		}
				

		if (count( $cids )) {
			foreach($cids as $cid) {
			$query = 'DELETE FROM #__ejoshop_currency'
			. ' WHERE id = ' .$cid;
				$db->setQuery( $query );
				if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
				}
			}
		}
		return true;
	}
	
	
	public function publish($pks = null, $state = 1, $userId = 0)
	{
		// Initialise variables.
		$k = $this->_tbl_key;
		
		// Sanitize input.
		JArrayHelper::toInteger($pks);
		$userId = (int) $userId;
		$state = (int) $state;

		// If there are no primary keys set check to see if the instance key is set.
		if (empty($pks))
		{
			if ($this->$k)
			{
				$pks = array($this->$k);
			}
			// Nothing to set publishing state on, return false.
			else
			{
				$e = new JException(JText::_('JLIB_DATABASE_ERROR_NO_ROWS_SELECTED'));
				$this->setError($e);

				return false;
			}
		}

		// Update the publishing state for rows with the given primary keys.
		$query = $this->_db->getQuery(true);
		$query->update($this->_tbl);
		$query->set('state = ' . (int) $state);

		// Determine if there is checkin support for the table.
		if (property_exists($this, 'checked_out') || property_exists($this, 'checked_out_time'))
		{
			$query->where('(checked_out = 0 OR checked_out = ' . (int) $userId . ')');
			$checkin = true;
			
		}
		else
		{
			$checkin = false;
		}

		// Build the WHERE clause for the primary keys.
		$query->where($k . ' = ' . implode(' OR ' . $k . ' = ', $pks));
	
		$this->_db->setQuery($query);

		// Check for a database error.
		if (!$this->_db->execute())
		{
			$e = new JException(JText::sprintf('JLIB_DATABASE_ERROR_PUBLISH_FAILED', get_class($this), $this->_db->getErrorMsg()));
			$this->setError($e);

			return false;
		}

		// If checkin is supported and all rows were adjusted, check them in.
		if ($checkin && (count($pks) == $this->_db->getAffectedRows()))
		{
			// Checkin the rows.
			foreach ($pks as $pk)
			{
				$this->checkin($pk);
			}
		}

		// If the JTable instance value is in the list of primary keys that were set, set the instance.
		if (in_array($this->$k, $pks))
		{
			$this->state = $state;
		}

		$this->setError('Error');
		return true;
	}

}
