<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modeladmin');
jimport('joomla.html.pagination');
jimport( 'joomla.application.component.modellist' );

class  EjoshopModelEjoshopNewGallery extends JModelList
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'hits', 'a.hits',
				'name', 'a.title',

			);
		}

		parent::__construct($config);
	}

	protected function getListQuery()
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
 
                //CHANGE THIS QUERY AS YOU NEED...
                $query->select('id As value, name As name');
		$query->from('#__ejoshop_galleries AS a');
		$query->order('a.name');

 
 
		// Filter
		$search = $this->getState('filter.search');
		if (!empty($search)) {
			$query->where('(a.name LIKE '.$search.')');
		}
 
		return $query;
	}
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');

		// Load the filter state.
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);


		// List state information.
		parent::populateState('a.galid', 'asc');
	}
	
	var $_foobar;

	public function getForm($data = array(), $loadData = true) {
		
		$app	= JFactory::getApplication();
		$form 	= $this->loadForm('com_ejoshop.ejoshopallgalleries', 'galleries', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}
		return $form;
	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getCategories()
	{

	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getCategories();

		if (empty($form)) {
			return false;
		}
		return $form;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPhotos()
	{
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		$query->select('photos.*,gal.name as galery_name,cat.title as category_name');
		$query->from('`#__ejoshop_photos` AS photos');
		$query->join('LEFT', '#__ejoshop_galleries AS gal ON (photos.galid = gal.galid)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering');
		$orderDirn	= $this->state->get('list.direction');

		$query->order($db->escape($orderCol.' '.$orderDirn));
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->categories = $db->loadObjectList();

		return $this->categories;

	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getGalleries()
	{
	
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		$query->select('gal.*');
		$query->from('`#__ejoshop_galleries` AS gal');
		
		$query->order('galid DESC');
		$query = $db->setQuery( $query );
		$this->categories = $db->loadObjectList();
		return $this->categories;

	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getFoobar()
	{

	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');
	if($data['task'] !== 'add') {
	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select('a.*');
		$query->from('`#__ejoshop` AS a');
		$search = $this->getState('filter.search');
		
		if (!empty($search))
		{
			if (stripos($search, 'id:') === 0) {
				$query->where('a.id = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( a.name LIKE '.$search.')');
			}
		}
		$query->order('galid DESC');
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->_foobar = $db->loadObjectList();
		
	}
	else {
	
		$query = ' SELECT * '
			. ' FROM #__ejoshop_galleries ORDER BY GALID DESC';
			$query = $db->setQuery( $query);
		$this->_foobar = $db->loadObjectList();
		}
		return $this->_foobar;
	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */

	
	function getReviews()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_galleries";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_galleries";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	
	
	function getPhotosPager()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_photos";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_photos";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
		
	function store($post)
	{
		$row = $this->getTable('ejoshopnewgallery');
		
	
		
		$data = JRequest::get( 'post' );
		$data['misil'] = JRequest::getVar('misil', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$data['misilonclick'] = JRequest::getVar('misilonclick', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$data['text_map_yandex'] = JRequest::getVar('jform', '', 'post', 'string', JREQUEST_ALLOWRAW);
		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		$date = date("Y-m-d H:i:s", time());

		// Store the web link table to the database
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_galleries')
			." (
				`name` ,
				`gallery_type` ,
				`description` ,
				`ordering` ,
				`published` ,
				`hits` ,
				`catid` ,
				`params`,
				`created`
				)
				VALUES (
				'".$data['name']."', 'map', '".$data['description']."', '0', '0', '0', '".$data['category']."', '', '".$date."'
				);";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}

	function delete(&$post)
	{

		$cids = $post['cid'];
		$db		=& JFactory::getDBO();
		if (count( $cids )) {
			foreach($cids as $cid) {
			$query = 'DELETE FROM #__ejoshop'
			. ' WHERE id = ' .$cid;
				$db->setQuery( $query );
				if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
				}
			}
		}
		return true;
	}

}


