<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modeladmin');
jimport('joomla.application.component.model');
jimport( 'joomla.application.component.modelform' );
jimport('joomla.html.pagination');
jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.render.renderpayd' );
ejoshopimport( 'ejoshop.developer.developer' );

class EjoshopModelEjoshopOrder extends EjoshopModel
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
			$config['filter_fields'] = array(
				'pid', 'orders.pid',
				'published', 'orders.published',
				'hits', 'orders.hits',
				'name', 'orders.name',
				'created', 'orders.created',

			);

		parent::__construct($config);
	}

	function getCat()
	{
		$tableCode = EjoshopModel::getInstance('EjoshopModelEjoshopNewGallery', '');

		return $tableCode;
	}
	
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');
		$option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		// Load the filter state.
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		
		$filter_type = $app->getUserStateFromRequest('filter.filter_type', 'filter_type', '');
		$app->setUserState('filter.filter_type', $filter_type);
		
		$filter_status = $app->getUserStateFromRequest($option.$view.'.filter.filter_status', 'filter_status', '');
		
		$this->setState('filter.filter_status', $filter_status);
		// List state information.
		parent::populateState('orders.pid', 'desc');
	}
	


	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}
	
	/**
	 * 
	 * @возвращает все заказы и не только завершённые, 
	 * заказы с метками cart и confirm удаляются автоматически после 1 суток
	 */
	function getOrder($pid = 0)
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'pid' );
		}
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$task = JRequest::getVar('task',FALSE);
		$controller = JRequest::getVar('controller',FALSE);
		
		$limitstart = JRequest::getVar('limitstart', 0);
				
	

		$query->from('`#__ejoshop_shop_order` AS orders');
		$query->select('userinfo_cart.*,cat.*,orders.*,photos.*,orders.created_by as orderuser,orders.status as orderstatus, orders.created as ordertime, userinfo_cart.name as username,userinfo_cart.lastname as infolastname, payd.*,orders.moneysystem as moneysystem,fm.filename,fm.uri');
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.id = orders.photo_id)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (cat.id = photos.catid)');
		$query->join('LEFT', '#__ejoshop_userinfo_cart AS userinfo_cart ON (userinfo_cart.uid = orders.created_by)');
		$query->join('LEFT', '#__ejoshop_payd AS payd ON (payd.payid = orders.payid)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (fm.fid = photos.filename)');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','pid');
		$orderDirn	= $this->state->get('list.direction','DESC');
		//var_dump($query->_toString($query));
		
		if(isset($pid)) {
			$query->where('orders.pid = '.(int) $pid);
		}

		/* STATUS FILTER */
		$filter_status = $this->getState('filter.filter_status', 'all');
		
		if(!empty($filter_status)) {
		
			if($filter_status != 'all') {
		
				$query->where("orders.status = '". $filter_status ."'");					
			}

		} 

				
		$filter_type = $app->getUserStateFromRequest('filter.filter_type', 'filter_type', '');
	
		if(empty($filter_type)) {
			$filter_type = $app->getUserState('filter.filter_type', '');
		}
		
		/* TYPE PAYMENT FILTER */
		if(!empty($task)) {
			$filter_type = (JRequest::getVar('filter_type',0)) ? JRequest::getVar('filter_type',0) : $task;
			$filter_type = $app->setUserState('filter.filter_type',$filter_type);
		}

	
		
		if(!empty($filter_type)) {
			$task = $filter_type;
		}
		if($filter_type == 'all') {
			$task = FALSE;
		}
		
		$not_money_system = array('paywithpost','paywithbill');
		if($task && strpos($task,'today') === FALSE && $task != 'all') {
			if(!in_array($task,$not_money_system)) {
				$query->where("payd.moneysystem = '".$task."'");
			} else {
				$query->where("orders.moneysystem = '".$task."'");
			}
		} 
		else if(strpos($task,'today') !== FALSE) {
			if(!in_array($task,$not_money_system)) {
				$query->where("payd.moneysystem = '".str_replace('today','',$task)."' AND DATE(`payd`.`created`) = CURDATE()");
			} else {
				$query->where("orders.moneysystem = '".str_replace('today','',$task)."' AND DATE(`orders`.`created`) = CURDATE()");
			}
		}
		
		$search = $this->getState('filter.search');
	

		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);

		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->orders = $db->loadObjectList();

		return $this->orders;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getFoobar()
	{

	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');
	if($data['task'] !== 'add') {
	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select('a.*');
		$query->from('`#__ejoshop_categories` AS a');
		$search = $this->getState('filter.search');
		
		if (!empty($search))
		{
	
			if (stripos($search, 'id:') === 0) {
				$query->where('a.cat = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( a.name LIKE '.$search.')');
			}
		}
		
		$query->order('id DESC');
	
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->_foobar = $db->loadObjectList();
		
	}
	else {
	
		$query = ' SELECT * '
			. ' FROM #__ejoshop_categories ORDER BY ID DESC';
			$query = $db->setQuery( $query);
		$this->_foobar = $db->loadObjectList();
		}
		return $this->_foobar;
	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */

	
	function getReviews()
	{

		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart');
		$task = JRequest::getVar('task',FALSE);
	
		$db = JFactory::getDBO();
		$not_money_system = array('paywithpost','paywithbill');
		$query	= $db->getQuery(true);
		$query->from('`#__ejoshop_shop_order` AS orders');
	
		$query->select('count(*) as total, userinfo_cart.*,cat.*,orders.*,photos.*,orders.created_by as orderuser,orders.status as orderstatus, orders.created as ordertime, userinfo_cart.name as username,userinfo_cart.lastname as infolastname, orders.moneysystem as moneysystem');
		if(!in_array($task,$not_money_system)) {
			$query->select('payd.*');
		}
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.id = orders.photo_id)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (cat.id = photos.catid)');
		$query->join('LEFT', '#__ejoshop_userinfo_cart AS userinfo_cart ON (userinfo_cart.uid = orders.created_by)');
		

				
		if(!in_array($task,$not_money_system)) {
			$query->join('LEFT', '#__ejoshop_payd AS payd ON (payd.payid = orders.payid)');
		}
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','pid');
		$orderDirn	= $this->state->get('list.direction','DESC');
		//var_dump($query->_toString($query));


	

		
		$filter_status = $this->getState('filter.filter_status', 'all');
		
		if(!empty($filter_status)) {
		
			if($filter_status != 'all') {
		
				$query->where("orders.status = '". $filter_status ."'");					
			}

		}
	

		/* TYPE PAYMENT FILTER */
		if(!empty($task)) {
			$filter_type = (JRequest::getVar('filter_type',0)) ? JRequest::getVar('filter_type',0) : $task;
			$filter_type = $app->setUserState('filter.filter_type',$filter_type);
		}
		
		$filter_type = $app->getUserState('filter.filter_type', '');

		if(!empty($filter_type)) {
			$task = $filter_type;
		}

		if($task && strpos($task,'today') === FALSE && $task != 'all') {
			if(!in_array($task,$not_money_system)) {
				$query->where("payd.moneysystem = '".$task."'");
			} else {
				$query->where("orders.moneysystem = '".$task."'");
			}
		} 
		else if(strpos($task,'today') !== FALSE) {
			if(!in_array($task,$not_money_system)) {
				$query->where("payd.moneysystem = '".str_replace('today','',$task)."' AND DATE(`payd`.`created`) = CURDATE()");
			} else {
				$query->where("orders.moneysystem = '".str_replace('today','',$task)."' AND DATE(`orders`.`created`) = CURDATE()");
			}
		}
		
		$search = $this->getState('filter.search');
		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}
		$query->order($db->escape($orderCol.' '.$orderDirn));
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);

		$db->setQuery( $query );

		$total = $db->loadAssoc();

		return $this->pageNav = new JPagination($total['total'], $limitstart, $limit);
		
	}
	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
		
	function store($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$galid = $data['galid'];
		$catid = $data['catid'];

			
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_photos') 
			." (`galid`, `catid`, `params`) VALUES ('".$galid."', '".$catid."', '');";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}


	function closeorder($post)
	{

			$data = JRequest::get( 'post' );
			$pids = $data['pid'];
			if(!is_array($pids)) $pids = array($pids);
			
			$db = $this->getDBO();
			foreach($pids as $pid) {
				$query = "UPDATE ".$db->quoteName('#__ejoshop_shop_order') 
				." set ".$db->quoteName('status')." = 'closed' WHERE ".$db->quoteName('pid')." =".$pid;
				
				$db->setQuery($query);
				
				if (!$db->query()) {
					$this->setError($this->_db->getErrorMsg());
					//print $this->_db->getErrorMsg();
					//die();
					return false;
				
				}
			}

		return true;
	}

	
	function photoedit($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$latitude = $data['latitude'];
		$longitude = $data['longitude'];
		$description = $data['intro'];
		$coords = $data['coords'];
		$allcoolor = array();
		foreach($data['color'] as $al) {
			$allcoolor[] = $al;
		}		
		$color = json_encode($allcoolor);
		$data['phototext'] = JRequest::getVar('phototext', '', 'post', 'string', JREQUEST_ALLOWRAW);

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		$data["parent_category"] = (empty($data["parent_category"])) ? 0 : $data["parent_category"];
		
		$date = date("Y-m-d H:i:s", time());
		$this->photo = $this->getPhotos($data['id']);
		$this->photo = $this->photo[0];	
		$data['tplonephoto'] = !empty($data['tplonephoto']) ? $data['tplonephoto'] : $this->photo->tplonephoto;
		// Store the web link table to the database
			$db = $this->getDBO();
			
			$query = "UPDATE ".$db->quoteName('#__ejoshop_photos') 
			." set ".$db->quoteName('latitude')." = '".$this->textnl($latitude)
			."', ".$db->quoteName('longitude')." = '".$this->textnl($longitude)
			."', ".$db->quoteName('intro')." = '".$this->textnl($data['intro'])
			."', ".$db->quoteName('maptype')." = '".$this->textnl($data['coords'])
			."', ".$db->quoteName('catid')." = '".$this->textnl($data['category'])
			."', ".$db->quoteName('galid')." = '".$this->textnl($data['gallery'])
			."', ".$db->quoteName('price')." = '".$this->textnl($data['price'])
			."', ".$db->quoteName('showprice')." = '".$this->textnl($data['showprice'])
			."', ".$db->quoteName('currency')." = '".$this->textnl($data['currency'])
			."', ".$db->quoteName('created')." = '".$this->textnl($data['created'])
			."', ".$db->quoteName('description')." = '".$this->textnl($data['description'])
			."', ".$db->quoteName('keyword')." = '".$this->textnl($data['keyword'])
			."', ".$db->quoteName('tplonephoto')." = '".$data['tplonephoto']
			."', ".$db->quoteName('showquanity')." = '".$this->textnl($data['showquanity'])
			."', ".$db->quoteName('quanity')." = '".$this->textnl($data['quanity'])
			."', ".$db->quoteName('phototext')." = '".$data['phototext']
			."', ".$db->quoteName('showcolor')." = '".$this->textnl($data['showcolor'])
			."', ".$db->quoteName('created_by')." = '".$this->textnl($data['created_by'])
			."', ".$db->quoteName('sizethumb')." = '".$data['sizethumb']
			."', ".$db->quoteName('color')." = '".$this->textnl($color)
			."', ".$db->quoteName('addtocartshow')." = '".$data['addtocartshow']
			."' WHERE ".$db->quoteName('id')." =".$data['id'];
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				//print $this->_db->getErrorMsg();
				//die();
				return false;
			
			}
			/* pre generate mini thumb */
			
			
			if(!empty($data['sizethumb']) && $data['sizethumb'] != $this->photo->sizethumb) {
				
				
				if($this->photo) {
				
					$prevphoto = $this->photo;
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
					$path_parts = pathinfo($path.$prevphoto->name);
					$newfileimgsrc = $path.'_s.png';
					$thumb = $path.$path_parts['filename'].'_'.$this->photo->sizethumb.'_s.png';
	
					JFILE::delete($thumb);
		
					 
				}
				
						$sizethumb = explode('x',$data['sizethumb']);
						
						
						$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$this->photo->uri;
						$targetDir = $path;
						$path_parts = pathinfo($path.$this->photo->name);
						
						
						$newfileimgsrc = $path.'_s.png';

						$thumb = $path.$path_parts['filename'].'_s.png';
						$imgsrc = $path.$this->photo->name;
					
						if(is_file($path.$this->photo->name)) {
							$image = new JImage();
						 $path = $endpath;
						 //загружаем исходный файл
						 $image->loadFile($targetDir.$this->photo->name);

						$sourceWidth = $image->getWidth();
						$sourceHeight = $image->getHeight();

						$targetWidth = $sizethumb[0];
						$targetHeight = $sizethumb[1];

						$sourceRatio = $sourceWidth / $sourceHeight;
						$targetRatio = $targetWidth / $targetHeight;

						if ( $sourceRatio < $targetRatio ) {
							$scale = $sourceWidth / $targetWidth;
						} else {
							$scale = $sourceHeight / $targetHeight;
						}

						$resizeWidth = (int)($sourceWidth / $scale);
						$resizeHeight = (int)($sourceHeight / $scale);

						$cropLeft = (int)(($resizeWidth - $targetWidth) / 2);
						$cropTop = (int)(($resizeHeight - $targetHeight) / 2);

						$newimg = $image->resize($resizeWidth, $resizeHeight, true, JImage::SCALE_OUTSIDE);
						$newimg =  $newimg->crop($targetWidth, $targetHeight, $cropLeft, $cropTop, true);
						//уменьшаем размеры в 2 раза
						$new_width = $sizethumb[0];
						$new_height = $sizethumb[1];
						//задаем размеры для нового изображения.
						//параметр "true" означает, что данный метод вернет новый объект JImage уже с измененным изображением
						
						//сохраняем изображение в новый файл
						$path_parts = pathinfo($imgsrc);

						/*
							echo $path_parts['dirname'], "\n";
							echo $path_parts['basename'], "\n";
							echo $path_parts['extension'], "\n";
							echo $path_parts['filename'], "\n"; // начиная с PHP 5.2.0
						*/
						
						$newfileimgsrc = $targetDir.$path_parts['filename'].'_'.$data['sizethumb'].'_s.png';
						$newimg->toFile($newfileimgsrc, IMAGETYPE_PNG);
				} else {
				
				
				}
			}

		return true;
	}

	function delete(&$post)
	{
		$type_fileter = $this->getState('filter.filter_type', '');


		
		$pids = $post['pid'];
		$db		= JFactory::getDBO();


		if($type_fileter == 'pay' || $type_fileter == 'all') {
			$orderclass = new EjoshopRenderPayd();
			$items = $orderclass->getOrderInfo($pids); // get data from orders
			$check = $this->CheckCanDeleteItems($items,$pids); // update info in payd table
			
			if(!empty($check)) {
				$s = implode(',',$check);
				JError::raiseWarning( 500, JText::plural('COM_EJOSHOP_ORDERS_IS_USED', $s));
				$pids = array_diff($pids,$check);
		
			}
		
			
			$newitem = $this->GeneretenewItems($items,$pids); // update info in payd table


			$query = "DELETE FROM #__ejoshop_shop_order"
				. " WHERE pid IN (" . implode(',',$pids) . ");";
			$db->setQuery( $query );
			if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
					return false;
			}
				
			foreach($newitem as $key =>$item) {
				$item = array_values($item);
				$data['pids'] = json_encode($item);
				$data['payid'] = $key;
				
				$orderclass->updateOrders($data);
			}
		
		} else {
			if (count( $pids )) {
			 
				$query = $db->getQuery(true);
				$conditions  = array();
				if(!empty($type_fileter)) {
					$conditions = array(
						$db->quoteName('status') . '='.$type_fileter, 
					);
				}
				array_push($conditions,$db->quoteName('pid') . ' IN('.implode(',',$pids).')');

				$query->delete($db->quoteName('#__ejoshop_shop_order'));
				$query->where($conditions);
	
				$db->setQuery($query);
				
				if (!$db->execute()) {
					JError::raiseWarning( 500, $db->getError() );
				}

				}
			
			
		}
		
		
		return true;
	}
	
   /*
	* check order time, if more than one days it can be delete
	*
	*/
	
	public function CheckCanDeleteItems($items,$pids)
	{
		$itemtochange = array();
		$newitem = array();

		foreach($items as $item) {
			
			$passtime = (time() - $item->ordertime) / 86400;
			
			if($passtime < 1) {
				$newitem[] = $item->pid;	
			}
		}
		return $newitem;
		
	}
	
	public function GeneretenewItems($items,$pids)
	{
		


		
		$itemtochange = array();
		$newitem = array();

		foreach($items as $item) {
			if(!empty($item->payid)) {
					$expids = json_decode($item->pids);
					if(!empty($expids)) {
						foreach($expids as $id) {
		
							if(in_array($id,$pids)) {
						
								$i = array_search($id,$expids);
		
								unset($expids[$i]);
								$newitem[$item->payid] = $expids;
							}
						}
					}
					//$newitem[] = json_encode(array_values($expids));
					
		
			}
		}

		return $newitem;
	}
	
	
	public function publish(&$pks, $value = 1)
	{

		// Initialise variables.
		$dispatcher = JDispatcher::getInstance();
		$user = JFactory::getUser();
		$table = $this->getTable();
		$pks = (array) $pks;

		// Include the content plugins for the change of state event.
		JPluginHelper::importPlugin('content');

		// Access checks.
		foreach ($pks as $i => $pk)
		{
			$table->reset();
		}

		// Attempt to change the state of the records.
		if (!$table->publish($pks, $value, $user->get('id')))
		{

		$this->setError($table->getError());
		
		return false;
		}

		$context = $this->option . '.' . $this->name;

		// Trigger the onContentChangeState event.
		$result = $dispatcher->trigger($this->event_change_state, array($context, $pks, $value));

		if (in_array(false, $result, true))
		{
		$this->setError($table->getError());
		return false;
		}

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
