<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modeladmin');
jimport('joomla.application.component.model');
jimport( 'joomla.application.component.modelform' );
jimport('joomla.html.pagination');
jimport( 'joomla.application.component.modellist' );

class  EjoshopModelejoshopPayd extends JModelList
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
			$config['filter_fields'] = array(
				'payid', 'payd.payid',
				'created', 'payd.created',
				'moneysystem', 'payd.moneysystem',

			);

		parent::__construct($config);
	}

	
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');

		// Load the filter state.
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);


		// List state information.
		parent::populateState('payd.payid', 'desc');
	}
	
	var $_foobar;

	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}
	
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPayds($pid = 0)
	{
		$payid = JRequest::getVar('payid',0);

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'payd.*'
			)
		);
		$query->from('`#__ejoshop_payd` AS payd');
		
		// Add the list ordering clause.
		// Add the list ordering clause.
		$listOrder	= $this->state->get('list.ordering');
		$listDirn	= $this->state->get('list.direction');

		if(!empty($payid)) {
			$query->where('payd.payid = '.(int) $payid);
		}

		$query->order($db->escape($listOrder.' '.$listDirn));
			//var_dump($query->__toString());
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->payd = $db->loadObjectlist();
		
		for($i = 0; $i < count($this->payd); $i++) {
		
			switch ($this->payd[$i]->moneysystem) {
				case 'webmoney':
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_WM');
				break;
				case 'yandexmoney' :
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_YANDEXM');
				break;
				case 'paypal':
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_PAYPAL');
				break;
				case 'anet':
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_ANET');
				break;
				case 'postpay':
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_POSTPAY');
				break;
				default:
				$this->payd[$i]->moneysystem = JText::_('COM_EJOSHOP_NO_MONEY_SYSTEM');
				break;
			}
		}
		
		if(!empty($payid)) {
			
			$products = $this->getProducts($this->payd[0]->payid);
			return $products;
		}
		
		return $this->payd;

	}


	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getProducts($payid = 0,$limit = 0, $module = false)
	{

		if(empty($payid)) {
			$payid = JRequest::getVar( 'id' );
		}

		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'shoporders.select',
				'shoporders.*'
			)
		);
		
				

		$query->from('`#__ejoshop_shop_order` as shoporders');
		$query->select('cat.title as category_name, photos.*');
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.id= shoporders.photo_id)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('shoporders.ordering','shoporders.pid');
		$orderDirn	= $this->state->get('shoporders.direction','DESC');
	
		//var_dump($pid);
		if(!$module) {
			if(isset($payid)) {
				if(is_array($payid)) {
					$query->where('shoporders.payid IN ('.implode(',', $payid).')');
				} else {
					$query->where('shoporders.payid = '.(int) $payid);
			
				}
			}
		}
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		//$query->group('shoporders.payid');
		//var_dump($query->__toString());
		$query = $db->setQuery( $query );
		
		try {
				
			if(!$db->query()) {
				throw new Exception($db->getErrorMsg());
			}
		} catch(Exception $e) {
			$app->enqueueMessage($e->getMessage(), 'error');
		}
		$this->photos = $db->loadObjectList();
		/*
		if (!$db->query()) {
			
			
			// Include the JLog class.
			jimport('joomla.log.log');
			
			// Add the logger.
			JLog::addLogger(
				 // Pass an array of configuration options
				array(
						// Set the name of the log file
						
						// (optional) you can change the directory
						'text_file' => 'com_ejoshop.log.php',
						JLog::ALL,
					   //Chooses a category name
		   				'com_ejoshop'
				 )
			);
			
			// start logging...
			
  			JLog::add($this->_db->getErrorMsg(), JLog::WARNING);
		
				return false;
		}
		*/

		
		return $this->photos;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */

	
	function getPaypager()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_payd";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_payd";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
		
	function store($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$galid = $data['galid'];
		$catid = $data['catid'];

			
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_payd') 
			." (`galid`, `catid`, `params`) VALUES ('".$galid."', '".$catid."', '');";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}

	
	function createFields($fieldsname,$fieldsvalue)
	{
		$o = array();
		foreach($fieldsname as $key => $val) {
		
			$o[$key] = array($val,$fieldsvalue[$key]);
			
		}
		
		$r = serialize($o);


		return $r;

	}	
	function photoedit($post)
	{
		$row = $this->getTable('ejoshoppayd');
 	//id 	p_name 	p_desc 	p_settings 	published 	p_createdon 	p_sdk_version 	type 	bill
		$data = JRequest::get( 'post' );
		

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
			
		}
		// Store the Phoca gallery table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
		
			return false;
		}
		return true;
	}

	/*
	 * Delete data about payments
	 *
	 */
	
	function delete(&$post)
	{
		$cids = $post['cid'];
		
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('payd.*');
		$query->from('`#__ejoshop_payd` AS payd');

		if(isset($cids)) {
			$query->where('payd.payid IN (' .  implode(',', $cids) . ')');
		}
		$query = $db->setQuery( $query);
		$payd = $db->loadObjectList();	

		foreach($payd as $order_item) {
			
			$query = $db->getQuery(true);
			$conditions  = array();

			$conditions = array(
				$db->quoteName('payid') . '='.$order_item->payid, 
			);
			$query->delete($db->quoteName('#__ejoshop_shop_order'));
			$query->where($conditions);
	
			$db->setQuery($query);
			
			if (!$db->execute()) {
				JError::raiseWarning( 500, $db->getError() );
			}
		}
				
		
		if (count( $cids )) {
			foreach($cids as $cid) {
			$query = 'DELETE FROM #__ejoshop_payd'
			. ' WHERE payid = ' .$cid;
				$db->setQuery( $query );
				if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
					return false;
				}
			}
		}
		return true;
	}
	
	public function publish(&$pks, $value = 1)
	{

		// Initialise variables.
		$dispatcher = JDispatcher::getInstance();
		$user = JFactory::getUser();
		$table = $this->getTable();
		$pks = (array) $pks;

		// Include the content plugins for the change of state event.
		JPluginHelper::importPlugin('content');

		// Access checks.
		foreach ($pks as $i => $pk)
		{
			$table->reset();
		}

		// Attempt to change the state of the records.
		if (!$table->publish($pks, $value, $user->get('id')))
		{

		$this->setError($table->getError());
		
		return false;
		}

		$context = $this->option . '.' . $this->p_name;

		// Trigger the onContentChangeState event.
		$result = $dispatcher->trigger($this->event_change_state, array($context, $pks, $value));

		if (in_array(false, $result, true))
		{
		$this->setError($table->getError());
		return false;
		}

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
