<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport('joomla.html.pagination');
jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.developer.developer' );

class  EjoshopModelejoshoppayments extends JModelList
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
			$config['filter_fields'] = array(
				'id', 'payments.id',
				'published', 'payments.published',
				'hits', 'payments.p_hits',
				'name', 'payments.p_name',
				'p_createdon', 'payments.p_createdon',

			);

		parent::__construct($config);
	}

	
	protected function getListQuery()
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
 
        //CHANGE THIS QUERY AS YOU NEED...
        $query->select('id As value, name As name');
		$query->from('#__ejoshop_payments AS a');
		$query->order('a.name');

 
 
		// Filter
		$search = $this->getState('filter.search');
		if (!empty($search)) {
			$query->where('(a.name LIKE '.$search.')');
		}
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
		return $query;
	}
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');
        $option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		// Load the filter state.
		$search = $app->getUserStateFromRequest($option.$view.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);


		// List state information.
		parent::populateState('payments.id', 'desc');
	}


	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}
	
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPayments($pid = 0)
	{
		
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		$option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'payments.*'
			)
		);
		
				

		$query->from('`#__ejoshop_payments` AS payments');
				
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering');
		$orderDirn	= $this->state->get('list.direction','DESC');
		
		$search	= $app->getUserStateFromRequest($option.$view.'.filter.search','filter_search',FALSE);
		if (!empty($search))
		{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( payments.p_name LIKE '.$search.')');
		};
		
		if(isset($pid)) {
			$query->where('payments.id = '.(int) $pid);
		}
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->payments = $db->loadObjectList();

		return $this->payments;

	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */

	
	function getPaypager()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',
		$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query = "SELECT count(*) FROM #__ejoshop_payments";
		$db->setQuery( $query );
		$total = $db->loadResult();
		$query = "SELECT * FROM #__ejoshop_payments";
		$db->setQuery( $query, $limitstart, $limit );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
		
	function store($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$galid = $data['galid'];
		$catid = $data['catid'];

			
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_payments') 
			." (`galid`, `catid`, `params`) VALUES ('".$galid."', '".$catid."', '');";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}

	
	function createFields($fieldsname,$fieldsvalue)
	{
		$o = array();
		foreach($fieldsname as $key => $val) {
		
			$o[$key] = array($val,$fieldsvalue[$key]);
			
		}
		
		$r = serialize($o);


		return $r;

	}	
	function photoedit($post)
	{
		$row = $this->getTable('ejoshoppayments');
 	//id 	p_name 	p_desc 	p_settings 	published 	p_createdon 	p_sdk_version 	type 	bill
		$data = JRequest::get( 'post' );
		

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
			
		}
		// Store the Phoca gallery table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
		
			return false;
		}
		return true;
	}

	function delete(&$post)
	{
		$cids = $post['cid'];
		
		$db		=& JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('payments.*');
		$query->from('`#__ejoshop_payments` AS payments');

		if(isset($cids)) {
			$query->where('payments.id IN (' .  implode(',', $cids) . ')');
		}
		$query = $db->setQuery( $query);
		$payments = $db->loadObjectList();	

		foreach($payments as $photo) {
			


			$prevphoto = $photo;
			$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
			$path_parts = pathinfo($path.$prevphoto->name);
			$newfileimgsrc = $path.'_s.png';
			$thumb = $path.$path_parts['filename'].'_s.png';


			if(!JFILE::delete($path.$prevphoto->name)) {
				//JError::raiseWarning( 500, 'Ошибка при удалении файла!');
			}
			if(!JFILE::delete($thumb)) {
				//JError::raiseWarning( 500, 'Ошибка при удалении файла!');
			}
		}
				

		if (count( $cids )) {
			foreach($cids as $cid) {
			$query = 'DELETE FROM #__ejoshop_payments'
			. ' WHERE id = ' .$cid;
				$db->setQuery( $query );
				if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
				}
			}
		}
		return true;
	}
	
	public function publish(&$pks, $value = 1)
	{

		// Initialise variables.
		$dispatcher = JDispatcher::getInstance();
		$user = JFactory::getUser();
		$table = $this->getTable();
		$pks = (array) $pks;

		// Include the content plugins for the change of state event.
		JPluginHelper::importPlugin('content');

		// Access checks.
		foreach ($pks as $i => $pk)
		{
			$table->reset();
		}

		// Attempt to change the state of the records.
		if (!$table->publish($pks, $value, $user->get('id')))
		{

		$this->setError($table->getError());
		
		return false;
		}

		$context = $this->option . '.' . $this->p_name;

		// Trigger the onContentChangeState event.
		$result = $dispatcher->trigger($this->event_change_state, array($context, $pks, $value));

		if (in_array(false, $result, true))
		{
		$this->setError($table->getError());
		return false;
		}

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
