<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.render.renderpayd' );
ejoshopimport( 'ejoshop.imageeditor.phpimageeditor') ;
ejoshopimport( 'ejoshop.developer.developer' );
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.html.pagination');
ejoshopimport('ejoshop.fields.fields');
ejoshopimport('ejoshop.render.renderinfo');

class EjoshopModelEjoshopPhotos extends EjoshopModel
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'id', 'photos.id',
				'name', 'photos.name',
				'title', 'cat.title',
				'alias', 'photos.alias',
				'checked_out', 'photos.checked_out',
				'created', 'photos.created',
				'catid', 'photos.catid', 'category_title',
				'state', 'photos.state',
				'access', 'photos.access', 'access_level',
				'created', 'photos.created',
				'created_by', 'photos.created_by',
				'created_by_alias', 'photos.created_by_alias',
				'ordering', 'photos.ordering',
				'featured', 'photos.featured',
				'language', 'photos.language',
				'hits', 'photos.hits',
				'publish_up', 'photos.publish_up',
				'publish_down', 'photos.publish_down',
			);
		}

		parent::__construct($config);
	}


    function publish()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');
        foreach ($cid as $id)
        {
        	$row = JTable::getInstance('EjoshopPhotos', 'Table');
            $row->load($id);
            $row->publish($id, 1);
        }
        JPluginHelper::importPlugin('finder');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.photos', $cid, 1));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopphotos');
    }
	
    function unpublish()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');

        foreach ($cid as $id)
        {
		
        	$row = JTable::getInstance('EjoshopPhotos', 'Table');
            $row->load($id);
		
            $row->publish($id, 0);
        }
        JPluginHelper::importPlugin('finder');
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.photos', $cid, 0));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopphotos');
    }
	
	
    function trash()
    {

        $mainframe = JFactory::getApplication();
        $cid = JRequest::getVar('cid');
        foreach ($cid as $id)
        {
        	$row = JTable::getInstance('EjoshopPhotos', 'Table');
            $row->load($id);
            $row->trash($id, -2);
        }
    
        $dispatcher = JDispatcher::getInstance();
        $dispatcher->trigger('onFinderChangeState', array('com_ejoshop.photos', $cid, 1));
        $cache = JFactory::getCache('com_ejoshop');
        $cache->clean();
        $mainframe->redirect('index.php?option=com_ejoshop&view=ejoshopphotos');
    }
	
	function getCat()
	{
		$tableCode = EjoshopModel::getInstance('EjoshopModelEjoshopCategory', '');

		return $tableCode;
	}
	
	protected function getListQuery()
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		$option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!isset($limit)) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
				

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name, fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');

	// Join over the asset groups.
		$query->select('ag.title AS access_level');
		$query->join('LEFT', '#__viewlevels AS ag ON ag.id = photos.access');

		
		$search = $this->getState('filter.search');
	
		
		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}		

		// Add the list ordering clause.
		// Add the list ordering clause.
		$orderCol	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','photos.id');
		$orderDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');

		// Filter by access level.
		if ($access = $this->getState('filter.access')) {
			$query->where('photos.access = ' . (int) $access);
		}

		if(isset($pid)) {
			$query->where('photos.id = '.(int) $pid);
		}

		// Filter by published state
		$published = $this->getState($option.$view.'filter.photo_published');
	
		if (is_numeric($published)) {
			$query->where('photos.state = ' . (int) $published);
					

		}
		elseif ($published === '') {
			$query->where('(photos.state = 0 OR photos.state = 1)');
		}

		$category_id = $this->getState('filter.category_id');

		
		if (is_numeric($category_id)) {
			
			$query->where('photos.catid = ' . (int) $category_id);
		}
		
	
		$query->order($db->escape($orderCol.' '.$orderDirn));
 		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
	
		$db->setQuery($query,$limitstart,$limit);
		$items = $db->loadObjectList();
		return $items;
	}
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication();
        $option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		// Load the filter state.
		$orderCol	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','photos.id');
		$orderDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');
	
		$this->setState($option.$view.'filter.filter_order', $orderCol);
		$this->setState($option.$view.'filter.filter_order_Dir', $orderDirn);


		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		
		$search = $app->getUserStateFromRequest($option.$view.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$access = $app->getUserStateFromRequest($option.$view.'.filter.access', 'filter_access', 0, 'int');
		$this->setState('filter.access', $access);

		$authorId = $app->getUserStateFromRequest($option.$view.'.filter.author_id', 'filter_author_id');
		$this->setState('filter.author_id', $authorId);

		$published = $app->getUserStateFromRequest($option.$view.'.filter.photo_published', 'filter_published', '');
		$this->setState($option.$view.'filter.photo_published', $published);

		$categoryId = $app->getUserStateFromRequest($option.$view.'.filter.category_id', 'filter_category_id');
		$this->setState('filter.category_id', $categoryId);

		$level = $app->getUserStateFromRequest($option.$view.'.filter.level', 'filter_level', 0, 'int');
		$this->setState('filter.level', $level);


		$language = $app->getUserStateFromRequest($option.$view.'.filter.language', 'filter_language', '');
		$this->setState('filter.language', $language);


		// List state information.
		parent::populateState('photos.id', 'desc');
	}


	
	var $_foobar;

	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}

	/**
	 * Method to get a list of articles.
	 * Overridden to add a check for access levels.
	 *
	 * @return	mixed	An array of data items on success, false on failure.
	 * @since	1.6.1
	 */
	public function getItems()
	{
		$items	= $this->getListQuery();

		return $items;
	}
	

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPhotos($pid = 0,$limit = 0)
	{
		
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!$limit) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
				

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name,fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
	
		// Add the list ordering clause.
		$orderCol	= $this->getState('filter.filter_order','photos.id');
		$orderDirn	= $this->getState('filter.filter_order_Dir','DESC');
		
		
		if(isset($pid)) {
			$query->where('photos.id = '.(int) $pid);
		}
		
		$query->order($db->escape($orderCol.' '.$orderDirn));

		$query = $db->setQuery( $query, $limitstart, $limit );
		
		
		
		$this->photos = $db->loadObjectList();
	


		
		return $this->photos;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getFoobar()
	{

	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');
	if($data['task'] !== 'add') {
	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select('a.*');
		$query->from('`#__ejoshop_categories` AS a');
		$search = $this->getState('filter.search');
		
		if (!empty($search))
		{
	
			if (stripos($search, 'id:') === 0) {
				$query->where('a.cat = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( a.name LIKE '.$search.')');
			}
		}
		
		$query->order('id DESC');
	
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->_foobar = $db->loadObjectList();
		
	}
	else {
	
		$query = ' SELECT * '
			. ' FROM #__ejoshop_categories ORDER BY id DESC';
			$query = $db->setQuery( $query);
		$this->_foobar = $db->loadObjectList();
		}
		return $this->_foobar;
	}

	
	function getPhotosPager()
	{
		global $option, $mainframe;
		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		$db = JFactory::getDBO();
		$query	= $db->getQuery(true);
		$option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('COUNT(*)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');

		// Join over the asset groups.
		$query->select('ag.title AS access_level');
		$query->join('LEFT', '#__viewlevels AS ag ON ag.id = photos.access');

		
		$search = $this->getState('filter.search');
	
		
		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}		

		// Add the list ordering clause.
		// Add the list ordering clause.
		$orderCol	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','photos.id');
		$orderDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');

		// Filter by access level.
		if ($access = $this->getState('filter.access')) {
			$query->where('photos.access = ' . (int) $access);
		}

		if(isset($pid)) {
			$query->where('photos.id = '.(int) $pid);
		}

		// Filter by published state
		$published = $this->getState($option.$view.'filter.photo_published');
	
		if (is_numeric($published)) {
			$query->where('photos.state = ' . (int) $published);
					

		}
		elseif ($published === '') {
			$query->where('(photos.state = 0 OR photos.state = 1)');
		}

		$category_id = $this->getState('filter.category_id');

		
		if (is_numeric($category_id)) {
			
			$query->where('photos.catid = ' . (int) $category_id);
		}
		
	
		$query->order($db->escape($orderCol.' '.$orderDirn));
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		return $this->pageNav = new JPagination($total, $limitstart, $limit);
		
	}
	

	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n", '<br />',$text); 

		return $text;
	}
	
	function getFile($fid)
	{
 		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

        //CHANGE THIS QUERY AS YOU NEED...
        $query->select('f.*');
		$query->from('#__ejoshop_file_managed AS f');

		$query->where("f.fid = '$fid'");
		$query = $db->setQuery( $query );
	
		$file = $db->loadArray();
		return $file;
	}
	
	
	function store()
	{

		$data = JRequest::get( 'post' );
		$data = $data['jform'];
		$catid = $data['catid'];
		$name = $data['name'];
		$intro = $data['intro'];
		$articul = $data['articul'];
		$imagestyle = $data['imagestyle'];
		$dpath = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).'/media/com_ejoshop/files/tmp/';
		$filename = '';
		$userpath = '';
		$user		= JFactory::getUser();
		$userId		= $user->get('id');

		//$tmp_path = '/media/com_ejoshop/files/tmp/'; / tmp folder need create temporary image
		
		/* *** New image **** */
		$imgsrc	= JRequest::getVar('imgsrc',0);
		$fid	= JRequest::getVar('fid',0);
		if($fid) {
			$table = $this->getTable('ejoshopFilemanaged');
			$table->load($fid);
				
		}
		if(!empty($imgsrc)) {
			$path = $dpath.$table->filename; /* from tmp */
			$path_parts = pathinfo($path);
			$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
			$tmpthumbnail = $dpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
			if(!empty($fid)) {
				$filefromdb = $this->getFile($fid);
				if($filefromdb['imagestyle'] != $imagestyle) {
					$ni = new EjoshopPHPImageEditor($path,$tmpthumbnail,'thumbnail',$imagestyle,FALSE);
				}
			}

			$filename = $path_parts['filename'].'.'.$path_parts['extension'];
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
			
			$model = EjoshopModel::getInstance('Ajaxupload', 'EjoshopModel');
			/* This is a moment of creating new item in table AND SEE BELLOW */
			$pid = $model->save($fid,$pid);
			$userpath = '/media/com_ejoshop/files/'.$catid.'/'.$pid.'/';

			if(!is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
				JFolder::create(JPATH_ROOT.$userpath);
			}
			
			if(copy($path,$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath.$filename)) {
				unlink($path);
			}
			
			if($fid) {
	
				// Bind the form fields to the hello table
				$savedata = array('fid'=>$fid,'uri'=>$userpath, 'type'=>'mainphoto','status'=>1,'fpid'=>$pid);
				if (!$table->bind($savedata)) {
					$this->setError($this->_db->getErrorMsg());
					return false;
					
				}
					
				// Store the Phoca gallery table to the database
				if (!$table->store()) {
					$this->setError($this->_db->getErrorMsg());
				
					return false;
				}
				
			}
			
			
			if(copy($tmpthumbnail,$_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'])) {
				unlink($dpath.$path_parts['filename'].'_s.'.$path_parts['extension']);
			}
		}

		
		/* *** New image **** */

		
		if(!empty($data['alias'])) {
			$data['alias'] = JFilterOutput::stringURLSafe($data['alias']); 
		} else {
			$data['alias'] = JFilterOutput::stringURLSafe($data['name']); 
		}
		if(!$data['state']) $data['state'] = 0;

			$date = gmdate("Y-m-d H:i:s", time());
			$db = $this->getDBO();
			
			if(!empty($pid)) {
	
				$query = "UPDATE " . $db->quoteName('#__ejoshop_photos') ."
				SET `filename` = '".$fid."',`name` = '".$db->escape($name)."',`intro` = '".$db->escape($intro)."',`alias` = '".$data['alias']."',`catid` = '".$catid."',`articul` = '".$articul."',`price` = '".$data['price']."',`state` = '".$data['state']."', `created_by` = '".$userId."' WHERE " . $db->quoteName('#__ejoshop_photos') .".`id` = '".$pid."' LIMIT 1 ;";
			} else {

				$query = "INSERT INTO ".$db->quoteName('#__ejoshop_photos') 
				." (`name`,`intro`,`alias`,`catid`,`articul`,`price`,`created`,`currency`,`state`,`created_by`) VALUES ('".$name."','".$db->escape($data['intro'])."','".$data['alias']."', '".$catid."','".$articul."','".$data['price']."','".$date."','-1','".$data['state']."','".$userId."');";
			}
	
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			$pid = (empty($pid)) ? $db->insertid() : $pid;
			$data['rulesdata']['rules'] = $data['rules'];
			$data['rulesdata']['id'] = $pid;
			$data['rulesdata']['catid'] = $catid;

			$this->updateProductTable($data['rulesdata']);

			return $pid;
	}

	
	function createFields($fieldsname,$fieldsvalue)
	{
		$o = array();
		foreach($fieldsname as $key => $val) {
		
			$o[$key] = array($val,$fieldsvalue[$key]);
			
		}
		
		$r = serialize($o);


		return $r;

	}	
	
	public function getAllFields()
	{
		$results = array();
		$db		= JFactory::getDBO();
		$query = "SELECT fc . *
		FROM #__ejoshop_field_config fc
		WHERE fc.active = 1 AND fc.storage_active = 1";
		$config = new JConfig();


		$db->setQuery($query);
		$results = $db->loadAssocList();
		
		foreach($results as $key => $field) {
			$results[$key]['field_table_name'] = $config->dbprefix . 'ejoshop_field_data_'.$field['field_name'];
		}
		return $results;
	}
	
	
	public function add_field_ordelete_field($field_table_name,$field_name, $value, $entity_id)
	{

		$db = $this->getDBO();
		$query	= $db->getQuery(true);
		$query->select('fields.*');
		$query->from('`'.$field_table_name.'` AS fields');


		
		$query->where("fields.entity_id = '".$entity_id."'");
		
		$query = $db->setQuery( $query);
		$fields = $db->loadAssoc();
		if(empty($fields) && $value != 'notselected') {

			if(is_array($value)) {
			++$i;
				foreach($value as $key => $insert) {
					$query = "INSERT INTO ".$field_table_name
					." (`entity_type`,`bundle`,`deleted`,`delta`,`entity_id`,`".$field_name."_value`) 
					VALUES ('product','product','0','".$i."','".$entity_id."','".$insert."');";
				}
			} else {
					$query = "INSERT INTO " .$field_table_name
					." (`entity_type`,`bundle`,`deleted`,`entity_id`,`".$field_name."_value`) 
					VALUES ('product','product','0','".$entity_id."','".$value."');";
			}

			

		} else {
			if(is_array($value)) {
				
				$query = "DELETE FROM " . $field_table_name ." WHERE `entity_id` = '".$entity_id."';";
				$db->setQuery($query);
				if (!$db->query()) {
				
					throw new Exception($db->getErrorMsg());
				}
				$i = 0;
				$query = 'INSERT INTO '.$field_table_name
					.' (`entity_type`,`bundle`,`deleted`,`delta`,`entity_id`,`'.$field_name.'_value`) VALUES';
					
				foreach($value as $key => $insert) {
					++$i;
					
					$query .= " ('product','product','0', '".$i."','".$entity_id."','".$insert."'),";
					
				}
				$query = substr($query,0,-1).';';
			
			} else if($value == 'notselected'){
				$query = "DELETE FROM " . $field_table_name ." WHERE `entity_id` = '".$entity_id."';";
				$db->setQuery($query);
				if (!$db->query()) {
				
					throw new Exception($db->getErrorMsg());
				}
				
			} else {
				$query = "UPDATE " . $field_table_name ."
				SET `".$field_name."_value` = '".$value."' WHERE `entity_id` = '".$entity_id."' LIMIT 1;";
			}
		}
	
		$db->setQuery($query);
	
		if (!$db->query()) {
		
			throw new Exception(__LINE__ . $db->getErrorMsg());
		}
			
	}
	
	/* main function to edit product item when user clicked save buttons */
	
	public function photoedit($post)
	{

		$app = JFactory::getApplication(); 
		$db = $this->getDBO();
		$data = JRequest::get( 'post' );
		

		$existing_fields = array();
		$existing_fields = $this->getAllFields();
		if(!empty($existing_fields)) {
			$fieldsClass = new EjoshopFields();	
		}
		

		foreach($existing_fields as $fieldset) {
			if(!empty($data['field_data_' . $fieldset['field_name']])) {
				$value = $data['field_data_' . $fieldset['field_name']];
				try {
					$fieldsClass->checkvalue($fieldset['type'],$value);
					
					$this->add_field_ordelete_field($fieldset['field_table_name'],$fieldset['field_name'],$value,$data['id']);
					
				} catch(Exception $e) {
				
					$app->enqueueMessage($e->getMessage(), 'error');
				
				}
			}
			
		
		}
	

		
		$latitude = $data['latitude'];
		$longitude = $data['longitude'];
		$description = $data['intro'];
		$coords = $data['coords'];
		$catid= $data['jform']['catid'];
		
		$moreimg_show = $data['jform']['moreimg_show'];
		$catid = (empty($catid)) ? 0 : $catid;
		$articul = $data['jform']['articul'];	
		$data['opimagestyle'] = $data['jform']['opimagestyle'];	
		$data['imagestyle'] = $data['jform']['imagestyle'];

		$rules = array();
		$rules['rulesdata']['id'] = $data['id'];
		$rules['rulesdata']['rules'] = $data['jform']['rules'];
		$rules['rulesdata']['catid'] = $data['jform']['catid'];


		$this->updateProductTable($rules['rulesdata']);


		
		$allcoolor = array();
		if($data['color']) {
			foreach($data['color'] as $al) {
				$allcoolor[] = $al;
			}		
		}
		if(!empty($data['jform']['alias'])) {
			$data['alias'] = JFilterOutput::stringURLSafe($data['jform']['alias']); 
		} else {
			$data['alias'] = JFilterOutput::stringURLSafe($data['jform']['name']); 
		}
		
		$fieldsname = $data['fieldsname'];
		$fieldsvalue = $data['fieldsvalue'];
		if(!empty($fieldsname)) {
			$jsonfields = $this->createFields($fieldsname,$fieldsvalue);
		}

						
		$color = json_encode($allcoolor);
		$data['phototext'] = JRequest::getVar('phototext', '', 'post', 'string', JREQUEST_ALLOWHTML);


		$data["parent_category"] = (empty($data["parent_category"])) ? 0 : $data["parent_category"];
		

		$date = gmdate("Y-m-d H:i:s", time());
		$this->photo = $this->getPhotos($data['id']);
		$this->photo = $this->photo[0];	

		foreach($data as $key => $val) {
			if(is_array($data[$key])) {
				foreach($data[$key] as $key2 => $val2) {
					//EjoshopDeveloper::debugPrint($data['rulesdata']);	
					if(!is_array($val2)) {
						$data[$key][$key2] = $db->escape($val2);
					}
				}
			} else {
		
				$data[$key] = $db->escape($val);
			}
		}		

		
		$data['tplonephoto'] = !empty($data['tplonephoto']) ? $data['tplonephoto'] : $this->photo->tplonephoto;
		$intro = $this->textnl($data['intro']);	
		$intro = $db->escape($intro);	
	
			$query = "UPDATE ".$db->quoteName('#__ejoshop_photos') 
			." set ".$db->quoteName('latitude')." = '".$this->textnl($latitude)
			."', ".$db->quoteName('longitude')." = '".$this->textnl($longitude)
			."', ".$db->quoteName('name')." = '".$this->textnl($data['jform']['name'])
			."', ".$db->quoteName('articul')." = '".$db->escape($articul)
			."', ".$db->quoteName('intro')." = '".$intro
			."', ".$db->quoteName('maptype')." = '".$this->textnl($data['coords'])
			."', ".$db->quoteName('showmap')." = '".$this->textnl($data['showmap'])
			."', ".$db->quoteName('alias')." = '".$data['alias']
			."', ".$db->quoteName('catid')." = '".$catid
			."', ".$db->quoteName('price')." = '".$data['jform']['price']
			."', ".$db->quoteName('showprice')." = '".$this->textnl($data['showprice'])
			."', ".$db->quoteName('currency')." = '".$this->textnl($data['currency'])
			."', ".$db->quoteName('created')." = '".$date
			."', ".$db->quoteName('description')." = '".$this->textnl($data['description'])
			."', ".$db->quoteName('keywords')." = '".$this->textnl($data['keywords'])
			."', ".$db->quoteName('tplonephoto')." = '".$data['tplonephoto']
			."', ".$db->quoteName('showquanity')." = '".$this->textnl($data['showquanity'])
			."', ".$db->quoteName('quanity')." = '".$this->textnl($data['quanity'])
			."', ".$db->quoteName('phototext')." = '".$data['phototext']
			."', ".$db->quoteName('show_phototext')." = '".$data['show_phototext']
			."', ".$db->quoteName('showcolor')." = '".$this->textnl($data['showcolor'])
			."', ".$db->quoteName('created_by')." = '".$this->textnl($data['created_by'])
			."', ".$db->quoteName('color')." = '".$this->textnl($color)
			."', ".$db->quoteName('addtocartshow')." = '".$data['addtocartshow']
			."', ".$db->quoteName('fields')." = '".$db->escape($jsonfields)
			."', ".$db->quoteName('moreimg_show')." = '".$moreimg_show
			."' WHERE ".$db->quoteName('id')." =".$data['id'];
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($db->getErrorMsg());
				print $db->getErrorMsg();
				die();
				return false;
			
			}
	
			/* pre generate mini thumb */

				if($this->photo) {
				
					$prevphoto = $this->photo;
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri.$this->photo->filename;
					$path_parts = pathinfo($path);
					$thumb = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri.$this->photo->sizethumb;
				}

			if(!empty($data['opimagestyle'])) { // opimagestyle для единичного фото detail.php
				$query = $db->getQuery(true);
				$query->select("fm.*");
				$query->from('`#__ejoshop_file_managed` as fm');
				$query->where("fm.fpid = '".$this->photo->id."' AND fm.type='onephoto'");
				$query = $db->setQuery($query);
				$this->existfile = $db->loadObject();
				
				if($this->existfile) {
					$this->photo->opimagestyle = $this->existfile->imagestyle;
				}

			}


			if((!empty($data['opimagestyle']) && $data['opimagestyle'] != (int)$this->photo->opimagestyle)
			|| !is_file($path) || !is_file($thumb)
			|| (!empty($data['imagestyle']) && $data['imagestyle'] != (int)$this->photo->imagestyle) 
			) {

				/* delete if photo exist*/
				if($this->photo) {
				
					$prevphoto = $this->photo;
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
					$path_parts = pathinfo($path.$prevphoto->filename);
					// imagestyle у основного изображения
					if(!empty($data['imagestyle'])) {
						$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
						if(is_file($thumb)) {
							JFILE::delete($thumb);
						}
					}
					if(!empty($data['opimagestyle'])) { // sizethumb для единичного фото
	
						$thumb = $path.$this->existfile->filename;

						if(is_file($thumb)) {
							JFILE::delete($thumb);
						}
					}

					

				}

						$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$this->photo->uri;
						$targetDir = $path;
						$path_parts = pathinfo($path.$this->photo->filename);
						$endpath = $path.$this->photo->filename;
	
				if(is_file($endpath)) {
						
						$path_parts = pathinfo($endpath);
						$newfileimgsrc = $targetDir.$path_parts['filename'].'_%s_s.'.$path_parts['extension'];
						
						$ie = new EjoshopPHPImageEditor();
						if(!empty($data['imagestyle'])) {
							$thumbnail = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
							$ie->processMainPhoto($endpath,$thumbnail,'thumbnail',$data['imagestyle'],$this->photo);
						}
						
						$ie->processOnePhoto($endpath,$newfileimgsrc,'onephoto',$data['opimagestyle'],$this->photo);

		
				} else {
				
				
				}
			}

		return true;
	}
	
	
   /*
	* save photo for detail.php on site part
	*
	*/
	
	function saveOnephotofile($data) {

			$table = $this->getTable('ejoshopFilemanaged');
			if($data['imagestyle']) {
				$db = $this->getDBO();
				$query = $db->getQuery(true);
				$query->select("fm.*");
				$query->from('`#__ejoshop_file_managed` as fm');
				$query->where("fm.fpid = '".$data['fpid']."' AND fm.type='onephoto'");
				$query = $db->setQuery($query);
				$this->existfile = $db->loadObject();

				$app = JFactory::getApplication();
				//$app->enqueueMessage($data));
				// Bind the form fields to the hello table
				$savedata = array(
					'filename'=>$data['filename'], 'uri'=>$data['uri'], 'type'=>'onephoto','status'=>1,'fpid'=>$data['fpid'],'imagestyle'=>$data['imagestyle']
				);
				if(!empty($this->existfile->fid)) {
					$savedata['fid']=$this->existfile->fid;
				}
				if (!$table->bind($savedata)) {
					$this->setError($db->getErrorMsg());
					return false;
					
				}
					
				// Store the Phoca gallery table to the database
				if (!$table->store()) {
					$this->setError($db->getErrorMsg());
				
					return false;
				}
			}
			
			return $table->fid;
	}
	
	
	function updateProductTable($data,$photo= null,$type = null) {

		$app = JFactory::getApplication();
		$Filestable = $this->getTable('ejoshopFilemanaged');
		if($photo->fid ) {

			if($type == 'thumbnail') $type = 'mainphoto';
			$load = $Filestable->load(array('fid'=>$photo->fid, 'type'=>$type));
			$app->enqueueMessage($type);
			if($load) {
				$savedata = array('fid'=>$photo->fid, 'imagestyle'=>$data['imagestyle']);
				if (!$Filestable->bind($savedata)) {
					$this->setError($db->getErrorMsg());
					return false;
					
				}
				if (!$Filestable->store()) {
					$this->setError($db->getErrorMsg());
				
					return false;
				}
			}

		}
		$pk = (!empty($data['id'])) ? (int)$data['id'] : 0;
	
			$table = $this->getTable();
			

			$isNew = FALSE;
	
			// Load the row if saving an existing taxs.
			if ($pk > 0)
			{
				$table->load($pk);
				$isNew = false;
			}

			// Bind the data.
			if (!$table->bind($data))
			{
				$this->setError($table->getError());
				return false;

			}
			

			// Check the data.
			if (!$table->check())
			{

				$this->setError($table->getError());
				return false;
			}
			// Store the data.
			if (!$table->store())
			{
			
				$this->setError($table->getError());
				return false;
				
			}
				
			return true;
	}
	
	/* удаление товаров и всего, что с ними связано */
	function delete(&$post)
	{
		
		$post = JRequest::get( 'post' );
		$cids = $post['cid'];

		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('photos.*,fm.*');
		$query->from('`#__ejoshop_photos` AS photos');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		if(isset($cids)) {
			$query->where('photos.id IN (' .  implode(',', $cids) . ')');
		}
		$query = $db->setQuery( $query);
		$photos = $db->loadObjectList();	
		

	

		$orderclass = new EjoshopRenderPayd();
		$isUsed = $orderclass->checkItemInUsedOrders($cids); // check if item used in orders
		
		
		if(count($isUsed) > 0) {
			

	
		}
		
		$Filestable = $this->getTable('ejoshopFilemanaged');
		foreach($photos as $product) {
			
			if(in_array($product->id,$isUsed)) {
			
				JLog::add(JText::plural('COM_EJOSHOP_ITEM_IS_USED', $product->id),JLog::WARNING);
				
				continue;
			}


			$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$product->uri;
			$path_parts = pathinfo($path.$product->filename);
			$newfileimgsrc = $path.'_s.'.$path_parts['extension'];
			$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];

			/* mainphoto */
			if(is_file($path.$product->filename)) {
				if(!JFILE::delete($path.$product->filename)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
			
			/* thumb of mainphoto */
			if(is_file($thumb)) {
				if(!JFILE::delete($thumb)) {
					JError::raiseWarning( 500, 'Ошибка при удалении файла!');
				}
			}
			
			/* mainphoto delete */
		
			$load = $Filestable->load(array('fid'=>$product->fid, 'type'=>'mainphoto'));
			if($load) $Filestable->delete($product->fid);
			
			/* onephoto detail.php */
			$Filestable->reset();
			$load = $Filestable->load(array('fid'=>$product->onephoto, 'type'=>'onephoto'));

			if($Filestable->filename) {
				

				$sizethumb = $path.$Filestable->filename;
				if(is_file($sizethumb)) {
					if(!JFILE::delete($sizethumb)) {
						JError::raiseWarning( 500, 'Ошибка при удалении файла!');
					}
				}
	
				$Filestable->delete($Filestable->fid);
			
			}
			
			
			$mp = new EjoshopRenderInfo();
			$ophoto =  $mp->getOtherPhotos($product->id);
	
			foreach($ophoto as $item) {
				$itemfile = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$item->uri.$item->filename;
				if(is_file($itemfile)) {
					if(!JFILE::delete($itemfile)) {
						JError::raiseWarning( 500, 'Ошибка при удалении файла!');
					}
					$path_parts = pathinfo($itemfile);
					$thumb = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$item->uri.$path_parts['filename'].'_s.'.$path_parts['extension'];
					if(is_file($thumb)) {
						if(!JFILE::delete($thumb)) {
							JError::raiseWarning( 500, 'Ошибка при удалении файла!');
						}
					
					}
				}
				$Filestable->reset();
				$Filestable->load($item->fid);
				$Filestable->delete($item->fid);

				
			}
			/* full deleting path and folder to images */
			if(is_dir($path)) {
				$files = scandir($path);
				unset($files[0],$files[1]);
				/*$app = JFactory::getApplication();
				$app->enqueueMessage($files[2]);*/
				if(!in_array(array('administrator','admin','templates'),$files)) {
					if($files[2] == 'other' || $this->is_dir_empty($path)) {
						JFolder::delete($path);

					}
				}
			}
		}
				

		if (count( $cids )) {
			foreach($cids as $cid) {
				if(in_array($cid,$isUsed)) {
					continue;
				}
				$query = 'DELETE FROM #__ejoshop_photos'
				. ' WHERE id = ' .$cid;

					try {

					
						$db->setQuery( $query );
						if(!$db->query()) {
			
							 throw new Exception($db->getError());
						}
						
					} catch (RuntimeException $e)
					{
						
						JLog::add('This query failed: '.$query,JLog::WARNING);
						JLog::add('This query failed: '.$e->getMessage(),JLog::WARNING);
						return false;
					}
			}
		}
		return true;
	}
	
	
	
	public function is_dir_empty($dir) {
	  if (!is_readable($dir)) return NULL; 
	  return (count(scandir($dir)) == 2);
	}


}