<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modeladmin');
jimport('joomla.application.component.model');
jimport( 'joomla.application.component.modelform' );
jimport('joomla.html.pagination');
jimport( 'joomla.application.component.modellist' );
ejoshopimport( 'ejoshop.render.renderpayd' );
ejoshopimport( 'ejoshop.developer.developer' );

class EjoshopModelEjoshopUsers extends EjoshopModel
{
protected	$option 		= 'com_ejoshop';

	public function __construct($config = array())
	{
			$config['filter_fields'] = array(
				'id', 'users.id',
				'created', 'users.created',
				'total_purchase', 'users.total_purchase',

			);

		parent::__construct($config);
	}

	function getCat()
	{
		$tableCode = EjoshopModel::getInstance('EjoshopModelEjoshopNewGallery', '');

		return $tableCode;
	}
	
 
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');
		$option = JRequest::getCmd('option');
        $view = JRequest::getCmd('view');
		// Load the filter state.
		
		$orderCol	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','users.id');
		$orderDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');
	
		$this->setState($option.$view.'filter.filter_order', $orderCol);
		$this->setState($option.$view.'filter.filter_order_Dir', $orderDirn);
		
		
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		
		$filter_type = $app->getUserStateFromRequest('filter.filter_type', 'filter_type', '');
		$app->setUserState('filter.filter_type', $filter_type);
		
		$filter_status = $app->getUserStateFromRequest($option.$view.'.filter.filter_status', 'filter_status', '');
		
		$this->setState('filter.filter_status', $filter_status);
		// List state information.
		parent::populateState('users.id', 'desc');
	}
	


	public function getMyForm($data = array(), $loadData = true) {
	
		ejoshopimport('ejoshop.getmyform.getmyform');
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();

		
		$form 	= $form->getForm();

		if (empty($form)) {
			return false;
		}
		return $form;
	}
	
	/**
	 * 
	 * @возвращает все заказы и не только завершённые, 
	 * заказы с метками cart и confirm удаляются автоматически после 1 суток
	 */
	 
	function getUsers($pid = 0)
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'pid' );
		}
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$task = JRequest::getVar('task',FALSE);
		$controller = JRequest::getVar('controller',FALSE);
		
		$limitstart = JRequest::getVar('limitstart', 0);
				
	

		$query->from('`#__ejoshop_userinfo_cart` AS users');
		$query->select('users.*');
	
		// Add the list ordering clause.
	
		// Add the list ordering clause.
		$listOrder	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','users.id');
		$listDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');


		
		if(isset($pid)) {
			$query->where('users.id = '.(int) $pid);
		}


		
		$filter_type = $app->getUserStateFromRequest('filter.filter_type', 'filter_type', '');
	
		if(empty($filter_type)) {
			$filter_type = $app->getUserState('filter.filter_type', '');
		}

		$search = $this->getState('filter.search');
	

		if (!empty($search))
		{
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( users.name LIKE '.$search.')');
		}
		
		$query->order($db->escape($listOrder.' '.$listDirn));
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
		//var_dump($query->__toString());
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->users = $db->loadObjectList();

		return $this->users;

	}
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getFoobar()
	{

	// Create a new query object.
	$db		= JFactory::getDBO();
	$query	= $db->getQuery(true);
	//вставляем насройки последней карты в новую...
	$data['task'] = JRequest::getVar('task');
	if($data['task'] !== 'add') {
	$app = JFactory::getApplication(); 
	$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
	
	$limitstart = JRequest::getVar('limitstart', 0);
		
		$query->select('a.*');
		$query->from('`#__ejoshop_categories` AS a');
		$search = $this->getState('filter.search');
		
		if (!empty($search))
		{
	
			if (stripos($search, 'id:') === 0) {
				$query->where('a.cat = '.(int) substr($search, 3));
	
			}
			else
			{
	
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( a.name LIKE '.$search.')');
			}
		}
		
		$query->order('id DESC');
	
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->_foobar = $db->loadObjectList();
		
	}
	else {
	
		$query = ' SELECT * '
			. ' FROM #__ejoshop_categories ORDER BY ID DESC';
			$query = $db->setQuery( $query);
		$this->_foobar = $db->loadObjectList();
		}
		return $this->_foobar;
	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */

	
	function getReviews()
	{

		$app = JFactory::getApplication(); 
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart');
		$task = JRequest::getVar('task',FALSE);
	
		$db = JFactory::getDBO();
		
		$query	= $db->getQuery(true);
		$query->from('`#__ejoshop_userinfo_cart` AS users');
	
		$query->select('count(*) as total, users.*');
	
		
		$filter_type = $app->getUserStateFromRequest('filter.filter_type', 'filter_type', '');
	
		if(empty($filter_type)) {
			$filter_type = $app->getUserState('filter.filter_type', '');
		}

		$search = $this->getState('filter.search');
	

		if (!empty($search))
		{
				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( users.name LIKE '.$search.')');
		}
		

		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		//var_dump($query->_toString($query));


		$query->order($db->escape($orderCol.' '.$orderDirn));
		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);

		$db->setQuery( $query );

		$total = $db->loadAssoc();

		return $this->pageNav = new JPagination($total['total'], $limitstart, $limit);
		
	}
	
	
	function textnl($text)
	{
		$text = str_replace("\r\n","<br />",$text);
		$text = str_replace("\r","<br />",$text);
		$text = str_replace("\n\n", '<p>',$text);
		$text = str_replace("\n", '<br />',$text); 
		$text = addslashes($text);
		return $text;
	}
		
		
	function store($post)
	{
		$row = $this->getTable('ejoshopcategories');

		$data = JRequest::get( 'post' );
		$galid = $data['galid'];
		$catid = $data['catid'];

			
			$db = $this->getDBO();
			$query = "INSERT INTO ".$db->quoteName('#__ejoshop_photos') 
			." (`galid`, `catid`, `params`) VALUES ('".$galid."', '".$catid."', '');";
			
			$db->setQuery($query);
			
			if (!$db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			

		return true;
	}


	function delete(&$post)
	{
		$type_fileter = $this->getState('filter.filter_type', '');


		
		$pids = $post['pid'];
		$db		= JFactory::getDBO();


		if($type_fileter == 'pay' || $type_fileter == 'all') {
			$orderclass = new EjoshopRenderPayd();
			$items = $orderclass->getOrderInfo($pids); // get data from orders
			$check = $this->CheckCanDeleteItems($items,$pids); // update info in payd table
			
			if(!empty($check)) {
				$s = implode(',',$check);
				JError::raiseWarning( 500, JText::plural('COM_EJOSHOP_ORDERS_IS_USED', $s));
				$pids = array_diff($pids,$check);
		
			}
		
			
			$newitem = $this->GeneretenewItems($items,$pids); // update info in payd table


			$query = "DELETE FROM #__ejoshop_shop_order"
				. " WHERE pid IN (" . implode(',',$pids) . ");";
			$db->setQuery( $query );
			if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
					return false;
			}
				
			foreach($newitem as $key =>$item) {
				$item = array_values($item);
				$data['pids'] = json_encode($item);
				$data['payid'] = $key;
				
				$orderclass->updateOrders($data);
			}
		
		} else {
			if (count( $pids )) {
			 
				$query = $db->getQuery(true);
				$conditions  = array();
				if(!empty($type_fileter)) {
					$conditions = array(
						$db->quoteName('status') . '='.$type_fileter, 
					);
				}
				array_push($conditions,$db->quoteName('pid') . ' IN('.implode(',',$pids).')');

				$query->delete($db->quoteName('#__ejoshop_shop_order'));
				$query->where($conditions);
	
				$db->setQuery($query);
				
				if (!$db->execute()) {
					JError::raiseWarning( 500, $db->getError() );
				}

				}
			
			
		}
		
		
		return true;
	}
	
   /*
	* check order time, if more than one days it can be delete
	*
	*/
	
	public function CheckCanDeleteItems($items,$pids)
	{
		$itemtochange = array();
		$newitem = array();

		foreach($items as $item) {
			
			$passtime = (time() - $item->ordertime) / 86400;
			
			if($passtime < 1) {
				$newitem[] = $item->pid;	
			}
		}
		return $newitem;
		
	}
	
	public function GeneretenewItems($items,$pids)
	{
		


		
		$itemtochange = array();
		$newitem = array();

		foreach($items as $item) {
			if(!empty($item->payid)) {
					$expids = json_decode($item->pids);
					if(!empty($expids)) {
						foreach($expids as $id) {
		
							if(in_array($id,$pids)) {
						
								$i = array_search($id,$expids);
		
								unset($expids[$i]);
								$newitem[$item->payid] = $expids;
							}
						}
					}
					//$newitem[] = json_encode(array_values($expids));
					
		
			}
		}

		return $newitem;
	}
	
	
	public function publish(&$pks, $value = 1)
	{

		// Initialise variables.
		$dispatcher = JDispatcher::getInstance();
		$user = JFactory::getUser();
		$table = $this->getTable();
		$pks = (array) $pks;

		// Include the content plugins for the change of state event.
		JPluginHelper::importPlugin('content');

		// Access checks.
		foreach ($pks as $i => $pk)
		{
			$table->reset();
		}

		// Attempt to change the state of the records.
		if (!$table->publish($pks, $value, $user->get('id')))
		{

		$this->setError($table->getError());
		
		return false;
		}

		$context = $this->option . '.' . $this->name;

		// Trigger the onContentChangeState event.
		$result = $dispatcher->trigger($this->event_change_state, array($context, $pks, $value));

		if (in_array(false, $result, true))
		{
		$this->setError($table->getError());
		return false;
		}

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
