<?php
/*
 * @package Joomla 3.x
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component GYMap Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined('_JEXEC') or die;
 
// import the list field type
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');
 
/**
 * HelloWorld Form Field class for the HelloWorld component
 */
class JFormFieldCategory extends JFormFieldList
{
	
	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return	array		An array of JHtml options.
	 */
	protected function getOptions() 
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
       //build the list of categories
		$query = 'SELECT * FROM '.$db->quoteName('#__ejoshop_categories').' AS cats WHERE cats.id !=1;';
		$db->setQuery( $query );
		$cats = $db->loadObjectList();
		$options = array();
		if ($cats)
		{
			foreach($cats as $cat) 
			{
				$options[] = JHtml::_('select.option', $cat->id, $cat->title);
			}
		}
		$options = array_merge(parent::getOptions(), $options);
		return $options;
	}
	
	
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{
		
		return parent::getInput();
	}	
}
