<?php
/**
 * @version		$Id$
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;


class JFormFieldColorpicker extends JFormField
{
	/**
	 * A flexible category list that respects access controls
	 *
	 * @var		string
	 * @since	1.6
	 */
	public $type = 'Colorpicker';

	/**
	 * Method to get a list of categories that respects access controls and can be used for
	 * either category assignment or parent category assignment in edit screens.
	 * Use the parent element to indicate that the field will be used for assigning parent categories.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getInput()
	{
		$fieldname = $this->__get('name');
		$value = $this->__get('value');
		$params = JComponentHelper::getParams('com_ejoshop') ;
		$val = $params->get($fieldname);

		
		$id = uniqid();
		$html_select = '
		<div class="clr"></div>
			<div class="control-group">
				<div class="controls">

			
					<input type="text" class="'.$id.'" name="'.$fieldname.'" value="'.$value.'" style="margin:0 0 10px 0px;">
					
					<div class="colorSelector" rel="'.$id.'">
					<div style="background-color: #'.$value.'">
					</div>
					</div>
					
				</div>
			</div>
			
		<div class="clr" style="clear:both;"></div>';
				
				
		return $html_select;
	}
	

}
