<?php
/*
 * @package Joomla 3.x
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component GYMap Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined('_JEXEC') or die;
 
// import the list field type
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');
 
/**
 * HelloWorld Form Field class for the HelloWorld component
 */
class JFormFieldCountries extends JFormFieldList
{
	
	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return	array		An array of JHtml options.
	 */
	protected function getOptions() 
	{

		$cats = array();

		array_push($cats,array(1, 4, 'AF', 'Afghanistan', 'AFGHANISTAN', 'AFG'));
		array_push($cats,(array(2, 248, 'AX', 'Aland Islands', 'ALAND ISLANDS', 'ALA')));
		array_push($cats,(array(3, 8, 'AL', 'Albania', 'ALBANIA', 'ALB')));
		array_push($cats,(array(4, 12, 'DZ', 'Algeria', 'ALGERIA', 'DZA')));
		array_push($cats,(array(5, 16, 'AS', 'American Samoa', 'AMERICAN SAMOA', 'ASM')));
		array_push($cats,(array(6, 20, 'AD', 'Andorra', 'ANDORRA', 'AND')));
		array_push($cats,(array(7, 24, 'AO', 'Angola', 'ANGOLA', 'AGO')));
		array_push($cats,(array(8, 660, 'AI', 'Anguilla', 'ANGUILLA', 'AIA')));
		array_push($cats,(array(9, 10, 'AQ', 'Antarctica', 'ANTARCTICA', 'ATA')));
		array_push($cats,(array(10, 28, 'AG', 'Antigua and Barbuda', 'ANTIGUA AND BARBUDA', 'ATG')));
		array_push($cats,(array(11, 32, 'AR', 'Argentina', 'ARGENTINA', 'ARG')));
		array_push($cats,(array(12, 51, 'AM', 'Armenia', 'ARMENIA', 'ARM')));
		array_push($cats,(array(13, 533, 'AW', 'Aruba', 'ARUBA', 'ABW')));
		array_push($cats,(array(14, 36, 'AU', 'Australia', 'AUSTRALIA', 'AUS')));
		array_push($cats,(array(15, 40, 'AT', 'Austria', 'AUSTRIA', 'AUT')));
		array_push($cats,(array(16, 31, 'AZ', 'Azerbaijan', 'AZERBAIJAN', 'AZE')));
		array_push($cats,(array(17, 44, 'BS', 'Bahamas', 'BAHAMAS', 'BHS')));
		array_push($cats,(array(18, 48, 'BH', 'Bahrain', 'BAHRAIN', 'BHR')));
		array_push($cats,(array(19, 50, 'BD', 'Bangladesh', 'BANGLADESH', 'BGD')));
		array_push($cats,(array(20, 52, 'BB', 'Barbados', 'BARBADOS', 'BRB')));
		array_push($cats,(array(21, 112, 'BY', 'Belarus', 'BELARUS', 'BLR')));
		array_push($cats,(array(22, 56, 'BE', 'Belgium', 'BELGIUM', 'BEL')));
		array_push($cats,(array(23, 84, 'BZ', 'Belize', 'BELIZE', 'BLZ')));
		array_push($cats,(array(24, 204, 'BJ', 'Benin', 'BENIN', 'BEN')));
		array_push($cats,(array(25, 60, 'BM', 'Bermuda', 'BERMUDA', 'BMU')));
		array_push($cats,(array(26, 64, 'BT', 'Bhutan', 'BHUTAN', 'BTN')));
		array_push($cats,(array(27, 68, 'BO', 'Bolivia, Plurinational State of', 'BOLIVIA, PLURINATIONAL STATE OF', 'BOL')));
		array_push($cats,(array(28, 535, 'BQ', 'Bonaire, Saint Eustatius and Saba', 'BONAIRE, SAINT EUSTATIUS AND SABA', 'BES')));
		array_push($cats,(array(29, 70, 'BA', 'Bosnia and Herzegovina', 'BOSNIA AND HERZEGOVINA', 'BIH')));
		array_push($cats,(array(30, 72, 'BW', 'Botswana', 'BOTSWANA', 'BWA')));
		array_push($cats,(array(31, 74, 'BV', 'Bouvet Island', 'BOUVET ISLAND', 'BVT')));
		array_push($cats,(array(32, 76, 'BR', 'Brazil', 'BRAZIL', 'BRA')));
		array_push($cats,(array(33, 86, 'IO', 'British Indian Ocean Territory', 'BRITISH INDIAN OCEAN TERRITORY', 'IOT')));
		array_push($cats,(array(34, 96, 'BN', 'Brunei Darussalam', 'BRUNEI DARUSSALAM', 'BRN')));
		array_push($cats,(array(35, 100, 'BG', 'Bulgaria', 'BULGARIA', 'BGR')));
		array_push($cats,(array(36, 854, 'BF', 'Burkina Faso', 'BURKINA FASO', 'BFA')));
		array_push($cats,(array(37, 108, 'BI', 'Burundi', 'BURUNDI', 'BDI')));
		array_push($cats,(array(38, 116, 'KH', 'Cambodia', 'CAMBODIA', 'KHM')));
		array_push($cats,(array(39, 120, 'CM', 'Cameroon', 'CAMEROON', 'CMR')));
		array_push($cats,(array(40, 124, 'CA', 'Canada', 'CANADA', 'CAN')));
		array_push($cats,(array(41, 132, 'CV', 'Cape Verde', 'CAPE VERDE', 'CPV')));
		array_push($cats,(array(42, 136, 'KY', 'Cayman Islands', 'CAYMAN ISLANDS', 'CYM')));
		array_push($cats,(array(43, 140, 'CF', 'Central African Republic', 'CENTRAL AFRICAN REPUBLIC', 'CAF')));
		array_push($cats,(array(44, 148, 'TD', 'Chad', 'CHAD', 'TCD')));
		array_push($cats,(array(45, 152, 'CL', 'Chile', 'CHILE', 'CHL')));
		array_push($cats,(array(46, 156, 'CN', 'China', 'CHINA', 'CHN')));
		array_push($cats,(array(47, 162, 'CX', 'Christmas Island', 'CHRISTMAS ISLAND', 'CXR')));
		array_push($cats,(array(48, 166, 'CC', 'Cocos Islands', 'COCOS (KEELING) ISLANDS', 'CCK')));
		array_push($cats,(array(49, 170, 'CO', 'Colombia', 'COLOMBIA', 'COL')));
		array_push($cats,(array(50, 174, 'KM', 'Comoros', 'COMOROS', 'COM')));
		array_push($cats,(array(51, 178, 'CG', 'Congo', 'CONGO', 'COG')));
		array_push($cats,(array(52, 180, 'CD', 'Congo, the Democratic Republic of the', 'CONGO, THE DEMOCRATIC REPUBLIC OF THE', 'COD')));
		array_push($cats,(array(53, 184, 'CK', 'Cook Islands', 'COOK ISLANDS', 'COK')));
		array_push($cats,(array(54, 188, 'CR', 'Costa Rica', 'COSTA RICA', 'CRI')));
		array_push($cats,(array(55, 384, 'CI', 'Cote D\'Ivoire', 'COTE D\'IVOIRE', 'CIV')));
		array_push($cats,(array(56, 191, 'HR', 'Croatia', 'CROATIA', 'HRV')));
		array_push($cats,(array(57, 192, 'CU', 'Cuba', 'CUBA', 'CUB')));
		array_push($cats,(array(58, 531, 'CW', 'Curacao', 'CURACAO', 'CUW')));
		array_push($cats,(array(59, 196, 'CY', 'Cyprus', 'CYPRUS', 'CYP')));
		array_push($cats,(array(60, 203, 'CZ', 'Czech Republic', 'CZECH REPUBLIC', 'CZE')));
		array_push($cats,(array(61, 208, 'DK', 'Denmark', 'DENMARK', 'DNK')));
		array_push($cats,(array(62, 262, 'DJ', 'Djibouti', 'DJIBOUTI', 'DJI')));
		array_push($cats,(array(63, 212, 'DM', 'Dominica', 'DOMINICA', 'DMA')));
		array_push($cats,(array(64, 214, 'DO', 'Dominican Republic', 'DOMINICAN REPUBLIC', 'DOM')));
		array_push($cats,(array(65, 218, 'EC', 'Ecuador', 'ECUADOR', 'ECU')));
		array_push($cats,(array(66, 818, 'EG', 'Egypt', 'EGYPT', 'EGY')));
		array_push($cats,(array(67, 222, 'SV', 'El Salvador', 'EL SALVADOR', 'SLV')));
		array_push($cats,(array(68, 226, 'GQ', 'Equatorial Guinea', 'EQUATORIAL GUINEA', 'GNQ')));
		array_push($cats,(array(69, 232, 'ER', 'Eritrea', 'ERITREA', 'ERI')));
		array_push($cats,(array(70, 233, 'EE', 'Estonia', 'ESTONIA', 'EST')));
		array_push($cats,(array(71, 231, 'ET', 'Ethiopia', 'ETHIOPIA', 'ETH')));
		array_push($cats,(array(72, 238, 'FK', 'Falkland Islands (Malvinas)', 'FALKLAND ISLANDS (MALVINAS)', 'FLK')));
		array_push($cats,(array(73, 234, 'FO', 'Faroe Islands', 'FAROE ISLANDS', 'FRO')));
		array_push($cats,(array(74, 242, 'FJ', 'Fiji', 'FIJI', 'FJI')));
		array_push($cats,(array(75, 246, 'FI', 'Finland', 'FINLAND', 'FIN')));
		array_push($cats,(array(76, 250, 'FR', 'France', 'FRANCE', 'FRA')));
		array_push($cats,(array(77, 254, 'GF', 'French Guiana', 'FRENCH GUIANA', 'GUF')));
		array_push($cats,(array(78, 258, 'PF', 'French Polynesia', 'FRENCH POLYNESIA', 'PYF')));
		array_push($cats,(array(79, 260, 'TF', 'French Southern Territories', 'FRENCH SOUTHERN TERRITORIES', 'ATF')));
		array_push($cats,(array(80, 266, 'GA', 'Gabon', 'GABON', 'GAB')));
		array_push($cats,(array(81, 270, 'GM', 'Gambia', 'GAMBIA', 'GMB')));
		array_push($cats,(array(82, 268, 'GE', 'Georgia', 'GEORGIA', 'GEO')));
		array_push($cats,(array(83, 276, 'DE', 'Germany', 'GERMANY', 'DEU')));
		array_push($cats,(array(84, 288, 'GH', 'Ghana', 'GHANA', 'GHA')));
		array_push($cats,(array(85, 292, 'GI', 'Gibraltar', 'GIBRALTAR', 'GIB')));
		array_push($cats,(array(86, 300, 'GR', 'Greece', 'GREECE', 'GRC')));
		array_push($cats,(array(87, 304, 'GL', 'Greenland', 'GREENLAND', 'GRL')));
		array_push($cats,(array(88, 308, 'GD', 'Grenada', 'GRENADA', 'GRD')));
		array_push($cats,(array(89, 312, 'GP', 'Guadeloupe', 'GUADELOUPE', 'GLP')));
		array_push($cats,(array(90, 316, 'GU', 'Guam', 'GUAM', 'GUM')));
		array_push($cats,(array(91, 320, 'GT', 'Guatemala', 'GUATEMALA', 'GTM')));
		array_push($cats,(array(92, 831, 'GG', 'Guernsey', 'GUERNSEY', 'GGY')));
		array_push($cats,(array(93, 324, 'GN', 'Guinea', 'GUINEA', 'GIN')));
		array_push($cats,(array(94, 624, 'GW', 'Guinea-Bissau', 'GUINEA-BISSAU', 'GNB')));
		array_push($cats,(array(95, 328, 'GY', 'Guyana', 'GUYANA', 'GUY')));
		array_push($cats,(array(96, 332, 'HT', 'Haiti', 'HAITI', 'HTI')));
		array_push($cats,(array(97, 334, 'HM', 'Heard Island and Mcdonald Islands', 'HEARD ISLAND AND MCDONALD ISLANDS', 'HMD')));
		array_push($cats,(array(98, 336, 'VA', 'Holy See (Vatican City State)', 'HOLY SEE (VATICAN CITY STATE)', 'VAT')));
		array_push($cats,(array(99, 340, 'HN', 'Honduras', 'HONDURAS', 'HND')));
		array_push($cats,(array(100, 344, 'HK', 'Hong Kong', 'HONG KONG', 'HKG')));
		array_push($cats,(array(101, 348, 'HU', 'Hungary', 'HUNGARY', 'HUN')));
		array_push($cats,(array(102, 352, 'IS', 'Iceland', 'ICELAND', 'ISL')));
		array_push($cats,(array(103, 356, 'IN', 'India', 'INDIA', 'IND')));
		array_push($cats,(array(104, 360, 'ID', 'Indonesia', 'INDONESIA', 'IDN')));
		array_push($cats,(array(105, 364, 'IR', 'Iran, Islamic Republic of', 'IRAN, ISLAMIC REPUBLIC OF', 'IRN')));
		array_push($cats,(array(106, 368, 'IQ', 'Iraq', 'IRAQ', 'IRQ')));
		array_push($cats,(array(107, 372, 'IE', 'Ireland', 'IRELAND', 'IRL')));
		array_push($cats,(array(108, 833, 'IM', 'Isle of Man', 'ISLE OF MAN', 'IMN')));
		array_push($cats,(array(109, 376, 'IL', 'Israel', 'ISRAEL', 'ISR')));
		array_push($cats,(array(110, 380, 'IT', 'Italy', 'ITALY', 'ITA')));
		array_push($cats,(array(111, 388, 'JM', 'Jamaica', 'JAMAICA', 'JAM')));
		array_push($cats,(array(112, 392, 'JP', 'Japan', 'JAPAN', 'JPN')));
		array_push($cats,(array(113, 832, 'JE', 'Jersey', 'JERSEY', 'JEY')));
		array_push($cats,(array(114, 400, 'JO', 'Jordan', 'JORDAN', 'JOR')));
		array_push($cats,(array(115, 398, 'KZ', 'Kazakhstan', 'KAZAKHSTAN', 'KAZ')));
		array_push($cats,(array(116, 404, 'KE', 'Kenya', 'KENYA', 'KEN')));
		array_push($cats,(array(117, 296, 'KI', 'Kiribati', 'KIRIBATI', 'KIR')));
		array_push($cats,(array(118, 408, 'KP', 'Korea, Democratic People\'s Republic of', 'KOREA, DEMOCRATIC PEOPLE\'S REPUBLIC OF', 'PRK')));
		array_push($cats,(array(119, 410, 'KR', 'Korea, Republic of', 'KOREA, REPUBLIC OF', 'KOR')));
		array_push($cats,(array(120, 414, 'KW', 'Kuwait', 'KUWAIT', 'KWT')));
		array_push($cats,(array(121, 417, 'KG', 'Kyrgyzstan', 'KYRGYZSTAN', 'KGZ')));
		array_push($cats,(array(122, 418, 'LA', 'Lao People\'s Democratic Republic', 'LAO PEOPLE\'S DEMOCRATIC REPUBLIC', 'LAO')));
		array_push($cats,(array(123, 428, 'LV', 'Latvia', 'LATVIA', 'LVA')));
		array_push($cats,(array(124, 422, 'LB', 'Lebanon', 'LEBANON', 'LBN')));
		array_push($cats,(array(125, 426, 'LS', 'Lesotho', 'LESOTHO', 'LSO')));
		array_push($cats,(array(126, 430, 'LR', 'Liberia', 'LIBERIA', 'LBR')));
		array_push($cats,(array(127, 434, 'LY', 'Libyan Arab Jamahiriya', 'LIBYAN ARAB JAMAHIRIYA', 'LBY')));
		array_push($cats,(array(128, 438, 'LI', 'Liechtenstein', 'LIECHTENSTEIN', 'LIE')));
		array_push($cats,(array(129, 440, 'LT', 'Lithuania', 'LITHUANIA', 'LTU')));
		array_push($cats,(array(130, 442, 'LU', 'Luxembourg', 'LUXEMBOURG', 'LUX')));
		array_push($cats,(array(131, 446, 'MO', 'Macao', 'MACAO', 'MAC')));
		array_push($cats,(array(132, 807, 'MK', 'Macedonia, the Former Yugoslav Republic of', 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF', 'MKD')));
		array_push($cats,(array(133, 450, 'MG', 'Madagascar', 'MADAGASCAR', 'MDG')));
		array_push($cats,(array(134, 454, 'MW', 'Malawi', 'MALAWI', 'MWI')));
		array_push($cats,(array(135, 458, 'MY', 'Malaysia', 'MALAYSIA', 'MYS')));
		array_push($cats,(array(136, 462, 'MV', 'Maldives', 'MALDIVES', 'MDV')));
		array_push($cats,(array(137, 466, 'ML', 'Mali', 'MALI', 'MLI')));
		array_push($cats,(array(138, 470, 'MT', 'Malta', 'MALTA', 'MLT')));
		array_push($cats,(array(139, 584, 'MH', 'Marshall Islands', 'MARSHALL ISLANDS', 'MHL')));
		array_push($cats,(array(140, 474, 'MQ', 'Martinique', 'MARTINIQUE', 'MTQ')));
		array_push($cats,(array(141, 478, 'MR', 'Mauritania', 'MAURITANIA', 'MRT')));
		array_push($cats,(array(142, 480, 'MU', 'Mauritius', 'MAURITIUS', 'MUS')));
		array_push($cats,(array(143, 175, 'YT', 'Mayotte', 'MAYOTTE', 'MYT')));
		array_push($cats,(array(144, 484, 'MX', 'Mexico', 'MEXICO', 'MEX')));
		array_push($cats,(array(145, 583, 'FM', 'Micronesia, Federated States of', 'MICRONESIA, FEDERATED STATES OF', 'FSM')));
		array_push($cats,(array(146, 498, 'MD', 'Moldova, Republic of', 'MOLDOVA, REPUBLIC OF', 'MDA')));
		array_push($cats,(array(147, 492, 'MC', 'Monaco', 'MONACO', 'MCO')));
		array_push($cats,(array(148, 496, 'MN', 'Mongolia', 'MONGOLIA', 'MNG')));
		array_push($cats,(array(149, 499, 'ME', 'Montenegro', 'MONTENEGRO', 'MNE')));
		array_push($cats,(array(150, 500, 'MS', 'Montserrat', 'MONTSERRAT', 'MSR')));
		array_push($cats,(array(151, 504, 'MA', 'Morocco', 'MOROCCO', 'MAR')));
		array_push($cats,(array(152, 508, 'MZ', 'Mozambique', 'MOZAMBIQUE', 'MOZ')));
		array_push($cats,(array(153, 104, 'MM', 'Myanmar', 'MYANMAR', 'MMR')));
		array_push($cats,(array(154, 516, 'NA', 'Namibia', 'NAMIBIA', 'NAM')));
		array_push($cats,(array(155, 520, 'NR', 'Nauru', 'NAURU', 'NRU')));
		array_push($cats,(array(156, 524, 'NP', 'Nepal', 'NEPAL', 'NPL')));
		array_push($cats,(array(157, 528, 'NL', 'Netherlands', 'NETHERLANDS', 'NLD')));
		array_push($cats,(array(158, 540, 'NC', 'New Caledonia', 'NEW CALEDONIA', 'NCL')));
		array_push($cats,(array(159, 554, 'NZ', 'New Zealand', 'NEW ZEALAND', 'NZL')));
		array_push($cats,(array(160, 558, 'NI', 'Nicaragua', 'NICARAGUA', 'NIC')));
		array_push($cats,(array(161, 562, 'NE', 'Niger', 'NIGER', 'NER')));
		array_push($cats,(array(162, 566, 'NG', 'Nigeria', 'NIGERIA', 'NGA')));
		array_push($cats,(array(163, 570, 'NU', 'Niue', 'NIUE', 'NIU')));
		array_push($cats,(array(164, 574, 'NF', 'Norfolk Island', 'NORFOLK ISLAND', 'NFK')));
		array_push($cats,(array(165, 580, 'MP', 'Northern Mariana Islands', 'NORTHERN MARIANA ISLANDS', 'MNP')));
		array_push($cats,(array(166, 578, 'NO', 'Norway', 'NORWAY', 'NOR')));
		array_push($cats,(array(167, 512, 'OM', 'Oman', 'OMAN', 'OMN')));
		array_push($cats,(array(168, 586, 'PK', 'Pakistan', 'PAKISTAN', 'PAK')));
		array_push($cats,(array(169, 585, 'PW', 'Palau', 'PALAU', 'PLW')));
		array_push($cats,(array(170, 275, 'PS', 'Palestinian Territory, Occupied', 'PALESTINIAN TERRITORY, OCCUPIED', 'PSE')));
		array_push($cats,(array(171, 591, 'PA', 'Panama', 'PANAMA', 'PAN')));
		array_push($cats,(array(172, 598, 'PG', 'Papua New Guinea', 'PAPUA NEW GUINEA', 'PNG')));
		array_push($cats,(array(173, 600, 'PY', 'Paraguay', 'PARAGUAY', 'PRY')));
		array_push($cats,(array(174, 604, 'PE', 'Peru', 'PERU', 'PER')));
		array_push($cats,(array(175, 608, 'PH', 'Philippines', 'PHILIPPINES', 'PHL')));
		array_push($cats,(array(176, 612, 'PN', 'Pitcairn', 'PITCAIRN', 'PCN')));
		array_push($cats,(array(177, 616, 'PL', 'Poland', 'POLAND', 'POL')));
		array_push($cats,(array(178, 620, 'PT', 'Portugal', 'PORTUGAL', 'PRT')));
		array_push($cats,(array(179, 630, 'PR', 'Puerto Rico', 'PUERTO RICO', 'PRI')));
		array_push($cats,(array(180, 634, 'QA', 'Qatar', 'QATAR', 'QAT')));
		array_push($cats,(array(181, 638, 'RE', 'Reunion', 'REUNION', 'REU')));
		array_push($cats,(array(182, 642, 'RO', 'Romania', 'ROMANIA', 'ROM')));
		array_push($cats,(array(183, 643, 'RU', 'Russian Federation', 'RUSSIAN FEDERATION', 'RUS')));
		array_push($cats,(array(184, 646, 'RW', 'Rwanda', 'RWANDA', 'RWA')));
		array_push($cats,(array(185, 652, 'BL', 'Saint Barthelemy', 'SAINT BARTHELEMY', 'BLM')));
		array_push($cats,(array(186, 654, 'SH', 'Saint Helena, Ascension and Tristan da Cunha', 'SAINT HELENA, ASCENSION AND TRISTAN DA CUNHA', 'SHN')));
		array_push($cats,(array(187, 659, 'KN', 'Saint Kitts and Nevis', 'SAINT KITTS AND NEVIS', 'KNA')));
		array_push($cats,(array(188, 662, 'LC', 'Saint Lucia', 'SAINT LUCIA', 'LCA')));
		array_push($cats,(array(189, 663, 'MF', 'Saint Martin (French part)', 'SAINT MARTIN (FRENCH PART)', 'MAF')));
		array_push($cats,(array(190, 666, 'PM', 'Saint Pierre and Miquelon', 'SAINT PIERRE AND MIQUELON', 'SPM')));
		array_push($cats,(array(191, 670, 'VC', 'Saint Vincent and the Grenadines', 'SAINT VINCENT AND THE GRENADINES', 'VCT')));
		array_push($cats,(array(192, 882, 'WS', 'Samoa', 'SAMOA', 'WSM')));
		array_push($cats,(array(193, 674, 'SM', 'San Marino', 'SAN MARINO', 'SMR')));
		array_push($cats,(array(194, 678, 'ST', 'Sao Tome and Principe', 'SAO TOME AND PRINCIPE', 'STP')));
		array_push($cats,(array(195, 682, 'SA', 'Saudi Arabia', 'SAUDI ARABIA', 'SAU')));
		array_push($cats,(array(196, 686, 'SN', 'Senegal', 'SENEGAL', 'SEN')));
		array_push($cats,(array(197, 688, 'RS', 'Serbia', 'SERBIA', 'SRB')));
		array_push($cats,(array(198, 690, 'SC', 'Seychelles', 'SEYCHELLES', 'SYC')));
		array_push($cats,(array(199, 694, 'SL', 'Sierra Leone', 'SIERRA LEONE', 'SLE')));
		array_push($cats,(array(200, 702, 'SG', 'Singapore', 'SINGAPORE', 'SGP')));
		array_push($cats,(array(201, 534, 'SX', 'Sint Maarten (Dutch part)', 'SINT MAARTEN (DUTCH PART)', 'SXM')));
		array_push($cats,(array(202, 703, 'SK', 'Slovakia', 'SLOVAKIA', 'SVK')));
		array_push($cats,(array(203, 705, 'SI', 'Slovenia', 'SLOVENIA', 'SVN')));
		array_push($cats,(array(204, 90, 'SB', 'Solomon Islands', 'SOLOMON ISLANDS', 'SLB')));
		array_push($cats,(array(205, 706, 'SO', 'Somalia', 'SOMALIA', 'SOM')));
		array_push($cats,(array(206, 710, 'ZA', 'South Africa', 'SOUTH AFRICA', 'ZAF')));
		array_push($cats,(array(207, 239, 'GS', 'South Georgia and the South Sandwich Islands', 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS', 'SGS')));
		array_push($cats,(array(208, 724, 'ES', 'Spain', 'SPAIN', 'ESP')));
		array_push($cats,(array(209, 144, 'LK', 'Sri Lanka', 'SRI LANKA', 'LKA')));
		array_push($cats,(array(210, 736, 'SD', 'Sudan', 'SUDAN', 'SDN')));
		array_push($cats,(array(211, 740, 'SR', 'Suriname', 'SURINAME', 'SUR')));
		array_push($cats,(array(212, 744, 'SJ', 'Svalbard and Jan Mayen', 'SVALBARD AND JAN MAYEN', 'SJM')));
		array_push($cats,(array(213, 748, 'SZ', 'Swaziland', 'SWAZILAND', 'SWZ')));
		array_push($cats,(array(214, 752, 'SE', 'Sweden', 'SWEDEN', 'SWE')));
		array_push($cats,(array(215, 756, 'CH', 'Switzerland', 'SWITZERLAND', 'CHE')));
		array_push($cats,(array(216, 760, 'SY', 'Syrian Arab Republic', 'SYRIAN ARAB REPUBLIC', 'SYR')));
		array_push($cats,(array(217, 158, 'TW', 'Taiwan, Province of China', 'TAIWAN, PROVINCE OF CHINA', 'TWN')));
		array_push($cats,(array(218, 762, 'TJ', 'Tajikistan', 'TAJIKISTAN', 'TJK')));
		array_push($cats,(array(219, 834, 'TZ', 'Tanzania, United Republic of', 'TANZANIA, UNITED REPUBLIC OF', 'TZA')));
		array_push($cats,(array(220, 764, 'TH', 'Thailand', 'THAILAND', 'THA')));
		array_push($cats,(array(221, 626, 'TL', 'Timor-Leste', 'TIMOR-LESTE', 'TLS')));
		array_push($cats,(array(222, 768, 'TG', 'Togo', 'TOGO', 'TGO')));
		array_push($cats,(array(223, 772, 'TK', 'Tokelau', 'TOKELAU', 'TKL')));
		array_push($cats,(array(224, 776, 'TO', 'Tonga', 'TONGA', 'TON')));
		array_push($cats,(array(225, 780, 'TT', 'Trinidad and Tobago', 'TRINIDAD AND TOBAGO', 'TTO')));
		array_push($cats,(array(226, 788, 'TN', 'Tunisia', 'TUNISIA', 'TUN')));
		array_push($cats,(array(227, 792, 'TR', 'Turkey', 'TURKEY', 'TUR')));
		array_push($cats,(array(228, 795, 'TM', 'Turkmenistan', 'TURKMENISTAN', 'TKM')));
		array_push($cats,(array(229, 796, 'TC', 'Turks and Caicos Islands', 'TURKS AND CAICOS ISLANDS', 'TCA')));
		array_push($cats,(array(230, 798, 'TV', 'Tuvalu', 'TUVALU', 'TUV')));
		array_push($cats,(array(231, 800, 'UG', 'Uganda', 'UGANDA', 'UGA')));
		array_push($cats,(array(232, 804, 'UA', 'Ukraine', 'UKRAINE', 'UKR')));
		array_push($cats,(array(233, 784, 'AE', 'United Arab Emirates', 'UNITED ARAB EMIRATES', 'ARE')));
		array_push($cats,(array(234, 826, 'GB', 'United Kingdom', 'UNITED KINGDOM', 'GBR')));
		array_push($cats,(array(235, 840, 'US', 'United States', 'UNITED STATES', 'USA')));
		array_push($cats,(array(236, 581, 'UM', 'United States Minor Outlying Islands', 'UNITED STATES MINOR OUTLYING ISLANDS', 'UMI')));
		array_push($cats,(array(237, 858, 'UY', 'Uruguay', 'URUGUAY', 'URY')));
		array_push($cats,(array(238, 860, 'UZ', 'Uzbekistan', 'UZBEKISTAN', 'UZB')));
		array_push($cats,(array(239, 548, 'VU', 'Vanuatu', 'VANUATU', 'VUT')));
		array_push($cats,(array(240, 862, 'VE', 'Venezuela, Bolivarian Republic of', 'VENEZUELA, BOLIVARIAN REPUBLIC OF', 'VEN')));
		array_push($cats,(array(241, 704, 'VN', 'Viet Nam', 'VIET NAM', 'VNM')));
		array_push($cats,(array(242, 92, 'VG', 'Virgin Islands, British', 'VIRGIN ISLANDS, BRITISH', 'VGB')));
		array_push($cats,(array(243, 850, 'VI', 'Virgin Islands, U.S.', 'VIRGIN ISLANDS, U.S.', 'VIR')));
		array_push($cats,(array(244, 876, 'WF', 'Wallis and Futuna', 'WALLIS AND FUTUNA', 'WLF')));
		array_push($cats,(array(245, 732, 'EH', 'Western Sahara', 'WESTERN SAHARA', 'ESH')));
		array_push($cats,(array(246, 887, 'YE', 'Yemen', 'YEMEN', 'YEM')));
		array_push($cats,(array(247, 894, 'ZM', 'Zambia', 'ZAMBIA', 'ZMB')));
		array_push($cats,(array(248, 716, 'ZW', 'Zimbabwe', 'ZIMBABWE', 'ZWE')));
		
		
		$options = array();
		if ($cats)
		{
			foreach($cats as $cat) 
			{
				$options[] = JHtml::_('select.option', $cat[3], $cat[3]);
			}
		}
		$options = array_merge(parent::getOptions(), $options);
		return $options;
	}
	
	
	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{
		
		return parent::getInput();
	}	
}
