<?php
/**
 * @version		$Id$
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

JFormHelper::loadFieldClass('list');

/**
 * Form Field class for the Joomla Framework.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_ejoshop
 * @since		1.6
 */
class JFormFieldMenulinks extends JFormField
{
	/**
	 * A flexible category list that respects access controls
	 *
	 * @var		string
	 * @since	1.6
	 */
	public $type = 'Menulinks';

	/**
	 * Method to get a list of categories that respects access controls and can be used for
	 * either category assignment or parent category assignment in edit screens.
	 * Use the parent element to indicate that the field will be used for assigning parent categories.
	 *
	 * @return	array	The field option objects.
	 * @since	1.6
	 */
	protected function getInput()
	{
				$fieldname = $this->__get('name');
				
				require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'libraries'.DS.'ejoshop/menu/menu.php');
				$tree = menu_build_tree('management');
				
				$helper = new EjoshopHelper();
				
				$content['menu'] = $helper->admin_menu_links_menu($tree);
				
				$select['select'] =  $content['menu'];
				$select['select']['#prefix'] = '<select name="'.$fieldname.'" id="menu-select">';
				$select['select']['#suffix'] = '</select>';
				$select['select']['#theme'] = 'admin_menu_select';
				$select['select']['#wrapper_attributes']['id'] = 'admin-menu-menu';
				$html_select = $helper->drupal_render($select, FALSE);
				if($fieldname == 'jform[mlid]') {
					$html_select .= '<div class="clr"></div><button onclick="Joomla.submitbutton(\'ejoshopmenu.deleteitem\')">Delete</button>';
				}
				return $html_select;
	}
	

}
