CREATE TABLE IF NOT EXISTS `#__ejoshop_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2;


INSERT INTO `#__ejoshop_categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 165, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 935, '2011-01-01 00:00:01', 0, '2011-01-01 00:00:01', 0, '*');


--
-- Table structure for table `#__ejoshop_csv`
--

CREATE TABLE IF NOT EXISTS `#__ejoshop_csv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `csvfile` text NOT NULL,
  `csvpath` text NOT NULL,
  `createdon` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `idf` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `#__ejoshop_csv`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__ejoshop_currency`
--

CREATE TABLE IF NOT EXISTS `#__ejoshop_currency` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `currency_country` char(50) NOT NULL,
  `currency_name` varchar(64) DEFAULT NULL,
  `currency_code` char(3) DEFAULT NULL,
  `currency_img` varchar(255) DEFAULT NULL,
  `imgparams` varchar(255) DEFAULT NULL,
  `currency_sign` char(5) DEFAULT NULL,
  `item` varchar(50) NOT NULL,
  `state` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_currency_name` (`currency_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=229 ;

--
-- Dumping data for table `#__ejoshop_currency`
--

INSERT INTO `#__ejoshop_currency` (`id`, `currency_country`, `currency_name`, `currency_code`, `currency_img`, `imgparams`, `currency_sign`, `item`, `state`) VALUES
(1, 'Afghanistan', 'Afghan afghani', 'AFN', '23px-Flag_of_Afghanistan.svg.png', '{"width":"23","height":"15"}', NULL, 'Pul', 0),
(2, 'Akrotiri and Dhekelia', 'Euro', 'EUR', '23px-Flag_of_the_United_Kingdom.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(3, 'Albania', 'Albanian lek', 'ALL', '21px-Flag_of_Albania.svg.png', '{"width":"21","height":"15"}', NULL, 'Qindarke', 0),
(4, 'Algeria', 'Algerian dinar', 'DZD', '23px-Flag_of_Algeria.svg.png', '{"width":"23","height":"15"}', NULL, 'Santeem', 0),
(5, 'Andorra', 'Euro', 'EUR', '22px-Flag_of_Andorra.svg.png', '{"width":"22","height":"15"}', NULL, 'Cent', 0),
(6, 'Angola', 'Angolan kwanza', 'AOA', '23px-Flag_of_Angola.svg.png', '{"width":"23","height":"15"}', NULL, 'Centimo', 0),
(7, 'Anguilla', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Anguilla.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(8, 'Antigua and Barbuda', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Antigua_and_Barbuda.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(9, 'Argentina', 'Argentine peso', 'ARS', '23px-Flag_of_Argentina.svg.png', '{"width":"23","height":"14"}', NULL, 'Centavo', 0),
(10, 'Armenia', 'Armenian dram', 'AMD', '23px-Flag_of_Armenia.svg.png', '{"width":"23","height":"12"}', NULL, 'Luma', 0),
(11, 'Aruba', 'Aruban florin', 'AWG', '23px-Flag_of_Aruba.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(12, 'Australia', 'Australian dollar', 'AUD', '23px-Flag_of_Australia.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(13, 'Austria', 'Euro', 'EUR', '23px-Flag_of_Austria.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(14, 'Azerbaijan', 'Azerbaijani manat', 'AZN', '23px-Flag_of_Azerbaijan.svg.png', '{"width":"23","height":"12"}', NULL, 'Q?pik', 0),
(15, 'The Bahamas', 'Bahamian dollar', 'BSD', '23px-Flag_of_the_Bahamas.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(16, 'Bahrain', 'Bahraini dinar', 'BHD', '23px-Flag_of_Bahrain.svg.png', '{"width":"23","height":"14"}', NULL, 'Fils', 0),
(17, 'Bangladesh', 'Bangladeshi taka', 'BDT', '23px-Flag_of_Bangladesh.svg.png', '{"width":"23","height":"14"}', NULL, 'Paisa', 0),
(18, 'Barbados', 'Barbadian dollar', 'BBD', '23px-Flag_of_Barbados.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(19, 'Belarus', 'Belarusian ruble', 'BYR', '23px-Flag_of_Belarus.svg.png', '{"width":"23","height":"12"}', NULL, 'Kapyeyka', 0),
(20, 'Belgium', 'Euro', 'EUR', '23px-Flag_of_Belgium_%28civil%29.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(21, 'Belize', 'Belize dollar', 'BZD', '23px-Flag_of_Belize.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(22, 'Benin', 'West African CFA franc', 'XOF', '23px-Flag_of_Benin.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(23, 'Bermuda', 'Bermudian dollar', 'BMD', '23px-Flag_of_Bermuda.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(24, 'Bhutan', 'Bhutanese ngultrum', 'BTN', '23px-Flag_of_Bhutan.svg.png', '{"width":"23","height":"15"}', NULL, 'Chetrum', 0),
(25, 'Bolivia', 'Bolivian boliviano', 'BOB', '22px-Flag_of_Bolivia.svg.png', '{"width":"22","height":"15"}', NULL, 'Centavo', 0),
(26, 'Bonaire', 'United States dollar', 'USD', '23px-Flag_of_Bonaire.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(27, 'Bosnia and Herzegovina', 'Bosnia and Herzegovina convertible mark', 'BAM', '23px-Flag_of_Bosnia_and_Herzegovina.svg.png', '{"width":"23","height":"12"}', NULL, 'Fening', 0),
(28, 'Botswana', 'Botswana pula', 'BWP', '23px-Flag_of_Botswana.svg.png', '{"width":"23","height":"15"}', NULL, 'Thebe', 0),
(29, 'Brazil', 'Brazilian real', 'BRL', '22px-Flag_of_Brazil.svg.png', '{"width":"22","height":"15"}', NULL, 'Centavo', 0),
(30, 'British Indian Ocean Territory', 'United States dollar', 'USD', '23px-Flag_of_the_British_Indian_Ocean_Territory.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent[D]', 0),
(31, 'Brunei', 'Brunei dollar', 'BND', '23px-Flag_of_Brunei.svg.png', '{"width":"23","height":"12"}', NULL, 'Sen', 0),
(32, 'Bulgaria', 'Bulgarian lev', 'BGN', '23px-Flag_of_Bulgaria.svg.png', '{"width":"23","height":"14"}', NULL, 'Stotinka', 0),
(33, 'Burkina Faso', 'West African CFA franc', 'XOF', '23px-Flag_of_Burkina_Faso.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(34, 'Burma', 'Burmese kyat', 'MMK', '23px-Flag_of_Myanmar.svg.png', '{"width":"23","height":"15"}', NULL, 'Pya', 0),
(35, 'Burundi', 'Burundian franc', 'BIF', '23px-Flag_of_Burundi.svg.png', '{"width":"23","height":"14"}', NULL, 'Centime', 0),
(36, 'Cambodia', 'Cambodian riel', 'KHR', '23px-Flag_of_Cambodia.svg.png', '{"width":"23","height":"15"}', NULL, 'Sen', 0),
(37, 'Cameroon', 'Central African CFA franc', 'XAF', '23px-Flag_of_Cameroon.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(38, 'Canada', 'Canadian dollar', 'CAD', '23px-Flag_of_Canada.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(39, 'Cape Verde', 'Cape Verdean escudo', 'CVE', '23px-Flag_of_Cape_Verde.svg.png', '{"width":"23","height":"14"}', NULL, 'Centavo', 0),
(40, 'Cayman Islands', 'Cayman Islands dollar', 'KYD', '23px-Flag_of_the_Cayman_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(41, 'Central African Republic', 'Central African CFA franc', 'XAF', '23px-Flag_of_the_Central_African_Republic.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(42, 'Chad', 'Central African CFA franc', 'XAF', '23px-Flag_of_Chad.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(43, 'Chile', 'Chilean peso', 'CLP', '23px-Flag_of_Chile.svg.png', '{"width":"23","height":"15"}', NULL, 'Centavo', 0),
(44, 'China', 'Chinese yuan', 'CNY', '23px-FlagRepublic_of_China.svg.png', '{"width":"23","height":"15"}', NULL, 'Fen[E]', 0),
(45, 'Cocos (Keeling) Islands', 'Australian dollar', 'AUD', '23px-Flag_of_the_Cocos_%28Keeling%29_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(46, 'Colombia', 'Colombian peso', 'COP', '23px-Flag_of_Colombia.svg.png', '{"width":"23","height":"15"}', NULL, 'Centavo', 0),
(47, 'Comoros', 'Comorian franc', 'KMF', '23px-Flag_of_the_Comoros.svg.png', '{"width":"23","height":"14"}', NULL, 'Centime', 0),
(48, 'Democratic Republic of the Congo', 'Congolese franc', 'CDF', '20px-Flag_of_the_Democratic_Republic_of_the_Congo.svg.png', '{"width":"20","height":"15"}', NULL, 'Centime', 0),
(49, 'Republic of the Congo', 'Central African CFA franc', 'XAF', '23px-Flag_of_the_Republic_of_the_Congo.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(50, 'Cook Islands', 'New Zealand dollar', 'NZD', '23px-Flag_of_the_Cook_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(51, 'Costa Rica', 'Costa Rican colon', 'CRC', '23px-Flag_of_Costa_Rica.svg.png', '{"width":"23","height":"14"}', NULL, 'Centimo', 0),
(52, 'Ivory Coast', 'West African CFA franc', 'XOF', '23px-Flag_of_C%C3%B4te_d%27Ivoire.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(53, 'Croatia', 'Croatian kuna', 'HRK', '23px-Flag_of_Croatia.svg.png', '{"width":"23","height":"12"}', NULL, 'Lipa', 0),
(54, 'Cuba', 'Cuban convertible peso', 'CUC', '23px-Flag_of_Cuba.svg.png', '{"width":"23","height":"12"}', NULL, 'Centavo', 0),
(55, 'Curacao', 'Netherlands Antillean guilder', 'ANG', '23px-Flag_of_Cura%C3%A7ao.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(56, 'Cyprus', 'Euro', 'EUR', '23px-Flag_of_Cyprus.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(57, 'Czech Republic', 'Czech koruna', 'CZK', '23px-Flag_of_the_Czech_Republic.svg.png', '{"width":"23","height":"15"}', NULL, 'Haler', 0),
(58, 'Denmark', 'Danish krone', 'DKK', '20px-Flag_of_Denmark.svg.png', '{"width":"20","height":"15"}', NULL, 'Ore', 0),
(59, 'Djibouti', 'Djiboutian franc', 'DJF', '23px-Flag_of_Djibouti.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(60, 'Dominica', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Dominica.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(61, 'Dominican Republic', 'Dominican peso', 'DOP', '23px-Flag_of_the_Dominican_Republic.svg.png', '{"width":"23","height":"14"}', NULL, 'Centavo', 0),
(62, 'East Timor', 'United States dollar', 'USD', '23px-Flag_of_East_Timor.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent[D]', 0),
(63, 'Ecuador', 'United States dollar', 'USD', '23px-Flag_of_Ecuador.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent[D]', 0),
(64, 'Egypt', 'Egyptian pound', 'EGP', '23px-Flag_of_Egypt.svg.png', '{"width":"23","height":"15"}', NULL, 'Piastre[F]', 0),
(65, 'El Salvador', 'Salvadoran colon', 'SVC', '23px-Flag_of_El_Salvador.svg.png', '{"width":"23","height":"13"}', NULL, 'Centavo', 0),
(66, 'Equatorial Guinea', 'Central African CFA franc', 'XAF', '23px-Flag_of_Equatorial_Guinea.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(67, 'Eritrea', 'Eritrean nakfa', 'Nfk', '23px-Flag_of_Eritrea.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(68, 'Estonia', 'Euro', 'EUR', '23px-Flag_of_Estonia.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(69, 'Ethiopia', 'Ethiopian birr', 'ETB', '23px-Flag_of_Ethiopia.svg.png', '{"width":"23","height":"12"}', NULL, 'Santim', 0),
(70, 'Falkland Islands', 'Falkland Islands pound', 'FKP', '23px-Flag_of_the_Falkland_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(71, 'Faroe Islands', 'Danish krone', 'DKK', '21px-Flag_of_the_Faroe_Islands.svg.png', '{"width":"21","height":"15"}', NULL, 'Ore', 0),
(72, 'Fiji', 'Fijian dollar', 'FJD', '23px-Flag_of_Fiji.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(73, 'Finland', 'Euro', 'EUR', '23px-Flag_of_Finland.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 0),
(74, 'France', 'Euro', 'EUR', '23px-Flag_of_France.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(75, 'French Polynesia', 'CFP franc', 'XPF', '23px-Flag_of_French_Polynesia.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(76, 'Gabon', 'Central African CFA franc', 'XAF', '20px-Flag_of_Gabon.svg.png', '{"width":"20","height":"15"}', NULL, 'Centime', 0),
(77, 'The Gambia', 'Gambian dalasi', 'GMD', '23px-Flag_of_The_Gambia.svg.png', '{"width":"23","height":"15"}', NULL, 'Butut', 0),
(78, 'Georgia (country)', 'Georgian lari', 'GEL', '23px-Flag_of_Georgia.svg.png', '{"width":"23","height":"15"}', NULL, 'Tetri', 0),
(79, 'Germany', 'Euro', 'EUR', '23px-Flag_of_Germany.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 1),
(80, 'Ghana', 'Ghana cedi', 'GHS', '23px-Flag_of_Ghana.svg.png', '{"width":"23","height":"15"}', NULL, 'Pesewa', 0),
(81, 'Gibraltar', 'Gibraltar pound', 'GIP', '23px-Flag_of_Gibraltar.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(82, 'Greece', 'Euro', 'EUR', '23px-Flag_of_Greece.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(83, 'Grenada', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Grenada.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 0),
(84, 'Guatemala', 'Guatemalan quetzal', 'GTQ', '23px-Flag_of_Guatemala.svg.png', '{"width":"23","height":"14"}', NULL, 'Centavo', 0),
(85, 'Guernsey', 'Pound sterling', 'GBP', '23px-Flag_of_Guernsey.svg.png', '{"width":"23","height":"15"}', NULL, 'Penny', 0),
(86, 'Guinea', 'Guinean franc', 'GNF', '23px-Flag_of_Guinea.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(87, 'Guinea-Bissau', 'West African CFA franc', 'XOF', '23px-Flag_of_Guinea-Bissau.svg.png', '{"width":"23","height":"12"}', NULL, 'Centime', 0),
(88, 'Guyana', 'Guyanese dollar', 'GYD', '23px-Flag_of_Guyana.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 0),
(89, 'Haiti', 'Haitian gourde', 'HTG', '23px-Flag_of_Haiti.svg.png', '{"width":"23","height":"14"}', NULL, 'Centime', 0),
(90, 'Honduras', 'Honduran lempira', 'HNL', '23px-Flag_of_Honduras.svg.png', '{"width":"23","height":"12"}', NULL, 'Centavo', 0),
(91, 'Hong Kong', 'Hong Kong dollar', 'HKD', '23px-Flag_of_Hong_Kong.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(92, 'Hungary', 'Hungarian forint', 'HUF', '23px-Flag_of_Hungary.svg.png', '{"width":"23","height":"12"}', NULL, 'Filler', 0),
(93, 'Iceland', 'Icelandic krona', 'ISK', '21px-Flag_of_Iceland.svg.png', '{"width":"21","height":"15"}', NULL, 'Eyrir', 0),
(94, 'India', 'Indian rupee', 'INR', '23px-Flag_of_India.svg.png', '{"width":"23","height":"15"}', NULL, 'Paisa', 0),
(95, 'Indonesia', 'Indonesian rupiah', 'IDR', '23px-Flag_of_Indonesia.svg.png', '{"width":"23","height":"15"}', NULL, 'Sen', 0),
(96, 'Iran', 'Iranian rial', 'IRR', '23px-Flag_of_Iran.svg.png', '{"width":"23","height":"13"}', NULL, 'Dinar', 0),
(97, 'Iraq', 'Iraqi dinar', 'IQD', '23px-Flag_of_Iraq.svg.png', '{"width":"23","height":"15"}', NULL, 'Fils', 0),
(98, 'Republic of Ireland', 'Euro', 'EUR', '23px-Flag_of_Ireland.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(99, 'Isle of Man', 'Pound sterling', 'GBP', '23px-Flag_of_the_Isle_of_Man.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(100, 'Israel', 'Israeli new shekel', 'ILS', '21px-Flag_of_Israel.svg.png', '{"width":"21","height":"15"}', NULL, 'Agora', 0),
(101, 'Italy', 'Euro', 'EUR', '23px-Flag_of_Italy.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(102, 'Jamaica', 'Jamaican dollar', 'JMD', '23px-Flag_of_Jamaica.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(103, 'Japan', 'Japanese yen', 'JPY', '23px-Flag_of_Japan.svg.png', '{"width":"23","height":"15"}', NULL, 'Sen[G]', 0),
(104, 'Jersey', 'Pound sterling', 'GBP', '23px-Flag_of_Jersey.svg.png', '{"width":"23","height":"14"}', NULL, 'Penny', 0),
(105, 'Jordan', 'Jordanian dinar', 'JOD', '23px-Flag_of_Jordan.svg.png', '{"width":"23","height":"12"}', NULL, 'Piastre[H]', 0),
(106, 'Kazakhstan', 'Kazakhstani tenge', 'KZT', '23px-Flag_of_Kazakhstan.svg.png', '{"width":"23","height":"12"}', NULL, 'Ti?n', 0),
(107, 'Kenya', 'Kenyan shilling', 'KES', '23px-Flag_of_Kenya.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(108, 'Kiribati', 'Australian dollar', 'AUD', '23px-Flag_of_Kiribati.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(109, 'North Korea', 'North Korean won', 'KPW', '23px-Flag_of_North_Korea.svg.png', '{"width":"23","height":"12"}', NULL, 'Chon', 0),
(110, 'South Korea', 'South Korean won', 'KRW', '23px-Flag_of_South_Korea.svg.png', '{"width":"23","height":"15"}', NULL, 'Jeon', 0),
(111, 'Republic of Kosovo', 'Euro', 'EUR', '21px-Flag_of_Kosovo.svg.png', '{"width":"21","height":"15"}', NULL, 'Cent', 0),
(112, 'Kuwait', 'Kuwaiti dinar', 'KWD', '23px-Flag_of_Kuwait.svg.png', '{"width":"23","height":"12"}', NULL, 'Fils', 0),
(113, 'Kyrgyzstan', 'Kyrgyzstani som', 'KGS', '23px-Flag_of_Kyrgyzstan.svg.png', '{"width":"23","height":"14"}', NULL, 'Tyiyn', 0),
(114, 'Laos', 'Lao kip', 'LAK', '23px-Flag_of_Laos.svg.png', '{"width":"23","height":"15"}', NULL, 'Att', 0),
(115, 'Latvia', 'Latvian lats', 'LVL', '23px-Flag_of_Latvia.svg.png', '{"width":"23","height":"12"}', NULL, 'Santims', 0),
(116, 'Lebanon', 'Lebanese pound', 'LBP', '23px-Flag_of_Lebanon.svg.png', '{"width":"23","height":"15"}', NULL, 'Piastre', 0),
(117, 'Lesotho', 'Lesotho loti', 'LSL', '23px-Flag_of_Lesotho.svg.png', '{"width":"23","height":"15"}', NULL, 'Sente', 0),
(118, 'Liberia', 'Liberian dollar', 'LRD', '23px-Flag_of_Liberia.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(119, 'Libya', 'Libyan dinar', 'LYD', '23px-Flag_of_Libya.svg.png', '{"width":"23","height":"12"}', NULL, 'Dirham', 0),
(120, 'Liechtenstein', 'Swiss franc', 'CHF', '23px-Flag_of_Liechtenstein.svg.png', '{"width":"23","height":"14"}', NULL, 'Rappen', 0),
(121, 'Lithuania', 'Lithuanian litas', 'LTL', '23px-Flag_of_Lithuania.svg.png', '{"width":"23","height":"14"}', NULL, 'Centas', 0),
(122, 'Luxembourg', 'Euro', 'EUR', '23px-Flag_of_Luxembourg.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 0),
(123, 'Macau', 'Macanese pataca', 'MOP', '23px-Flag_of_Macau.svg.png', '{"width":"23","height":"15"}', NULL, 'Avo', 0),
(124, 'Republic of Macedonia', 'Macedonian denar', 'MKD', '23px-Flag_of_Macedonia.svg.png', '{"width":"23","height":"12"}', NULL, 'Deni', 0),
(125, 'Madagascar', 'Malagasy ariary', 'MGA', '23px-Flag_of_Madagascar.svg.png', '{"width":"23","height":"15"}', NULL, 'Iraimbilanja', 0),
(126, 'Malawi', 'Malawian kwacha', 'MWK', '23px-Flag_of_Malawi.svg.png', '{"width":"23","height":"15"}', NULL, 'Tambala', 0),
(127, 'Malaysia', 'Malaysian ringgit', 'MYR', '23px-Flag_of_Malaysia.svg.png', '{"width":"23","height":"12"}', NULL, 'Sen', 0),
(128, 'Maldives', 'Maldivian rufiyaa', 'MVR', '23px-Flag_of_Maldives.svg.png', '{"width":"23","height":"15"}', NULL, 'Laari', 0),
(129, 'Mali', 'West African CFA franc', 'XOF', '23px-Flag_of_Mali.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(130, 'Malta', 'Euro', 'EUR', '23px-Flag_of_Malta.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(131, 'Marshall Islands', 'United States dollar', 'USD', '23px-Flag_of_the_Marshall_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent[D]', 0),
(132, 'Mauritania', 'Mauritanian ouguiya', 'MRO', '23px-Flag_of_Mauritania.svg.png', '{"width":"23","height":"15"}', NULL, 'Khoums', 0),
(133, 'Mauritius', 'Mauritian rupee', 'MUR', '23px-Flag_of_Mauritius.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(134, 'Mexico', 'Mexican peso', 'MXN', '23px-Flag_of_Mexico.svg.png', '{"width":"23","height":"13"}', NULL, 'Centavo', 0),
(135, 'Moldova', 'Moldovan leu', 'MDL', '23px-Flag_of_Moldova.svg.png', '{"width":"23","height":"12"}', NULL, 'Ban', 0),
(136, 'Monaco', 'Euro', 'EUR', '19px-Flag_of_Monaco.svg.png', '{"width":"19","height":"15"}', NULL, 'Cent', 0),
(137, 'Mongolia', 'Mongolian togrog', 'MNT', '23px-Flag_of_Mongolia.svg.png', '{"width":"23","height":"12"}', NULL, 'Mongo', 0),
(138, 'Montenegro', 'Euro', 'EUR', '23px-Flag_of_Montenegro.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(139, 'Montserrat', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Montserrat.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(140, 'Morocco', 'Moroccan dirham', 'MAD', '23px-Flag_of_Morocco.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(141, 'Mozambique', 'Mozambican metical', 'MZN', '23px-Flag_of_Mozambique.svg.png', '{"width":"23","height":"15"}', NULL, 'Centavo', 0),
(142, 'Nagorno-Karabakh Republic', 'Armenian dram', 'AMD', '23px-Flag_of_Nagorno-Karabakh.svg.png', '{"width":"23","height":"12"}', NULL, 'Luma', 0),
(143, 'Namibia', 'Namibian dollar', 'NAD', '23px-Flag_of_Namibia.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(144, 'Nauru', 'Australian dollar', 'AUD', '23px-Flag_of_Nauru.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(145, 'Nepal', 'Nepalese rupee', 'NPR', '14px-Flag_of_Nepal.svg.png', '{"width":"14","height":"17"}', NULL, 'Paisa', 0),
(146, 'Netherlands', 'Euro', 'EUR', '23px-Flag_of_the_Netherlands.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(147, 'New Caledonia', 'CFP franc', 'XPF', '23px-Flag_of_New_Caledonia.svg.png', '{"width":"23","height":"12"}', NULL, 'Centime', 0),
(148, 'New Zealand', 'New Zealand dollar', 'NZD', '23px-Flag_of_New_Zealand.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(149, 'Nicaragua', 'Nicaraguan cordoba', 'NIO', '23px-Flag_of_Nicaragua.svg.png', '{"width":"23","height":"14"}', NULL, 'Centavo', 0),
(150, 'Niger', 'West African CFA franc', 'XOF', '18px-Flag_of_Niger.svg.png', '{"width":"18","height":"15"}', NULL, 'Centime', 0),
(151, 'Nigeria', 'Nigerian naira', 'NGN', '23px-Flag_of_Nigeria.svg.png', '{"width":"23","height":"12"}', NULL, 'Kobo', 0),
(152, 'Niue', 'New Zealand dollar', 'NZD', '23px-Flag_of_Niue.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(153, 'Northern Cyprus', 'Turkish lira', 'TRY', '23px-Flag_of_the_Turkish_Republic_of_Northern_Cyprus.svg.png', '{"width":"23","height":"15"}', NULL, 'Kurus', 0),
(154, 'Norway', 'Norwegian krone', 'NOK', '21px-Flag_of_Norway.svg.png', '{"width":"21","height":"15"}', NULL, 'Ore', 0),
(155, 'Oman', 'Omani rial', 'OMR', '23px-Flag_of_Oman.svg.png', '{"width":"23","height":"12"}', NULL, 'Baisa', 0),
(156, 'Pakistan', 'Pakistani rupee', 'PKR', '23px-Flag_of_Pakistan.svg.png', '{"width":"23","height":"15"}', NULL, 'Paisa', 0),
(157, 'State of Palestine', 'Israeli new shekel', 'ILS', '23px-Flag_of_Palestine.svg.png', '{"width":"23","height":"12"}', NULL, 'Agora', 0),
(158, 'Panama', 'Panamanian balboa', 'PAB', '23px-Flag_of_Panama.svg.png', '{"width":"23","height":"15"}', NULL, 'Centesimo', 0),
(159, 'Papua New Guinea', 'Papua New Guinean kina', 'PGK', '20px-Flag_of_Papua_New_Guinea.svg.png', '{"width":"20","height":"15"}', NULL, 'Toea', 0),
(160, 'Paraguay', 'Paraguayan guarani', 'PYG', '23px-Flag_of_Paraguay.svg.png', '{"width":"23","height":"14"}', NULL, 'Centimo', 0),
(161, 'Peru', 'Peruvian nuevo sol', 'PEN', '23px-Flag_of_Peru.svg.png', '{"width":"23","height":"15"}', NULL, 'Centimo', 0),
(162, 'Philippines', 'Philippine peso', 'PHP', '23px-Flag_of_the_Philippines.svg.png', '{"width":"23","height":"12"}', NULL, 'Centavo', 0),
(163, 'Pitcairn Islands', 'New Zealand dollar', 'NZD', '23px-Flag_of_the_Pitcairn_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(164, 'Poland', 'Polish zloty', 'PLN', '23px-Flag_of_Poland.svg.png', '{"width":"23","height":"14"}', NULL, 'Grosz', 0),
(165, 'Portugal', 'Euro', 'EUR', '23px-Flag_of_Portugal.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(166, 'Qatar', 'Qatari riyal', 'QAR', '23px-Flag_of_Qatar.svg.png', '{"width":"23","height":"9"}', NULL, 'Dirham', 0),
(167, 'Romania', 'Romanian leu', 'RON', '23px-Flag_of_Romania.svg.png', '{"width":"23","height":"15"}', NULL, 'Ban', 0),
(168, 'Russia', 'Russian ruble', 'RUB', '23px-Flag_of_Russia.svg.png', '{"width":"23","height":"15"}', NULL, 'Kopek', 1),
(169, 'Rwanda', 'Rwandan franc', 'RWF', '23px-Flag_of_Rwanda.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(170, 'Saba', 'United States dollar', 'USD', '23px-Flag_of_Saba.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(171, 'Sahrawi Arab Democratic Republic', 'Algerian dinar', 'DZD', '23px-Flag_of_the_Sahrawi_Arab_Democratic_Republic.svg.png', '{"width":"23","height":"12"}', NULL, 'Santeem', 0),
(172, 'Saint Helena', 'Saint Helena pound', 'SHP', '23px-Flag_of_Saint_Helena.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(173, 'Saint Kitts and Nevis', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Saint_Kitts_and_Nevis.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(174, 'Saint Lucia', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Saint_Lucia.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(175, 'Saint Vincent and the Grenadines', 'East Caribbean dollar', 'XCD', '23px-Flag_of_Saint_Vincent_and_the_Grenadines.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(176, 'Samoa', 'Samoan tala', 'WST', '23px-Flag_of_Samoa.svg.png', '{"width":"23","height":"12"}', NULL, 'Sene', 0),
(177, 'San Marino', 'Euro', 'EUR', '20px-Flag_of_San_Marino.svg.png', '{"width":"20","height":"15"}', NULL, 'Cent', 0),
(178, 'Sao Tome and Principe', 'Sao Tome and Principe dobra', 'STD', '23px-Flag_of_Sao_Tome_and_Principe.svg.png', '{"width":"23","height":"12"}', NULL, 'Centimo', 0),
(179, 'Saudi Arabia', 'Saudi riyal', 'SAR', '23px-Flag_of_Saudi_Arabia.svg.png', '{"width":"23","height":"15"}', NULL, 'Halala', 0),
(180, 'Senegal', 'West African CFA franc', 'XOF', '23px-Flag_of_Senegal.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(181, 'Serbia', 'Serbian dinar', 'RSD', '23px-Flag_of_Serbia.svg.png', '{"width":"23","height":"15"}', NULL, 'Para', 0),
(182, 'Seychelles', 'Seychellois rupee', 'SCR', '23px-Flag_of_Seychelles.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(183, 'Sierra Leone', 'Sierra Leonean leone', 'SLL', '23px-Flag_of_Sierra_Leone.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(184, 'Singapore', 'Brunei dollar', 'BND', '23px-Flag_of_Singapore.svg.png', '{"width":"23","height":"15"}', NULL, 'Sen', 0),
(185, 'Sint Eustatius', 'United States dollar', 'USD', '23px-Flag_of_Sint_Eustatius.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(186, 'Sint Maarten', 'Netherlands Antillean guilder', 'ANG', '23px-Flag_of_Sint_Maarten.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(187, 'Slovakia', 'Euro', 'EUR', '23px-Flag_of_Slovakia.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(188, 'Slovenia', 'Euro', 'EUR', '23px-Flag_of_Slovenia.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(189, 'Solomon Islands', 'Solomon Islands dollar', 'SBD', '23px-Flag_of_the_Solomon_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(190, 'Somalia', 'Somali shilling', 'SOS', '23px-Flag_of_Somalia.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(191, 'South Africa', 'South African rand', 'ZAR', '23px-Flag_of_South_Africa.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(192, 'South Georgia and the South Sandwich Islands', 'Pound sterling', 'GBP', '23px-Flag_of_South_Georgia_and_the_South_Sandwich_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(193, 'South Ossetia', 'Russian ruble', 'RUB', '23px-Flag_of_South_Ossetia.svg.png', '{"width":"23","height":"12"}', NULL, 'Kopek', 0),
(194, 'Spain', 'Euro', 'EUR', '23px-Flag_of_Spain.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(195, 'South Sudan', 'South Sudanese pound', 'SSP', '23px-Flag_of_South_Sudan.svg.png', '{"width":"23","height":"12"}', NULL, 'Piastre', 0),
(196, 'Sri Lanka', 'Sri Lankan rupee', 'LKR', '23px-Flag_of_Sri_Lanka.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(197, 'Sudan', 'Sudanese pound', 'SDG', '23px-Flag_of_Sudan.svg.png', '{"width":"23","height":"12"}', NULL, 'Piastre', 0),
(198, 'Suriname', 'Surinamese dollar', 'SRD', '23px-Flag_of_Suriname.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(199, 'Swaziland', 'Swazi lilangeni', 'SZL', '23px-Flag_of_Swaziland.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(200, 'Sweden', 'Swedish krona', 'SEK', '23px-Flag_of_Sweden.svg.png', '{"width":"23","height":"14"}', NULL, 'Ore', 0),
(201, 'Switzerland', 'Swiss franc', 'CHF', '16px-Flag_of_Switzerland.svg.png', '{"width":"16","height":"16"}', NULL, 'Rappen[K]', 0),
(202, 'Syria', 'Syrian pound', 'SYP', '23px-Flag_of_Syria.svg.png', '{"width":"23","height":"15"}', NULL, 'Piastre', 0),
(203, 'Taiwan', 'New Taiwan dollar', 'TWD', '23px-Flag_of_the_Republic_of_China.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(204, 'Tajikistan', 'Tajikistani somoni', 'TJS', '23px-Flag_of_Tajikistan.svg.png', '{"width":"23","height":"12"}', NULL, 'Diram', 0),
(205, 'Tanzania', 'Tanzanian shilling', 'TZS', '23px-Flag_of_Tanzania.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(206, 'Thailand', 'Thai baht', 'THB', '23px-Flag_of_Thailand.svg.png', '{"width":"23","height":"15"}', NULL, 'Satang', 0),
(207, 'Togo', 'West African CFA franc', 'XOF', '23px-Flag_of_Togo.svg.png', '{"width":"23","height":"14"}', NULL, 'Centime', 0),
(208, 'Tonga', 'Tongan pa?anga', 'TOP', '23px-Flag_of_Tonga.svg.png', '{"width":"23","height":"12"}', NULL, 'Seniti[L]', 0),
(209, 'Trinidad and Tobago', 'Trinidad and Tobago dollar', 'TTD', '23px-Flag_of_Trinidad_and_Tobago.svg.png', '{"width":"23","height":"14"}', NULL, 'Cent', 0),
(210, 'Tristan da Cunha', 'Saint Helena pound', 'SHP', '23px-Flag_of_Tristan_da_Cunha.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 0),
(211, 'Tunisia', 'Tunisian dinar', 'TND', '23px-Flag_of_Tunisia.svg.png', '{"width":"23","height":"15"}', NULL, 'Millime', 0),
(212, 'Turkey', 'Turkish lira', 'TRY', '23px-Flag_of_Turkey.svg.png', '{"width":"23","height":"15"}', NULL, 'Kurus', 0),
(213, 'Turkmenistan', 'Turkmenistan manat', 'TMT', '23px-Flag_of_Turkmenistan.svg.png', '{"width":"23","height":"15"}', NULL, 'Tennesi', 0),
(214, 'Turks and Caicos Islands', 'United States dollar', 'USD', '23px-Flag_of_the_Turks_and_Caicos_Islands.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent[D]', 0),
(215, 'Tuvalu', 'Australian dollar', 'AUD', '23px-Flag_of_Tuvalu.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent', 0),
(216, 'Uganda', 'Ugandan shilling', 'UGX', '23px-Flag_of_Uganda.svg.png', '{"width":"23","height":"15"}', NULL, 'Cent', 0),
(217, 'Ukraine', 'Ukrainian hryvnia', 'UAH', '23px-Flag_of_Ukraine.svg.png', '{"width":"23","height":"15"}', NULL, 'Kopiyka', 0),
(218, 'United Arab Emirates', 'United Arab Emirates dirham', 'AED', '23px-Flag_of_the_United_Arab_Emirates.svg.png', '{"width":"23","height":"12"}', NULL, 'Fils', 0),
(219, 'United Kingdom', 'Pound sterling', 'GBP', '23px-Flag_of_the_United_Kingdom.svg.png', '{"width":"23","height":"12"}', NULL, 'Penny', 1),
(220, 'United States', 'United States dollar', 'USD', '23px-Flag_of_the_United_States.svg.png', '{"width":"23","height":"12"}', NULL, 'Cent[D]', 1),
(221, 'Uruguay', 'Uruguayan peso', 'UYU', '23px-Flag_of_Uruguay.svg.png', '{"width":"23","height":"15"}', NULL, 'Centesimo', 0),
(222, 'Uzbekistan', 'Uzbekistani som', 'UZS', '23px-Flag_of_Uzbekistan.svg.png', '{"width":"23","height":"12"}', NULL, 'Tiyin', 0),
(223, 'Vatican City', 'Euro', 'EUR', '16px-Flag_of_the_Vatican_City.svg.png', '{"width":"16","height":"16"}', NULL, 'Cent', 0),
(224, 'Venezuela', 'Venezuelan bolivar', 'VEF', '23px-Flag_of_Venezuela.svg.png', '{"width":"23","height":"15"}', NULL, 'Centimo', 0),
(225, 'Wallis and Futuna', 'CFP franc', 'XPF', '23px-Flag_of_France.svg.png', '{"width":"23","height":"15"}', NULL, 'Centime', 0),
(226, 'Yemen', 'Yemeni rial', 'YER', '23px-Flag_of_Yemen.svg.png', '{"width":"23","height":"15"}', NULL, 'Fils', 0),
(227, 'Zambia', 'Zambian kwacha', 'ZMW', '23px-Flag_of_Zambia.svg.png', '{"width":"23","height":"15"}', NULL, 'Ngwee', 0),
(228, 'Zimbabwe', 'Botswana pula', 'BWP', '23px-Flag_of_Zimbabwe.svg.png', '{"width":"23","height":"12"}', NULL, 'Thebe', 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__ejoshop_field_config`
--

CREATE TABLE IF NOT EXISTS `#__ejoshop_field_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',
  `type` varchar(128) NOT NULL COMMENT 'The type of this field.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',
  `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',
  `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',
  `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',
  `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',
  `cardinality` tinyint(4) NOT NULL DEFAULT '0',
  `translatable` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  `widget_type` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `field_name` (`field_name`),
  KEY `active` (`active`),
  KEY `storage_active` (`storage_active`),
  KEY `deleted` (`deleted`),
  KEY `module` (`module`),
  KEY `storage_module` (`storage_module`),
  KEY `type` (`type`),
  KEY `storage_type` (`storage_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;





--
-- Table structure for table `#__ejoshop_image_styles`
--

CREATE TABLE IF NOT EXISTS `#__ejoshop_image_styles` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',
  `options` text NOT NULL,
  `name_imagestyle` varchar(255) NOT NULL DEFAULT '',
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `type_image_crop` varchar(255) NOT NULL DEFAULT '',
  `type` char(50) NOT NULL,
  `cwbn` int(11) NOT NULL DEFAULT '0' COMMENT 'Clear white background noise',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.' AUTO_INCREMENT=28 ;



INSERT INTO `#__ejoshop_image_styles` (`id`, `options`, `name_imagestyle`, `width`, `height`, `type_image_crop`, `type`, `cwbn`) VALUES
(1, '', 'Image as is', 0, 0, 'aspectratio', 'system', 0),
(8, '', 'Мини изображение', 60, 60, 'aspectratio', 'system', 0),
(11, '', 'Большое изображение', 480, 360, 'aspectratio', 'system', 0),
(17, '', 'Среднее изображение', 220, 165, 'aspectratio', 'system', 0),
(18, '', 'Мой стиль', 90, 90, 'aspectratio', '', 0),
(22, '', 'Второй стиль', 350, 300, 'aspectratio', '', 0),
(23, '', '80 на 80', 80, 80, 'aspectratio', '', 0),
(24, '', 'Open pens', 70, 70, 'aspectratio', '', 0),
(25, '', 'Acer style', 180, 180, 'aspectratio', '', 0),
(26, '', '300 на 300', 300, 300, 'aspectratio', '', 1),
(27, '', '400 на 400', 400, 400, 'aspectratio', '', 0);

-- --------------------------------------------------------



CREATE TABLE IF NOT EXISTS `#__ejoshop_menu_links` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  `link_view` varchar(255) NOT NULL DEFAULT '' COMMENT 'Joomla view',
  `link_task` varchar(255) NOT NULL DEFAULT '' COMMENT 'Joomla task',
  PRIMARY KEY (`mlid`),
  KEY `path_menu` (`link_path`(128),`menu_name`),
  KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `router_path` (`router_path`(128))
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.' AUTO_INCREMENT=694 ;


INSERT INTO `#__ejoshop_menu_links` (`menu_name`, `mlid`, `plid`, `link_path`, `router_path`, `link_title`, `options`, `module`, `hidden`, `external`, `has_children`, `expanded`, `weight`, `depth`, `customized`, `p1`, `p2`, `p3`, `p4`, `p5`, `p6`, `p7`, `p8`, `p9`, `updated`, `link_view`, `link_task`) VALUES
('management', 1, 0, 'admin', 'admin', 'Administration', 0x613a303a7b7d, 'system', 0, 0, 1, 0, 9, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 7, 1, 'ejoshoppayments', 'ejoshoppayments', 'COM_EJOSHOP_PAYMENTS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33333a2253656c65637420616e6420636f6e66696775726520796f7572207468656d65732e223b7d7d, 'system', 0, 0, 0, 0, -6, 2, 0, 1, 7, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', ''),
('management', 8, 1, 'ejoshopconfig', 'ejoshopconfig', 'COM_EJOSHOP_CONFIG', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32303a2241646d696e69737465722073657474696e67732e223b7d7d, 'system', 0, 0, 1, 0, 0, 2, 0, 1, 8, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopconfig', ''),
('management', 9, 1, 'ejoshopcategories', 'ejoshopcategories', 'COM_EJ_CATEGORY_PRODUCTS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33323a2241646d696e697374657220636f6e74656e7420616e6420636f6d6d656e74732e223b7d7d, 'system', 0, 0, 1, 0, -10, 2, 0, 1, 9, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', ''),
('management', 11, 1, 'ejoshopphotos', 'ejoshopphotos', 'COM_EJ_PRODUCTS_AND_PHOTO', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33343a225669657720616e6420637573746f6d697a6520796f75722064617368626f6172642e223b7d7d, 'system', 0, 0, 1, 0, -15, 2, 0, 1, 11, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', ''),
('management', 12, 1, 'admin/index', 'admin/index', 'Index', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -18, 2, 0, 1, 12, 0, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 15, 1, 'ejoshopuploadcsv', 'ejoshopuploadcsv', 'COM_EJOSHOP_CSV', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32363a22457874656e6420736974652066756e6374696f6e616c6974792e223b7d7d, 'system', 0, 0, 0, 0, -2, 2, 0, 1, 15, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopuploadcsv', ''),
('management', 17, 1, 'ejoshopsales', 'ejoshopsales', 'COM_EJOSHOP_SALE', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a34353a224d616e6167652075736572206163636f756e74732c20726f6c65732c20616e64207065726d697373696f6e732e223b7d7d, 'system', 0, 0, 0, 0, -4, 2, 0, 1, 17, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopsales', ''),
('management', 18, 1, 'ejoshopinfo/ejoshopinfo.updates', 'ejoshopinfo/ejoshopinfo.updates', 'COM_EJOSHOP_UPDATE', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33343a2256696577207265706f7274732c20757064617465732c20616e64206572726f72732e223b7d7d, 'system', 0, 0, 1, 0, 5, 2, 0, 1, 18, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopinfo', 'ejoshopinfo.updates'),
('management', 20, 1, 'ejoshoporder', 'ejoshoporder', 'COM_EJ_LIST_OF_ORDERS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a34353a2241646d696e697374657220626c6f636b732c20636f6e74656e742074797065732c206d656e75732c206574632e223b7d7d, 'system', 0, 0, 1, 0, -8, 2, 0, 1, 20, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshoporder', ''),
('management', 21, 1, 'admin/tasks', 'admin/tasks', 'Tasks', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -20, 2, 0, 1, 21, 0, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 27, 17, 'ejoshopsales/ejoshopsale.add', 'ejoshopsales/ejoshopsale.add', 'COM_EJOSHOP_ADDNEW', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 17, 27, 0, 0, 0, 0, 0, 0, 0, 'ejoshopsales', 'ejoshopsale.add'),
('management', 28, 20, 'ejoshoppayd', 'ejoshoppayd', 'COM_EJ_PAYMENTS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a37393a22436f6e666967757265207768617420626c6f636b20636f6e74656e74206170706561727320696e20796f75722073697465277320736964656261727320616e64206f7468657220726567696f6e732e223b7d7d, 'system', 0, 0, 1, 0, 0, 3, 0, 1, 20, 28, 0, 0, 0, 0, 0, 0, 0, 'ejoshoppayd', ''),
('management', 30, 9, 'ejoshopcategories', 'ejoshopcategories', 'COM_EJ_STATE_OF_CATEGORY', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a35393a224c69737420616e642065646974207369746520636f6d6d656e747320616e642074686520636f6d6d656e7420617070726f76616c2071756575652e223b7d7d, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 9, 30, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', ''),
('management', 31, 11, 'ejoshopphotos', 'ejoshopphotos', 'All products', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a35333a22436f6e66696775726520776869636820626c6f636b732063616e2062652073686f776e206f6e207468652064617368626f6172642e223b7d7d, 'system', -1, 0, 0, 0, -30, 3, 0, 1, 11, 31, 0, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', ''),
('management', 32, 9, 'ejoshopcategories', 'ejoshopcategories', 'All categories', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 3, 0, 1, 9, 32, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', ''),
('management', 34, 20, 'ejoshoporder', 'ejoshoporder', 'COM_EJ_ALLORDERS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a39323a224d616e61676520636f6e74656e742074797065732c20696e636c7564696e672064656661756c74207374617475732c2066726f6e7420706167652070726f6d6f74696f6e2c20636f6d6d656e742073657474696e67732c206574632e223b7d7d, 'system', 0, 0, 1, 0, 0, 3, 0, 1, 20, 34, 0, 0, 0, 0, 0, 0, 0, 'ejoshoporder', ''),
('management', 35, 11, 'ejoshopphotos/ejoshopphoto.add', 'ejoshopphotos/ejoshopphoto.add', 'COM_EJ_CREATE_PRODUCT', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32353a22437573746f6d697a6520796f75722064617368626f6172642e223b7d7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 11, 35, 0, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', 'ejoshopphoto.add'),
('management', 41, 17, 'ejoshopsales', 'ejoshopsales', 'COM_EJOSHOP_ALL', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a35303a2246696e6420616e64206d616e6167652070656f706c6520696e746572616374696e67207769746820796f757220736974652e223b7d7d, 'system', -1, 0, 0, 0, -10, 3, 0, 1, 17, 41, 0, 0, 0, 0, 0, 0, 0, 'ejoshopsales', ''),
('management', 42, 7, 'ejoshoppayments', 'ejoshoppayments', 'COM_EJOSHOP_ALL_PAYMENTS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33313a2253656c65637420616e6420636f6e66696775726520796f7572207468656d65223b7d7d, 'system', -1, 0, 0, 0, -1, 3, 0, 1, 7, 42, 0, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', ''),
('management', 51, 7, 'ejoshoppayments', 'ejoshoppayments', 'COM_EJOSHOP_TYPE_PAYMENTS', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a34363a22436f6e6669677572652064656661756c7420616e64207468656d652073706563696669632073657474696e67732e223b7d7d, 'system', -1, 0, 1, 0, 20, 3, 0, 1, 7, 51, 0, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', ''),
('management', 64, 28, 'ejoshoporder/webmoney', 'ejoshoporder/webmoney', 'COM_EJ_WITH_WEBMONEY', 0x613a303a7b7d, 'system', -1, 0, 1, 0, 0, 4, 0, 1, 20, 28, 64, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'webmoney'),
('management', 65, 34, 'ejoshoporder/closed', 'ejoshoporder/closed', 'COM_EJ_CLOSED_ORDERS', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 20, 34, 65, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'closed'),
('management', 67, 51, 'ejoshoppayments/ejoshoppayments.webmoney', 'ejoshoppayments/ejoshoppayments.webmoney', 'COM_EJOSHOP_WEBMONEY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 7, 51, 67, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.webmoney'),
('management', 71, 18, 'admin/reports/event/%', 'admin/reports/event/%', 'Details', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 18, 71, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 73, 51, 'ejoshoppayments/ejoshoppayments.yandexmoney', 'ejoshoppayments/ejoshoppayments.yandexmoney', 'COM_EJOSHOP_YANDEXMONEY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 7, 51, 73, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.yandexmoney'),
('management', 74, 51, 'ejoshoppayments/ejoshoppayments.paypal', 'ejoshoppayments/ejoshoppayments.paypal', 'COM_EJOSHOP_PAYPAL', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -1, 4, 0, 1, 7, 51, 74, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.paypal'),
('management', 78, 34, 'ejoshoporder/pay', 'ejoshoporder/pay', 'COM_EJ_FEE_ORDERS', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 4, 0, 1, 20, 34, 78, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'pay'),
('management', 84, 30, 'ejoshopcategories/ejoshopcategories.publishedcat', 'ejoshopcategories/ejoshopcategories.publishedcat', 'COM_EJ_PUBLISHED', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 4, 0, 1, 9, 30, 84, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', 'ejoshopcategories.publishedcat'),
('management', 88, 51, 'ejoshoppayments/ejoshoppayments.paywithpost', 'ejoshoppayments/ejoshoppayments.paywithpost', 'COM_EJOSHOP_POST', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 7, 51, 88, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.paywithpost'),
('management', 90, 51, 'ejoshoppayments/ejoshoppayments.paywithbill', 'ejoshoppayments/ejoshoppayments.paywithbill', 'COM_EJOSHOP_BILLFORBANK', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 7, 51, 90, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.paywithbill'),
('management', 94, 30, 'ejoshopphotos/ejoshopcategories.notpublishedcat', 'ejoshopphotos/ejoshopcategories.notpublishedcat', 'COM_EJ_NOT_PUBLISHED', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 9, 30, 94, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', 'ejoshopcategories.notpublishedcat'),
('management', 99, 28, 'ejoshoporder/yandexmoney', 'ejoshoporder/yandexmoney', 'COM_EJ_WITH_YANDEXMONEY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 20, 28, 99, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'yandexmoney'),
('management', 101, 20, 'admin/structure/menu/manage/%', 'admin/structure/menu/manage/%', 'Customize menu', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 1, 0, 0, 3, 0, 1, 20, 101, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 102, 34, 'admin/structure/types/manage/%', 'admin/structure/types/manage/%', 'Edit content type', 0x613a303a7b7d, 'system', 0, 0, 1, 0, 0, 4, 0, 1, 20, 34, 102, 0, 0, 0, 0, 0, 0, '', ''),
('management', 104, 28, 'ejoshoporder/paywithpost', 'ejoshoporder/paywithpost', 'COM_EJOSHOP_PAYWITHPOST', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 20, 28, 104, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'paywithpost'),
('management', 107, 28, 'ejoshoporder/paypal', 'ejoshoporder/paypal', 'COM_EJ_WITH_PAYPAL', 0x613a303a7b7d, 'system', -1, 0, 1, 0, -10, 4, 0, 1, 20, 28, 107, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'paypal'),
('management', 109, 28, 'ejoshoporder/paywithbill', 'ejoshoporder/paywithbill', 'COM_EJ_WITH_BILLFORBANK', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 20, 28, 109, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'paywithbill'),
('management', 115, 104, 'ejoshoporder/paywithposttoday', 'ejoshoporder/paywithposttoday', 'COM_EJ_TODAY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 28, 104, 115, 0, 0, 0, 0, 0, 'ejoshoporder', 'paywithposttoday'),
('management', 121, 101, 'admin/structure/menu/manage/%/add', 'admin/structure/menu/manage/%/add', 'Add link', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 44, 101, 121, 0, 0, 0, 0, 0, '', ''),
('management', 122, 28, 'admin/structure/block/manage/%/%', 'admin/structure/block/manage/%/%', 'Configure block', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 4, 0, 1, 20, 28, 122, 0, 0, 0, 0, 0, 0, '', ''),
('management', 124, 102, 'admin/structure/types/manage/%/delete', 'admin/structure/types/manage/%/delete', 'Delete', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 5, 0, 1, 20, 34, 102, 124, 0, 0, 0, 0, 0, '', ''),
('management', 127, 101, 'admin/structure/menu/manage/%/delete', 'admin/structure/menu/manage/%/delete', 'Delete menu', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 5, 0, 1, 20, 44, 101, 127, 0, 0, 0, 0, 0, '', ''),
('management', 128, 20, 'admin/structure/menu/item/%/delete', 'admin/structure/menu/item/%/delete', 'Delete menu link', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 128, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 129, 87, 'admin/people/permissions/roles/delete/%', 'admin/people/permissions/roles/delete/%', 'Delete role', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 5, 0, 1, 17, 46, 87, 129, 0, 0, 0, 0, 0, '', ''),
('management', 131, 102, 'admin/structure/types/manage/%/edit', 'admin/structure/types/manage/%/edit', 'Edit', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 34, 102, 131, 0, 0, 0, 0, 0, '', ''),
('management', 132, 101, 'admin/structure/menu/manage/%/edit', 'admin/structure/menu/manage/%/edit', 'Edit menu', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 44, 101, 132, 0, 0, 0, 0, 0, '', ''),
('management', 133, 20, 'admin/structure/menu/item/%/edit', 'admin/structure/menu/item/%/edit', 'Edit menu link', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 133, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 134, 87, 'admin/people/permissions/roles/edit/%', 'admin/people/permissions/roles/edit/%', 'Edit role', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 5, 0, 1, 17, 46, 87, 134, 0, 0, 0, 0, 0, '', ''),
('management', 135, 101, 'admin/structure/menu/manage/%/list', 'admin/structure/menu/manage/%/list', 'List links', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 5, 0, 1, 20, 44, 101, 135, 0, 0, 0, 0, 0, '', ''),
('management', 136, 20, 'admin/structure/menu/item/%/reset', 'admin/structure/menu/item/%/reset', 'Reset menu link', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 136, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 137, 102, 'admin/structure/types/manage/%/comment/display', 'admin/structure/types/manage/%/comment/display', 'Comment display', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 4, 5, 0, 1, 20, 34, 102, 137, 0, 0, 0, 0, 0, '', ''),
('management', 138, 102, 'admin/structure/types/manage/%/comment/fields', 'admin/structure/types/manage/%/comment/fields', 'Comment fields', 0x613a303a7b7d, 'system', -1, 0, 1, 0, 3, 5, 0, 1, 20, 34, 102, 138, 0, 0, 0, 0, 0, '', ''),
('management', 139, 122, 'admin/structure/block/manage/%/%/configure', 'admin/structure/block/manage/%/%/configure', 'Configure block', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 28, 122, 139, 0, 0, 0, 0, 0, '', ''),
('management', 140, 122, 'admin/structure/block/manage/%/%/delete', 'admin/structure/block/manage/%/%/delete', 'Delete block', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 28, 122, 140, 0, 0, 0, 0, 0, '', ''),
('management', 151, 1, 'ejoshopinfo', 'ejoshopinfo', 'COM_EJOSHOP_HELP', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a34383a225265666572656e636520666f722075736167652c20636f6e66696775726174696f6e2c20616e64206d6f64756c65732e223b7d7d, 'system', 0, 0, 0, 0, 9, 2, 0, 1, 151, 0, 0, 0, 0, 0, 0, 0, 0, 'ejoshopinfo', ''),
('management', 162, 151, 'ejoshopinfo/ejoshopinfo.doc-yandex-money-payment', 'ejoshopinfo/ejoshopinfo.doc-yandex-money-payment', 'COM_EJ_HOW_ADD_YANDEXMONEY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 151, 162, 0, 0, 0, 0, 0, 0, 0, 'ejoshopinfo', 'ejoshopinfo.doc-yandex-money-payment'),
('management', 163, 151, 'ejoshopinfo/ejoshopinfo.doc-webmoney-payment', 'ejoshopinfo/ejoshopinfo.doc-webmoney-payment', 'How setup Webmoney payments', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 151, 163, 0, 0, 0, 0, 0, 0, 0, 'ejoshopinfo', 'ejoshopinfo.doc-webmoney-payment'),
('management', 188, 20, 'admin/structure/taxonomy/%', 'admin/structure/taxonomy/%', '', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 188, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 198, 188, 'admin/structure/taxonomy/%/add', 'admin/structure/taxonomy/%/add', 'Add term', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 156, 188, 198, 0, 0, 0, 0, 0, '', ''),
('management', 200, 188, 'admin/structure/taxonomy/%/edit', 'admin/structure/taxonomy/%/edit', 'Edit', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 5, 0, 1, 20, 156, 188, 200, 0, 0, 0, 0, 0, '', ''),
('management', 202, 188, 'admin/structure/taxonomy/%/list', 'admin/structure/taxonomy/%/list', 'List', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -20, 5, 0, 1, 20, 156, 188, 202, 0, 0, 0, 0, 0, '', ''),
('management', 311, 188, 'admin/structure/taxonomy/%/display', 'admin/structure/taxonomy/%/display', 'Manage display', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 2, 5, 0, 1, 20, 156, 188, 311, 0, 0, 0, 0, 0, '', ''),
('management', 313, 188, 'admin/structure/taxonomy/%/fields', 'admin/structure/taxonomy/%/fields', 'Manage fields', 0x613a303a7b7d, 'system', -1, 0, 1, 0, 1, 5, 0, 1, 20, 156, 188, 313, 0, 0, 0, 0, 0, '', ''),
('management', 315, 311, 'admin/structure/taxonomy/%/display/default', 'admin/structure/taxonomy/%/display/default', 'Default', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 6, 0, 1, 20, 156, 188, 311, 315, 0, 0, 0, 0, '', ''),
('management', 317, 102, 'admin/structure/types/manage/%/display', 'admin/structure/types/manage/%/display', 'Manage display', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 2, 5, 0, 1, 20, 34, 102, 317, 0, 0, 0, 0, 0, '', ''),
('management', 318, 102, 'admin/structure/types/manage/%/fields', 'admin/structure/types/manage/%/fields', 'Manage fields', 0x613a303a7b7d, 'system', -1, 0, 1, 0, 1, 5, 0, 1, 20, 34, 102, 318, 0, 0, 0, 0, 0, '', ''),
('management', 319, 311, 'admin/structure/taxonomy/%/display/full', 'admin/structure/taxonomy/%/display/full', 'Taxonomy term page', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 6, 0, 1, 20, 156, 188, 311, 319, 0, 0, 0, 0, '', ''),
('management', 321, 313, 'admin/structure/taxonomy/%/fields/%', 'admin/structure/taxonomy/%/fields/%', '', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 6, 0, 1, 20, 156, 188, 313, 321, 0, 0, 0, 0, '', ''),
('management', 323, 317, 'admin/structure/types/manage/%/display/default', 'admin/structure/types/manage/%/display/default', 'Default', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 6, 0, 1, 20, 34, 102, 317, 323, 0, 0, 0, 0, '', ''),
('management', 324, 317, 'admin/structure/types/manage/%/display/full', 'admin/structure/types/manage/%/display/full', 'Full content', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 6, 0, 1, 20, 34, 102, 317, 324, 0, 0, 0, 0, '', ''),
('management', 325, 317, 'admin/structure/types/manage/%/display/rss', 'admin/structure/types/manage/%/display/rss', 'RSS', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 2, 6, 0, 1, 20, 34, 102, 317, 325, 0, 0, 0, 0, '', ''),
('management', 326, 317, 'admin/structure/types/manage/%/display/search_index', 'admin/structure/types/manage/%/display/search_index', 'Search index', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 3, 6, 0, 1, 20, 34, 102, 317, 326, 0, 0, 0, 0, '', ''),
('management', 327, 317, 'admin/structure/types/manage/%/display/search_result', 'admin/structure/types/manage/%/display/search_result', 'Search result', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 4, 6, 0, 1, 20, 34, 102, 317, 327, 0, 0, 0, 0, '', ''),
('management', 328, 317, 'admin/structure/types/manage/%/display/teaser', 'admin/structure/types/manage/%/display/teaser', 'Teaser', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 1, 6, 0, 1, 20, 34, 102, 317, 328, 0, 0, 0, 0, '', ''),
('management', 329, 318, 'admin/structure/types/manage/%/fields/%', 'admin/structure/types/manage/%/fields/%', '', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 6, 0, 1, 20, 34, 102, 318, 329, 0, 0, 0, 0, '', ''),
('management', 330, 321, 'admin/structure/taxonomy/%/fields/%/delete', 'admin/structure/taxonomy/%/fields/%/delete', 'Delete', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 10, 7, 0, 1, 20, 156, 188, 313, 321, 330, 0, 0, 0, '', ''),
('management', 331, 321, 'admin/structure/taxonomy/%/fields/%/edit', 'admin/structure/taxonomy/%/fields/%/edit', 'Edit', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 156, 188, 313, 321, 331, 0, 0, 0, '', ''),
('management', 332, 321, 'admin/structure/taxonomy/%/fields/%/field-settings', 'admin/structure/taxonomy/%/fields/%/field-settings', 'Field settings', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 156, 188, 313, 321, 332, 0, 0, 0, '', ''),
('management', 333, 321, 'admin/structure/taxonomy/%/fields/%/widget-type', 'admin/structure/taxonomy/%/fields/%/widget-type', 'Widget type', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 156, 188, 313, 321, 333, 0, 0, 0, '', ''),
('management', 338, 137, 'admin/structure/types/manage/%/comment/display/default', 'admin/structure/types/manage/%/comment/display/default', 'Default', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 6, 0, 1, 20, 34, 102, 137, 338, 0, 0, 0, 0, '', ''),
('management', 339, 137, 'admin/structure/types/manage/%/comment/display/full', 'admin/structure/types/manage/%/comment/display/full', 'Full comment', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 6, 0, 1, 20, 34, 102, 137, 339, 0, 0, 0, 0, '', ''),
('management', 340, 138, 'admin/structure/types/manage/%/comment/fields/%', 'admin/structure/types/manage/%/comment/fields/%', '', 0x613a303a7b7d, 'system', 0, 0, 0, 0, 0, 6, 0, 1, 20, 34, 102, 138, 340, 0, 0, 0, 0, '', ''),
('management', 341, 329, 'admin/structure/types/manage/%/fields/%/delete', 'admin/structure/types/manage/%/fields/%/delete', 'Delete', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 10, 7, 0, 1, 20, 34, 102, 318, 329, 341, 0, 0, 0, '', ''),
('management', 342, 329, 'admin/structure/types/manage/%/fields/%/edit', 'admin/structure/types/manage/%/fields/%/edit', 'Edit', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 318, 329, 342, 0, 0, 0, '', ''),
('management', 343, 329, 'admin/structure/types/manage/%/fields/%/field-settings', 'admin/structure/types/manage/%/fields/%/field-settings', 'Field settings', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 318, 329, 343, 0, 0, 0, '', ''),
('management', 344, 329, 'admin/structure/types/manage/%/fields/%/widget-type', 'admin/structure/types/manage/%/fields/%/widget-type', 'Widget type', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 318, 329, 344, 0, 0, 0, '', ''),
('management', 345, 340, 'admin/structure/types/manage/%/comment/fields/%/delete', 'admin/structure/types/manage/%/comment/fields/%/delete', 'Delete', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 10, 7, 0, 1, 20, 34, 102, 138, 340, 345, 0, 0, 0, '', ''),
('management', 346, 340, 'admin/structure/types/manage/%/comment/fields/%/edit', 'admin/structure/types/manage/%/comment/fields/%/edit', 'Edit', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 138, 340, 346, 0, 0, 0, '', ''),
('management', 347, 340, 'admin/structure/types/manage/%/comment/fields/%/field-settings', 'admin/structure/types/manage/%/comment/fields/%/field-settings', 'Field settings', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 138, 340, 347, 0, 0, 0, '', ''),
('management', 348, 340, 'admin/structure/types/manage/%/comment/fields/%/widget-type', 'admin/structure/types/manage/%/comment/fields/%/widget-type', 'Widget type', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 7, 0, 1, 20, 34, 102, 138, 340, 348, 0, 0, 0, '', ''),
('management', 392, 154, 'admin/reports/fields/list', 'admin/reports/fields/list', 'List', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 4, 0, 1, 18, 154, 392, 0, 0, 0, 0, 0, 0, '', ''),
('management', 405, 154, 'admin/reports/fields/views-fields', 'admin/reports/fields/views-fields', 'Used in views', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33373a224f76657276696577206f66206669656c6473207573656420696e20616c6c2076696577732e223b7d7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 18, 154, 405, 0, 0, 0, 0, 0, 0, '', ''),
('management', 407, 400, 'admin/structure/views/settings/advanced', 'admin/structure/views/settings/advanced', 'Advanced', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 1, 5, 0, 1, 20, 370, 400, 407, 0, 0, 0, 0, 0, '', ''),
('management', 408, 400, 'admin/structure/views/settings/basic', 'admin/structure/views/settings/basic', 'Basic', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 400, 408, 0, 0, 0, 0, 0, '', ''),
('management', 412, 20, 'admin/structure/pages/edit/%', 'admin/structure/pages/edit/%', 'Edit', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 412, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 419, 20, 'admin/structure/views/view/%', 'admin/structure/views/view/%', '', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 419, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 420, 419, 'admin/structure/views/view/%/break-lock', 'admin/structure/views/view/%/break-lock', 'Break lock', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 420, 0, 0, 0, 0, 0, '', ''),
('management', 421, 419, 'admin/structure/views/view/%/edit', 'admin/structure/views/view/%/edit', 'Edit view', 0x613a303a7b7d, 'system', -1, 0, 0, 0, -10, 5, 0, 1, 20, 370, 419, 421, 0, 0, 0, 0, 0, '', ''),
('management', 424, 311, 'admin/structure/taxonomy/%/display/token', 'admin/structure/taxonomy/%/display/token', 'Tokens', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 1, 6, 0, 1, 20, 156, 188, 311, 424, 0, 0, 0, 0, '', ''),
('management', 425, 20, 'admin/structure/pages/%/operation/%', 'admin/structure/pages/%/operation/%', '', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 425, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 427, 419, 'admin/structure/views/view/%/clone', 'admin/structure/views/view/%/clone', 'Clone', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 427, 0, 0, 0, 0, 0, '', ''),
('management', 428, 419, 'admin/structure/views/view/%/delete', 'admin/structure/views/view/%/delete', 'Delete', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 428, 0, 0, 0, 0, 0, '', ''),
('management', 429, 419, 'admin/structure/views/view/%/export', 'admin/structure/views/view/%/export', 'Export', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 429, 0, 0, 0, 0, 0, '', ''),
('management', 430, 419, 'admin/structure/views/view/%/revert', 'admin/structure/views/view/%/revert', 'Revert', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 430, 0, 0, 0, 0, 0, '', ''),
('management', 431, 20, 'admin/structure/views/ajax/preview/%/%', 'admin/structure/views/ajax/preview/%/%', '', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 431, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 432, 20, 'admin/structure/views/nojs/preview/%/%', 'admin/structure/views/nojs/preview/%/%', '', 0x733a363a22613a303a7b7d223b, 'system', 0, 0, 0, 0, 0, 3, 0, 1, 20, 432, 0, 0, 0, 0, 0, 0, 0, '', ''),
('management', 433, 317, 'admin/structure/types/manage/%/display/token', 'admin/structure/types/manage/%/display/token', 'Tokens', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 5, 6, 0, 1, 20, 34, 102, 317, 433, 0, 0, 0, 0, '', ''),
('management', 434, 419, 'admin/structure/views/view/%/preview/%', 'admin/structure/views/view/%/preview/%', '', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 370, 419, 434, 0, 0, 0, 0, 0, '', ''),
('management', 435, 137, 'admin/structure/types/manage/%/comment/display/token', 'admin/structure/types/manage/%/comment/display/token', 'Tokens', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 1, 6, 0, 1, 20, 34, 102, 137, 435, 0, 0, 0, 0, '', ''),
('management', 448, 151, 'ejoshopinfo/ejoshopinfo.doc-paypal-payment', 'ejoshopinfo/ejoshopinfo.doc-paypal-payment', 'COM_EJ_HOW_ADD_PAYPAL', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 151, 448, 0, 0, 0, 0, 0, 0, 0, 'ejoshopinfo', 'ejoshopinfo.doc-paypal-payment'),
('management', 450, 99, 'ejoshoporder/yandexmoneytoday', 'ejoshoporder/yandexmoneytoday', 'COM_EJ_TODAY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 5, 0, 1, 20, 28, 99, 450, 0, 0, 0, 0, 0, 'ejoshoporder', 'yandexmoneytoday'),
('management', 506, 501, 'admin/structure/features/create', 'admin/structure/features/create', 'Create feature', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32313a224372656174652061206e657720666561747572652e223b7d7d, 'system', -1, 0, 0, 0, 10, 4, 0, 1, 20, 501, 506, 0, 0, 0, 0, 0, 0, '', ''),
('management', 508, 501, 'admin/structure/features/manage', 'admin/structure/features/manage', 'Manage', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32383a22456e61626c6520616e642064697361626c652066656174757265732e223b7d7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 20, 501, 508, 0, 0, 0, 0, 0, 0, '', ''),
('management', 510, 501, 'admin/structure/features/%/view', 'admin/structure/features/%/view', 'View', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a33323a22446973706c617920636f6d706f6e656e7473206f66206120666561747572652e223b7d7d, 'system', -1, 0, 0, 0, -10, 4, 0, 1, 20, 501, 510, 0, 0, 0, 0, 0, 0, '', ''),
('management', 511, 501, 'admin/structure/features/%/recreate', 'admin/structure/features/%/recreate', 'Recreate', 0x613a313a7b733a31303a2261747472696275746573223b613a313a7b733a353a227469746c65223b733a32393a22526563726561746520616e206578697374696e6720666561747572652e223b7d7d, 'system', -1, 0, 0, 0, 11, 4, 0, 1, 20, 501, 511, 0, 0, 0, 0, 0, 0, '', ''),
('management', 640, 9, 'ejoshopcategories', 'ejoshopcategories', 'COM_EJ_FUNCTION', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 3, 0, 1, 9, 640, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', ''),
('management', 641, 640, 'admin/content/seanumbers/addnew', 'admin/content/seanumbers/addnew', 'Add new non free to slider', 0x613a303a7b7d, 'system', 1, 0, 0, 0, 0, 4, 0, 1, 9, 640, 641, 0, 0, 0, 0, 0, 0, '', ''),
('management', 642, 640, 'admin/content/seanumbers/action', 'admin/content/seanumbers/action', 'Remove non free from slider', 0x613a303a7b7d, 'system', 1, 0, 0, 0, 0, 4, 0, 1, 9, 640, 642, 0, 0, 0, 0, 0, 0, '', ''),
('management', 644, 640, 'ejoshopcategories/ejoshopcategory.add', 'ejoshopcategories/ejoshopcategory.add', 'COM_EJ_CREATE_CATEGORY', 0x613a303a7b7d, 'system', -1, 0, 0, 0, 0, 4, 0, 1, 9, 640, 644, 0, 0, 0, 0, 0, 0, 'ejoshopcategories', 'ejoshopcategory.add'),
('management', 674, 11, 'ejoshopphotos', 'ejoshopphotos', 'COM_EJ_TYPE_OF_PRODUCTS', 0x613a303a7b7d, 'menu', 0, 0, 1, 0, 0, 3, 0, 1, 11, 674, 0, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', ''),
('management', 677, 674, 'Выберите view/ejoshopphotos.published', 'Выберите view/ejoshopphotos.published', 'COM_EJ_PUBLISHED', 0x733a363a22613a303a7b7d223b, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 11, 674, 677, 0, 0, 0, 0, 0, 0, 'Выберите view', 'ejoshopphotos.published'),
('management', 679, 11, 'ejoshopanalytics', 'ejoshopanalytics', 'COM_EJ_ANALYTICS', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 3, 0, 1, 11, 679, 0, 0, 0, 0, 0, 0, 0, 'ejoshopanalytics', ''),
('management', 680, 674, 'ejoshopphotos/ejoshopphotos.notpublished', 'ejoshopphotos/ejoshopphotos.notpublished', 'COM_EJ_NOT_PUBLISHED', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 11, 674, 680, 0, 0, 0, 0, 0, 0, 'ejoshopphotos', 'ejoshopphotos.notpublished'),
('management', 681, 107, 'ejoshoporder/paypaltoday', 'ejoshoporder/paypaltoday', 'COM_EJ_TODAY', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 5, 0, 1, 20, 28, 107, 681, 0, 0, 0, 0, 0, 'ejoshoporder', 'paypaltoday'),
('management', 682, 64, 'ejoshoporder/webmoneytoday', 'ejoshoporder/webmoneytoday', 'COM_EJ_TODAY', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 5, 0, 1, 20, 28, 64, 682, 0, 0, 0, 0, 0, 'ejoshoporder', 'webmoneytoday'),
('management', 683, 8, 'ejoshopcurrency', 'ejoshopcurrency', 'COM_EJ_CURRENCY', 0x613a303a7b7d, 'system', 0, 0, 1, 0, 0, 3, 0, 1, 8, 683, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcurrency', ''),
('management', 684, 8, 'ejoshoptaxes', 'ejoshoptaxes', 'COM_EJ_TAX', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 3, 0, 1, 8, 684, 0, 0, 0, 0, 0, 0, 0, 'ejoshoptaxes', ''),
('management', 685, 683, 'ejoshopcurrency/ejoshopcurrency.pub', 'ejoshopcurrency/ejoshopcurrency.pub', 'COM_EJ_PUBLISHED', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 8, 683, 685, 0, 0, 0, 0, 0, 0, 'ejoshopcurrency', 'ejoshopcurrency.pub'),
('management', 686, 683, 'ejoshopcurrency/ejoshopcurrency.nopub', 'ejoshopcurrency/ejoshopcurrency.nopub', 'COM_EJ_NOT_PUBLISHED', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 8, 683, 686, 0, 0, 0, 0, 0, 0, 'ejoshopcurrency', 'ejoshopcurrency.nopub'),
('management', 687, 683, 'ejoshopcurrency/ejoshopcurrency.all', 'ejoshopcurrency/ejoshopcurrency.all', 'COM_EJ_ALL_CUR', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 8, 683, 687, 0, 0, 0, 0, 0, 0, 'ejoshopcurrency', 'ejoshopcurrency.all'),
('management', 688, 8, 'ejoshopstyles', 'ejoshopstyles', 'COM_EJOSHOP_STYLES', 0x613a303a7b7d, 'menu', 0, 0, 1, 0, -10, 3, 0, 1, 8, 688, 0, 0, 0, 0, 0, 0, 0, 'ejoshopstyles', ''),
('management', 689, 688, 'ejoshopstyles/ejoshopstyles.imagestyles', 'ejoshopstyles/ejoshopstyles.imagestyles', 'COM_EJOSHOP_STYLES_SYS', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 8, 688, 689, 0, 0, 0, 0, 0, 0, 'ejoshopstyles', 'ejoshopstyles.imagestyles'),
('management', 690, 28, 'ejoshoporder/anet', 'ejoshoporder/anet', 'COM_EJ_WITH_ANET', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 20, 28, 690, 0, 0, 0, 0, 0, 0, 'ejoshoporder', 'anet'),
('management', 691, 51, 'ejoshoppayments/ejoshoppayments.anet', 'ejoshoppayments/ejoshoppayments.anet', 'COM_EJ_WITH_ANET', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 4, 0, 1, 7, 51, 691, 0, 0, 0, 0, 0, 0, 'ejoshoppayments', 'ejoshoppayments.anet'),
('management', 692, 8, 'ejoshopconfig/ejoshopconfig.clearcache', 'ejoshopconfig/ejoshopconfig.clearcache', 'COM_EJ_CLEAR_CACHE', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 3, 0, 1, 8, 692, 0, 0, 0, 0, 0, 0, 0, 'ejoshopconfig', 'ejoshopconfig.clearcache'),
('management', 693, 11, 'ejoshopfields', 'ejoshopfields', 'COM_EJ_FIELD_M', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 10, 3, 0, 1, 11, 693, 0, 0, 0, 0, 0, 0, 0, 'ejoshopfields', ''),
('management', 694, 1, 'ejoshopcomments/', 'ejoshopcomments/', 'COM_EJOSHOP_COMMENTS', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, 0, 2, 0, 1, 12, 694, 0, 0, 0, 0, 0, 0, 0, 'ejoshopcomments', ''),
('management', 695, 1, 'ejoshopusers', 'ejoshopusers', 'COM_EJ_USERS', 0x613a303a7b7d, 'menu', 0, 0, 0, 0, -5, 2, 0, 1, 12, 695, 0, 0, 0, 0, 0, 0, 0, 'ejoshopusers', '');



--
-- Table structure for table `#__ejoshop_payd`
--

CREATE TABLE IF NOT EXISTS `#__ejoshop_payd` (
  `payid` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `pids` varchar(255) DEFAULT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `payer` varchar(100) NOT NULL,
  `moneysystem` char(50) NOT NULL,
  `amount` varchar(100) NOT NULL,
  `cur` char(5) NOT NULL,
  `status` int(11) NOT NULL,
  PRIMARY KEY (`payid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=139 ;


-- --------------------------------------------------------

CREATE TABLE IF NOT EXISTS `#__ejoshop_payments` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_name` text NOT NULL,
  `p_type` char(50) NOT NULL,
  `p_desc` varchar(255) NOT NULL,
  `p_settings` text NOT NULL,
  `published` tinyint(4) DEFAULT '0',
  `p_createdon` datetime NOT NULL,
  `p_sdk_version` text NOT NULL,
  `bill` varchar(255) DEFAULT NULL,
  `result_url` varchar(255) DEFAULT NULL,
  `success_url` varchar(255) DEFAULT NULL,
  `fail_url` varchar(255) DEFAULT NULL,
  `secretkey` varchar(255) DEFAULT NULL,
  `client_id` varchar(255) NOT NULL,
  `secretkeyfornotifyym` varchar(255) NOT NULL,
  `trankeyanet` varchar(255) NOT NULL DEFAULT '',
  `textafterpaysuccess` text,
  `textafterpayfail` text,
  `paypalapisignature` varchar(255) NOT NULL COMMENT 'for paypal api',
  `paypalapipassword` varchar(255) NOT NULL COMMENT 'for paypal api',
  `paypalapiusername` varchar(255) NOT NULL COMMENT 'for paypal api',
  `bankbik` varchar(255) NOT NULL,
  `corschet` varchar(255) NOT NULL,
  `costumer` varchar(255) NOT NULL,
  `nameofcompany` varchar(255) NOT NULL,
  `innofcompany` varchar(255) NOT NULL,
  `kppofcompany` varchar(255) NOT NULL,
  `nameofbank` varchar(255) NOT NULL,
  `sandbox` int(1) DEFAULT '0',
  `sys_type` enum('system','plugin') NOT NULL DEFAULT 'system' COMMENT 'for plugins',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;

--
-- Dumping data for table `#__ejoshop_payments`
--

INSERT INTO `#__ejoshop_payments` (`id`, `p_name`, `p_type`, `p_desc`, `p_settings`, `published`, `p_createdon`, `p_sdk_version`, `bill`, `result_url`, `success_url`, `fail_url`, `secretkey`, `client_id`, `secretkeyfornotifyym`, `trankeyanet`, `textafterpaysuccess`, `textafterpayfail`, `paypalapisignature`, `paypalapipassword`, `paypalapiusername`, `bankbik`, `corschet`, `costumer`, `nameofcompany`, `innofcompany`, `kppofcompany`, `nameofbank`, `sandbox`) VALUES
(1, 'Yandex Money', 'yandexmoney', 'Yandex Money Api', '', 0, '2013-09-15 00:00:00', '', '41001296634791', 'http://test-j257.ru/index.php?option=com_egallery&view=cart&task=backtocartfromym', NULL, NULL, '', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, '', 0),
(2, 'PayPal', 'paypal', 'PayPal Api with Rest SDK from github\r\n\r\n', '', 1, '2013-09-15 00:00:00', '', NULL, NULL, NULL, NULL, NULL, '', '', '', 'Текст после успешной оплаты', 'Текст после не успешной оплаты ', '', '', 'pp.sandbox_api1.yandex.ru', '', '', '', '', 0, 0, '', 1),
(3, 'Webmoney', 'webmoney', 'Web Merchant Interface', '', 1, '2013-09-15 23:07:18', '', 'R139690428407', 'http://test-j257.ru/index.php?option=com_ejoshop&view=cart&task=backtocartfromwm', 'http://test-j257.ru/index.php?option=com_ejoshop&view=cart&task=backtocartfromwmsuccess', 'http://test-j257.ru/index.php?option=com_ejoshop&view=cart&task=backtocartfromwmerror', '', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, '', 0),
(4, 'Write bill for bank', 'writebill', 'Write bill only for Russian', '', 0, '2013-09-26 16:09:50', '1', '41015545656487', NULL, NULL, NULL, NULL, '', '', '', NULL, NULL, '', '', '', '252', '233456777', 'Joomla', 'ООО "Ejoshop"', 2147483647, 2147483647, 'ОАО "Сбербанк России"', 0),
(5, 'Authorize.Net', 'anet', 'Authorize.Net is a registered trademark of CyberSource, a Visa company\r\nApi version 3.1', '', 1, '2013-11-15 00:00:00', '', NULL, '', '', '', 'Simon', '3jM95Pq8', '9UJ73U8h7Znj72yS', '9UJ73U8h7Znj72yS', 'I am good Anet!', 'I am bad Anet!', '', '', '', '', '', '', '', 0, 0, '', 1),
(6, 'Post service', 'paywithpost', 'Post service', '', 0, '2013-11-16 16:25:34', '', NULL, NULL, NULL, NULL, NULL, '', '', '', 'Оплата почтовым переводом! Без ошибка!', 'Ошибка!Оплата почтовым переводом! ', '', '', '', '', '', '', '', 0, 0, '', 0);


CREATE TABLE IF NOT EXISTS `#__ejoshop_photos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` int(11) NOT NULL COMMENT 'Fid of files in file_managed teble',
  `name` varchar(255) NOT NULL,
  `articul` varchar(100) NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `filesize` text NOT NULL,
  `alias` varchar(255) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` varchar(100) NOT NULL,
  `access` int(11) NOT NULL DEFAULT '1',
  `ordering` int(11) unsigned NOT NULL DEFAULT '0',
  `hits` int(11) unsigned NOT NULL DEFAULT '0',
  `galid` int(11) unsigned NOT NULL,
  `catid` int(11) unsigned NOT NULL,
  `params` text NOT NULL,
  `intro` text NOT NULL,
  `longitude` varchar(255) NOT NULL,
  `latitude` varchar(255) NOT NULL,
  `maptype` enum('google','yandex') NOT NULL DEFAULT 'google',
  `showmap` int(1) NOT NULL DEFAULT '0',
  `currency` varchar(100) NOT NULL,
  `showprice` int(1) NOT NULL DEFAULT '-1',
  `showquanity` int(1) NOT NULL DEFAULT '-1',
  `showcolor` int(1) NOT NULL,
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `quanity` int(11) NOT NULL,
  `description` text NOT NULL,
  `keywords` varchar(300) NOT NULL,
  `tplonephoto` char(10) NOT NULL DEFAULT 'photo1',
  `onephoto` int(11) NOT NULL COMMENT 'fid from file_managed table',
  `color` text NOT NULL,
  `phototext` text NOT NULL,
  `show_phototext` int(1) NOT NULL DEFAULT '0',
  `addtocartshow` int(1) NOT NULL DEFAULT '-1',
  `fields` text NOT NULL,
  `moreimg_show` tinyint(1) NOT NULL DEFAULT '1',
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;





CREATE TABLE IF NOT EXISTS `#__ejoshop_file_managed` (
  `fid` INT(11) NOT NULL AUTO_INCREMENT COMMENT 'File ID.',
  `fpid` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `uid` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `filename` VARCHAR(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',
  `uri` VARCHAR(255) CHARACTER SET 'utf8' COLLATE 'utf8_bin' NOT NULL COMMENT 'The URI to access the file (either local or remote).',
  `filemime` VARCHAR(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',
  `filesize` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',
  `status` TINYINT(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',
  `timestamp` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',
  `type` VARCHAR(50) NOT NULL DEFAULT 'undefined' COMMENT 'The type of this file.',
  `imagestyle` INT(11) NULL DEFAULT '8',
  PRIMARY KEY (`fid`),
  INDEX `uid` (`uid` ASC),
  INDEX `status` (`status` ASC),
  INDEX `timestamp` (`timestamp` ASC),
  INDEX `file_type` (`type` ASC),
  INDEX `imagestyle_idx` (`imagestyle` ASC),
  CONSTRAINT `imagestyle`
    FOREIGN KEY (`imagestyle`)
    REFERENCES `#__ejoshop_image_styles` (`id`)
    ON DELETE SET NULL
    ON UPDATE SET NULL)
ENGINE = InnoDB
AUTO_INCREMENT = 0
DEFAULT CHARACTER SET = utf8
COMMENT = 'Stores information for uploaded files.';



-- --------------------------------------------------------

CREATE TABLE IF NOT EXISTS `#__ejoshop_sales` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(50) NOT NULL,
  `intro` text,
  `urltoarticle` varchar(255) DEFAULT NULL,
  `saleslogo` varchar(255) DEFAULT NULL,
  `uri` varchar(255) DEFAULT NULL,
  `params` varchar(255) DEFAULT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `catid` tinyint(3) NOT NULL,
  `createdon` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0;


CREATE TABLE IF NOT EXISTS `#__ejoshop_shop_order` (
  `pid` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `photo_id` INT(11) NOT NULL,
  `payid` INT(11) NOT NULL COMMENT 'For join with payd table',
  `qty` INT(11) NOT NULL COMMENT 'Quanity',
  `status` CHAR(20) NOT NULL DEFAULT 'cart' COMMENT 'Only six type accept: cart, confirm, pay, closed, paywithpost, paywithbill',
  `created` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` VARCHAR(100) NOT NULL COMMENT 'User joomla id or unique id for not logged users',
  `moneysystem` CHAR(50) NOT NULL COMMENT 'Only five type accept: paypal, anet, webmoney, yandexmoney, paywithpost,paywithbill',
  `paystatus` INT(11) NOT NULL DEFAULT '0',
  `paydate` DATETIME NOT NULL,
  `payerbill` VARCHAR(255) NOT NULL,
  `payerwmid` VARCHAR(255) NOT NULL,
  `payerphone` VARCHAR(50) NOT NULL,
  `payerdesc` TEXT NOT NULL COMMENT 'seller description',
  `countrycode` CHAR(20) NOT NULL,
  `transactiontype` CHAR(50) NOT NULL,
  `transactionid` VARCHAR(255) NOT NULL,
  `firstname` VARCHAR(255) NOT NULL,
  `lastname` VARCHAR(255) NOT NULL,
  `sid` VARCHAR(100) NOT NULL,
  PRIMARY KEY (`pid`),
  INDEX `phot_id_idx` (`photo_id` ASC),
  CONSTRAINT `photo_id`
    FOREIGN KEY (`photo_id`)
    REFERENCES `#__ejoshop_photos` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB
AUTO_INCREMENT = 0
DEFAULT CHARACTER SET = utf8;


CREATE TABLE IF NOT EXISTS `#__ejoshop_taxes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(50) NOT NULL,
  `intro` text,
  `perc` decimal(10,2) DEFAULT NULL,
  `params` varchar(255) DEFAULT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `catid` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'TO DO, not used',
  `typetaxvalue` tinyint(1) NOT NULL COMMENT 'Type of tax value 1 - perc, 2 - fixed amount',
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

CREATE TABLE IF NOT EXISTS `#__ejoshop_userinfo_cart` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` varchar(100) DEFAULT NULL,
  `name` varchar(100) NOT NULL,
  `middlename` varchar(255) NOT NULL,
  `lastname` varchar(100) NOT NULL,
  `email` char(55) NOT NULL,
  `zipcode` char(50) NOT NULL,
  `address` varchar(100) NOT NULL,
  `real_address` varchar(255) NOT NULL,
  `city` varchar(100) NOT NULL,
  `street` varchar(255) NOT NULL,
  `housenumber` int(11) NOT NULL,
  `corpusnumber` int(11) NOT NULL,
  `phone` varchar(100) NOT NULL,
  `region` varchar(100) NOT NULL,
  `country` varchar(100) NOT NULL,
  `house` varchar(255) NOT NULL,
  `flat` char(10) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `uniqid` varchar(255) NOT NULL,
  `latilng` varchar(50) NOT NULL,
  `total_purchase` int(11) NOT NULL DEFAULT '0' COMMENT 'Total count',
  `ip` char(55) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=18 ;


CREATE TABLE IF NOT EXISTS `#__ejoshop_comments` (
  `comment_name` VARCHAR(32) NOT NULL DEFAULT '' COMMENT 'The comments tree name.',
  `mlid` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'The comment link ID (mlid) is the integer primary key.',
  `plid` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The parent comment ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `pid` INT(11) NOT NULL,
  `username` VARCHAR(255) NOT NULL,
  `useremail` VARCHAR(255) NOT NULL,
  `link_path` VARCHAR(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` VARCHAR(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` VARCHAR(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` BLOB NULL DEFAULT NULL COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` VARCHAR(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` INT(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` INT(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` SMALLINT(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  `comment` TEXT NOT NULL COMMENT 'Comment text',
  `state` TINYINT(4) NOT NULL DEFAULT '1',
  `created` DATETIME NOT NULL,
  PRIMARY KEY (`mlid`, `pid`),
  INDEX `path_menu` (`link_path`(128) ASC, `comment_name` ASC),
  INDEX `menu_plid_expand_child` (`comment_name` ASC, `plid` ASC, `expanded` ASC, `has_children` ASC),
  INDEX `menu_parents` (`comment_name` ASC, `p1` ASC, `p2` ASC, `p3` ASC, `p4` ASC, `p5` ASC, `p6` ASC, `p7` ASC, `p8` ASC, `p9` ASC),
  INDEX `router_path` (`router_path`(128) ASC),
  INDEX `pid_to_product_idx` (`pid` ASC),
  CONSTRAINT `pid_to_product`
    FOREIGN KEY (`pid`)
    REFERENCES `#__ejoshop_photos` (`id`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB
AUTO_INCREMENT = 0
DEFAULT CHARACTER SET = utf8
COMMENT = 'Contains the individual links within a menu.';