<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

// Import JTableCategory
JLoader::register('JTableNested', JPATH_PLATFORM . '/joomla/database/tablenested.php');

/**
 * @package		Joomla.Administrator
 * @subpackage	com_categories
 */
class TableEjoshopCategory extends JTableNested
{

	
	public function __construct($db)
	{
		parent::__construct('#__ejoshop_categories', 'id', $db);


	}
	
	
  /**         
  * Method to compute the default name of the asset.         
  * The default name is in the form `table_name.id`         
  * where id is the value of the primary key of the table.         
  *         
  * @return      string         
  * @since       2.5         
  */
  
  protected function _getAssetName()        {
	$k = $this->_tbl_key;                
	return 'com_ejoshop.ejoshopcategory.'.(int) $this->$k;        
  }         
  
  /**      
  * Method to return the title to use for the asset table.         
  *         
  * @return      string         
  * @since       2.5         
  */        
  
  protected function _getAssetTitle()        
  {                
	return $this->greeting;        
  }   
  /**         
  * Method to get the asset-parent-id of the item         
  *         
  * @return      int         
  */        
  protected function _getAssetParentId(JTable $table = null, $id = null)  {       
	  // We will retrieve the parent-asset from the Asset-table                
	  $assetParent = JTable::getInstance('Asset');  
	  // Default: if no asset-parent can be found we take the global asset                
	  $assetParentId = $assetParent->getRootId();                 
	  // Find the parent-asset                
	  if (($this->catid)&& !empty($this->catid))                {                        
	  // The item has a ejoshopphoto as asset-parent                        
		$assetParent->loadByName('com_ejoshop.ejoshopcategory.' . (int) $this->catid);                
	  }             
	  else {                        
	  // The item has the component as asset-parent       
		$assetParent->loadByName('com_ejoshop');                
	  }                 
	  // Return the found asset-parent-id                
	  if ($assetParent->id)  {                        
		$assetParentId = $assetParent->id;                
	   }  
		
		return $assetParentId;        
  }

}
