<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
// Include library dependencies
jimport('joomla.filter.input');
// import Joomla table library
jimport('joomla.database.table');
class TableEjoshopPhoto extends JTable
{

	function __construct(& $db) {
		parent::__construct('#__ejoshop_photos', 'id', $db);
	}

        /**
         * Overridden bind function
         *
         * @param       array           named array
         * @return      null|string     null if operation was satisfactory, otherwise returns an error
         * @see JTable:bind
         * @since 1.5
         */
        public function bind($array, $ignore = '') 
        {

                if (isset($array['params']) && is_array($array['params'])) 
                {
                        // Convert the params field to a string.
                        $parameter = new JRegistry;
                        $parameter->loadArray($array['params']);
                        $array['params'] = (string)$parameter;
                }
 
                // Bind the rules.                
				if (isset($array['rules']) && is_array($array['rules'])) {
					$rules = new JAccessRules($array['rules']);                        
					$this->setRules($rules);               
				}                 
				return parent::bind($array, $ignore);        
		}

}
?>