<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

// Include library dependencies
jimport('joomla.filter.input');
// import Joomla table library
jimport('joomla.database.table');
class TableEjoshopPhotos extends JTable
{
	var $catid;
	var $greeting;
	
	function __construct(& $db) {
		parent::__construct('#__ejoshop_photos', 'id', $db);
	}

	
	function publish($pks = null, $state = 1, $userId = 0)
	{

		// Initialise variables.
		$k = $this->_tbl_key;
		
		// Sanitize input.
		JArrayHelper::toInteger($pks);
		$userId = (int) $userId;
		$state = (int) $state;
		$db = $this->getDBO();
		// If there are no primary keys set check to see if the instance key is set.
		if (empty($pks))
		{
			if ($this->$k)
			{
				$pks = array($this->$k);
			}
			// Nothing to set publishing state on, return false.
			else
			{
				$e = new JException(JText::_('JLIB_DATABASE_ERROR_NO_ROWS_SELECTED'));
				$this->setError($e);

				return false;
			}
		}

		// Update the publishing state for rows with the given primary keys.
		$query = $db->getQuery(true);
		$query->update($this->_tbl);
		$query->set('state = ' . (int) $state);

		// Determine if there is checkin support for the table.
		if (property_exists($this, 'checked_out') || property_exists($this, 'checked_out_time'))
		{
			$query->where('(checked_out = 0 OR checked_out = ' . (int) $userId . ')');
			$checkin = true;
			
		}
		else
		{
			$checkin = false;
		}

		// Build the WHERE clause for the primary keys.
		$query->where($k . ' = ' . implode(' OR ' . $k . ' = ', $pks));

		$db->setQuery($query);
		
		// Check for a database error.
		if (!$db->query())
		{
			$e = new JException(JText::sprintf('JLIB_DATABASE_ERROR_PUBLISH_FAILED', get_class($this), $db->getErrorMsg()));
			$this->setError($e);
			return false;
		}

		// If checkin is supported and all rows were adjusted, check them in.
		if ($checkin && (count($pks) == $db->getAffectedRows()))
		{
			// Checkin the rows.
			foreach ($pks as $pk)
			{
				$this->checkin($pk);
			}
		}

		// If the JTable instance value is in the list of primary keys that were set, set the instance.
		if (in_array($this->$k, $pks))
		{
			$this->state = $state;
		}

		$this->setError('Error');
		return true;
	}
	
    /**
     * Overridden bind function
     *
     * @param       array           named array
     * @return      null|string     null if operation was satisfactory, otherwise returns an error
     * @see JTable:bind
     * @since 1.5
     */
	 
    public function bind($array, $ignore = '') 
    {


            if (isset($array['params']) && is_array($array['params'])) 
            {
                    // Convert the params field to a string.
                    $parameter = new JRegistry;
                    $parameter->loadArray($array['params']);
                    $array['params'] = (string)$parameter;
            }
			
			if(!empty($array['catid']))	$this->catid = $array['catid'];
			
            // Bind the rules.                
			if (isset($array['rules']) && is_array($array['rules'])) {
												
				foreach($array['rules'] as $key => $rule) {
					//
					
					foreach($array['rules'][$key] as $keyaccess => $valueaccess) {
					
						if($valueaccess == '') {
							unset($array['rules'][$key][$keyaccess]); // delete inherited values if it empty
						}
					}

					
					
				}
	
				$rules = new JAccessRules($array['rules']);                        
				$this->setRules($rules);               
			}                 
			return parent::bind($array, $ignore);        
	}
	
	function trash($pks = null, $state = -2, $userId = 0)
	{

		// Initialise variables.
		$k = $this->_tbl_key;
		
		// Sanitize input.
		JArrayHelper::toInteger($pks);
		$userId = (int) $userId;
		$state = (int) $state;
		$db = $this->getDBO();
		// If there are no primary keys set check to see if the instance key is set.
		if (empty($pks))
		{
			if ($this->$k)
			{
				$pks = array($this->$k);
			}
			// Nothing to set publishing state on, return false.
			else
			{
				$e = new JException(JText::_('JLIB_DATABASE_ERROR_NO_ROWS_SELECTED'));
				$this->setError($e);

				return false;
			}
		}

		// Update the publishing state for rows with the given primary keys.
		$query = $db->getQuery(true);
		$query->update($this->_tbl);
		$query->set('state = ' . (int) $state);

		// Determine if there is checkin support for the table.
		if (property_exists($this, 'checked_out') || property_exists($this, 'checked_out_time'))
		{
			$query->where('(checked_out = 0 OR checked_out = ' . (int) $userId . ')');
			$checkin = true;
			
		}
		else
		{
			$checkin = false;
		}

		// Build the WHERE clause for the primary keys.
		$query->where($k . ' = ' . implode(' OR ' . $k . ' = ', $pks));

		$db->setQuery($query);
		
		// Check for a database error.
		if (!$db->query())
		{
			$e = new JException(JText::sprintf('JLIB_DATABASE_ERROR_PUBLISH_FAILED', get_class($this), $db->getErrorMsg()));
			$this->setError($e);
			return false;
		}

		// If checkin is supported and all rows were adjusted, check them in.
		if ($checkin && (count($pks) == $db->getAffectedRows()))
		{
			// Checkin the rows.
			foreach ($pks as $pk)
			{
				$this->checkin($pk);
			}
		}

		// If the JTable instance value is in the list of primary keys that were set, set the instance.
		if (in_array($this->$k, $pks))
		{
			$this->state = $state;
		}

		$this->setError('Error');
		return true;
	}

  /**         
  * Method to compute the default name of the asset.         
  * The default name is in the form `table_name.id`         
  * where id is the value of the primary key of the table.         
  *         
  * @return      string         
  * @since       2.5         
  */
  
  protected function _getAssetName()        {
	$k = $this->_tbl_key;                
	return 'com_ejoshop.ejoshopphoto.'.(int) $this->$k;        
  }         
  
  /**      
  * Method to return the title to use for the asset table.         
  *         
  * @return      string         
  * @since       2.5         
  */        
  
  protected function _getAssetTitle()        
  {                
	return $this->greeting;        
  }   
  /**         
  * Method to get the asset-parent-id of the item         
  *         
  * @return      int         
  */        
  protected function _getAssetParentId(JTable $table = null, $id = null)  {       
	  // We will retrieve the parent-asset from the Asset-table                
	  $assetParent = JTable::getInstance('Asset');  
	  // Default: if no asset-parent can be found we take the global asset                
	  $assetParentId = $assetParent->getRootId();                 
	  // Find the parent-asset     

	  if (($this->catid)&& !empty($this->catid))                {                        
	  // The item has a ejoshopphoto as asset-parent                        
		$assetParent->loadByName('com_ejoshop.ejoshopcategory.' . (int) $this->catid);                
	  }             
	  else {                        
	  // The item has the component as asset-parent       
		$assetParent->loadByName('com_ejoshop');                
	  }                 
	  // Return the found asset-parent-id                
	  if ($assetParent->id)  {                        
		$assetParentId = $assetParent->id;                
	   }  

		return $assetParentId;        
  }
	
}
?>