<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
jimport( 'joomla.application.component.model' );
jimport( 'joomla.html.pagination');
jimport( 'joomla.filesystem.file' );
jimport( 'joomla.image.image') ;
ejoshopimport( 'ejoshop.imageeditor.phpimageeditor') ;


class EjoshopViewAjaxupload extends EjoshopView
{

	function display($tpl = null) {
		$uploadcsv = JRequest::getVar('uploadcsv');
		$type = JRequest::getVar('type');
		
		if($uploadcsv || $type == 'sale') {
			$this->uploadcsv();	
		}
		
		if($type == 'removefid') {
			$this->removefid();	
		}
		
		if($type == 'otherphotos') {
			$this->otherphotos();	
		}
		$id = JRequest::getVar('id');
		
		$doc =JFactory::getDocument();

		$filenm = $_GET['qqfile'];

		$nid = JRequest::getVar('nid');
		$step = JRequest::getVar('step');


		/* If $filenm is an array, it means we've used IE and we need to use a different name. */
		if (is_array($filenm)) $filenm = $filenm['name'];

	
		/* Upload */
		$catid = JRequest::getVar('catid');
		$pid = JRequest::getVar('pid');
		$isNew = (int)JRequest::getVar('new',0);
		$type = JRequest::getVar('type');
		$imagestyle = JRequest::getVar('imagestyle');
		$imagestyle = (!empty($imagestyle)) ? $imagestyle : 8;
		$catid = (empty($catid)) ? '' : $catid = $catid.'/';
		$catid = (!empty($type)) ? $type : $catid;
		if(!$isNew) {
			$userpath = '/media/com_ejoshop/files/'.$catid.'/'.$pid.'/';
		} else {
			$userpath = '/media/com_ejoshop/files/tmp/';
		}
		if(!is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
			JFolder::create($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
		
		}

		$targetDir = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath;

		/* upload the file */
		$path_parts = pathinfo($filenm);


		$filename = strtolower($path_parts['filename']).'.'.$path_parts['extension'];
		$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
		$endpath = $targetDir.$filename;

		if (@file_exists($absolutePath)) {
			@unlink($absolutePath);
		}
		/* Using AJAX upload */
		if(empty($_FILES['qqfile']['name']))  {
		
			$input = fopen("php://input", "r");
			
			$target = fopen($absolutePath, "w");
			
			$bytes = stream_copy_to_stream($input, $target);
			fclose($input);
			fclose($target);


			if ($bytes == 0) {

				return;
			} else {
			
				$filename = $this->check($filename,0,$targetDir);
				$endpath = $targetDir.$filename;
				
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
				$model = $this->getModel();
				if(!empty($pid)) {
					$prevphoto = $model->prevphoto($pid);
				}
				
				/* при повторной загрузке перезапись и удаление старого файла */
				if(!empty($prevphoto[0])) {
					
					$prevphoto = $prevphoto[0];
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
					$path_parts = pathinfo($path.$prevphoto->filename);
					$newfileimgsrc = $path.'_s.'.$path_parts['extension'];
					$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
					
					if(is_file($path.$prevphoto->filename)) {
						JFILE::delete($path.$prevphoto->filename);
						
					}
					if(is_file(JFILE::delete($thumb))) {
						JFILE::delete($thumb);
						
					}
					
					if(!empty($prevphoto->opimagestyle)) { // sizethumb для единичного фото
						$onephoto = $prevphoto->sizethumb;
						$thumb = $path.$onephoto;
						if(is_file($thumb)) {
							JFILE::delete($thumb);
						}
					}
				}
				/* only if not new product */
				$fid = (!empty($prevphoto)) ? $prevphoto->fid : 0;
				/* OLD */
				if(!$isNew) {
					/* update existing photo or add new photo */
					$pid = $model->savefile($filename,$userpath,$prevphoto->id,$endpath,1, 'mainphoto',$imagestyle,$fid);
				}
				/* NEW */
				if($isNew) { 
				/* new files must be temporary to delete it when we clear cache, but we should output fid of new file for new product fo hidden input */
					$fid = $model->savefile($filename,$userpath,0,$endpath,0, 'temporary',$imagestyle);
				}
				
				$path = $endpath;
				$path_parts = pathinfo($endpath);
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				
				$ie = new EjoshopPHPImageEditor();
				$ie->processMainPhoto($path,$newfileimgsrc,'thumbnail',$imagestyle,$prevphoto);
				
				if(!empty($prevphoto->opimagestyle)) { // opimagestyle для единичного фото
					$newfileimgsrc = $targetDir.$path_parts['filename'].'_%s_s.'.$path_parts['extension'];
					
					$ie->processOnePhoto($endpath,$newfileimgsrc,'onephoto',$prevphoto->opimagestyle,$prevphoto);
				}
				
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$userpath = ltrim ($userpath,'/');
				$imgsrc = JURI::root(false).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$newfileimg = '<img align="left" class="uploadedimg" src="'.$imgsrc.'">';
				$this->pricefile = json_encode(
				array(
					'success' => true,
					'newfile'=>$filename,
					'id'=>$pid,
					'fid'=>$fid,
					'newfileimg'=>$newfileimg,
					'endpath'=>$endpath,
					'imgsrc'=>$imgsrc
					)
				);
				echo $this->pricefile;
				
				jexit();

			}
		}
		/* простая загрузка osel */
		else {
		
			$fielname = $_FILES["qqfile"]["name"];
			$tmp_name = $_FILES["qqfile"]["tmp_name"];
			$path_parts = pathinfo($fielname);


			$filename = $path_parts['filename'].'.'.$path_parts['extension'];
			$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
			$endpath = $targetDir.$filename;
		
				move_uploaded_file($tmp_name, $absolutePath);
			
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
	
				$model = $this->getModel();
				if(!empty($pid)) {
					$prevphoto = $model->prevphoto($pid);
				}
				
				/* при повторной загрузке перезапись и удаление старого файла */
				if(!empty($prevphoto[0])) {
					
					$prevphoto = $prevphoto[0];
					$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
					$path_parts = pathinfo($path.$prevphoto->filename);
					$newfileimgsrc = $path.'_s.'.$path_parts['extension'];
					$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
					
					if(is_file($path.$prevphoto->filename)) {
						JFILE::delete($path.$prevphoto->filename);
						
					}
					if(is_file(JFILE::delete($thumb))) {
						JFILE::delete($thumb);
						
					}
					
					if(!empty($prevphoto->opimagestyle)) { // sizethumb для единичного фото
						$onephoto = $prevphoto->sizethumb;
						$thumb = $path.$onephoto;
						if(is_file($thumb)) {
							JFILE::delete($thumb);
						}
					}
				}
				/* only if not new product */
				$fid = 0;
				$path_parts = pathinfo($endpath);
				/* save in file managed table*/
				$fid = $model->savefile($path_parts['filename'].'_s.'.$path_parts['extension'],$userpath,0,$endpath,0, 'temporary',$imagestyle);
				
				
				$path = $endpath;
				$path_parts = pathinfo($endpath);
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				
				
				$pi = new EjoshopPHPImageEditor($path,$newfileimgsrc,'thumbnail',$imagestyle,$prevphoto);
				
				if(!empty($prevphoto->opimagestyle)) { // sizethumb для единичного фото
					$newfileimgsrc = $targetDir.$path_parts['filename'].'_%s_s.'.$path_parts['extension'];
					$pi = new EjoshopPHPImageEditor($endpath,$newfileimgsrc,'onephoto',$prevphoto->opimagestyle,$prevphoto);
				}
				
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$userpath = ltrim ($userpath,'/');
				$imgsrc = JURI::root(false).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$newfileimg = '<img align="left" class="uploadedimg" src="'.$imgsrc.'">';
				if($this->is_image($newfileimgsrc)) $image = true;
				$this->pricefile = json_encode(
				array(
				'success' => true,
				'newfile'=>$filename,
				'id'=>$pid,
				'fid'=>$fid,
				'newfileimg'=>$newfileimg,
				'imgsrc'=>$imgsrc,
				'image'=>$image
				)
				);
				echo $this->pricefile;
				
				jexit();

		}
	}
	 
	 
	 
	public function sanitize($string) {
		$match = array("/\s+/","/[^a-zA-Z0-9\-\_]/","/-+/","/^-+/","/-+$/");
		$replace = array("-","","-","","");
		$string = preg_replace($match,$replace, $string);
		$string = strtolower($string);
		return $string;
	}
	
	public function check ($f = '', $i , $dir, &$all = array()) {
	++$i;
	$pi = pathinfo($f);
	$name = $pi['filename'];
	$ext = $pi['extension'];
	$f = $this->sanitize($name).'.'.$ext;
	$all[] = $f;

	if ($handle = opendir($dir)) {



		/* Именно этот способ чтения элементов каталога является правильным. */

		while (false !== ($entry = readdir($handle))) {
				
				
				if ($entry != "." && $entry != "..") {
					if($entry == $f) {
			

					$pi = pathinfo($all[0]);
					$name = $pi['filename'];
					$ext = $pi['extension'];
					$newname = $this->sanitize($name)."_$i.".$ext;
					
					
					$this->check($newname,$i,$dir, $all);
							
						
					} else {
							//echo $entry .'<br />';
					}
				}
			}
			closedir($handle);
		}

		return end($all); 
	}
	
	
	/*
	*
	* загрузка csv файлов
	*/
	
	public function uploadcsv() {
		
		$app = JFactory::getApplication();
		
		$filenm = $app->input->get('qqfile');
		$nid = $app->input->get('nid');
		$step = $app->input->get('step');
		$type = $app->input->get('type');
		$saleid = $app->input->get('id');;

		/* If $filenm is an array, it means we've used IE and we need to use a different name. */
		if (is_array($filenm)) $filenm = $filenm['name'];
	
		/* Upload */
		$galid = JRequest::getVar('galid');
		$catid = JRequest::getVar('catid');
		$pid = JRequest::getVar('pid');
		$galid = (empty($galid)) ? 'csvfiles/' : $galid = 'csvfiles/'.$galid.'/';
		$galid = (!empty($type)) ? 'files/'.$type.'/' : $galid;
		
		$userpath = '/media/com_ejoshop/'.$galid;
		
		if(!is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath)) {
			if(!is_dir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).'/media/com_ejoshop/')) {
				mkdir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).'/media/com_ejoshop/');
			}
	
			mkdir($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath);
		
		}
		
		$targetDir = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$userpath;

		/* upload the file */
		$path_parts = pathinfo($filenm);


		$filename = $path_parts['filename'].'.'.$path_parts['extension'];

		$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
		$endpath = $targetDir.$filename;

		if (@file_exists($absolutePath)) {
			@unlink($absolutePath);
		}

		/* Using AJAX upload */
		if (empty($_FILES['qqfile']['name'])) {
			
			
			$input = fopen("php://input", "r");

			$target = fopen($absolutePath, "w");
			
			$bytes = stream_copy_to_stream($input, $target);
			fclose($input);
			fclose($target);
			
			if ($bytes == 0) {
				
			
				return;
			} else {
			
				$filename = $this->check($filename,0,$targetDir);
				$endpath = $targetDir.$filename;
				
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
				$model = $this->getModel();
				if($type == 'sale') {
				
					
					if(!empty($saleid)) {
						$prevphoto = $model->prevphotoforsales($saleid);
					
					
					}
					
					/* при повторной загрузке перезапись и удаление старого файла */
					if(!empty($prevphoto)) {
						$prevphoto = $prevphoto;
						$path = $_SERVER['DOCUMENT_ROOT'].JURI::root(true).$prevphoto->uri;
									
						if(is_file($path.$prevphoto->saleslogo)) {
							JFILE::delete($path.$prevphoto->saleslogo);
							
						}
		
						 
					}
					$id = $model->savesale($filename,$userpath,$saleid);
					$imgsrc = JURI::root(false).$userpath.$filename;
					$newfileimg = '<img align="left" class="uploadedimg" src="'.$imgsrc.'">';
					$this->pricefile = json_encode(array('success' => true,'newfile'=>$filename,'id'=>$id,'newfileimg'=>$newfileimg));
					print $this->pricefile;
			
					jexit();
				} else {
					$id = $model->savecsv($filename,$userpath);
				}
				
				echo json_encode(array('success'=>true,'id'=>$id));
				jexit();
			}
			

		} else {
			$fielname = $_FILES["qqfile"]["name"];
			$tmp_name = $_FILES["qqfile"]["tmp_name"];
			$path_parts = pathinfo($fielname);


			$filename = $path_parts['filename'].'.'.$path_parts['extension'];
			$relativePath = $albumDir.$filename;
			$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
			$endpath = $targetDir.$filename;
		
			move_uploaded_file($tmp_name, $absolutePath);
			
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
	

				$this->pricefile = json_encode(array('success' => true,'newfile'=>$filename,'id'=>1));
				print $this->pricefile;
				jexit();
		}
	}



	/*
	*
	* загрузка второстепенных файлов
	*/
	
	public function otherphotos() {
		
		$filenm = JRequest::getVar('qqfile');
		$imagestyle = JRequest::getVar('imagestyle');
		$SD = $_SERVER['DOCUMENT_ROOT'];

		/* If $filenm is an array, it means we've used IE and we need to use a different name. */
		if (is_array($filenm)) $filenm = $filenm['name'];
	
		/* Upload */
		$catid = JRequest::getVar('catid');
		$pid = JRequest::getVar('pid');

		$path = '/media/com_ejoshop/files/';
		$userpath = $path.$catid.'/'.$pid.'/other/';
		
		if(!is_dir($SD.JURI::root(true).$path.$catid.DS.$pid)) {
			JFolder::create($SD.JURI::root(true).$path.$catid.DS.$pid);
		}
		
		if(!is_dir($SD.JURI::root(true).$userpath)) {

			JFolder::create($SD.JURI::root(true).$userpath);
	
		}

		
		$targetDir = $SD.JURI::root(true).$userpath;

		/* upload the file */
		$path_parts = pathinfo($filenm);


		$filename = $path_parts['filename'].'.'.$path_parts['extension'];

		$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
		$endpath = $targetDir.$filename;

		if (@file_exists($absolutePath)) {
			@unlink($absolutePath);
		}

		/* простая загрузка osel */
		if (empty($_FILES['qqfile']['name'])) {
			/* Using AJAX upload */
			
			$input = fopen("php://input", "r");
			$target = fopen($absolutePath, "w");
			
			$bytes = stream_copy_to_stream($input, $target);
			fclose($input);
			fclose($target);
			
			if ($bytes == 0) {
				return;
			} else {
			
				$filename = $this->check($filename,0,$targetDir);
				$endpath = $targetDir.$filename;
				
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
				$model = $this->getModel();

				$path_parts = pathinfo($endpath);
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$ie = new EjoshopPHPImageEditor();	
				$ie->processOtherPhoto($endpath,$newfileimgsrc,'ophoto',$imagestyle,$pid);	
		
				$fid = $model->savefile($filename,$userpath,$pid,$endpath,1,'ophoto',$imagestyle);
				$imgsrc = JURI::root(false).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$newfileimg = '<img align="left" class="uploadedimg" src="'.$imgsrc.'">';
				$this->pricefile = json_encode(array('success' => true,'newfile'=>$filename,'fid'=>$fid,'newfileimg'=>$newfileimg));
				print $this->pricefile;
			
				jexit();
				

			}


		} else {
			
				$fielname = $_FILES["qqfile"]["name"];
				$tmp_name = $_FILES["qqfile"]["tmp_name"];
				$path_parts = pathinfo($fielname);


				$filename = $path_parts['filename'].'.'.$path_parts['extension'];

				$absolutePath = $targetDir.uniqid().'.'.$path_parts['extension'];
				$endpath = $targetDir.$filename;
			
				move_uploaded_file($tmp_name, $absolutePath);
				
				$filename = $this->check($filename,0,$targetDir);
				$endpath = $targetDir.$filename;
				
				if(JFile::copy($absolutePath, $endpath)) {
					JFile::delete($absolutePath);
				}
				$model = $this->getModel();

				$path_parts = pathinfo($endpath);
				$newfileimgsrc = $targetDir.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$pi = new EjoshopPHPImageEditor($endpath,$newfileimgsrc,'ophoto',$imagestyle,$pid);	
		
				$fid = $model->savefile($filename,$userpath,$pid,$endpath);
				$imgsrc = JURI::root(false).$userpath.$path_parts['filename'].'_s.'.$path_parts['extension'];
				$newfileimg = '<img align="left" class="uploadedimg" src="'.$imgsrc.'">';
				$this->pricefile = json_encode(array('success' => true,'newfile'=>$filename,'fid'=>$fid,'newfileimg'=>$newfileimg));
				print $this->pricefile;
			
				jexit();
			}
	}
	
	
	/*
	*
	* загрузка второстепенных файлов
	*/
	
	public function removefid($fid = FALSE,$json = TRUE) {
		if(!$fid) $fid = JRequest::getVar('fid');
	
		
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'tables');
		//$tableProduct = JTable::getInstance('EjoshopPhotos', 'Table');
		$table		  = JTable::getInstance('ejoshopFilemanaged', 'Table');
		$table->reset();
		if($table->load($fid)) {
						
			$file  = JPATH_ROOT.$table->uri . $table->filename;
			$path_parts = pathinfo($file);
			$thumb = JPATH_ROOT.$table->uri . $path_parts['filename'].'_s.'.$path_parts['extension'];
		
			if(is_file($file)) {
	
				JFILE::delete($file);
			}	
			if(is_file($thumb)) {
		
				JFILE::delete($thumb);
			}		

			$table->delete($fid);  
			
			echo json_encode(array('success' => true));
		}
		if($json) {
			jexit();
		}
	
	}
	
	
}