<?php
/*
 * @package		Joomla.Framework
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 *
 */
defined( '_JEXEC' ) or die();
jimport( 'joomla.application.component.view' );
ejoshopimport( 'ejoshop.render.renderinfo' );

class EjoshopViewEjoshop extends EjoshopView
{
	public function display($tpl = null) {

		$tmpl = array();
		$doc =JFactory::getDocument();

		EjoshopHelper::load_menu();
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css' );
		
		// prepare the cSS
			$css = '.icon-48-ejoshop {
				background: url("'.JURI::root(true).
				'/media/com_ejoshop/assets/images/icon-48-ejoshop.png") 0 0 no-repeat;
			}';
			// add the CSS to the document

		$doc->addStyleDeclaration($css);
		$tmpl['version'] = EjoshopRenderInfo::getEjoshopVersion();
	
		$MapYandexRenderAdmin = new EjoshopRenderAdmin();
		
		$this->assignRef('tmpl',	$tmpl);
		$this->assignRef('EjoshopRenderAdmin', $MapYandexRenderAdmin);
		$this->addToolbar();
		$this->params = JComponentHelper::getParams('com_ejoshop');
	
		$this->switchpayments = $this->params->get('switchpayments',0);
		$this->switchyandexmoney = $this->params->get('switchyandexmoney',0);
		$this->switchwebmoney = $this->params->get('switchwebmoney',0);
		$this->switchpaypal = $this->params->get('switchpaypal',0);
		$this->switchshop = $this->params->get('switchshop',0);
		$this->switchpost = $this->params->get('switchpost',0);
		$this->switchwritebill = $this->params->get('switchwritebill',0);
			
		EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
		//$model = JModel::getInstance('updatesmigration', 'VirtueMartModel');
		$model = EjoshopModel::getInstance('EjoshopPhotos', 'EjoshopModel');

        $this->allphotos = $model->getPhotos(0,5);
		
		
		parent::display($tpl);
	}
	
	protected function addToolbar() {
		
		require_once JPATH_COMPONENT.DS.'helpers'.DS.'ejoshop.php';
		$canDo = EjoshopHelper::getProductsActions();
		$state	= $this->get('State');
		if($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_ejoshop', '460');
			
		}
		JToolBarHelper::title( JText::_( 'COM_EJOSHOP' ), 'ejoshop.png' );
		$juri = new JUri();
		//$uri = $juri->getHost();
		$uri = 'http://ejoshop.com/articles/';
		$help_url  = $uri;
		JToolBarHelper::help( 'screen.ejoshophelp', true, $help_url,'com_ejoshop' );
		
		
	}
}
?>