<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
ejoshopimport('ejoshop.render.renderadmin');
/**
* Foobar View
*/
class EjoshopViewEjoshopCategories extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->filterForm    = $this->get('FilterForm');
		$this->activeFilters = $this->get('ActiveFilters');
		EjoshopHelper::load_menu();
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		// Preprocess the list of items to find ordering divisions.
		foreach ($this->items as &$item) {
			$this->ordering[$item->parent_id][] = $item->id;
		}
		

		
		// Levels filter.
		$options	= array();
		$options[]	= JHtml::_('select.option', '1', JText::_('J1'));
		$options[]	= JHtml::_('select.option', '2', JText::_('J2'));
		$options[]	= JHtml::_('select.option', '3', JText::_('J3'));
		$options[]	= JHtml::_('select.option', '4', JText::_('J4'));
		$options[]	= JHtml::_('select.option', '5', JText::_('J5'));
		$options[]	= JHtml::_('select.option', '6', JText::_('J6'));
		$options[]	= JHtml::_('select.option', '7', JText::_('J7'));
		$options[]	= JHtml::_('select.option', '8', JText::_('J8'));
		$options[]	= JHtml::_('select.option', '9', JText::_('J9'));
		$options[]	= JHtml::_('select.option', '10', JText::_('J10'));

		$this->f_levels = $options;

	

		$this->addToolbar();

		
		$params = JComponentHelper::getParams( 'com_ejoshop' );
				
		
		$this->assignRef( 'tmpl', $tmpl );
		
		
		parent::display($tpl);
	}
/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		JHtml::stylesheet( 'media/com_ejoshop/assets/ejoshop.css' );
		JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_CATEGORY_INFO' ), 'ejoshopcategories' );
		$canDo = EjoshopHelper::getProductsActions();
		if($canDo->get('core.create')) {
			JToolBarHelper::addNew('ejoshopcategory.add');
		}
		JToolBarHelper::preferences('com_ejoshop', '460');
		
			
		if($canDo->get('core.delete')) {
			JToolBarHelper::publish('ejoshopcategories.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('ejoshopcategories.unpublish', 'JTOOLBAR_UNPUBLISH', true);
		

		
			if ($this->state->get('filter.published') == -2) {
				JToolBarHelper::deleteList('', 'ejoshopcategories.delete', 'JTOOLBAR_EMPTY_TRASH');
			}
			else {
				JToolBarHelper::trash('ejoshopcategories.trash');
				JToolBarHelper::divider();
			}
		}
	}
	
	/*TODO - change it to php 5 rules */
	protected function processTree( $data, $tree, $id = 0, $text='', $currentId) {
	
		$countItemsInCat 	= 0;// Ordering
		
		foreach ($data as $key) {

			
			$show_text =  $text . $key->name;
	
			static $iCT = 0;// All displayed items
			if ($key->parent_id == $id && $currentId != $id && $currentId != $key->catid ) {	

				$tree[$iCT] 					= new JObject();
				
				// Ordering MUST be solved here
				if ($countItemsInCat > 0) {
					$tree[$iCT]->orderup				= 1;
				} else {
					$tree[$iCT]->orderup 				= 0;
				}
				
				if ($countItemsInCat < ($key->countid - 1)) {
					$tree[$iCT]->orderdown 				= 1;
				} else {
					$tree[$iCT]->orderdown 				= 0;
				}
		

				$tree[$iCT]->catid 				= $key->catid;
				$tree[$iCT]->name 				= $show_text;
				$tree[$iCT]->name_self 		= $key->name;
				$tree[$iCT]->parent_id			= $key->parent_id;
				$tree[$iCT]->owner_id			= $key->owner_id;
				$tree[$iCT]->alias				= $key->alias;
				$tree[$iCT]->image				= $key->image;
				$tree[$iCT]->section			= $key->section;
				$tree[$iCT]->image_position		= $key->image_position;
				$tree[$iCT]->description		= $key->description;
				$tree[$iCT]->published			= $key->published;
				$tree[$iCT]->editor				= $key->editor;
				$tree[$iCT]->ordering			= $key->ordering;
				$tree[$iCT]->access				= $key->access;
				$tree[$iCT]->access_level		= $key->access_level;
				$tree[$iCT]->count				= $key->count;
				$tree[$iCT]->params				= $key->params;
				$tree[$iCT]->checked_out		= $key->checked_out;
				$tree[$iCT]->checked_out_time	= $key->checked_out_time;
				$tree[$iCT]->groupname			= 0;
				$tree[$iCT]->username			= $key->username;
				$tree[$iCT]->usernameno			= $key->usernameno;
				$tree[$iCT]->parentcat_title	= $key->parentcat_title;
				$tree[$iCT]->parentcat_id		= $key->parentcat_id;
				$tree[$iCT]->hits				= $key->hits;
				$tree[$iCT]->ratingavg			= $key->ratingavg;
				$tree[$iCT]->accessuserid		= $key->accessuserid;
				$tree[$iCT]->uploaduserid		= $key->uploaduserid;
				$tree[$iCT]->deleteuserid		= $key->deleteuserid;
				$tree[$iCT]->userfolder			= $key->userfolder;
				$tree[$iCT]->latitude			= $key->latitude;
				$tree[$iCT]->longitude			= $key->longitude;
				$tree[$iCT]->geotitle			= $key->geotitle;
				$tree[$iCT]->approved			= $key->approved;
				$tree[$iCT]->language			= $key->language;
				$tree[$iCT]->language_title		= $key->language_title;
				$tree[$iCT]->link				= '';
				$tree[$iCT]->filename			= '';// Will be added in View (after items will be reduced)
				$tree[$iCT]->linkthumbnailpath	= '';

				$iCT++;
				
				$tree = $this->processTree($data, $tree, $key->catid, $show_text . " - ", $currentId );
				$countItemsInCat++;
			}	
		}
		
		return($tree);
	}	



/*TODO - change it to php 5 rules */
	protected function getAllSubCats( $data, $tree, $id = 0, $subcat= '', $currentId) {
	
		$countItemsInCat 	= 0;// Ordering
		
		foreach ($data as $key) {
			
			
			$cat_text =  $subcat . $key->catid;
	
			static $iCT = 0;// All displayed items
			if ($key->parent_id == $id && $currentId != $id && $currentId != $key->catid ) {	

				$tree[$iCT] 					= new JObject();
				
				// Ordering MUST be solved here
				if ($countItemsInCat > 0) {
					$tree[$iCT]->orderup				= 1;
				} else {
					$tree[$iCT]->orderup 				= 0;
				}
				
				if ($countItemsInCat < ($key->countid - 1)) {
					$tree[$iCT]->orderdown 				= 1;
				} else {
					$tree[$iCT]->orderdown 				= 0;
				}
		

				$tree[$iCT]->catid 				= $key->catid;
				$tree[$iCT]->name 				= $cat_text;

				$iCT++;
				
				$tree = $this->getAllSubCats($data, $tree, $key->catid, $cat_text . "-", $currentId );
				$countItemsInCat++;
			}	
		}
		
		return($tree);
	}	


/*TODO - change it to php 5 rules */
	protected function getSubAllCatForParent( $data, $parent) {
	
		$onlysub	= array();// Ordering
		
		foreach ($data as $key) {
			$allcatid = explode('-',$key->name);
			/*
				print '<pre>';
				print_r($allcatid);
				print '</pre>';
			*/
			
			if(in_array(10,$allcatid)) {
				$onlysub = array_merge($onlysub,$allcatid);	
				
			}
	
		}
		
		
		//return($tree);
	}	
	
	
	public function filteCategoryForChange () {
		
		$db = &JFactory::getDBO();
	
		   //build the list of categories
			$query = 'SELECT a.name AS text, a.catid AS value, a.parent_id as parentid'
			. ' FROM #__ejoshop_categories AS a'
			. ' WHERE a.published = 1';
			$db->setQuery( $query );
			$cats = $db->loadObjectList();
			
			// TODO - check for other views than category edit
			$view 	= JRequest::getVar( 'view' );
			$catId	= -1;
			if ($view == 'ejoshopcategories') {
				$id 	= JRequest::getVar( 'id' ); // id of current category
				if ((int)$id > 0) {
					$catId = $id;
				}
			}
			
			// Initialize JavaScript field attributes.
			$attr = '';
			$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';
			$attr .= ' class="inputbox"';
			
			$document					= JFactory::getDocument();
			$document->addCustomTag('<script type="text/javascript">
	function changeCatid() {
		var catid = document.getElementById(\'jform_catid\').value;
		var href = document.getElementById(\'pgselectytb\').href;
		href = href.substring(0, href.lastIndexOf("&"));
		href += \'&catid=\' + catid;
		document.getElementById(\'pgselectytb\').href = href;
	}
	</script>');
			
			$tree = array();
			$text = '';
	
			$tree = EjoshopRenderAdmin::CategoryTreeOption($cats, $tree, 0, $text, $catId);
			
	
			array_unshift($tree, JHTML::_('select.option', '', '- '.JText::_('COM_EJOSHOP_SELECT_CATEGORY').' -', 'value', 'text'));
			
		
			
			return JHTML::_('select.genericlist',  $tree,  'parent_id', trim($attr), 'value', 'text', $this->value, $this->id );		
	}

}

?>
