<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
ejoshopimport('ejoshop.developer.developer');
ejoshopimport('ejoshop.render.renderinfo');
ejoshopimport('ejoshop.render.renderjquery');
ejoshopimport('ejoshop.comments.comments');

class EjoshopViewEjoshopComment extends EjoshopView
{
	/**
	 * Comments view display method
	 * @return void
	 **/
	 
	function display($tpl = null)
	{
		EjoshopHelper::load_menu();
		$doc =JFactory::getDocument();
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/themes/base/jquery.ui.all.css' );
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css' );
		
		$ejoj = new EjoshopRenderJquery();
		$ejoj->addjQuery();	
		
		JHtml::script( JURI::root().'/media/com_ejoshop/assets/js/ejoshop.js' );
		
		EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
		$model = EjoshopModel::getInstance('EjoshopComments', 'EjoshopModel');
        $this->comments = $model->getListQuery();

		$this->comment = $this->comments[0];


		$this->state = $this->get('State');
		$this->form = $this->get('Form');
		$this->form->bind($this->comment);
		
		$this->myform = $this->get('MyForm');
		
		$data['layout'] = JRequest::getVar('layout');
		
		if($data['layout'] == 'edit' || $data['layout'] == 'edit') {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_EDIT_COMMENT' ), 'ejoshopcomments' );
			JToolBarHelper::save('ejoshopcomments.edit', 'COM_EJOSHOP_SAVE');
			JToolBarHelper::apply('ejoshopcomments.apply', 'COM_EJOSHOP_SAVE');
			JToolBarHelper::cancel( 'ejoshopcomments.cancel', 'Close' );
			
		}
		else {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_COMMENT' ), 'ejoshopcomments' );
			JToolBarHelper::preferences('com_ejoshop', '460');
			JToolBarHelper:: publishList ('ejoshopcomments.publish');
			JToolBarHelper:: unpublishList ('ejoshopcomments.unpublish');
			
			JToolBarHelper::deleteList(JText::_( 'COM_EJOSHOP_DELETE_CONFIRM' ),'ejoshopcomments.remove');
		}
		// interrogate the model
	
		$params = JComponentHelper::getParams( 'com_ejoshop' );
				
		$this->assignRef( 'tmpl', $tmpl );
		
		
		parent::display($tpl);
	}
	

}

?>
