<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
ejoshopimport( 'ejoshop.render.rendercurrency' );
ejoshopimport( 'ejoshop.comments.comments' );
/**
* Foobar View
*/
class EjoshopViewEjoshopComments extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	 
	function display($tpl = null)
	{
		EjoshopHelper::load_menu();
		$doc = JFactory::getDocument();
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/themes/base/jquery.ui.all.css' );
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css' );
				
		
		//require_once JPATH_COMPONENT.DS.'helpers'.DS.'ejoshop.php';
		$app = JFactory::getApplication(); 
		EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
		//$model = EjoshopModel::getInstance('updatesmigration', 'VirtueMartModel');
		//$model = EjoshopModel::getInstance('EjoshopNewGallery', 'EjoshopModel');
	
        //$this->allcat = $model->getCategories();
		

        $this->comments = $this->get('Items');
		$params = JComponentHelper::getParams( 'com_ejoshop' );


		$this->state = $this->get('State');
		$this->form = $this->get('Form');

		//Get custom field
		JFormHelper::addFieldPath(JPATH_COMPONENT . '/models/fields');
		$Filtercategories = JFormHelper::loadFieldType('Filtercategories', false);
		$this->fieldOptions = $Filtercategories->getOptions(); // works only if you set your field getOptions on public!!
		$op = array();
		foreach($this->fieldOptions  as $o) {
			if($o->value == 1) {
				$op[] = JHTML::_('select.option','', JTEXT::_('COM_EJ_SELECT') );
			} else {
				$op[] = JHTML::_('select.option',$o->value, $o->text );
			}
		}
		
		$this->options  = JHTML::_('select.genericlist',  $op, $name = 'batch[category_id]', $attribs = null, $key = 'value', $text = 'text', 0, $idtag = false, $translate = false );
		
		$this->opp = array();
		$this->opp[] = JHTML::_('select.option','', JTEXT::_('COM_EJOSHOP_ALL') );
		foreach($this->fieldOptions  as $o) {
	
				$this->opp[] = JHTML::_('select.option',$o->value, $o->text );
			
		}

		
		$data['layout'] = JRequest::getVar('layout');
		$canDo = EjoshopHelper::getProductsActions();	

				
				
		if($data['layout'] == 'addcomments' || $data['layout'] == 'commentedit') {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_ALL_COMMENTS' ), 'ejoshopcomments' );
			if($canDo->get('core.edit')) {
				JToolBarHelper::save('ejoshopcomments.commentedit', 'COM_EJOSHOP_SAVE');
				JToolBarHelper::apply('ejoshopcomments.commentapply', 'COM_EJOSHOP_SAVE');
			}
			JToolBarHelper::cancel( 'ejoshopcomments.cancel', 'Close' );
			
		}
		else {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_ALL_COMMENTS' ), 'ejoshopcomments' );
			if($canDo->get('core.edit.state')) {
				JToolBarHelper:: publishList ('ejoshopcomments.publish');
				JToolBarHelper:: unpublishList ('ejoshopcomments.unpublish');
			}
			
		
		if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'ejoshopcomments.remove', 'COM_EJOSHOP_DELETE');
			JToolBarHelper::divider();
		}
		else {
			if($canDo->get('core.delete')) { 
				JToolBarHelper::deleteList('', 'ejoshopcomments.remove', 'COM_EJOSHOP_DELETE');
			}
			JToolBarHelper::divider();
		}
		}
		// interrogate the model
		JToolBarHelper::preferences('com_ejoshop', '460');

		
		$this->commentpager = $this->get('CommentsPager');


		
		$params = JComponentHelper::getParams( 'com_ejoshop' );
				
		
		$this->assignRef( 'tmpl', $tmpl );
		
		
		parent::display($tpl);
	}
	
	
	function processItems ($items,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$auto_convert_currency = false;
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		//var_dump($sitecuurecny);
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		/* глобальные настройки если не указны отдельные настройки */

	
					
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecuurecny);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {
					$items[$i]->currencyl = '';
				}
				
				/* валюта продукта не соответсвует валюте пользователя и включена опция авконвертирования валют */
				if($items[$i]->currency != $sitecuurecny && $auto_convert_currency) {
					
				
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */
				
					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecuurecny && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
				}
				
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}


		}	
		return $items; 
	}
}

?>
