<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport( 'joomla.application.component.view' );
ejoshopimport( 'ejoshop.render.renderinfo' );
ejoshopimport( 'ejoshop.render.rendercurrency' );
ejoshopimport( 'ejoshop.render.renderpayd' );
ejoshopimport( 'ejoshop.render.rendercart' );
		
/**
* Foobar View
*/
class EjoshopViewEjoshoporder extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		EjoshopHelper::load_menu();
		$doc = JFactory::getDocument();
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css' );
		$canDo = EjoshopHelper::getProductsActions();		
		$this->state = $this->get('State');
		$this->form = $this->get('MyForm');	

		//require_once JPATH_COMPONENT.DS.'helpers'.DS.'ejoshop.php';
		
		EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
		//$model = EjoshopModel::getInstance('updatesmigration', 'VirtueMartModel');
		$model = EjoshopModel::getInstance('EjoshopCategory', 'EjoshopModel');
	
        $this->allcat = $model->getCategories();
   
		$this->allorders = $this->get('Order');
	
		$egri = new EjoshopRenderInfo();
		$egrc = new EjoshopRenderCurrency();
		$params = JComponentHelper::getParams( 'com_ejoshop' );
		$this->allorders = $this->processItems($this->allorders,false,$params);
		
		if(is_array($this->allorders)) {
			foreach($this->allorders as $key => $val) {
				$this->allorders[$key]->moneysystemtype = $this->allorders[$key]->moneysystem;
				$this->allorders[$key]->curlang = $egri->getLangCurrency($this->allorders[$key]->currency,$this->allorders[$key]->price);
				$this->allorders[$key]->moneysystem = $egrc->getMoneySystem($this->allorders[$key]->moneysystem);
				$this->allorders[$key]->cur = $egri->getLangCurrency($this->allorders[$key]->cur);
			}
		}

		$pid = JRequest::getVar( 'pid' );

		if(isset($pid)) {
			$this->photo = $this->allorders[0];
			$this->photo->curlang = $egri->getLangCurrency($this->photo->currency);
		
		}
		
		//$this->allcat = $table->get('Categories');
		
		// add the CSS to the document
	


		
		$data['layout'] = JRequest::getVar('layout');
		
		if($data['layout'] == 'addphotos' || $data['layout'] == 'orderedit') {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_ORDER_DETAILS' ), 'ejoshoporder' );
			//JToolBarHelper::save('ejoshoporder.photoedit', 'COM_EJOSHOP_SAVE');
			//JToolBarHelper::apply('ejoshoporder.photoapply', 'COM_EJOSHOP_SAVE');
			JToolBarHelper::cancel( 'ejoshoporder.cancel', 'Close' );
			if($canDo->get('core.edit')) {
				JToolBarHelper::custom('ejoshoporder.closeorder', 'closeorder.png', '',  'COM_EJOSHOP_CLOSEORDER' , true);
			}
		}
		else {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_ALL_ORDERS' ), 'ejoshoporder' );
			if($canDo->get('core.delete')) {
				JToolBarHelper::deleteList(JText::_( 'COM_EJOSHOP_DELETE_CONFIRM' ),'ejoshoporder.remove');
			}
			if($canDo->get('core.edit')) {
				JToolBarHelper::custom('ejoshoporder.closeorder', 'closeorder.png', '',  'COM_EJOSHOP_CLOSEORDER' , true);
			}
		}
		JToolBarHelper::preferences('com_ejoshop', '460');
		// interrogate the model
	

		
		$this->photopager = $this->get('Reviews');
		
	
		$params = JComponentHelper::getParams( 'com_ejoshop' );
				
		
		$this->assignRef( 'tmpl', $tmpl );
		
		
		parent::display($tpl);
	}
	
	function processItems ($items,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$auto_convert_currency = $params->get('convert_currency');
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		//var_dump($sitecuurecny);
		$cart = new EjoshopRenderCart();
		/*        */

	
					
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
			$c = json_decode($items[$i]->color);
			$items[$i]->allimg = '';
			if(!empty($c)) {
				foreach($c as $color) {
					$items[$i]->allimg .= JHTML::_('image', 'media/com_ejoshop/assets/color/'.$color.'.jpg','','style="width:19px; height:20px; margin-bottom: 3px;"');
				}
			}
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecuurecny);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {
					$items[$i]->currencyl = '';
				}
				
				/*           */
				if($items[$i]->currency != $sitecuurecny && $auto_convert_currency) {
					
		
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /*      */
				
					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecuurecny && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
				}
				
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}
			
			/*        */

			if($items[$i]->showprice < 0) $items[$i]->showprice = $params->get('showprice');
			if($items[$i]->showquanity < 0) $items[$i]->showquanity = $params->get('showquanity');
			if($items[$i]->addtocartshow < 0) $items[$i]->addtocartshow = $params->get('addtocartshow');
			$items[$i]->allimg = '';
			$c = json_decode($items[$i]->color);
			
			if(!empty($c)) {
				foreach($c as $color) {
					$items[$i]->allimg .= JHTML::_('image', 'media/com_ejoshop/assets/color/'.$color.'.jpg','','style="width:19px; height:20px; margin: 0px 0 -5px 2px;"');
				}
			}
			$items[$i]->photoproduct = $cart->getImageForCartItems($items[$i]);
		}	
		
		return $items; 
	}	
}

?>
