<?php 
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined('_JEXEC') or die('Restricted access'); 



$document = JFactory::getDocument();
$user		= JFactory::getUser();
$userId		= $user->get('id');

$document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js');
$document->addStyleSheet(JURI::root(true).'/media/com_ejoshop/colorbox/colorbox.css');
$document->addScript(JURI::root(true).'/media/com_ejoshop/colorbox/jquery.colorbox-min.js');

$option = JRequest::getCmd('option');
$view = JRequest::getCmd('view');
$app = JFactory::getApplication(); 
$listOrder	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order','filter_order','photos.id');
$listDirn	= $app->getUserStateFromRequest($option.$view.'.filter.filter_order_Dir','filter_order_Dir','DESC');

JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('formbehavior.chosen', 'select');
$colorbox = '
$(function(){
	var colorbx_settings = {maxWidth:$(window).height(),maxHeight:$(window).height(),opacity:0.8,scrolling:true,transition:"elastic"};
	$(\'a[rel="colorbox"]\').colorbox(colorbx_settings);
});
';

$document->addScriptDeclaration($colorbox);
?>

<div id="ejoshop">	
<form action="<?php JRoute::_('index.php?option=com_ejoshop'); ?>" method="post" id="adminForm" name="adminForm">
		<div class="clearfix">
		
		<div class="js-stools-container-bar">
			<div class="btn-wrapper input-append">
				<input type="text" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" value="<?php echo $this->state->get('filter.search');?>" id="filter_search" name="filter_search">			
				<button title="" class="btn hasTooltip" type="submit" data-original-title="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>">
					<i class="icon-search"></i>
				</button>
			</div>
			<div class="btn-wrapper">
				<button type="submit" class="btn"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
				<button type="button" class="btn" onclick="document.id('filter_search').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
			</div>
		</div>
		</div>
		
		<div class="clearfix">
			<select name="filter_published" class="inputbox" onchange="this.form.submit()">
				<option value=""><?php echo JText::_('JOPTION_SELECT_PUBLISHED');?></option>
				<?php echo JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get($option.$view.'filter.photo_published'), true);?>
			</select>

   
		<?php 

		$categoryId = $this->state->get('filter.category_id');
	
		
		echo JHTML::_('select.genericlist',  $this->opp, 'filter_category_id', array('onchange'=>"this.form.submit()"),  $key = 'value', $text = 'text',  $categoryId, $idtag = false, $translate = false );
		?>


			<select name="filter_access" class="inputbox" onchange="this.form.submit()">
				<option value=""><?php echo JText::_('JOPTION_SELECT_ACCESS');?></option>
				<?php echo JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $this->state->get('filter.access'));?>
			</select>

		</div>
	

<div id="editcell">

    <table id="articleList" class="table table-striped">

    <thead>
        <tr>


            <th width="20">
             <?php echo JHtml::_('grid.checkall'); ?>
            </th>
			<th width="200">
				<?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_NAME_FILE', 'photos.name', $listDirn, $listOrder ); ?>
            </th>
			<th width="200">
				<?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_ITEMNAME', 'photos.name', $listDirn, $listOrder ); ?>
            </th>
            <th>
                <?php echo JText::_( 'COM_EJOSHOP_DESCRIPTIONOFTAG' ); ?>
            </th>
			<th width="5%" nowrap="nowrap"><?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_PUBLISHED', 'photos.state', $listDirn, $listOrder ); ?>

            <th>
			<?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_IN_CATEGORY', 'photos.catid', $listDirn, $listOrder ); ?>              
			
            </th>			
			<th>
				<?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_HITS', 'photos.hits', $listDirn, $listOrder ); ?>
            </th>
			<th>
                <?php echo JText::_( 'COM_EJOSHOP_YMCODE' ); ?>
            </th>
			<th>
                <?php echo JText::_( 'COM_EJOSHOP_ACCESS' ); ?>
            </th>

			<th>
				<?php echo JHTML::_('grid.sort',  'COM_PHOTO_TIME', 'photos.created', $listDirn, $listOrder ); ?>
            </th>
            </th>
			<th>
				  <?php echo JText::_( 'COM_EJOSHOP_PRICE' ); ?>
            </th>
			<th>
		
            </th>
            <th width="5">
              
				<?php echo JHTML::_('grid.sort',  'COM_EJOSHOP_ID', 'photos.id', $listDirn, $listOrder ); ?>
            </th>
        </tr>            
    </thead>
    <?php
    $k = 0;
    for ($i=0, $n=count( $this->allphotos ); $i < $n; $i++)
    {
        $row = $this->allphotos[$i];
        $checked    = JHTML::_( 'grid.id', $i, $row->id );
		$link = JRoute::_( 'index.php?option=com_ejoshop&view=ejoshopphoto&layout=photoedit&id='. $row->id );

		$canAdmin   = $user->authorise('core.admin',      'com_ejoshop'); // Configuer
		$canManage  = $user->authorise('core.manage',     'com_ejoshop'); // Access to admin manager
		
		$canCreate  = $user->authorise('core.create',     'com_ejoshop');
		$canDelete  = $user->authorise('core.delete',     'com_ejoshop.ejoshopphoto.'.(int)$row->id);
		
		$canEditProduct = $user->authorise('core.edit',       'com_ejoshop');
		$canEdit    = $user->authorise('core.edit',       'com_ejoshop.ejoshopphoto.'.(int)$row->id);
		
		$canChange  = $user->authorise('core.edit.state', 'com_ejoshop');
		$canEditOwn = $user->authorise('core.edit.own',   'com_ejoshop.ejoshopphoto') && $row->created_by == $userId;
		$canDo = EjoshopHelper::getProductsActions($row->id);
		
	
		//EjoshopDeveloper::DebugPrint($canEditProduct);
		//EjoshopDeveloper::DebugPrint($canEdit);
		//EjoshopDeveloper::DebugPrint($canEdit);

        ?>
        <tr class="<?php echo "row$k"; ?>">


            <td>
              <?php echo $checked; ?>
            </td>
			<td style="text-align:center;">
               <?php
			    $path = JURI::root(false).$row->uri;
			   	$path_parts = pathinfo($path.$row->filename);
	
				if(!is_file(JPATH_ROOT.$row->uri.$row->filename)) {
					print '<a rel="colorbox" href="'.$link.'">
							<img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png">
						</a>';
				} else {
					
					$newfileimgsrc = $path.'_s.';

					$thumb = $path.$path_parts['filename'].'_s.'.$path_parts['extension'];
					$imgsrc = $path.$row->filename;

					if(is_file($_SERVER['DOCUMENT_ROOT'].JURI::root(true).$row->uri.$path_parts['filename'].'_s.'.$path_parts['extension'])) {
						print '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
					} else {
						if(is_file(JPATH_ROOT.$row->uri.$row->filename)) {
							print '<a rel="colorbox" href="'.$path.$row->filename.'"><img src="'.JURI::root(false).$row->uri.$row->filename.'"></a>';
						} else {
							print '<a rel="colorbox" href="'.$link.'">
								<img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png">
							</a>';
						}
					}
				}
			   ?>

            </td>
            <td>
			<?php if($canDo->get('core.edit')) : ?>
                <a href="<?php echo $link; ?>"><?php echo $row->name; ?></a>
			<?php else :?>
				<?php echo $row->name; ?>
			<?php endif ?>
			
				<?php
				if(!empty($row->morephoto)) :
					echo '<div style="clear:both;">'.$row->morephoto.'</div>'; 
				endif;
				?>
				
				
				<div style="clear:both;"></div>
            </td>
            <td>
                <a href="<?php echo $link; ?>"><?php echo JHTML::_('string.truncate', ($row->intro), 30); ?></a>
            </td>

	  		<td class="center">
			<?
			echo JHtml::_('jgrid.published', $row->state, $i, 'ejoshopphotos.', true, 'cb');
			?>
			</td>
            <td>
				<?php if($canDo->get('core.edit')) : ?>
					<a href="<?php echo $link; ?>"><?php echo $row->category_name; ?></a>
				
				<?php else : ?>
					<?php echo $row->category_name; ?>
				<?php endif; ?>
            </td>
			<td style="text-align:center;">
                <?php echo $row->hits; ?>
            </td>
			<td style="text-align:center;">
                <?php
					echo '{ejitem_id='.$row->id.'}';
				
				?>
            </td>
			<td class="center">
					<?php echo $this->escape($row->access_level); ?>
			</td>

			<td style="text-align:center;">

			<?php
			
				echo JHTML::_('date', $row->created, 'Y:m:d h:m:s');
			
			?>
            </td>
			<td style="text-align:center;">
                <?php
					echo $row->price. ' ' .$row->currencyl;
				
				?>
            </td>
			<td>
			<?php if($canDo->get('core.edit')) : ?>
			    <a href="<?php echo $link; ?>"><img title="<?php  print JText::_('COM_EJOSHOP_ORDER_EDIT'); ?>" src="<?php -print JURI::root(false)."media/com_ejoshop/assets/images/edititem-s.png";?>" /></a>

			<?php endif; ?>
			</td>
		    <td>
                <?php echo $row->id; ?>
            </td>
        </tr>
        <?php
        $k = 1 - $k;
    }
    ?>
<tr>
	<td colspan="15"><?php echo $this->photopager->getListFooter(); ?></td>
</tr>
    </table>
<?php echo $this->loadTemplate('batch'); ?>
</div>
 

<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
        <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
        <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
<?php echo JHtml::_('form.token'); ?>
</form>
</div>

