<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
ejoshopimport( 'ejoshop.render.rendercurrency' );
ejoshopimport( 'ejoshop.render.renderinfo' );
/**
* Foobar View
*/
class EjoshopViewEjoshopPhotos extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
			$css = '.icon-48-ejoshopphotos {
				background: url("'.JURI::root(true).'/media/com_ejoshop/assets/images/icon-48-ejoshopphotos.png") 0 0 no-repeat;
			}';
		EjoshopHelper::load_menu();
		$doc = JFactory::getDocument();
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/themes/base/jquery.ui.all.css' );
		$doc->addStylesheet( JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css' );
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');		
		$pid = JRequest::getVar( 'id' );
		//require_once JPATH_COMPONENT.DS.'helpers'.DS.'ejoshop.php';
		$app = JFactory::getApplication(); 
		EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/models');
		
			$canDo = EjoshopHelper::getProductsActions($pid);
		
        $this->allphotos = $this->get('Items');
		$params = JComponentHelper::getParams( 'com_ejoshop' );
		
		$egrc = new EjoshopRenderCurrency();
		//$this->allphotos = $egrc->getCurrencyName($this->allphotos);
		$this->allphotos = $this->processItems($this->allphotos,false,$params);


		if(isset($pid)) {
			$this->photo = $this->allphotos;
		}
	
		//$this->allcat = $table->get('Categories');
		
		// add the CSS to the document
		
		$doc->addStyleDeclaration($css);

		$this->state = $this->get('State');
		$this->form = $this->get('Form');

		//Get custom field
		JFormHelper::addFieldPath(JPATH_COMPONENT . '/models/fields');
		$Filtercategories = JFormHelper::loadFieldType('Filtercategories', false);
		$this->fieldOptions = $Filtercategories->getOptions(); // works only if you set your field getOptions on public!!
		$op = array();
		foreach($this->fieldOptions  as $o) {
			if($o->value == 1) {
				$op[] = JHTML::_('select.option','', JTEXT::_('COM_EJ_SELECT') );
			} else {
				$op[] = JHTML::_('select.option',$o->value, $o->text );
			}
		}
		
		$this->options  = JHTML::_('select.genericlist',  $op, $name = 'batch[category_id]', $attribs = null, $key = 'value', $text = 'text', 0, $idtag = false, $translate = false );
		
		$this->opp = array();
		$this->opp[] = JHTML::_('select.option','', JTEXT::_('COM_EJOSHOP_ALL') );
		foreach($this->fieldOptions  as $o) {
	
				$this->opp[] = JHTML::_('select.option',$o->value, $o->text );
			
		}

		
		$data['layout'] = JRequest::getVar('layout');


				
				
		if($data['layout'] == 'addphotos' || $data['layout'] == 'photoedit') {
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_YANDEXNEWMAP' ), 'ejoshopphotos' );
			JToolBarHelper::save('ejoshopphotos.photoedit', 'COM_EJOSHOP_SAVE_AND_CLOSE');
			JToolBarHelper::apply('ejoshopphotos.photoapply', 'COM_EJOSHOP_SAVE');
			JToolBarHelper::cancel( 'ejoshopphotos.cancel', 'Close' );
			
		}
		else {
			
			JToolBarHelper::title(   JText::_( 'COM_EJOSHOP_ALLPHOTOS' ), 'ejoshopphotos' );
			if($canDo->get('core.create')) {
				JToolBarHelper::addNew('ejoshopphoto.add');
			}
			if($canDo->get('core.edit')) {
				JToolBarHelper:: publishList ('ejoshopphotos.publish');
				JToolBarHelper:: unpublishList ('ejoshopphotos.unpublish');
			}
			
			if ( $this->state->get($option.$view.'filter.photo_published') == -2 && $canDo->get('core.delete')) {
				JToolBarHelper::deleteList('', 'ejoshopphotos.delete', 'JTOOLBAR_EMPTY_TRASH');
				JToolBarHelper::divider();
			}
			else if($canDo->get('core.delete')) {
				JToolBarHelper::trash('ejoshopphotos.trash');
			
			} else {
				
			}	
		}
		// interrogate the model
		if($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_ejoshop', '460');
		}
		
		$this->photopager = $this->get('PhotosPager');


		
		$params = JComponentHelper::getParams( 'com_ejoshop' );
				
		
		$this->assignRef( 'tmpl', $tmpl );
		
		
		parent::display($tpl);
	}
	
	
	function processItems ($items,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$auto_convert_currency = false;
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		//var_dump($sitecuurecny);
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		/* глобальные настройки если не указны отдельные настройки */

	
					
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecuurecny);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {
					$items[$i]->currencyl = '';
				}
				
				/* валюта продукта не соответсвует валюте пользователя и включена опция авконвертирования валют */
				if($items[$i]->currency != $sitecuurecny && $auto_convert_currency) {
					
				
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */
				
					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecuurecny && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
				}
				
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}

			$items[$i]  = $this->getOtherPhoto($items[$i]);

		}	
		return $items; 
	}
	
	function getOtherPhoto($p) {
		$mp = new EjoshopRenderInfo();
	
		$OtherPhotos = $mp->getOtherPhotos($p->id);
		
		//EjoshopDeveloper::debugPrint($OtherPhotos);
		foreach($OtherPhotos as $item) {
			
			$uri = $item->uri;
			$path = JURI::root(false).substr($uri,1);
			$path_parts = pathinfo(JPATH_ROOT.DS.$uri.$item->filename);
			$thumb_s = $path_parts['filename'].'_s.'.$path_parts['extension'];
			
			
			$newfileimgsrc = $path.'_s.png';
	
			$thumb = $path.$thumb_s;

			
			$item->morephoto = '';
			$imgsrc = $path.$item->filename;
			/* detail photo */
			if(is_file(JPATH_ROOT.DS.$uri.$thumb_s)) { 
				$p->morephoto .= '<p class="floatpwithimgadmin"><a rel="colorbox" href="'.$imgsrc.'"><img style="height:25px;width:25px;" class="uploadedimg" src="'.$thumb.'"></a></p>';
			/* no photo */	
			} else {
				$p->morephoto .= '<p class="floatpwithimgadmin"><a rel="colorbox" href="'.$imgsrc.'"><img style="height:25px;width:25px;" class="uploadedimg" src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a></p>';
			}
		}
		
		return  $p;
	}
}

?>
