<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
ejoshopimport('ejoshop.render.renderinfo');

/**
* Foobar View
*/
class EjoshopViewEjoshopStyles extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
	
		EjoshopHelper::load_menu();
		$doc =JFactory::getDocument();
		$doc->addStylesheet(JURI::root(true).'/media/com_ejoshop/assets/ejoshop.css');
		

		$this->state = $this->get('State');
		$this->form = $this->get('Form');
		$this->imagestyles = $this->get('imagestyles');
		
		$model = $this->getModel();
		$this->items = $model->getImagestyles('all');
	
		$params = JComponentHelper::getParams('com_ejoshop');
		$pages = array('cart','detail','category');
		$sc = array('color_h','foncolor_th','color_goodbox','color_photo_border','color_cart_table','color_cart_button','color_cart_border');
		$data = array();
		$data['round_border'] = $params->get('round_border');
		$data['error'] = $params->get('error');
		$data['success'] = $params->get('success');
		$data['info'] = $params->get('info');
		
		foreach($pages as $page) { 
			foreach($sc as $color) { 
				$data[$page.'_'.$color] = $params->get($page.'_'.$color);
			}
		}

		$this->layout = JRequest::getVar('layout');
		
		if( $this->layout == 'imagestylesedit') {
			$data = $this->get('imagestyles');
			
			$this->id = $data[0]->id;
			$this->form->bind($data[0]);

		} else {
			$this->form->bind($data);
		}
		
		
		$this->task = JRequest::getVar('task');


		if(empty($this->layout)) $this->layout = 'default';
		if( $this->task != 'processimages') {
		
			$this->setLayout( $this->layout );
		}
		$this->addToolbar();	
		
		parent::display($tpl);
	}
	
	
	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	function addToolbar()
	{
		$canDo = EjoshopHelper::getProductsActions();
			JToolBarHelper::title(   JText::_( 'COM_EJ_STYLES' ), 'processimages' );
			if($this->layout == 'imagestylesedit') {
				if($canDo->get('core.edit')) {
					JToolBarHelper::apply('ejoshopstyles.apply');
				}
				JToolBarHelper::cancel('ejoshopstyles.cancel');
			} else if($this->layout == 'imagestyles') {
				if($canDo->get('core.edit')) {
					JToolBarHelper::addNew('ejoshopstyles.apply');
				}
			} else if($this->layout == 'default') {
				if($canDo->get('core.edit')) {
					if( $this->task != 'processimages') {
						JToolBarHelper::apply('ejoshopstyles.apply');
					}
				}
			}



		
	
	}	
}

?>