<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport('joomla.event.plugin');
jimport('joomla.plugin.plugin');
jimport('joomla.application.component.helper');
jimport('joomla.filter.output');
jimport('joomla.html.parameter');

if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}


class plgSystemEjoshop extends JPlugin
{

	var $_id;
	var $_db;
	var $num;
	var $map_type;
	var $userpath;
	var $comparams;
	var $here_jquery;

	public function __construct($subject, $config)
	{
		$mainframe = JFactory::getApplication();
		if ($mainframe->isSite()) {
			$view = JRequest::get('view');
						
			parent::__construct($subject, $config);
			
			$this->loadLanguage();
			$this->_id = JRequest::getInt('id');
			$this->_db = JFactory::getDBO();
			$document = JFactory::getDocument();
			$this->comparams = JComponentHelper::getParams( 'com_ejoshop' );
			
			$this->userpath = $this->comparams->get('userpathtoimg');
			$this->use_jquery = $this->comparams->get('use_jquery');
			$this->here_jquery = false;
			
			/* load language from admin and site and plg*/
			$this->loadLanguage('plg_ejoshop', JPATH_ADMINISTRATOR);
			$this->loadLanguage('com_ejoshop');
			$this->loadLanguage('com_ejoshop', JPATH_SITE);
			
			if (! class_exists('EjoshopLoader')) {
				require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ejoshop'.DS.'libraries'.DS.'loader.php');
			}

			JHtml::stylesheet( 'components/com_ejoshop/assets/ejoshop.css' );
			

		}
	}

	
	
	public function onContentPrepare($context, $row, $params, $page = 0)
	{

		$this->plgJSMarks($context, $row, $params, $page = 0);
	}
	
	function ejoshopdisp( $article, $params, $limitstart,$id,$idcount )
	{
		/*
		print '<h3>Статья</h3>';
		print '<pre>';
		print_r($idcount);
		print '</pre>';
		*/
		
		$this->_id = $id; 
		
		$view = JRequest::getCmd('view');
		
		if ( ($view != 'article' && $view != 'featured' && $view != 'html' && $view != 'contact' && $view != 'item' 
		&& $view != 'category')
		|| JRequest::getBool('fullview')
		|| JRequest::getVar('print'))
			{
					return null; 
					exit;
			} 
		
		
		if (!JComponentHelper::isEnabled('com_ejoshop', true)) {

			echo JText::_('COM_EJOSHOP_ERROR_PLUGIN_REQUIRES_COMPONENT');
			
		}
		/* The url adress of page */
		$currurl = JURI::current();
		$content='';

		
		$baseurl = JURI::base();
		$document = JFactory::getDocument();
		$title = $document->getTitle();
		
		$paramsc = $this->comparams;
	
		/* customs params  */
		$pretext = $paramsc->get( 'pretext');
		$h = $paramsc->get( 'size');
		$b = '#FDFFBC';
		$b = $paramsc->get( 'background');
		
		$cart = new EjoshopViewPhotos($this->_id);
		$itemsincart = $cart->displayconfig();
	
		if(!$itemsincart) $itemsincart = EjoshopRenderInfo::message(JText::_('COM_EJOSHOP_ERROR_PLUGIN_NO_DATA'),'egerror','return');
		
		$metka = '';
		
		if($paramsc->get('draggable_placemark')) {
			$draggable_placemark = 'draggable: true, // Метку можно перетаскивать, зажав левую кнопку мыши.';
		}
		
	
	
		
		
		$content .= ' 
			<div id="egitem-'.$idcount.'">
				'.$itemsincart.'
			</div>
	
			<div style="text-align:right;"><a href="http://ermakovshop.com" title="Ejoshop shop for Joomla">Ejoshop shop for Joomla</a></div>
	
			 <div class="clear"></div>';
		
	


		
	return $content;
	}



	function hit($id)
	{

		$db = JFactory::getDBO();
		$db->setQuery('UPDATE #__map_yandex
		SET hits = hits + 1 WHERE id ='.$id);
		$db->query();
	}
	
	protected function populateState() 
	{
			$app = JFactory::getApplication();
			// Get the message id
			$id = JRequest::getInt('id');
			$this->setState('message.id', $id);
	 
			// Load the parameters.
			$params = $app->getParams();
			$this->setState('params', $params);
			parent::populateState();
	}
	



	
	/**
	 * Возвращаем метки
	 * @return array Возврату подлежит массив объектов
	 */
	function getMetka($id)
	{
	
			$db = JFactory::getDbo();
			$query = "SELECT * FROM #__map_yandex_metki WHERE id_map =".$db->Quote($id);
			$db->setQuery($query);
			$metka = $db->loadObjectList();
	
		// return the foobar data
		return $metka;
	
	}
	function number($matches)
	{
		$c = preg_replace('@[^A-Za-z0-9]@si','',$this->context);
		
		$this->idfind[] = $c.uniqid();	

		return '{ejitem_id='.end($this->idfind).'}';
	
	}
	function plgJSMarks( $context, $article, $params, $limitstart )
	{
		


			if(preg_match('@{ejitem_id=(.*?)}@si',$article->text))
			{
				//$plugin =& JPluginHelper::getPlugin('content', 'mapyandex');
				$pluginParams = $params;
					
				preg_match_all('@{(ejitem_id)=(.*?)}@si',$article->text,$id);
	
				//замена одинаковых карт
				$this->idfind = array();
				$this->context = $context;
				$article->text = preg_replace_callback('@{ejitem_id=.*?}@si',array(&$this,'number'),$article->text);
				//замена разметки на html
				$idcount = -1;
				
				if(count($id[2]) > 0) {
					ejoshopimport('ejoshop.photos.viewphotos');
					ejoshopimport('ejoshop.render.renderjquery');
					ejoshopimport('ejoshop.render.renderinfo');
					
					$ejoj = new EjoshopRenderJquery();
					JHtml::_('jquery.framework');
					$ejoj->EjoshopUiInit();
					$ejoj->EjoshopRenderStyle('detail');

	
			
				}
				foreach($id[2] as $map) {
					++$idcount;	

					$content = $this->ejoshopdisp( $article, $pluginParams, $limitstart, $map,$this->idfind[$idcount]);
					$article->text = preg_replace('@{ejitem_id='.$this->idfind[$idcount].'}@si',$content,$article->text);

				}
			}

		return true;
	} 
	
    public function onAfterRender()
    {


        // Get the body and fetch a list of files
        $body = JResponse::getBody();
        // Remove all current links from the document
        // Fetch all the matches
        $matches = array();
        $body = $this->findBudJS($body);
		//var_dump($body);
		JResponse::setBody($body);

	}	
	/*
	* find js that include more than one
	*/
	
	function count_budJS($matches)
	{
		
		++$this->BudJs;	
		if($this->total == $this->BudJs) {
			
			return $matches[0];
		} else {
			return '';
		}
	
	}
	
    public function findBudJS($body)
    {
		preg_match_all('@EjoshopUi\.init\(\);@',$body,$matches);

		$this->BudJs = 0;
		$this->total = count($matches[0]);
		if($this->total > 1) {
			$body = preg_replace_callback('@EjoshopUi\.init\(\);@si',array(&$this,'count_budJS'),$body);
			//$body = preg_replace('@EjoshopUi\.init\(\);@','',$body);
		}
		return $body;
	}	
}