<?php
/*
 * @package Joomla 3.x
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component GYMap Component
 * @copyright Copyright (C) Aleksandr Ermakov http://ermakovshop.com
 */

defined('_JEXEC') or die;
//the name of the class must be the name of your component + InstallerScript
//for example: com_contentInstallerScript for com_content.
class com_ejoshopInstallerScript
{
	/*
	 * $parent is the class calling this method.
	 * $type is the type of change (install, update or discover_install, not uninstall).
	 * preflight runs before anything else and while the extracted files are in the uploaded temp folder.
	 * If preflight returns false, Joomla will abort the update and undo everything already done.
	 */
	function preflight( $type, $parent ) {
		$jversion = new JVersion();

		// Installing component manifest file version
		$this->release = $parent->get( "manifest" )->version;
		
		// Manifest file minimum Joomla version
		$this->minimum_joomla_release = $parent->get( "manifest" )->attributes()->version;   
		/*
				// Show the essential information at the install/update back-end
				echo '<p>Installing component manifest file version = ' . $this->release;
				echo '<br />Current manifest cache commponent version = ' . $this->getParam('version');
				echo '<br />Installing component manifest file minimum Joomla version = ' . $this->minimum_joomla_release;
				echo '<br />Current Joomla version = ' . $jversion->getShortVersion();
				echo '<br />$type = ' . $type;
		*/
		// abort if the current Joomla release is older
		if( version_compare( $jversion->getShortVersion(), $this->minimum_joomla_release, 'lt' ) ) {
			Jerror::raiseWarning(null, 'Cannot install com_democompupdate in a Joomla release prior to '.$this->minimum_joomla_release);
			return false;
		}
 
		// abort if the component being installed is not newer than the currently installed version
		if ( $type == 'update' ) {
			$oldRelease = $this->getParam('version');
			$rel = $oldRelease . ' to ' . $this->release;
			if ( version_compare( $this->release, $oldRelease, 'le' ) ) {
				Jerror::raiseWarning(null, 'Incorrect version sequence. Cannot upgrade ' . $rel);
				return false;
			}
		}
		else { $rel = $this->release; }
                // $parent is the class calling this method
                // $type is the type of change (install, update or discover_install)
	
	}
 
	/*
	 * $parent is the class calling this method.
	 * install runs after the database scripts are executed.
	 * If the extension is new, the install method is run.
	 * If install returns false, Joomla will abort the install and undo everything already done.
	 */
	function install( $parent ) {

		echo JText::_('COM_EJOSHOP_INSTALL');
		// You can have the backend jump directly to the newly installed component configuration page
		$parent->getParent()->setRedirectURL('index.php?option=com_ejoshop');
	}
 
	/*
	 * $parent is the class calling this method.
	 * update runs after the database scripts are executed.
	 * If the extension exists, then the update method is run.
	 * If this returns false, Joomla will abort the update and undo everything already done.
	 */
	function update( $parent ) {
		echo '<p>' . JText::_('COM_EJOSHOP_UPDATE_ to ' . $this->release) . '</p>';
		// You can have the backend jump directly to the newly updated component configuration page
		// $parent->getParent()->setRedirectURL('index.php?option=com_democompupdate');
	}
 
	/*
	 * $parent is the class calling this method.
	 * $type is the type of change (install, update or discover_install, not uninstall).
	 * postflight is run after the extension is registered in the database.
	 */
	function postflight( $type, $parent ) {
		// always create or modify these parameters

		// enable shop but disable payments it is need edit settings
		if ( $type == 'install' ) {
			$params['switchshop'] = 1;
			$params['switchyandexmoney'] = 0;
			$params['switchwebmoney'] = 0;
			$params['switchpaypal'] = 0;
			$params['switchpost'] = 0;
			$params['switchwritebill'] = 0;
			$params['currency'] = 'USD';
			$params['cart_only_regiestered_user'] = 1;
			$params['showprice'] = 1;
			$params['addtocartshow'] = 1;
			$params['typefilter'] = 'chosen';
			$params['transition'] = 'elastic';
			$params['toolbaron'] = 1;
			$params['quiqkedit'] = 1;
			$params['system_jquery_cdn'] = 1;
			$params['fopen_or_curl'] = 1;
			$params['curlopt_connecttimeout'] = 1;
		}
		$this->setParams( $params );

			$db = JFactory::getDBO();
			$status = new stdClass;
			$status->modules = array();
			$status->plugins = array();
			$src = $parent->getParent()->getPath('source');
			$manifest = $parent->getParent()->manifest;
			$plugins = $manifest->xpath('plugins/plugin');
			foreach ($plugins as $plugin)
			{
				$name = (string)$plugin->attributes()->plugin;
				$group = (string)$plugin->attributes()->group;
				$path = $src.'/plugins/'.$group;
				if (JFolder::exists($src.'/plugins/'.$group.'/'.$name))
				{
					$path = $src.'/plugins/'.$group.'/'.$name;
				}
				$installer = new JInstaller;
				$result = $installer->install($path);
				/*if ($result && $group != 'finder' && $group != 'josetta_ext')
				{
					if (JFile::exists(JPATH_SITE.'/plugins/'.$group.'/'.$name.'/'.$name.'.xml'))
					{
						JFile::delete(JPATH_SITE.'/plugins/'.$group.'/'.$name.'/'.$name.'.xml');
					}
					JFile::move(JPATH_SITE.'/plugins/'.$group.'/'.$name.'/'.$name.'.j25.xml', JPATH_SITE.'/plugins/'.$group.'/'.$name.'/'.$name.'.xml');
				}*/
				
				$query = "UPDATE #__extensions SET enabled=1 WHERE type='plugin' AND element=".$db->Quote($name)." AND folder=".$db->Quote($group);
				$db->setQuery($query);
				$db->query();
				$status->plugins[] = array('name' => $name, 'group' => $group, 'result' => $result);
			}		
			
		 		$modules = $manifest->xpath('modules/module');
				foreach ($modules as $module)
				{
					$name = (string)$module->attributes()->module;
					$client = (string)$module->attributes()->client;
					if (is_null($client))
					{
						$client = 'site';
					}
					($client == 'administrator') ? $path = $src.'/administrator/modules/'.$name : $path = $src.'/modules/'.$name;
					
					if($client == 'administrator')
					{
						$db->setQuery("SELECT id FROM #__modules WHERE `module` = ".$db->quote($name));
						$isUpdate = (int)$db->loadResult();
					}
					
					$installer = new JInstaller;
					$result = $installer->install($path);
					/*if ($result)
					{
						$root = $client == 'administrator' ? JPATH_ADMINISTRATOR : JPATH_SITE;
						if (JFile::exists($root.'/modules/'.$name.'/'.$name.'.xml'))
						{
							JFile::delete($root.'/modules/'.$name.'/'.$name.'.xml');
						}
						JFile::move($root.'/modules/'.$name.'/'.$name.'.j25.xml', $root.'/modules/'.$name.'/'.$name.'.xml');
					}*/
					$status->modules[] = array('name' => $name, 'client' => $client, 'result' => $result);

				}
			
		}

	/*
	 * $parent is the class calling this method
	 * uninstall runs before any other action is taken (file removal or database processing).
	 */
	function uninstall( $parent ) {
		
		$installer = new JInstaller;
		$db = JFactory::getDBO();
		$status = new stdClass;
		$status->modules = array();
		$status->plugins = array();
		$src = $parent->getParent()->getPath('source');
		$manifest = $parent->getParent()->manifest;
		$plugins = $manifest->xpath('plugins/plugin');
		foreach ($plugins as $plugin)
		{
			$name = (string)$plugin->attributes()->plugin;
			$group = (string)$plugin->attributes()->group;
			
			$db->setQuery('SELECT `extension_id` FROM #__extensions WHERE `type` = "plugin" AND `element` = "'.$name.'" AND `folder` = "'.$group.'"');
			$id = $db->loadResult();
			if(!empty($id)) {
				$installer = new JInstaller;
				$result = $installer->uninstall('plugin',$id,1);
				$status->plugins[] = array('name'=>$name,'group'=>$group, 'result'=>$result);
			}
		}		
		
		$modules = $manifest->xpath('modules/module');
		
		foreach ($modules as $module)
		{
			$name = (string)$module->attributes()->module;
			$client = (string)$module->attributes()->client;
			
			$db->setQuery('SELECT `extension_id` FROM #__extensions WHERE `type` = "module" AND `element` = "'.$name.'"');
			$id = $db->loadResult();
			if(!empty($id)) {
				$installer = new JInstaller;
				$result = $installer->uninstall('module',$id,1);
				$status->module[] = array('name'=>$name, 'result'=>$result);
			}

		}
		
		$config = new JConfig();
		$app = JFactory::getApplication();
	
		
		$db->setQuery("SHOW TABLES LIKE '".$config->dbprefix."ejoshop_field_config'");
		$db->query();
		$checktable = $db->getNumRows();
		
		if ($checktable) {
					
			$db->setQuery('SELECT * FROM #__ejoshop_field_config');
			$fields = $db->loadAssocList();
			
			foreach($fields as $field) {


				$db->setQuery(
					'DROP TABLE IF EXISTS `'.$config->dbprefix.'ejoshop_field_data_'.$field['field_name'].'`'
				);
				try {
					if (!$db->query()) {
						throw new Exception($db->getErrorMsg());
					}	
				} catch (Exception $e) {
					$app->enqueueMessage($e->getMessage(), 'error');
				}	
		
			}
		}
		$app->enqueueMessage(JText::_('COM_EJOSHOP_UNINSTALL'), 'info');
		//$app->enqueueMessage(JText::_('COM_EJOSHOP_UNINSTALL'), 'info');
	
	}
 
	/*
	 * get a variable from the manifest file (actually, from the manifest cache).
	 */
	function getParam( $name ) {
		$db = JFactory::getDbo();
		$db->setQuery('SELECT manifest_cache FROM #__extensions WHERE name = "com_ejoshop"');
		$manifest = json_decode( $db->loadResult(), true );
		return $manifest[ $name ];
	}
 
	/*
	 * sets parameter values in the component's row of the extension table
	 */
	function setParams($param_array) {
		if ( count($param_array) > 0 ) {
			// read the existing component value(s)
			$db = JFactory::getDbo();
			$db->setQuery('SELECT params FROM #__extensions WHERE name = "com_ejoshop"');
			$params = json_decode( $db->loadResult(), true );
			// add the new variable(s) to the existing one(s)
			foreach ( $param_array as $name => $value ) {
				$params[ (string) $name ] = (string) $value;
			}
			// store the combined new and existing values back as a JSON string
			$paramsString = json_encode( $params );
			$db->setQuery('UPDATE #__extensions SET params = ' .
				$db->quote( $paramsString ) .
				' WHERE name = "com_ejoshop"' );
				$db->query();
		}
	}
}