<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modelitem');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.developer.developer');
ejoshopimport('ejoshop.analytics.analytics');
ejoshopimport('ejoshop.render.rendercart');
	
	
class EjoshopModelCart extends JModelItem
{

	function __construct() {
		parent::__construct();
		$id = JRequest::getInt('pid');
		$this->setId((int)$id);
		
	}
	
	function setId($id){
		$this->_id = $id;
		
	
	}

	
	function getCategories($t = '')
	{
		
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$app = JFactory::getApplication(); 

		$query->from('`#__ejoshop_categories` AS cats');
		$query->select('photos.*,cats.*');
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.catid = cats.id)');
	
		
		$params = $app->getParams();
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','cats.lft');
		$orderDirn	= $this->state->get('list.direction','ASC');
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0);
		$app = JFactory::getApplication();
		$pathway = $app->getPathway();
		$pathWayItems 	= $pathway->getPathWay();
			$site = new JSite();
			$menu = $site->getMenu();
			
			$items		= $menu->getItems('component', 'com_ejoshop');
		
		$active = $menu->getActive();
		$view = (!empty($active->query['view'])) ? $active->query['view'] : JRequest::getVar('view');
		
		//EjoshopDeveloper::debugPrint($view);
		if($view == 'categories') {
			$this->catid = JRequest::getVar('id', 0, '', 'int');
		} else if($view == 'category') {
			$this->catid = JRequest::getVar('id', 0, '', 'int');	
		}

			





		
		$show_sub_cat_include = $params->get('show_sub_cat_include',0);
		
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $this->getState('list.start', 0);
		
		if (is_numeric($this->catid) && $show_sub_cat_include) {
		
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/tables');
			$cat_tbl = JTable::getInstance('Ejoshopcategories', 'Table');
			$cat_tbl->load($this->catid);
			$rgt = $cat_tbl->rgt;
			$lft = $cat_tbl->lft;

			$baselevel = (int) $cat_tbl->level;
			$query->where('cats.lft >= '.(int) $lft);
			$query->where('cats.rgt <= '.(int) $rgt);
			$query->where('photos.state = 1');
		} else {
			$query->where('cats.id = '.$this->catid.' AND photos.state = 1');
		}
		
		$query->where('cats.id != 1');
		$query->where('cats.published = 1');
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		//$query->group('cats.id');
		//var_dump($query->__toString());
		//var_dump($limitstart, $limit);
		$query = $db->setQuery( $query, $limitstart, $limit );

		if(!empty($this->catid)) {
			$this->categories = $db->loadObject();
		} else {
			$this->categories = $db->loadObjectList();
			foreach($this->categories as $key => $cat) {
			//var_dump($this->categories[$key]);
			$this->categories[$key]->slug = $this->categories[$key]->id . ':' . $this->categories[$key]->alias;
			}
				
		}
	
	
		return $this->categories;

	}
	
	
	/**
	 * 
	 * @ получаем адрес пользователя для вывода
	 */
	function getPostadress($pid = 0)
	{
		$db		= JFactory::getDBO();	
		$query	= $db->getQuery(true);
		$data = JRequest::get( 'get' );

			$query->select( 'uca.*'	);
			$query->from('`#__ejoshop_userinfo_cart` AS uca');			
			
			if(!empty($data['forpostpay']) && !empty($data['tid'])) {
			  $query->where(array("uca.id = '".$data['tid']."' AND uca.uniqid = '".base64_decode($data['forpostpay'])."'"));
			} else {
			  $data['tid'] = $_SESSION['cartid'];
			  $query->where(array("uca.uid = '".$data['tid']."'"));	
			}
			
			$query = $db->setQuery( $query );
			
			$adress = $db->loadObject();
			
			$s = '';
			if(!empty($adress->region)) $s .= $adress->region;
			if(!empty($adress->city)) $s .= ', ' . $adress->city;
			if(!empty($adress->street)) $s .= ', ' . $adress->street;
			if(!empty($adress->housenumber)) $s .= ', ' . $adress->housenumber;
			if(!empty($adress->flat)) $s .= ', ' . $adress->flat;
			
			return $s;
		
	}
	
	
	/**
	 * 
	 * @view.html.php
	 */
	function getPayments($type)
	{
		$db		= JFactory::getDBO();	
		$query	= $db->getQuery(true);
		
			$query->select(
				$this->getState(
					'list.select',
					'egp.*'
				)
			);
			$query->from('`#__ejoshop_payments` AS egp');			
			if(is_int($type)) {
				$query->where(array("egp.id = '".$type."'"));	
			} else {
				$query->where(array("egp.p_type = '".$type."'"));
			}
			$query = $db->setQuery( $query );
			
			$payment = $db->loadObject();
			
			return $payment;
		
	}
	
	/**
	 * 
	 * обрабатываем запрос от webmoney or yandexmoney or paypal при успешном
	 * платеже завершение оплаты товара
	 * отмечаем в таблицах как оплаченно
	 */
	 
	function processpaidpp($type = 'paypal',$pids = array(), $amount = 0, $id = false,$currency = '')
	{
			JError::$legacy = false;
			$row  = $this->getTable('ejoshopPayd', 'Table');
			$user = JFactory::getUser();
			//$pids = $_POST['item_id'];
			
			$pids = array_values($pids);
			
			$payddata['payer'] = $user->get('id', 0);
			$payddata['created'] = gmdate('Y-m-d H:i:s');
			$payddata['pids'] = json_encode($pids);
			$payddata['moneysystem'] = $type;
			$payddata['amount'] = $amount;
			$payddata['cur'] = ($type == 'anet' && empty($currency)) ?  'USD' : ($type == 'yandexmoney' && empty($currency)) ? 'RUB' :  $currency; // Anet accept only USD
			
			$payddata['status'] = 1; // 0 - not pay 1 - payd
			if($id) $payddata['payid'] = $id;
			try {
					
				$row->bind($payddata);
				$row->store();
			} catch(Exception $e) {
				print $e->getMessage();	
			}	
	
			return $row->payid;
			
	}
	/**
	 * 
	 * обрабатываем запрос от anet при успешном
	 * платеже завершение оплаты товара
	 * отмечаем в таблицах как оплаченно
	 */
	 
	function updatorderanet($pid = 0)
	{


	}
	
	
	/**
	 * 
	 * обрабатываем запрос от paypal при успешном
	 * платеже завершение оплаты товара
	 * отмечаем в таблицах как оплаченно
	 */
	 
	function DoPayPalExpressCheckout($pid = 0)
	{

		//Paypal redirects back to this page using ReturnURL, We should receive TOKEN and Payer ID
		if(isset($_GET["token"]) && isset($_GET["PayerID"]))
		{
				JError::$legacy = false;
				ejoshopimport('ejoshop.paypal.paypalclass');	
				ejoshopimport('ejoshop.render.rendercart');
				EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
				$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');
			
				$isempty = EjoshopRenderCart::isCartEmpty();	
				$currency = new EjoshopRenderCurrency;
				if($isempty) {
					
					return false;	
				}
				
				$application = JFactory::getApplication();
				$paypal = new EjoshopPayPalClass();
				$token = $_GET["token"];
				$playerid = $_GET["PayerID"];
				$this->payments = $this->getPayments('paypal'); // настройки paypal
				
		
				$PayPalCurrencyCode 	= $_SESSION['usercurrency']; //Paypal Currency Code
				$PayPalReturnURL 		=  JRoute::_('index.php?option=com_ejoshop&view=cart&task=backtocartfrompp'); 	$PayPalURL 	= JRoute::_('index.php?option=com_ejoshop&view=cart&task=paypal');				
				//Point to process.php page
				$PayPalCancelURL 		=  JRoute::_('index.php?option=com_ejoshop&view=cart&task=cancel'); //Cancel URL if user clicks cancel
	
				$PayPalApiSignature = $this->payments->paypalapisignature;
				$PayPalApiPassword = $this->payments->paypalapipassword;
				$PayPalApiUsername = $this->payments->paypalapiusername;
			
				//get session variables
				$ItemPrice 		= $_SESSION['itemprice'];
				$ItemTotalPrice = $_SESSION['totalamount'];
				if(isset($_SESSION['itemtotaltaxprice'])) {
					$ItemTotalTaxPrice = $_SESSION['itemtotaltaxprice'];
					$onlytax = $currency->getTaxAmount($ItemPrice,$ItemTotalTaxPrice);
					$tax = '&PAYMENTREQUEST_0_TAXAMT='.$onlytax;
				} else {
					$ItemTotalTaxPrice = $ItemTotalPrice;
				}
				
				$ItemName 		= $_SESSION['itemName'];
				$ItemNumber 	= $_SESSION['itemNo'];
				$ItemQty = (empty($_SESSION["itemQty"])) ? 0 : $_SESSION["itemQty"]; // Item Quantity
				$itemdesc = 'Оплата товаров';
				$padata = 	'&TOKEN='.urlencode($token).
									'&PAYERID='.urlencode($playerid).
									'&PAYMENTREQUEST_0_PAYMENTACTION='.urlencode("SALE").
									'&PAYMENTREQUEST_0_DESC ='.urlencode($itemdesc).
									$_SESSION['allitemcart'].
									'&PAYMENTREQUEST_0_AMT='.urlencode($ItemTotalTaxPrice).
									'&PAYMENTREQUEST_0_ITEMAMT='.urlencode($ItemTotalPrice).
									$tax . 
									'&PAYMENTREQUEST_0_CURRENCYCODE='.urlencode($PayPalCurrencyCode);

				if($this->payments->sandbox) {
					$PayPalMode = 'sandbox';
				} else {
					$PayPalMode = 'live';	
				}
				//We need to execute the "DoExpressCheckoutPayment" at this point to Receive payment from user.
				$paypal= new EjoshopPayPalClass();
				$httpParsedResponseAr = $paypal->PPHttpPost('DoExpressCheckoutPayment', $padata, $PayPalApiUsername, $PayPalApiPassword, $PayPalApiSignature, $PayPalMode);

				//Check if everything went ok..
				if("SUCCESS" == strtoupper($httpParsedResponseAr["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseAr["ACK"])) 
				{

						// Get a handle to the Joomla! application object
						
						 
						// Add a message to the message queue
						$application->enqueueMessage(JText::_('COM_EG_SUCCESS_PAYPAL'), 'message');
						$application->enqueueMessage($this->payments->textafterpaysuccess, 'message');
					
							/*
							//Sometimes Payment are kept pending even when transaction is complete. 
			
							//May be because of Currency change, or user choose to review each payment etc.
							//hence we need to notify user about it and ask him manually approve the transiction
							*/
							
							if('Completed' == $httpParsedResponseAr["PAYMENTINFO_0_PAYMENTSTATUS"])
							{
								$application->enqueueMessage(JText::_('COM_EG_SUCCESS_FEE_RECEIVED'), 'message');	
								$application->enqueueMessage('Your Transaction ID :'.urldecode($httpParsedResponseAr["PAYMENTINFO_0_TRANSACTIONID"]), 'message');	
								//echo '<div style="color:green">Payment Received! Your product will be sent to you very soon!</div>';
							}
							elseif('Pending' == $httpParsedResponseAr["PAYMENTINFO_0_PAYMENTSTATUS"])
							{
								$application->enqueueMessage(JText::_('COM_EG_SUCCESS_FEE_PENDING'), 'message');		
								//echo '<div style="color:red">Transaction Complete, but payment is still pending! You need to manually authorize this payment in your <a target="_new" href="http://www.paypal.com">Paypal Account</a></div>';
							}
			
							$transactionID = urlencode($httpParsedResponseAr["PAYMENTINFO_0_TRANSACTIONID"]);
				
				
							$lastpay = $model->processpaidpp($type = 'paypal',$pids = array(), urldecode($httpParsedResponseAr["PAYMENTINFO_0_AMT"]));
										
							$nvpStr = "&TRANSACTIONID=".$transactionID;
							$paypal= new EjoshopPayPalClass();
							$httpParsedResponseAr = $paypal->PPHttpPost('GetTransactionDetails', $nvpStr, $PayPalApiUsername, $PayPalApiPassword, $PayPalApiSignature, $PayPalMode);
							$TransactionDetails = $httpParsedResponseAr; 
					//echo '<h2>GetTransactionDetails</h2>';
	
				if("SUCCESS" == strtoupper($httpParsedResponseAr["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseAr["ACK"])) {

						$row = $this->getTable('ejoshopPayd', 'Table');
						$user 		= JFactory::getUser();
						foreach($httpParsedResponseAr as $key => $val) {
							if(strpos($key,'L_NUMBER') !== false) {
								$pids[] =	$val;
							}
						
						}
						$pids = array_values($pids);
						$payddata['payer'] = $user->get('id', 0);
						$payddata['created'] = gmdate('Y-m-d H:i:s');
						$payddata['moneysystem'] = 'paypal';
						$payddata['amount'] = urldecode($httpParsedResponseAr['AMT']);
						$payddata['payid'] = $lastpay;
						$payddata['status'] = 1;
						$payddata['pids'] = json_encode($pids);
						
						if(!empty($httpParsedResponseAr['CURRENCYCODE'])) {
							$payddata['cur'] =  $httpParsedResponseAr['CURRENCYCODE'];
						}
						try {
							$row->bind($payddata);
							$row->store();
						} catch (RuntimeException $e) {
							print $e->getMessage();
						}
						
						$waspayed = gmdate('Y-m-d H:i:s');
						$payerphone = '';
						if(!empty($httpParsedResponseAr['SHIPTOPHONENUM'])) $payerphone = urldecode($httpParsedResponseAr['SHIPTOPHONENUM']);
						$countrycode = '';
						if(!empty($httpParsedResponseAr['COUNTRYCODE'])) $countrycode = $httpParsedResponseAr['COUNTRYCODE'];
						$transactiontype = '';
						if(!empty($httpParsedResponseAr['TRANSACTIONTYPE'])) $transactiontype = $httpParsedResponseAr['TRANSACTIONTYPE'];
						$firstname = '';
						if(!empty($httpParsedResponseAr['FIRSTNAME'])) $firstname = urldecode($httpParsedResponseAr['FIRSTNAME']);
						$lastname = '';
						if(!empty($httpParsedResponseAr['LASTNAME'])) $lastname = urldecode($httpParsedResponseAr['LASTNAME']);
						$transactionid = '';
						if(!empty($httpParsedResponseAr['TRANSACTIONID'])) $transactionid = $httpParsedResponseAr['TRANSACTIONID'];
						$note = '';
						if(!empty($httpParsedResponseAr['NOTE'])) $note = $httpParsedResponseAr['NOTE'];
						//echo '<h2>Pids:</h2>';
						
						/* настройки платежа  paypal */	
						$db		= JFactory::getDBO();
						$query	= $db->getQuery(true);
				
						/* обновление данных об успешном платеже */
						$query = "UPDATE ".$db->quoteName('#__ejoshop_shop_order') 
							." set ".$db->quoteName('status')." = 'pay',
							 ".$db->quoteName('paystatus')." = '1',
							 ".$db->quoteName('payid')." = '".$payddata['payid']."',
							 ".$db->quoteName('paydate')." = '".$waspayed."',
							 ".$db->quoteName('moneysystem')." = 'paypal',
							 ".$db->quoteName('payerbill')." = '".urldecode($httpParsedResponseAr['RECEIVEREMAIL'])."',
							 ".$db->quoteName('payerwmid')." = '".$httpParsedResponseAr['PAYERID']."',
							 ".$db->quoteName('payerdesc')." = '".$note."',
							 ".$db->quoteName('transactiontype')." = '".$transactiontype."',
							 ".$db->quoteName('transactionid')." = '".$transactionid."',
							 ".$db->quoteName('countrycode')." = '".$countrycode."',
							 ".$db->quoteName('firstname')." = '".$firstname."',
							 ".$db->quoteName('lastname')." = '".$lastname."',
							 ".$db->quoteName('payerphone')." = '".$payerphone."'
							 WHERE ".$db->quoteName('pid')." IN (".  implode(',', $pids).");";
							
						$db->setQuery($query);
						try {
							$db->query();
						} catch (RuntimeException $e) {
							print $e->getMessage();
						}
						
						$analytics = new EjoshopAnalytics();
						$analytics->updateUserPurchase();
						EjoshopRenderCart::flushCart();	
						EjoshopRenderCart::sendEmail();
						
						JError::$legacy = true;
						return true;
	
							} else  {
								
								$application->enqueueMessage('Error GetTransactionDetails', 'error');
								$application->enqueueMessage(JText::_('COM_EG_GETTRANSACTIONDETAILS_FAILED'), 'error');	
								$application->enqueueMessage($this->payments->textafterpayfail, 'message');
								$application->redirect( $PayPalURL );
							}
				
				} else {
						$application->enqueueMessage('Error DoExpressCheckout', 'error');
						$application->enqueueMessage('Error: ' .  urldecode($httpParsedResponseAr["L_LONGMESSAGE0"], 'error'));	
						$application->enqueueMessage(urldecode($httpParsedResponseAr["L_LONGMESSAGE0"]), 'error');
						$application->enqueueMessage(urldecode($httpParsedResponseAr["L_ERRORCODE0"]), 'error');
						$application->enqueueMessage($this->payments->textafterpayfail, 'message');
						$application->redirect( $PayPalURL );
				}
			}
		
	
	
		
	}	
	
	/**
	 * 
	 * при отмене платежа удаляем данные
	 * о нём в таблице #__ejoshop_payd
	 * 
	 */
	 
	function paypalcancel($pid = 0)
	{
		
		$lastpay = JRequest::getVar('lastpay',0);
		if (!empty($lastpay) && isset($_GET["token"])) {
			$db		= JFactory::getDBO();
			$query = 'DELETE FROM #__ejoshop_payd'
			. ' WHERE payid = ' .$lastpay . ' LIMIT 1';
				$db->setQuery( $query );
				if (!$db->query()) {
					JError::raiseWarning( 500, $db->getError() );
				}
			
			return true;
		}
	}
	
	/**
	 * 
	 * обрабатываем запрос от webmoney при успешном
	 * платеже завершение оплаты товара
	 * отмечаем в таблицах как оплаченно
	 */
	 
	function flushCartAfterWebmoney($pid = 0)
	{
		EjoshopRenderCart::flushCart();	
		$application = JFactory::getApplication();	
		$application->enqueueMessage(JText::_('COM_EG_SUCCESS_FEE_RECEIVED'), 'message');
		return true;
	}
		
	/**
	 * 
	 * обрабатываем запрос от webmoney при успешном
	 * платеже завершение оплаты товара
	 * отмечаем в таблицах как оплаченно
	 */
	 
	function updatorderitem($pid = 0)
	{

	
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'payments.*'
			)
		);
	
		$query->from('`#__ejoshop_payments` AS payments');
		$query->where('payments.id = 3');
	
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->payments = $db->loadObject();
	
		//$secret_key=$this->payments->secretkey;
		$secret_key='A6368870-20B4-4DBC-974A-A49AD6A1A890';
		$common_string =
		$_POST['LMI_PAYEE_PURSE'].$_POST['LMI_PAYMENT_AMOUNT'].$_POST['LMI_PAYMENT_NO'].
		$_POST['LMI_MODE'].$_POST['LMI_SYS_INVS_NO'].$_POST['LMI_SYS_TRANS_NO'].
		$_POST['LMI_SYS_TRANS_DATE'].$secret_key.$_POST['LMI_PAYER_PURSE'].$_POST['LMI_PAYER_WM'];
		// Шифруем полученную строку в MD5 и переводим ее в верхний регистр 
		//http://wiki.webmoney.ru/projects/webmoney/wiki/Web_Merchant_Interface
		$hash = strtoupper(md5($common_string));
		
		$pids = array();
		for($i = 1; $i <= $_POST['ITEMS_COUNT']; $i++) {
	
				$pids[] = $_POST['PID_'.$i];
			
		}
		
		$payerphone = '';
		if(!empty($_POST['LMI_TELEPAT_PHONENUMBER'])) $payerphone = $_POST['LMI_TELEPAT_PHONENUMBER'];
		//if($hash!=$_POST['LMI_HASH']) $noequal = 'не соответсвуют!';
		
		//iconv('CP1251','UTF-8', urldecode(LMI_PAYMENT_DESC ));
		$desc = '';
		if(!empty($_POST['LMI_PAYMENT_DESC'])) $desc = urldecode($_POST['LMI_PAYMENT_DESC']);
		

		// Прерываем работу скрипта, если контрольные суммы не совпадают
		if($hash == $_POST['LMI_HASH']) {

				/* Добавляем платежи */
				$row = $this->getTable('ejoshopPayd', 'Table');
				$user 		= JFactory::getUser();
			
				$payddata['payer'] = $user->get('id', 0);
				$payddata['created'] = gmdate('Y-m-d H:i:s');
				$payddata['pids'] = json_encode($pids);
				$payddata['moneysystem'] = 'webmoney';
				$payddata['amount'] = $_POST['LMI_PAYMENT_AMOUNT'];
				
				if(!empty($_POST['LMI_PAYER_PURSE'])) {
					$payddata['cur'] =  substr($_POST['LMI_PAYER_PURSE'],0,1);
					if($payddata['cur'] == 'R') $payddata['cur'] = 'RUB';
					if($payddata['cur'] == 'Z') $payddata['cur'] = 'USD';
				}
				// Bind the form fields to the Cart User Info gallery table
				if (!$row->bind($payddata)) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				// Store the Phoca gallery table to the database
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
						
			$waspayed = gmdate('Y-m-d H:i:s');
		
			$query = "UPDATE ".$db->quoteName('#__ejoshop_shop_order') 
			." set ".$db->quoteName('status')." = 'pay',
			 ".$db->quoteName('paystatus')." = '1',
			  ".$db->quoteName('payid')." = '".$row->payid."',
			 ".$db->quoteName('paydate')." = '".$waspayed."',
			 ".$db->quoteName('moneysystem')." = 'webmoney',
			 ".$db->quoteName('payerbill')." = '".$_POST['LMI_PAYER_PURSE']."',
		     ".$db->quoteName('payerwmid')." = '".$_POST['LMI_PAYER_WM']."',
			  ".$db->quoteName('payerdesc')." = '".$desc."',
		     ".$db->quoteName('payerphone')." = '".$payerphone."'
			 WHERE ".$db->quoteName('pid')." IN (".  implode(',', $pids).");";

	
				$db->setQuery($query);
				if (!$db->query()) {
					$this->setError($db->getErrorMsg());
					return false;
				}
			EjoshopRenderCart::sendEmail();
		}
	}	

	/**
	 * 
	 * Обновление статуса товара в корзине для почты
	 */	
	
	function updateStatusAfterPostPay($createdby = 0,$type = 'paywithpost')
	{

		$db		= JFactory::getDBO();
		$data = JRequest::get( 'post' );
		$query	= $db->getQuery(true);
		$user 		= JFactory::getUser();
		
		$cartitems = $this->getCartItem();
		$pids = array();
		foreach($cartitems as $item) {
			$pids[] = $item->pid;
				
		}

		$this->postadress = $this->getPostadress();

		$gmdate = gmdate('Y-m-d H:i:s');
		$query = "UPDATE ".$db->quoteName('#__ejoshop_shop_order') 
							." set ".$db->quoteName('status')." = '".$type."',
						     ".$db->quoteName('moneysystem')." = '".$type."',
							 ".$db->quoteName('paydate')." = '".$gmdate."',
							 ".$db->quoteName('payerdesc')." = '".$this->postadress."'
							 WHERE ".$db->quoteName('pid')." IN (".  implode(',', $pids).");";
							
		$db->setQuery($query);
		if (!$db->query()) {
			$this->setError($db->getErrorMsg());
			return false;
		}
		
		return true;
		

	}
	
	
	
	/**
	 * 
	 * Только подтверждение информации
	 * и обновление данных о пользователе
	 */
	function confirmcart($pid = 0)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
			$user = JFactory::getUser(); // it's important to set the "0" otherwise your admin user information will be loaded

			if($user->id > 0) {
				$userID = $user->id;
			}
			if(!$user->id) {
				if(!empty($_SESSION['cartid'])) {	
					$userID = $_SESSION['cartid'];
				} else {
					$userID = uniqid();	
				}
			}
		$ReturnURL = JRoute::_('index.php?option=com_ejoshop&view=cart');
		$db		= JFactory::getDBO();
		$data = JRequest::get( 'post' );
		$query	= $db->getQuery(true);
		$user 		= JFactory::getUser();
		$userTable = new stdClass();
		$userTable->uid = $user->get('id', 0);
		$userTable = $this->getTable('ejoshopUserinfo', 'Table'); //__ejoshop_userinfo_cart
		$application = JFactory::getApplication();	
		/* 
			при выборе варианта оплаты - "почта" необходимо обновить адрес получателя 
			$data['postpay'] - шифр, 
			$data['tid'] - id записи в таблице __ejoshop_userinfo_cart
		*/
		 
		if(empty($data['postpay'])) {
			$data['id'] = (!empty($data['tid'])) ? $data['tid'] : 0;
			$data['uniqid']	= (!empty($data['postpay'])) ? crypt($data['postpay']) : crypt($userID);
		}
	
		/* check that user not bot */
		if(!empty($data['postpay'])) {
			$query->select(
				$this->getState(
					'list.select',
					'uca.*'
				)
			);
			$query->from('`#__ejoshop_userinfo_cart` AS uca');			
			$query->where(array("uca.id = '".$data['tid']."' AND uca.uniqid = '".base64_decode($data['postpay'])."'"));
			$query = $db->setQuery( $query );
			$check = $db->loadObject();
			if(empty($check->id)) $application->redirect( $ReturnURL );
		}
		
		
		/* get coords from where men */
		if(!empty($data['address'])) {
			ejoshopimport('ejoshop.geolocation.geolocation');
			$egeo = new EjoshopGeolocation();
	
			$data['latilng'] = $egeo->geocode($data['address']);
		}
		
		if(!empty($_SERVER['REMOTE_ADDR'])) {
			if(!class_exists('EjoshopGeolocation')) {
				ejoshopimport('ejoshop.geolocation.geolocation');
				$egeo = new EjoshopGeolocation();
			}
	
			$data['ip'] = $_SERVER['REMOTE_ADDR'];
			$real_address = $egeo->get_geobase_data($_SERVER['REMOTE_ADDR']);
			if(is_array($real_address) && !empty($real_address)) {
				$latlng = '';
				if(!empty($real_address['lat'])) {
					$latlng = '('.$real_address['lat'].'-'.$real_address['lng'].')';
				}
				$data['real_address'] = $real_address['country'].', '.$real_address['region'] .', '.$real_address['city'].$latlng;
			}
	
		}
		
		if(!empty($data['latilng'])) {
			$data['latilng'] = implode(',',$data['latilng']);
		}
		/* get coords from where men */
		
		/* получаем данные о пользователе */
		if(!empty($userID)) {
			$query	= $db->getQuery(true);
			$data['uid'] = $userID;
			$query->select('uca.*');
			$query->from('`#__ejoshop_userinfo_cart` AS uca');			
			$query->where(array("uca.uid = '".$userID."'"));
			$query = $db->setQuery( $query );
			$getUic= $db->loadObject();

		}
		
		// если информации пользователя нет добавляем
		$userTable->created = gmdate('Y-m-d H:i:s');
		try {
			// если информации пользователя нет добавляем
			if(empty($getUic)) {
				
					$userTable->bind($data);
					$userTable->store();
				
			} else { // иначе обновляем
					$data['id'] = $getUic->id;
					$userTable->bind($data);
					$userTable->store();
				
			}
		} catch (RuntimeException $e) {
				print $e->getMessage();	
		}
	
		/* UPDATE CART ITEMS STATUS CHANGE */	
		if(!is_array($_SESSION['cart'])) {
			$userproduct = json_decode($_SESSION['cart']);
		}
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}

				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set status = 'confirm' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
					. ".`pid` IN (".  implode(',', $userproduct).") AND created_by = '".$userID."';";
				$db->setQuery($query);
				if (!$db->query()) {
					$this->setError($db->getErrorMsg());
					return false;
				}
		}

			if(!empty($userTable->id)) {
				/* для почты */
				if(!empty($data['postpay'])) {
					$userTable->redirect = 'paypostconfirm';	
				}
				
				if(empty($data['postpay'])) {
					$userTable->uniqid = base64_encode($userTable->uniqid);
				} else {
					/* для почты */
					$userTable->uniqid = $data['postpay'];
				}

				return $userTable;
			} else {
				return true;		
			}
		
	}

	/**
	 * 
	 * @ yandex money notify and update status
	 *   payment in table #__ejoshop_payd
	 */
	function notifyurlyandexm($payment = '')
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db		= JFactory::getDBO();
		$data = JRequest::get( 'post' );
		$user 		= JFactory::getUser();

		$paydate = gmdate('Y-m-d H:i:s');
		$p = $this->getPayments(1);
		$s = $p->secretkeyfornotifyym;
		// required such order
		// notification_type&operation_id&amount&currency&datetime&sender&codepro&notification_secret&label
		
		$str = 	$_POST['notification_type'].'&'.
				$_POST['operation_id'].'&'.
				$_POST['amount'].'&'.
				$_POST['currency'].'&'.
				$_POST['datetime'].'&'.
				$_POST['sender'].'&'.
				$_POST['codepro'].'&'.
				$s.'&'.
				$_POST['label'];
		
		if($_POST['sha1_hash'] == sha1($secret) && !empty($_POST['label'])) {
				$row = $this->getTable('ejoshopPayd', 'Table');
				$user 		= JFactory::getUser();
				
				$payddata['payer'] = $user->get('id', 0);
				$payddata['created'] = gmdate('Y-m-d H:i:s');
				$payddata['moneysystem'] = 'yandexmoney';
				$payddata['amount'] = $_POST['amount'];
				$payddata['payid'] = $_POST['label'];
				$payddata['status'] = 1;
				
				if(!empty($_POST['currency'])) {
					if($_POST['currency'] == 643) $_POST['currency'] = 'RUB';	
					$payddata['cur'] =  $_POST['currency'];
				
				}
				
				try {
					$row->bind($payddata);
					$row->store();
				} catch (RuntimeException $e) {
					print $e->getMessage();
				}
		}

		return true;
	}
	


	/**
	 * 
	 * Pay From Yandex Money
	 */
	function PayFromYandexMoney($payer = '', $pids, $lastpay = 0)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db		= JFactory::getDBO();
		$data 	= JRequest::get( 'post' );
		$user 	= JFactory::getUser();
		ejoshopimport('ejoshop.render.rendercart');
		$application = JFactory::getApplication();		
		$paydate = gmdate('Y-m-d H:i:s');
		/* UPDATE CART ITEMS STATUS CHANGE */	
		$userproduct = json_decode($_SESSION['cart']);
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}
				
				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set paystatus = '1', moneysystem = 'yandexmoney', status = 'pay', payerbill ='".$payer."',  payid ='".$lastpay."', paydate = '".$paydate."' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
						. ".`pid` IN (".  implode(',', $pids).");";
					$db->setQuery($query);
					if (!$db->query()) {
						$this->setError($this->_db->getErrorMsg());
						return false;
					}

					EjoshopRenderCart::flushCart();	
					EjoshopRenderCart::sendEmail();
					$application->enqueueMessage(JText::_('COM_EG_SUCCESS_FEE_RECEIVED'), 'message');	
		}
		return true;
	}


	/**
	 * 
	 * Pay From Yandex Money
	 */
	function PayFromAnet($payer = '', $pids, $lastpay = 0)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db		= JFactory::getDBO();
		$data 	= JRequest::get( 'post' );
		$user 	= JFactory::getUser();
		ejoshopimport('ejoshop.render.rendercart');
		$application = JFactory::getApplication();		
		$paydate = gmdate('Y-m-d H:i:s');
		/* UPDATE CART ITEMS STATUS CHANGE */	
		$userproduct = json_decode($_SESSION['cart']);
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}
				
				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set paystatus = '1', moneysystem = 'anet', status = 'pay', payerbill ='".$payer."',  payid ='".$lastpay."', paydate = '".$paydate."' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
						. ".`pid` IN (".  implode(',', $pids).");";
					$db->setQuery($query);
					if (!$db->query()) {
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
					$analytics = new EjoshopAnalytics();
					$analytics->updateUserPurchase();
					EjoshopRenderCart::flushCart();	
					EjoshopRenderCart::sendEmail();
		}
		return true;
	}

	/**
	 * 
	 * Pay From Plugin Payment
	 */
	function PayFromPlugin($payer = '', $pids, $lastpay = 0,$psystem)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db		= JFactory::getDBO();
		$data 	= JRequest::get( 'post' );
		$user 	= JFactory::getUser();
		ejoshopimport('ejoshop.render.rendercart');
		$application = JFactory::getApplication();		
		$paydate = gmdate('Y-m-d H:i:s');
		/* UPDATE CART ITEMS STATUS CHANGE */	
		$userproduct = json_decode($_SESSION['cart']);
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}
				
				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set paystatus = '1', moneysystem = '".$psystem."', status = 'pay', payerbill ='".$payer."',  payid ='".$lastpay."', paydate = '".$paydate."' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
						. ".`pid` IN (".  implode(',', $pids).");";
					$db->setQuery($query);
					if (!$db->query()) {
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
					$analytics = new EjoshopAnalytics();
					$analytics->updateUserPurchase();
					EjoshopRenderCart::flushCart();	
					EjoshopRenderCart::sendEmail();
		}
		return true;
	}
	
	/**
	 * 
	 * 
	 */
	function getCartItem($pid = 0)
	{

		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		$sid = session_id();
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));

				
		$query->select(
			$this->getState(
				'list.select',
				'catritem.*'
			)
		);
		
				

		$query->from('`#__ejoshop_shop_order` AS catritem');
		$query->select('catritem.*,cat.title as category_name,photos.*,fm.*');
		$query->join('LEFT', '#__ejoshop_photos AS photos ON (photos.id = catritem.photo_id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		

		if(!empty($_SESSION['cart'])) {
			$userproduct = json_decode($_SESSION['cart']);
		}
		
		$userproduct = empty($userproduct) ? array() : $userproduct;
		foreach($userproduct as $key => $val) {
			if(empty($userproduct[$key])) { unset($userproduct[$key]);}
		}
		if(!empty($_SESSION['cartid'])) {
			$query->where(array('catritem.pid IN ('.  implode(',', $userproduct).') AND catritem.created_by = \''.$_SESSION['cartid'].'\' AND catritem.sid = \''.$sid.'\''));
		}
		
		$this->params = JComponentHelper::getParams('com_ejoshop');
		$devmode = $this->params->get('developer_mode',0);

		if($devmode) {
			ejoshopimport('ejoshop.developer.developer');
			EjoshopDeveloper::debugPrint($userproduct);
			
		}
		
		if(empty($userproduct)) return false;
		$query->order($db->escape('catritem.pid'.' DESC'));
		$query = $db->setQuery( $query );
		$this->cartitems = $db->loadObjectList();
		
		$this->cartitems = empty($this->cartitems) ? array() : $this->cartitems;
		return $this->cartitems;
		

	}


	function getPager()
	{
		$app = JFactory::getApplication(); 
		
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		$db->setQuery("SELECT COUNT(*) FROM `#__ejoshop_categories` AS cats LEFT JOIN `#__ejoshop_categories` AS a 				
					   ON (a.id = cats.id) WHERE cats.published =1");
		$total = $db->loadResult();
	
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('ejoshop.limitstart', 'limitstart', 0, 'int');
		

		$page = new JPagination($total, $limitstart, $limit);
		return $page->getListFooter();
	}
	
	
	/**
	 * 
	 * @return array
	 */
	function getuserInfo()
	{
		
			$user = JFactory::getUser();
			//$pids = $_POST['item_id'];
			
			if($user->id > 0) {
				$userID = $user->id;
			}
			if(!$user->id) {
				if(!empty($_SESSION['cartid'])) {	
					$userID = $_SESSION['cartid'];
				} 
			}
			
			if(empty($userID)) return false;

			$db = $this->getDBO();
			$query = "SELECT * FROM ".$db->quoteName('#__ejoshop_userinfo_cart') 
			." WHERE ".$db->quoteName('uid')." = '".$userID."'";
			$db->setQuery($query);
			$this->userdata = $db->loadObjectList();
			
			if(empty($this->userdata)) {
				$query = "SELECT * FROM ".$db->quoteName('#__users') 
				." WHERE ".$db->quoteName('id')." = '".$userID."'";
				$db->setQuery($query);
				$this->userdata = $db->loadObjectList();
			}
			
		// return the foobar data
		return $this->userdata;
	
	}

}