<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component 
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modellist');
jimport('joomla.html.pagination');
ejoshopimport('ejoshop.render.rendersales');
ejoshopimport('ejoshop.developer.developer');
ejoshopimport('ejoshop.fields.fields');
class EjoshopModelCategory extends JModelList
{


	function __construct() {
	
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'id', 'photos.id',
				'name', 'photos.name',
				'created', 'photos.created',
				'price', 'photos.price',

			);
		}

		parent::__construct($config);

		$id = JRequest::getInt('id');
	
		$this->setId((int)$id);
		
	}
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * return	void
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initiliase variables.
		$app	= JFactory::getApplication('site');
		$pk		= JRequest::getInt('id');

		$this->setState('category.id', $pk);

		// Load the parameters. Merge Global and Menu Item params into new object
		$params = $app->getParams();
		$menuParams = new JRegistry;

		if ($menu = $app->getMenu()->getActive()) {
			$menuParams->loadString($menu->params);
		}

		$mergedParams = clone $menuParams;
		$mergedParams->merge($params);

		$this->setState('params', $mergedParams);
		$user		= JFactory::getUser();
				// Create a new query object.
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		$groups	= implode(',', $user->getAuthorisedViewLevels());



		// Optional filter text
		$this->setState('list.filter', JRequest::getString('filter-search'));

		// filter.order
		$itemid = JRequest::getInt('id', 0) . ':' . JRequest::getInt('Itemid', 0);
		$orderCol = $app->getUserStateFromRequest('com_ejoshop.category.list.' . $itemid . '.filter_order', 'filter_order', '', 'string');
;
		if (!in_array($orderCol, $this->filter_fields)) {
			$orderCol = 'photos.id';
		}
		$this->setState('list.ordering', $orderCol);

		$listOrder = $app->getUserStateFromRequest('com_ejoshop.category.list.' . $itemid . '.filter_order_Dir',
			'filter_order_Dir', '', 'cmd');
		if (!in_array(strtoupper($listOrder), array('ASC', 'DESC', ''))) {
			$listOrder = 'ASC';
		}
		$this->setState('list.direction', $listOrder);

		$this->setState('list.start', JRequest::getUInt('limitstart', 0));
		
	


		$this->setState('list.limit', 20);



	}

	
	function setId($id){
		$this->_id = $id;
		
	
	}
	/**
	 * Myextensions data array
	 *
	 * @var array
	 */
	var $_foobar;


	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$query = ' SELECT * '
			. ' FROM #__map_yandex WHERE id ="'.(int)$this->_id.'"';

		return $query;
	}


	function hit()
	{

		$db = JFactory::getDBO();
		$db->setQuery('UPDATE '.$db->quoteName('#__map_yandex')
		.'SET '.$db->quoteName('hits').' = '.$db->quoteName('hits').' + 1 '.'WHERE id = '.$this->_id);
		$db->query();
	}
	

	
	function getCategories($t = '')
	{
		
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		$query->select(
			$this->getState(
				'list.select',
				'cats.*'
			)
		);
		$query->from('`#__ejoshop_categories` AS cats');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','cats.id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		$this->catid = JRequest::getVar('catid');
		
		if(!empty($this->catid) && empty($t)) {
			$query->where(array("cats.id = '".$this->catid."'"));
		}
		$query->order($db->escape($orderCol.' '.$orderDirn));
		$query = $db->setQuery( $query, $limitstart, $limit );
		if(!empty($this->catid)) {
			$this->categories = $db->loadObject();
		} else {
			$this->categories = $db->loadObjectList();
			foreach($this->categories as $key => $cat) {
			//var_dump($this->categories[$key]);
			$this->categories[$key]->slug = $this->categories[$key]->catid . ':' . $this->categories[$key]->alias;
			}
		}
		

	
		return $this->categories;

	}
	
	
	function getSubCategory() {
	
		$app	= JFactory::getApplication();
		$params	= $app->getParams();
		//$category_ordering	= $params->get( 'category_ordering', 1 );
		//$categoryOrdering 	= PhocaGalleryOrdering::getOrderingString($category_ordering, 2);
		

		//$query = 'SELECT c.*, COUNT(photos.id) countimage' ... Cannot be used because get error if there is no image
		//$query = 'SELECT cc.*, photos.filename, photos.extm, photos.exts, photos.extw, photos.exth'
		$query = 'SELECT cc.*,cc.alias as catalias, photos.*'
			.' FROM #__ejoshop_categories AS cc'
			.' LEFT JOIN #__ejoshop_photos AS photos ON cc.id = photos.catid'
			.' WHERE cc.parent_id = '.(int) $this->_id
			.' AND cc.published = 1'
			.' AND photos.state = 1'
			.' AND cc.id <> '.(int) $this->_id
		//	.' AND countimage > 0'
		//	.' AND (SELECT COUNT(photos.id) AS countimage'
		//	.' FROM #__phocagallery as a'
        //	.' WHERE photos.catid = c.id' 
        //	.' AND photos.published = 1) > 0'
			.' GROUP BY cc.id';
			//.$categoryOrdering['output'];
			
		
		$this->_db->setQuery($query);
	
		$subCategory = $this->_db->loadObjectList();
		

		return $subCategory;
	}
		
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function confirmcart($pid = 0)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db	  = JFactory::getDBO();
		$data = JRequest::get( 'post' );
		$user = JFactory::getUser();
		$row->uid = $user->get('id', 0);
		$row = $this->getTable('cart', 'Table');
			// Create the timestamp for the date
		$row->created = gmdate('Y-m-d H:i:s');
		// Bind the form fields to the Phoca gallery table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
	
			return false;
		}
		// Store the Phoca gallery table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
		}
		
		/* UPDATE CART ITEMS STATUS CHANGE */	
		$userproduct = json_decode($_SESSION['cart']);
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}

				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set status = 'confirm', created_by = '".$row->id."' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
					. ".`pid`IN (".  implode(',', $userproduct).");";
				$db->setQuery($query);
				if (!$db->query()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				unset($_SESSION['cart']);
		}
		return true;
	}
	
	
	function getPager($onlytotal = FALSE)
	{
		$catid = JRequest::getVar('id', 0, '', 'int'); //?
		$view = JRequest::getVar('view');
		//var_dump($view);
		$app = JFactory::getApplication(); 
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		
		$params = $app->getParams();
				

		$query->from('`#__ejoshop_photos` AS photos');	
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->select('COUNT(*)');
		
		$FieldsClass = new EjoshopFields();
		$joinfields = $FieldsClass->getFieldsForJoin();
		foreach($joinfields as $join) {
			$query->select('`'.$join['field_name'].'`.*');
			$query->join('LEFT', $join['field_table_name'] . ' AS `'.$join['field_name'].'` ON (photos.id = '.$join['field_name'].'.entity_id)');
			
		}
		
		$show_sub_cat_include = $params->get('show_sub_cat_include',0);
		
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $this->getState('list.start', 0);
		
		if (is_numeric($catid) && $show_sub_cat_include) {
		
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/tables');
			$cat_tbl = JTable::getInstance('Ejoshopcategories', 'Table');
			$cat_tbl->load($catid);
			$rgt = $cat_tbl->rgt;
			$lft = $cat_tbl->lft;

			$baselevel = (int) $cat_tbl->level;
			$query->where('cat.lft >= '.(int) $lft);
			$query->where('cat.rgt <= '.(int) $rgt);
			$query->where('photos.state = 1');
		} else {
			$query->where('cat.id = '.$catid.' AND photos.state = 1');
		}

		$query->where('cat.id != 1');
		$query->where('cat.published = 1');
	
		
		$cfieldfilter = JRequest::getVar('select_custom_filter_name');
		$cfieldfilter_value = JRequest::getVar('select_custom_filter_value');
		$customfilter_clear = JRequest::getVar('select_custom_filter_clear');
		if( !$cfieldfilter && !$customfilter_clear) {
			$cfieldfilter = !empty($_SESSION['cfieldfilter']) ? $_SESSION['cfieldfilter'] : '';
			$cfieldfilter_value = !empty($_SESSION['cfieldfilter_value']) ? $_SESSION['cfieldfilter_value'] : '';
		} else {
			$_SESSION['cfieldfilter'] = $cfieldfilter;
			$_SESSION['cfieldfilter_value'] = $cfieldfilter_value;
		}
		if(!empty($cfieldfilter) && $cfieldfilter_value) {
			$config = new JConfig();
		
			if($FieldsClass->checkTable($config->dbprefix.'ejoshop_'.$cfieldfilter)) {
			$table_field = str_replace('field_data_','',$cfieldfilter);
			$query->where("`" . $table_field."`.`".$table_field."_value` = '".$cfieldfilter_value."'");
			}
		}
		$db->setQuery( $query );
		$total = $db->loadResult();
		//var_dump($total);
		if($onlytotal) {
			return $total;
		} else {
			$page = new JPagination($total, $limitstart, $limit);
			return $page->getListFooter();
		}
	}

	
	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	 
	function getPhotos($catid = 0)
	{

		if(empty($catid)) {
			$site = new JSite();
			$menu = $site->getMenu();
				
			$items		= $menu->getItems('component', 'com_ejoshop');
			
			$active = $menu->getActive();
			//$view = (!empty($active->query['view'])) ? $active->query['view'] : JRequest::getVar('view');
			$view = JRequest::getVar('view');
	
			if($view == 'categories') {
				$catid = JRequest::getVar('catid', 0, '', 'int');
			} else if($view == 'category') {
				$catid = JRequest::getVar('id', 0, '', 'int');	
			}
		}
		
		//EjoshopDeveloper::debugPrint(JRequest::get());
		
		
		$app = JFactory::getApplication(); 
		//JAccess::getAuthorisedViewLevels($userId)
		
		$user		= JFactory::getUser();

	
		
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$params = $app->getParams();
		$show_sub_cat_include = $params->get('show_sub_cat_include',0);
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('ejoshop.limitstart', 'limitstart', 0, 'int');
		
	
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
				

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name,cat.id as category_id,cat.alias as catalias,cat.description as catdescription, fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		$query->select('ag.title AS access_level');
		$query->join('LEFT', '#__viewlevels AS ag ON ag.id = photos.access');
		
		$FieldsClass = new EjoshopFields();
		$joinfields = $FieldsClass->getFieldsForJoin();
		foreach($joinfields as $join) {
			
			$set = $FieldsClass->getFieldssettings($join);
			
			$query->select('`'.$join['field_name'].'`.*');
			$query->join('LEFT', $join['field_table_name'] . ' AS `'.$join['field_name'].'` ON (photos.id = '.$join['field_name'].'.entity_id)');
			
		}
		
		// Filter by a single or group of categories.

		$baselevel = 1;
		
		if (is_numeric($catid) && $show_sub_cat_include) {
		
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/tables');
			$cat_tbl = JTable::getInstance('Ejoshopcategories', 'Table');
			$cat_tbl->load($catid);
			$rgt = $cat_tbl->rgt;
			$lft = $cat_tbl->lft;

			$baselevel = (int) $cat_tbl->level;
			$query->where('cat.lft >= '.(int) $lft);
			$query->where('cat.rgt <= '.(int) $rgt);
			$query->where('photos.state = 1');
		} else {
			$query->where('cat.id = '.$catid.' AND photos.state = 1');
		}
		$search = $this->state->get('list.filter');
		
		if(!empty($search)) {
		
			$query->where("photos.name LIKE '%".$search."%' or photos.intro LIKE '%".$search."%'");
		}
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','photos.id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		
		$cfieldfilter = JRequest::getVar('select_custom_filter_name');
		$cfieldfilter_value = JRequest::getVar('select_custom_filter_value');
		$customfilter_clear = JRequest::getVar('select_custom_filter_clear');
		if( !$cfieldfilter && !$customfilter_clear) {
			$cfieldfilter = !empty($_SESSION['cfieldfilter']) ? $_SESSION['cfieldfilter'] : '';
			$cfieldfilter_value = !empty($_SESSION['cfieldfilter_value']) ? $_SESSION['cfieldfilter_value'] : '';
		} else {
			$_SESSION['cfieldfilter'] = $cfieldfilter;
			$_SESSION['cfieldfilter_value'] = $cfieldfilter_value;
		}
		if(!empty($cfieldfilter) && $cfieldfilter_value) {
			$table_field = str_replace('field_data_','',$cfieldfilter);
			$config = new JConfig();
	
			if($FieldsClass->checkTable($config->dbprefix.'ejoshop_'.$cfieldfilter)) {
				
				$table_field = str_replace('field_data_','',$cfieldfilter);
				$query->where("`" . $table_field."`.`".$table_field."_value` = '".$cfieldfilter_value."'");
			}
		}
		/* check access views levels 1 - guest 2 - regisered 3 - admin */
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$query->where("photos.access IN(".$groups.")");
		
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		//echo nl2br(str_replace('#__','jos_',$query));
		//die();
		//$checktotal = $this->getPager(TRUE);
		//var_dump($checktotal);
		$pagercheck = JRequest::getUInt('limitstart', 0);
		if(!$pagercheck) {
			$limitstart = 0;
		}
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->photos = $db->loadObjectList();
		
		/* добавляем распродажи к шаблону */
		$salesClass = new EjoshopRenderSales();
		//var_dump($this->photos);
		$sales = $salesClass->getSales($catid);
		$this->photos = $salesClass->appendSales($this->photos,$sales);
		/* добавляем распродажи к шаблону */
	
		return $this->photos;

	}


}
