<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop Component
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modelitem');
ejoshopimport('ejoshop.developer.developer');

class EjoshopModelDetail extends JModelItem
{

	function __construct() {
		parent::__construct();
		$id = JRequest::getInt('pid');
		$this->setId((int)$id);
		
	}
	
	function setId($id){
		$this->_id = $id;
		
	
	}
	/**
	 * Myextensions data array
	 *
	 * @var array
	 */
	var $_foobar;


	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$query = ' SELECT * '
			. ' FROM #__map_yandex WHERE id ="'.(int)$this->_id.'"';

		return $query;
	}


	function hit()
	{

		$db = JFactory::getDBO();
		$db->setQuery('UPDATE '.$db->quoteName('#__map_yandex')
		.'SET '.$db->quoteName('hits').' = '.$db->quoteName('hits').' + 1 '.'WHERE id = '.$this->_id);
		$db->query();
	}

	/**
	 * 
	 * @возвращает список строк в файл view.html.php
	 */
	function getPhotos($catid = 0, $module = FALSE)
	{
		if(empty($catid)) {
			$catid = JRequest::getVar('id', 0, '', 'int');
		}
		$user = JFactory::getUser();
		$app = JFactory::getApplication(); 
		$jinput = $app->input; 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
				

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name,cat.id as category_id,cat.alias as catalias, fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');

		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','photos.id');
		$orderDirn	= $this->state->get('list.direction','DESC');

		if(isset($catid)) {
	
			$query->where('photos.id = '.(int) $catid.' AND photos.state = 1');
		}
		
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$query->where("photos.access IN(".$groups.")");
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		
		if(!$module) {
			$query = $db->setQuery( $query, $limitstart, $limit );
		} else {
			$query = $db->setQuery( $query );
		}
		
		$this->photos = $db->loadObjectList();

		/* onephoto */
			$p = $this->photos[0];
			$query = $db->getQuery(true);
			$query->select("fm.*");
			$query->from('`#__ejoshop_file_managed` as fm');
			$query->where("fm.fpid = '".$p->id."' AND fm.type='onephoto'");
			$query = $db->setQuery($query);
			$this->existfile = $db->loadObject();
		
			if($this->existfile) {
				$this->photos[0]->opimagestyle = $this->existfile->imagestyle;
				$this->photos[0]->onephoto = $this->existfile->filename;
				$this->photos[0]->onephotouri = $this->existfile->uri;
			}
		/* onephoto */	

		return $this->photos;

	}
	
	
	
	/**
	 * 
	 * @возвращает список дополнительных фото
	 */
	 
	function getOtherPhotos($pid = 0)
	{
		if(empty($pid)) {
			$pid = JRequest::getVar('pid', 0, '', 'int');
		}
		
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->select('fm.*');
		$query->from('`#__ejoshop_file_managed` AS fm');
		if(isset($pid)) {
	
			$query->where("fm.fpid = '".(int) $pid."' AND fm.status = 1 AND type='ophoto'");
		}

		$query = $db->setQuery( $query );
		$this->photos = $db->loadObjectList();

		return $this->photos;

	}
	
	function getCategories($t = '')
	{

		
	
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		$query->select(
			$this->getState(
				'list.select',
				'cats.*'
			)
		);
		$query->from('`#__ejoshop_categories` AS cats');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','cats.id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		$this->catid = JRequest::getVar('catid');
		if(!$this->catid) {
			$js		= new JSite();
			$menu = $js->getMenu();	
			$item = $menu->getActive();
			$this->catid = $item->query['id'];	
	
		}
		if(!empty($this->catid) && empty($t)) {
				
			$query->where(array("cats.id = '".$this->catid."'"));
		}
		$query->where('cats.id != 1');
		$query->where('cats.published = 1');
		$query->order($db->escape($orderCol.' '.$orderDirn));
		$query = $db->setQuery( $query );
		if(!empty($this->catid)) {
			$this->categories = $db->loadObject();
		} else {
			$this->categories = $db->loadObjectList();
			foreach($this->categories as $key => $cat) {
			//var_dump($this->categories[$key]);
			$this->categories[$key]->slug = $this->categories[$key]->id . ':' . $this->categories[$key]->id;
			}
		}
		

	
		return $this->categories;

	}

	/**
	 * 
	 *
	 * 
	 */
	 
	function getComments($pid = 0)
	{

		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}


		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
				
	
		$query = 'SELECT c . *, CONCAT_WS(" ",p1,p2,p3,p4,p5,p6,p7,p8,p9) as cwsp
				FROM #__ejoshop_comments c
				WHERE (
				c.comment_name = \'allcomment\' AND c.pid = '.$pid.'
				) 
				ORDER BY p1 ASC , p2 ASC , p3 ASC , p4 ASC , p5 ASC , p6 ASC , p7 ASC , p8 ASC , p9 ASC';
				

		$query = $db->setQuery( $query );
		$this->comments = $db->loadObjectList();
		
		$this->comments = empty($this->comments) ? array() : $this->comments;
		if(!empty($this->comments)) {
			foreach($this->comments as $key => $comment) {
				$this->comments[$key]->gravatar = $this->get_gravatar($comment->useremail);
			}
		}
		return $this->comments;
		

	}
	
	
	function get_gravatar( $email, $s = 20, $d = 'mm', $r = 'g', $img = true, $atts = array()) {
		
		
		$url = 'http://www.gravatar.com/avatar/';
		$url .= md5( strtolower( trim( $email ) ) );
		$url .= "?s=$s&d=$d&r=$r";
		if ( $img ) {
			$url = '<img src="' . $url . '"';
			foreach ( $atts as $key => $val )
				$url .= ' ' . $key . '="' . $val . '"';
			$url .= ' />';
		}
		
		
		

		return $url;
	}
}