<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component 
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.modellist');
jimport('joomla.html.pagination');
ejoshopimport('ejoshop.render.rendersales');
ejoshopimport('ejoshop.render.renderinfo');
ejoshopimport( 'ejoshop.developer.developer' );

class EjoshopModelUseraccount extends JModelList
{


	function __construct() {
		parent::__construct();
		$id = JRequest::getInt('id');
	
		$this->setId((int)$id);
		
	}
	
	function setId($id){
		$this->_id = $id;
		
	
	}
	/**
	 * Myextensions data array
	 *
	 * @var array
	 */
	var $_foobar;
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');

		// Load the filter state.
		$search = $app->getUserStateFromRequest('filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$access = $this->getUserStateFromRequest($this->context.'.filter.access', 'filter_access', 0, 'int');
		$this->setState('filter.access', $access);

		$authorId = $app->getUserStateFromRequest($this->context.'.filter.author_id', 'filter_author_id');
		$this->setState('filter.author_id', $authorId);

		$published = $this->getUserStateFromRequest($this->context.'.filter.published', 'filter_published', '');
		$this->setState('filter.published', $published);

		$categoryId = $this->getUserStateFromRequest($this->context.'.filter.category_id', 'filter_category_id');
		$this->setState('filter.category_id', $categoryId);

		$level = $this->getUserStateFromRequest($this->context.'.filter.level', 'filter_level', 0, 'int');
		$this->setState('filter.level', $level);


		$language = $this->getUserStateFromRequest($this->context.'.filter.language', 'filter_language', '');
		$this->setState('filter.language', $language);


		// List state information.
		parent::populateState('photos.id', 'desc');
	}

	protected function getListQuery()
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!isset($limit)) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
		$allend = JRequest::getVar( 'allend' );	

		$query->from('`#__ejoshop_shop_order` AS orders');
		$query->select('orders.*,cat.title as category_name');
		$query->join('INNER', '#__ejoshop_photos AS photos ON (photos.id = orders.photo_id)');
		if($allend) {
			$query->select('payd.cur');
			$query->join('INNER', '#__ejoshop_payd AS payd ON (payd.payid = orders.payid)');
		}
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');



		
		$search = $this->getState('filter.search');
	
		
		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}		
		// Add the list ordering clause.
		$orderCol	= 'orders.pid';
		$orderDirn	= $this->state->get('list.direction','DESC');
		// Filter by access level.
		if ($access = $this->getState('filter.access')) {
			$query->where('photos.access = ' . (int) $access);
		}

		if(isset($pid)) {
			$query->where('photos.id = '.(int) $pid);
		}
		// Filter by published state
		$published = $this->getUserStateFromRequest('filter.published', 'filter_published', '');
		
	
		if (is_numeric($published)) {
			$query->where('photos.state = ' . (int) $published);
		}
		elseif ($published === '') {
			$query->where('(photos.state = 0 OR photos.state = 1)');
		}
		$user	= JFactory::getUser();


		if(!$allend) {
			$query->where("orders.status IN ('cart', 'confirm')");
		} else {
			$query->where("orders.status IN ('pay', 'closed', 'paywithpost', 'paywithbill')");
		}
		if($user->get('id'))  {
			$query->where('(orders.created_by = '.$user->get('id').')');
		}
		
	
		$query->order($db->escape($orderCol.' '.$orderDirn));
 		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
		return $query;
	}
	
	public function getUserInfo()
	{
		$info = new EjoshopRenderInfo;
		$info = $info->getUserInfoFromCartData();
		return $info;
	}


	
	
	public function getItems()
	{
		$items	= parent::getItems();

	
		$app	= JFactory::getApplication();
		if ($app->isSite()) {
			$user	= JFactory::getUser();
			$groups	= $user->getAuthorisedViewLevels();

			for ($x = 0, $count = count($items); $x < $count; $x++) {
				//Check the access level. Remove articles the user shouldn't see
				if (!in_array($items[$x]->access, $groups)) {
					unset($items[$x]);
				}
			}
		}
		return $items;
	}
	
	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$query = ' SELECT * '
			. ' FROM #__map_yandex WHERE id ="'.(int)$this->_id.'"';

		return $query;
	}


	
	function getCategories($t = '')
	{
	
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
	
		$query->select(
			$this->getState(
				'list.select',
				'cats.*'
			)
		);
		$query->from('`#__ejoshop_categories` AS cats');
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','cats.id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		$this->catid = JRequest::getVar('catid');
		
		if(!empty($this->catid) && empty($t)) {
			$query->where(array("cats.id = '".$this->catid."'"));
		}
		$query->order($db->escape($orderCol.' '.$orderDirn));
		$query = $db->setQuery( $query, $limitstart, $limit );
		if(!empty($this->catid)) {
			$this->categories = $db->loadObject();
		} else {
			$this->categories = $db->loadObjectList();
			foreach($this->categories as $key => $cat) {
			//var_dump($this->categories[$key]);
			$this->categories[$key]->slug = $this->categories[$key]->catid . ':' . $this->categories[$key]->alias;
			}
		}
		

	
		return $this->categories;

	}
	
	
	function getSubCategory() {
	
		$app	= JFactory::getApplication();
		$params	= $app->getParams();
		//$category_ordering	= $params->get( 'category_ordering', 1 );
		//$categoryOrdering 	= PhocaGalleryOrdering::getOrderingString($category_ordering, 2);
		
		
		//$query = 'SELECT c.*, COUNT(a.id) countimage' ... Cannot be used because get error if there is no image
		//$query = 'SELECT cc.*, a.filename, a.extm, a.exts, a.extw, a.exth'
		$query = 'SELECT cc.*,cc.alias as catalias, a.*'
			.' FROM #__ejoshop_categories AS cc'
			.' LEFT JOIN #__ejoshop_photos AS a ON cc.id = a.catid'
			.' WHERE cc.parent_id = '.(int) $this->_id
			.' AND cc.published = 1'
			.' AND a.state = 1'
			.' AND cc.id <> '.(int) $this->_id
		//	.' AND countimage > 0'
		//	.' AND (SELECT COUNT(a.id) AS countimage'
		//	.' FROM #__phocagallery as a'
        //	.' WHERE a.catid = c.id' 
        //	.' AND a.published = 1) > 0'
			.' GROUP BY cc.id';
			//.$categoryOrdering['output'];
			
		$this->_db->setQuery($query);
	
		$subCategory = $this->_db->loadObjectList();
	
		return $subCategory;
	}
		
	/**
	 * 
	 * @     view.html.php
	 */
	function confirmcart($pid = 0)
	{
		/* ADD USER INFO AFTER CONFIRM ORDER */
		$db	  = JFactory::getDBO();
		$data = JRequest::get( 'post' );
		$user = JFactory::getUser();
		$row->uid = $user->get('id', 0);
		$row = $this->getTable('cart', 'Table');
			// Create the timestamp for the date
		$row->created = gmdate('Y-m-d H:i:s');
		// Bind the form fields to the Phoca gallery table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
	
			return false;
		}
		// Store the Phoca gallery table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
		}
		
		/* UPDATE CART ITEMS STATUS CHANGE */	
		$userproduct = json_decode($_SESSION['cart']);
		if(!empty($userproduct)) {
			foreach($userproduct as $key => $val) {
				if(empty($userproduct[$key])) { unset($userproduct[$key]);}
			}

				$query = "UPDATE " . $db->quoteName('#__ejoshop_shop_order') 
					. " set status = 'confirm', created_by = '".$row->id."' WHERE " . $db->quoteName('#__ejoshop_shop_order') 
					. ".`pid`IN (".  implode(',', $userproduct).");";
				$db->setQuery($query);
				if (!$db->query()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				unset($_SESSION['cart']);
		}
		return true;
	}
	
	
	function getPager()
	{
		if(empty($pid)) {
			$pid = JRequest::getVar( 'id' );
		}
		
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		
		if(!isset($limit)) $limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		$limitstart = JRequest::getVar('limitstart', 0);
		
				
		$query->select('COUNT(*)');
		
				

		$query->from('`#__ejoshop_shop_order` AS orders');
		$query->select('orders.*,cat.title as category_name');
		$query->join('INNER', '#__ejoshop_photos AS photos ON (photos.id = orders.photo_id)');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');



		
		$search = $this->getState('filter.search');
	
		
		if (!empty($search))
		{

				$search = $db->Quote('%'.$db->escape($search, true).'%');
				$query->where('( photos.name LIKE '.$search.' OR photos.intro LIKE '.$search.')');
			
		}		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','photos.id');
		$orderDirn	= $this->state->get('list.direction','DESC');
		// Filter by access level.
		if ($access = $this->getState('filter.access')) {
			$query->where('photos.access = ' . (int) $access);
		}

		if(isset($pid)) {
			$query->where('photos.id = '.(int) $pid);
		}
		// Filter by published state
		$published = $this->getUserStateFromRequest('filter.published', 'filter_published', '');
		
	
		if (is_numeric($published)) {
			$query->where('photos.state = ' . (int) $published);
		}
		elseif ($published === '') {
			$query->where('(photos.state = 0 OR photos.state = 1)');
		}
		$user	= JFactory::getUser();

		
		$query->where("orders.status IN ('cart', 'confirm')");
		$query->where('(orders.created_by = '.$user->get('id').')');

	
		$query->order($db->escape($orderCol.' '.$orderDirn));
 		EjoshopDeveloper::debugQuery($query,__LINE__,__FILE__);
		$db->setQuery($query);
		
		
		$total = $db->loadResult();
	
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('ejoshop.limitstart', 'limitstart', 0, 'int');
		$page = new JPagination($total, $limitstart, $limit);
		return $page->getListFooter();
	}	
	/**
	 * 
	 * @     view.html.php
	 */
	function getPhotos($catid = 0)
	{
		if(empty($catid)) {
			$catid = JRequest::getVar('catid', 0, '', 'int');
		}
		
		
		$app = JFactory::getApplication(); 
		// Create a new query object.
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$params = $app->getParams();
		$show_sub_cat_include = $params->get('show_sub_cat_include',0);
		$limit = $app->getUserStateFromRequest('ejoshop.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('ejoshop.limitstart', 'limitstart', 0, 'int');
		
				
		$query->select(
			$this->getState(
				'list.select',
				'photos.*'
			)
		);
		
				

		$query->from('`#__ejoshop_photos` AS photos');
		$query->select('cat.title as category_name,cat.id as category_id,cat.alias as catalias,cat.description as catdescription,fm.*');
		$query->join('LEFT', '#__ejoshop_categories AS cat ON (photos.catid = cat.id)');
		$query->join('LEFT', '#__ejoshop_file_managed AS fm ON (photos.filename = fm.fid)');
		
		// Filter by a single or group of categories.

		$baselevel = 1;
		if (is_numeric($catid) && $show_sub_cat_include) {
			EjoshopModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/tables');
			$cat_tbl = JTable::getInstance('Ejoshopcategories', 'Table');
			$cat_tbl->load($catid);
			$rgt = $cat_tbl->rgt;
			$lft = $cat_tbl->lft;

			$baselevel = (int) $cat_tbl->level;
			$query->where('cat.lft >= '.(int) $lft);
			$query->where('cat.rgt <= '.(int) $rgt);
			$query->where('photos.state = 1');
		} else {
			$query->where('cat.id = '.$catid.' AND photos.state = 1');
		}
		
		
		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering','photos.id');
		$orderDirn	= $this->state->get('list.direction','DESC');

	
		
		$query->order($db->escape($orderCol.' '.$orderDirn));
		// echo nl2br(str_replace('#__','jos_',$query));
		
		$query = $db->setQuery( $query, $limitstart, $limit );
		$this->photos = $db->loadObjectList();
		/*     */
		$salesClass = new EjoshopRenderSales();
		//var_dump($this->photos);
		$sales = $salesClass->getSales($catid);
		$this->photos = $salesClass->appendSales($this->photos,$sales);
		/*     */
		return $this->photos;

	}


}
