<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ermakovshop.com
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

 jimport('joomla.application.categories');

 
function EjoshopBuildRoute(&$query)
{

$segments	= array();

	// get a menu item based on Itemid or currently active
	$app		= JFactory::getApplication();
	$menu		= $app->getMenu();
	$params		= JComponentHelper::getParams('com_ejoshop');
	$advanced	= $params->get('sef_advanced_link', 0);

		$show_count_in_cart = $params->get('show_count_in_cart',0);
	
		if($show_count_in_cart) {
			
		
			$items		= $menu->getItems('component', 'com_ejoshop');

			foreach($items as $item) {
				if($item->query['option'] == 'com_ejoshop' && $item->query['view'] == 'cart') {
						
			
						$all = array();
						$_SESSION['cart'] = empty($_SESSION['cart']) ? array() : $_SESSION['cart'];
						$i = 0;
						$cart = array();
						if(!empty($_SESSION['cart'])) {
				
							$cart = json_decode($_SESSION['cart']);
						} else {
							
						}
						if($cart) {
							foreach($cart as $val) {
								++$i;
									$all[] = $val;
					
								
							}
						} else {
							$all = array();
						}	
						
						$c = count(array_unique($all));
					
						switch($c) {
							case 1:
							$t = JText::_('COM_EJ_CART_T');
							break;
							case in_array($c,array(2,3,4)):
							$t = JText::_('COM_EJ_CART_TRUS');
							break;
							case $c > 1:
							$t = JText::_('COM_EJ_CART_TS');
							break;
						}
						if($c) {
							$item->title = JText::_('COM_EJ_CART_S');
							$item->title = $item->title . ' ('.$c.' '.JText::_('COM_EJ_CART_ITEM').''.$t.')';
						} else {
								$item->title = JText::_('COM_EJ_CART_WITHOUT_S');
								$item->title = $item->title . ' ('.JText::_('COM_EJ_CART_EMPTY').')';					
						}
				}
				
			}
			
	
		}
		
	// we need a menu item.  Either the one specified in the query, or the current active one if none specified
	if (empty($query['Itemid'])) {
		$menuItem = $menu->getActive();
		$menuItemGiven = false;
	}
	else {
		$menuItem = $menu->getItem($query['Itemid']);
		$menuItemGiven = true;
	}

	if (isset($query['view'])) {
		$view = $query['view'];
	
	}
	else {
			
		// we need to have a view in the query or it is an invalid URL
		return $segments;
	}
	
	// are we dealing with an detail or category that is attached to a menu item?
	if (($menuItem instanceof stdClass) && $menuItem->query['view'] == $query['view'] && isset($query['id']) && $menuItem->query['id'] == intval($query['id'])) {
		unset($query['view']);

		if (isset($query['catid'])) {
			unset($query['catid']);
		}
		
		if (isset($query['layout'])) {
			unset($query['layout']);
		}

		unset($query['id']);

		return $segments;
	}

	if ($view == 'category' || $view == 'detail')
	{
	
		if (!$menuItemGiven) {
			//$segments[] = $view;
		}

		unset($query['view']);

		if ($view == 'detail') {
			if (isset($query['id']) && isset($query['catid']) && $query['catid']) {
				$catid = $query['catid'];
				// Make sure we have the id and the alias
				if (strpos($query['id'], ':') === false) {
					$db = JFactory::getDbo();
					$aquery = $db->setQuery($db->getQuery(true)
						->select('alias')
						->from('#__ejoshop_photos')
						->where('id='.(int)$query['id'])
					);
					$alias = $db->loadResult();
					$query['id'] = $query['id'].':'.$alias;
				}
			} else {
				// we should have these two set for this view.  If we don't, it is an error
				return $segments;
			}
		}
		else {
			if (isset($query['id'])) {
				$catid = $query['id'];
			} else {
	
				// we should have id set for this view.  If we don't, it is an error
				return $segments;
			}
		}

		if ($menuItemGiven && isset($menuItem->query['id'])) {
			$mCatid = $menuItem->query['id'];
		} else {
			$mCatid = 0;
		}

		$categories = JCategories::getInstance('ejoshop');
		$category = $categories->get($catid);

		if (!$category) {
			
			// we couldn't find the category we were given.  Bail.
			return $segments;
		}

		$path = array_reverse($category->getPath());

		$array = array();

		foreach($path as $id) {
			if ((int)$id == (int)$mCatid) {
				break;
			}
			
			list($tmp, $id) = explode(':', $id, 2);
		
			$array[] = $id;
		}
		
		$array = array_reverse($array);

		if (!$advanced && count($array)) {
			$array[0] = (int)$catid.':'.$array[0];
		}

		$segments = array_merge($segments, $array);

		if ($view == 'detail') {
			if ($advanced) {
				list($tmp, $id) = explode(':', $query['id'], 2);
			}
			else {
				$id = $query['id'];
			}
			$segments[] = $id;
		}
		
		unset($query['id']);
		unset($query['catid']);
	}
	if ($view == 'cart') {
			
		if (!empty($items) && is_array($items))
		{
			if (isset($item->query['view']) && $item->query['view'] == 'cart') {
				
				$itemid	= $item->id;
			} 
		}
	
		//ejoshopimport('ejoshop.developer.developer');
		
		//EjoshopDeveloper::debugPrint($query);
		if(!empty($itemid) && !empty($query['task']) && empty($query['module'])) {
			if(!$menuItemGiven) {
				$segments[] = $query['view'];
			}
			$segments[] = $query['task'];
			
		} else if (!empty($query['module'])) {
			
			if(!$menuItemGiven) {
				if(isset($query['Itemid'])) unset($query['Itemid']);
				$segments[] = $query['view'];
			}
			
			unset($query['module']);
		}  else {
			if(!$menuItemGiven) {
				$segments[] = $view;
			}

			if(!empty($query['task'])) $segments[] = $query['task'];
			
		}
		
		unset($query['task']);
		unset($query['view']);
		unset($query['catid']);
	}
	
	if ($view == 'archive') {
		if (!$menuItemGiven) {
			$segments[] = $view;
			unset($query['view']);
		}

		if (isset($query['year'])) {
			if ($menuItemGiven) {
				$segments[] = $query['year'];
				unset($query['year']);
			}
		}

		if (isset($query['year']) && isset($query['month'])) {
			if ($menuItemGiven) {
				$segments[] = $query['month'];
				unset($query['month']);
			}
		}
	}

	// if the layout is specified and it is the same as the layout in the menu item, we
	// unset it so it doesn't go into the query string.
	if (isset($query['layout'])) {
		if ($menuItemGiven && isset($menuItem->query['layout'])) {
			if ($query['layout'] == $menuItem->query['layout']) {

				unset($query['layout']);
			}
		}
		else {
			if ($query['layout'] == 'default') {
				unset($query['layout']);
			}
		}
	}
	
	//unset($query['Itemid']);
	return $segments;
}

/**
 * Method to parse for Cart view
 * @param array $segments
 */ 
function checkcart($segments,$item) {
	
	//
	
	if($item->query['view'] == 'cart' || $segments[0] == 'cart') {

		if(!empty($item->query['view']))
		$vars['view']	= $item->query['view'];
		if($segments[0] == 'cart') {	
			$vars['view'] = $segments[0];
			$vars['task']	= $segments[1];
		} else {
			$vars['task']	= $segments[0];
		}
	
		return $vars;
		
	} else {
		return false;
	}

}


/**
 * Method to parse Route
 * @param array $segments
 */ 
function EjoshopParseRoute($segments) {
			
	$vars = array();
	
	//Get the active menu item.
	$app	= JFactory::getApplication();
	$menu	= $app->getMenu();
	$item	= $menu->getActive();
	$params = JComponentHelper::getParams('com_ejoshop');
	$advanced = $params->get('sef_advanced_link', 0);
	$db = JFactory::getDBO();

	/*
		print '<pre>';
		print_r($menu->getDefault());
		print '</pre>';
	*/
	if(!$item) {
		$home = $menu->getDefault();
		$item = $menu->getItem($home->id);
	}
	
	// Count route segments
	$count = count($segments);
	$vars = checkcart($segments,$item);

	if($vars) {
		return $vars;
	}
	// Standard routing for details.  If we don't pick up an Itemid then we get the view from the segments
	// the first segment is the view and the last segment is the id of the detail or category.
	if (!isset($item)) {
	
		$vars['view']	= $segments[0];
		$vars['id']		= $segments[$count - 1];

		return $vars;
	}


		

	
	// if there is only one segment, then it points to either an detail or a category
	// we test it first to see if it is a category.  If the id and alias match a category
	// then we assume it is a category.  If they don't we assume it is an detail
	if ($count == 1) {
	
		// we check to see if an alias is given.  If not, we assume it is an detail
		if (strpos($segments[0], ':') === false) {
			$vars['view'] = 'detail';
			$vars['id'] = (int)$segments[0];
			return $vars;
		}

		list($id, $alias) = explode(':', $segments[0], 2);

		// first we check if it is a category
		$category = JCategories::getInstance('ejoshop')->get($id);



		if ($category && $category->alias == $alias) {
			$vars['view'] = 'category';
			$vars['id'] = $id;

			return $vars;
		} else {
			$query = 'SELECT alias, catid FROM #__ejoshop_photos WHERE id = '.(int)$id;
			$db->setQuery($query);
			$detail = $db->loadObject();

			if ($detail) {
				if ($detail->alias == $alias) {
					$vars['view'] = 'detail';
					$vars['catid'] = (int)$detail->catid;
					$vars['id'] = (int)$id;

					return $vars;
				}
			}
		}
	}

	// if there was more than one segment, then we can determine where the URL points to
	// because the first segment will have the target category id prepended to it.  If the
	// last segment has a number prepended, it is an detail, otherwise, it is a category.
	if (!$advanced) {
		$cat_id = (int)$segments[0];

		$detail_id = (int)$segments[$count - 1];

		if ($detail_id > 0) {
			$vars['view'] = 'detail';
			$vars['catid'] = $cat_id;
			$vars['id'] = $detail_id;
			
		} else {
			$vars['view'] = 'category';
			$vars['id'] = $cat_id;

		}

		return $vars;
	}

	// we get the category id from the menu item and search from there
	$id = $item->query['id'];
	$category = JCategories::getInstance('ejoshop')->get($id);

	if (!$category) {
		JError::raiseError(404, JText::_('com_ejoshop_ERROR_PARENT_CATEGORY_NOT_FOUND'));
		return $vars;
	}

	$categories = $category->getChildren();
	$vars['catid'] = $id;
	$vars['id'] = $id;
	$found = 0;

	foreach($segments as $segment)
	{
		$segment = str_replace(':', '-', $segment);

		foreach($categories as $category)
		{
			if ($category->alias == $segment) {
				$vars['id'] = $category->id;
				$vars['catid'] = $category->id;
				$vars['view'] = 'category';
				$categories = $category->getChildren();
				$found = 1;
				break;
			}
		}

		if ($found == 0) {
			if ($advanced) {
				$db = JFactory::getDBO();
				$query = 'SELECT id FROM #__ejoshop_photos WHERE catid = '.$vars['catid'].' AND alias = '.$db->Quote($segment);
				$db->setQuery($query);
				$cid = $db->loadResult();
			} else {
				$cid = $segment;
			}

			$vars['id'] = $cid;

			if ($item->query['view'] == 'archive' && $count != 1){
				$vars['year']	= $count >= 2 ? $segments[$count-2] : null;
				$vars['month'] = $segments[$count-1];
				$vars['view']	= 'archive';
			}
			else {
				$vars['view'] = 'detail';
			}
		}

		$found = 0;
	}

	return $vars;
}
?>