<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
// import the Ejoshop class
ejoshopimport('ejoshop.yandexmoney.yandexmoneynew');
ejoshopimport('ejoshop.paypalsdk.sample.bootstrap');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.render.renderinfo');
ejoshopimport('ejoshop.render.renderjquery');
ejoshopimport('ejoshop.render.rendercart');
ejoshopimport('ejoshop.analytics.analytics');



use PayPal\Api\Authorization;
use PayPal\Api\Payment;


/**
 * Ejoshop main View that proceess payments
 * and output cart, method of payments, page after redirect from payment system
 * All process payments - PayPal, Anet, Yandex, Webmoney START HERE
 */

class EjoshopViewCart extends EjoshopView
{
	var $currencyCache = array();
	var $id      	   = "euro";


	function display($tpl = null)
	{
		$app = JFactory::getApplication(); 
		JHtml::_('jquery.framework');
		$pathway = $app->getPathway();
		$document = JFactory::getDocument();
		$ejoj = new EjoshopRenderJquery();
		$ejoj->EjoshopRenderStyle('cart');
		$this->layout = $this->getLayout();
		
		$tmpl = array();
		JHtml::stylesheet( 'components/com_ejoshop/assets/ejoshop.css' );
		$this->params = $app->getParams();
		$this->task = JRequest::getVar( 'task' );	
		
		
		
		$this->checkOnPayments();


		if(!$this->switchshop) {
			EjoshopRenderInfo::message(JText::_('COM_EJOSHOP_SHOP_IS_OFF'),'egmessage');
			return;
		}
		$this->cartitems = $this->get('CartItem');
		
		if(!$this->cartitems) {
			EjoshopRenderInfo::message(JText::_('COM_EJOSHOP_CART_IS_EMPTY'),'egmessage');
			return;
		}
		
		ejoshopimport('ejoshop.getmyform.getmyform');

		$ejoj->addCssForItemsCartTable();
		$ejoj->addJsColorbox();
		$ejoj->EjoshopUiInit(true,false,false);
		
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();
		$getCurencyClass = new EjoshopRenderCurrency();
		$this->sitecurecny = $getCurencyClass->getCurrencyAbbr();
		
		$this->form = $form->getForm();
		/* Fill from inputs */
		if($this->task == 'checkout' || $this->task == 'anet' || $this->task == 'paypost' ) {

			$this->userform = $this->get('userInfo');
			if(!empty($this->userform[0])) {
				$this->form->bind($this->userform[0]);
			}
		}
		$params = JComponentHelper::getParams( 'com_ejoshop' );
		
		/* convert currency, process value to money format and other */		
		$this->cartitems = $this->processItems($this->cartitems,false,$params);
		//EjoshopDeveloper::debugPrint($this->cartitems);
		$isIntl = $getCurencyClass->is_extension_loaded('intl'); /* used as default method to parse money value */
		
		$this->sumpriceItem = 0;
		$this->sumprice = 0;
		$lang = JFactory::getLanguage();
		$this->tag = $lang->getTag();
		$checkcur = array();
		
		/* столбец итоговый для всей цены заказа */

		if($isIntl) {
			$fmt = new NumberFormatter( $this->tag, NumberFormatter::DECIMAL );
		}	

		for($i = 0; $i < count($this->cartitems); $i++) {
			$checkcur[] = $this->cartitems[$i]->currency;

			if($isIntl) {
				
				$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * $this->cartitems[$i]->qty);	
				//$this->sumpriceItem += ($fmt->parse($this->cartitems[$i]->decimalprice) * $this->cartitems[$i]->qty);	
			} else {
				$this->cartitems[$i]->decimalprice = $getCurencyClass->toInt($this->cartitems[$i]->decimalprice);
				$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * (int)$this->cartitems[$i]->qty);	
			}
		
			$this->sumprice = $this->sumpriceItem;
		}
		
		/* если все элементы корзины имеют одну валюту */
		if(count(array_unique($checkcur)) == 1 || !empty($_SESSION['usercurrency'])) {
			
			$defcur = $checkcur[0];
			
			if(!empty($_SESSION['usercurrency'])) {
				$defcur = $_SESSION['usercurrency'];
			} else {
				 $_SESSION['usercurrency'] = $defcur; 
			}
			
			$this->sumpricetoshow = $getCurencyClass->getValue($this->sumprice,$defcur); // for user not to payment
			
			//ejoshopimport('ejoshop.developer.developer');
			//EjoshopDeveloper::debugPrint($this->cartitems);
			$this->currencylshow = $_SESSION['usercurrency'];
			
		
		} else {
			$this->selectcurrency = TRUE;
			$this->sumpricetoshow = '';
			$this->currencylshow = '';
		}
		if($this->task == 'anet') {
			$app->enqueueMessage('Authorize.net. All transactions have to be in US currency.', 'info');
			if($_SESSION['anetusercurrency'] != 'USD') {
				$app->enqueueMessage('Therefore Ejoshop convert '.$_SESSION['anetusercurrency'].' to USD. For more info see <a href="http://www.authorize.net/international/">authorize.net</a>.  If your currency non USD your bank will handle the conversion from non USD currency to dollars.', 'info');
			}
		}
		
		/* Taxes */
		$this->istaxes = $getCurencyClass->countTaxes();
		$tax = '';
		if($this->istaxes) {
			$withtax = $getCurencyClass->getWithTax($this->sumprice,FALSE);
			$this->sumpricetowithtax = number_format($withtax,2);
			$this->sumpricetowithtaxtoshow = $getCurencyClass->getValue($withtax,$defcur); // for user not to payment
		}

		$pathway->addItem(JText::_('COM_VIRTUEMART_CART_OVERVIEW'));

		$text = JText::_('COM_VIRTUEMART_CHECKOUT_TITLE');
		$checkout_task = 'checkout';
		$this->forpostpay = JRequest::getVar( 'forpostpay','');	
		$this->tid = JRequest::getVar( 'tid','');	
			
		$comurlcom = 'index.php?option=com_ejoshop&view=cart&';
		
		$this->setRoute();
		
		$config = new JConfig();
		$format = (!empty($config->sef_rewrite)) ?  '?format=row' : '&format=row';
		$this->writebillsave = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=writebillsave').$format;
	
		$be = $this->forpostpay;
		$this->paypost= JRoute::_ ($comurlcom.'task=paypost&forpostpay='.$be.'&tid='.$this->tid);

		/* For each payment we use different View actions */
		$this->getPaymentsSettings();
		$all_cart_task = $this->getAllCartTask();
		
		if( $this->task == 'pluginsprocess') {
			$this->setLayout('pluginsprocess');
		}
		if(!in_array($this->task,$all_cart_task) && !empty($this->task)) {
			
			$this->setLayout('tmplforplugns');
		}
		
		parent::display($tpl);
	}
	

	/*
	 * Get all system task for cart view
	 *
	 */

	 function getAllCartTask(){
		
		$dir = __DIR__ . DS . 'tmpl' . DS;
		$alltask = array();
		if ($handle = opendir($dir)) {
	

			/* Именно этот способ чтения элементов каталога является правильным. */
			while (false !== ($entry = readdir($handle))) {
				if($entry != '.' && $entry != '..') {
					$alltask[] =  preg_replace('@\.php@si','',$entry); 
				}
			}


			closedir($handle);
		}
		
		return $alltask;
	 
	 }
	 
	 

	/*
	 * Pperforming data (photo, price, currency) to outout
	 *
	 */

	 function processItems ($items,$sub = false,$params){
	
		$CurencyClass = new EjoshopRenderCurrency();
		$cart = new EjoshopRenderCart();
		$auto_convert_currency = $params->get('convert_currency');
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecurrency = $CurencyClass->getCurrencyAbbr();
		} 
		/* if vaailable only one currency */
		$site_available_currencies = $CurencyClass->getAvailableCurrencies();
		if(count($site_available_currencies) == 1) {
	
			$_SESSION['usercurrency'] = $site_available_currencies[0]['currency_code'];
			$sitecurrency = $_SESSION['usercurrency'];
		}
		
		if(!empty($_SESSION['usercurrency'])) {
			$sitecurrency = $_SESSION['usercurrency'];
			$auto_convert_currency = true;
			// Anet accept only USD
			if($this->task == 'anet') {
				$_SESSION['anetusercurrency'] = $_SESSION['usercurrency'];
				$sitecurrency = $_SESSION['usercurrency'] = 'USD';
				
			}
		} else { // default currency settings
			$sitecurrency = $params->get('currency');
		}
	

		
		/* глобальные настройки если не указны отдельные настройки */
			
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecurrency);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {

					$items[$i]->currencyl = '';
				}

				$items[$i]->decimalprice = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price,false);
				
				/* валюта продукта не соответсвует валюте польователя и включена опция авконвертирования */
				if($items[$i]->currency != $sitecurrency && $auto_convert_currency) {

	
					
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */

					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecurrency && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
				}

			
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_(JURI::base().'index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_(JURI::base().'index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}

			$items[$i]->photoproduct = $cart->getImageForCartItems($items[$i]);
		}	
		return $items; 
	}
	
    public function webmoneyAction()
    {
	


	
		$this->backtocart = JURI::base().'index.php?option=com_ejoshop&view=cart&task=backtocartfromwm';
			
	}

	/*
	* Paypal process action
	* 
	*/
	
    public function processppAction()
    {
		
		ejoshopimport('ejoshop.paypal.paypalclass');	
		$paypal = new EjoshopPayPalClass();
		$lang = JFactory::getLanguage();
		
		$this->curl = $lang->getName();
		$this->tag = $lang->getTag();
		$this->tag = explode('-',$this->tag);
		$this->payments = $this->getPaymentset(2);
		
		if($_POST)
		{
			$ItemName = $_POST["itemname"]; //Item Name
			$ItemPrice = $_POST["itemprice"]; //Item Price
			$ItemNumber = $_POST["itemnumber"]; //Item Number
			$ItemQty = (empty($_POST["itemQty"])) ? 0 : $_POST["itemQty"]; // Item Quantity
			$ItemTotalPrice = $ItemPrice; //(Item Price x Quantity = Total) Get total amount of product; 
			
			EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
			$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');


			$ju = new JUri();
			$ju->parse(JURI::base());
			$sheme = $ju->getScheme();
			$host = $ju->getHost();
			$basehref = $sheme .'://'.$host;
		
			$PayPalCurrencyCode = !empty($_SESSION['usercurrency']) ? $_SESSION['usercurrency'] : 'USD'; //Paypal Currency 
			$PayPalReturnURL 	=   $basehref.JRoute::_('index.php?option=com_ejoshop&view=cart&task=backtocartfrompp');
			$PayPalCancelURL 	= $basehref.JRoute::_('index.php?option=com_ejoshop&view=cart&task=cancelpaypal');
			$PayPalURL 	= $basehref.JRoute::_('index.php?option=com_ejoshop&view=cart&task=paypal');
		
			$PayPalApiSignature = $this->payments->paypalapisignature;
			$PayPalApiPassword = $this->payments->paypalapipassword;
			$PayPalApiUsername = $this->payments->paypalapiusername;
			
			$allitemcart = '';
			$itemsamount = $_POST["amountp"];
			$itemsname = $_POST["item_name"];
			$itemsdesc = $_POST["item_desc"];
			$itemsqty = $_POST["item_qty"];
			$currency = new EjoshopRenderCurrency;
			$istaxes = $currency->countTaxes();
			$tax = '';
			$TAXAMT = 0;
			$ItemTotalTaxPrice = 0;
			foreach($_POST["item_id"] as $key => $item) {

			if($istaxes) {
				$itemsamount_with_tax[$key] = number_format($currency->getWithTax($itemsamount[$key],FALSE),2);
				$ItemTotalTaxPrice += $itemsamount_with_tax[$key];
				
			}
			
					$allitemcart .= 
					'&L_PAYMENTREQUEST_0_NAME'.$key.'='.urlencode($itemsname[$key]).
					'&L_PAYMENTREQUEST_0_NUMBER'.$key.'='.urlencode($item);
					if(!empty($itemsdesc[$key])) {
						$allitemcart .= '&L_PAYMENTREQUEST_0_DESC'.$key.'='.urlencode(substr($itemsdesc[$key],0,126));
					}
					$allitemcart .= '&L_PAYMENTREQUEST_0_AMT'.$key.'='.urlencode($itemsamount[$key]).
					'&L_PAYMENTREQUEST_0_QTY'.$key.'='.(int)urlencode($itemsqty[$key]);
					
					
			}
			

			if($istaxes) {
				$onlytax = $currency->getTaxAmount($ItemPrice,$ItemTotalTaxPrice);
				$tax = '&PAYMENTREQUEST_0_TAXAMT='.$onlytax;
			} else {
				$ItemTotalTaxPrice = $ItemTotalPrice;
			}

			$_SESSION['allitemcart'] = $allitemcart;
			//Data to be sent to paypal
			$padata = 	'&PAYMENTREQUEST_0_CURRENCYCODE='.urlencode($PayPalCurrencyCode).
						'&PAYMENTREQUEST_0_PAYMENTACTION=Sale'.
						'&ALLOWNOTE=1'.
						'&PAYMENTREQUEST_0_AMT='.urlencode($ItemTotalTaxPrice).
						'&PAYMENTREQUEST_0_ITEMAMT='.urlencode($ItemTotalPrice). 
						 $allitemcart.
						'&RETURNURL='.urlencode($PayPalReturnURL).
						$tax.
						'&LOCALECODE='.urlencode($this->tag[1]).
						'&CANCELURL='.urlencode($PayPalCancelURL);	
				
				//var_dump($padata);
				//die();		
				//We need to execute the "SetExpressCheckOut" method to obtain paypal token
				$paypal= new EjoshopPayPalClass();
				if($this->payments->sandbox) {
					$PayPalMode = 'sandbox';
				} else {
					$PayPalMode = 'live';	
				}

				
				$httpParsedResponseAr = $paypal->PPHttpPost('SetExpressCheckout', $padata, $PayPalApiUsername, $PayPalApiPassword, $PayPalApiSignature, $PayPalMode);
				
				//Respond according to message we receive from Paypal
				if("SUCCESS" == strtoupper($httpParsedResponseAr["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpParsedResponseAr["ACK"]))
				{
							
						// If successful set some session variable we need later when user is redirected back to page from paypal. 
						$_SESSION['itemprice'] =  $ItemPrice;
						$_SESSION['totalamount'] = $ItemTotalPrice;
						$_SESSION['itemName'] =  $ItemName;
						$_SESSION['itemNo'] =  $ItemNumber;
						$_SESSION['itemQTY'] =  $ItemQty;
						$_SESSION['itemtotaltaxprice'] =  $ItemTotalTaxPrice;
						if($PayPalMode=='sandbox')
						{
							$paypalmode 	=	'.sandbox';
						}
						else
						{
							$paypalmode 	=	'';
						}
						//Redirect user to PayPal store with Token received.
						$paypalurl ='https://www'.$paypalmode.'.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token='.$httpParsedResponseAr["TOKEN"].'';
						header('Location: '.$paypalurl);
					 
				} else{
					$app = JFactory::getApplication(); 
					$app->enqueueMessage('Error SetExpressCheckout', 'error');
					$app->enqueueMessage(urldecode($httpParsedResponseAr["L_LONGMESSAGE0"]), 'error');
					$app->enqueueMessage(urldecode($httpParsedResponseAr["L_ERRORCODE0"]), 'error');
					$app->redirect( $PayPalURL );
					//print_r($httpParsedResponseAr);
				
				}
		
		} else { /* paypal form */
		
			$PayPalApiSignature = $this->payments->paypalapisignature;
			$PayPalApiPassword = $this->payments->paypalapipassword;
			$PayPalApiUsername = $this->payments->paypalapiusername;
			$app = JFactory::getApplication(); 
		
			if ($PayPalApiSignature == "") {
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_PAYPALAPISIGNATURE'), 'error');
			}
			if ($PayPalApiPassword == "") {
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_PAYPALAPIPASSWORD'), 'error');
			}
			if ($PayPalApiUsername == "") {
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_PAYPALAPIUSERNAME'), 'error');
			}
			if ($this->payments->sandbox) {
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_ANET_TEST_MODE'), 'message');

			}
		}
		
		
	}
	

	/*
	* 1 step Ante - FORM FOR USER DATA
	*/
	
    public function AnetAction()
    {

		ejoshopimport('ejoshop.anetphpsdk.authorizenet');
		// 5 - Anet settings
		$this->payments = $this->getPaymentset(5);
		
		$AUTHORIZENET_API_LOGIN_ID = $this->payments->client_id;
		$AUTHORIZENET_TRANSACTION_KEY = $this->payments->trankeyanet;
		$AUTHORIZENET_SANDBOX = $this->payments->sandbox;
		if($this->payments->sandbox) {
			$TEST_REQUEST = TRUE;
		} else {
			$TEST_REQUEST = FALSE;
		}
		
		$this->METHOD_TO_USE = "AIM";
		// $METHOD_TO_USE = "DIRECT_POST";         // Uncomment this line to test DPM


		define("AUTHORIZENET_API_LOGIN_ID",$AUTHORIZENET_API_LOGIN_ID);    // Add your API LOGIN ID
		define("AUTHORIZENET_TRANSACTION_KEY",$AUTHORIZENET_TRANSACTION_KEY); // Add your API transaction key
		define("AUTHORIZENET_SANDBOX",$AUTHORIZENET_SANDBOX);       // Set to false to test against production
		define("TEST_REQUEST", $TEST_REQUEST);           // You may want to set to true if testing against production


		// You only need to adjust the two variables below if testing DPM
		define("AUTHORIZENET_MD5_SETTING","");                // Add your MD5 Setting.
		$app = JFactory::getApplication(); 
		
		if (AUTHORIZENET_API_LOGIN_ID == "") {
			$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_CREDENTIALS'), 'error');

		}
		if (AUTHORIZENET_TRANSACTION_KEY == "") {
			$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_TRANSACTION_KEY_EMPTY'), 'error');

		}
		if (TEST_REQUEST) {
			$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_ANET_TEST_MODE'), 'message');

		}

	}	

	/*
	 2 step Ante - PROCESS PAYMENT
	*/
	
    public function processanet()
    {

		ejoshopimport('ejoshop.anetphpsdk.anetphpsdk');

		$a = new Ejoshopanetphpsdk;
		$this->payments = $this->getPaymentset(5);
		$app = JFactory::getApplication(); 
				
		$AUTHORIZENET_API_LOGIN_ID = $this->payments->client_id;
		$AUTHORIZENET_TRANSACTION_KEY = $this->payments->trankeyanet;
		$AUTHORIZENET_SANDBOX = $this->payments->sandbox;
		if($this->payments->sandbox) {
			$TEST_REQUEST = TRUE;
		} else {
			$TEST_REQUEST = FALSE;
		}
		
		$this->METHOD_TO_USE = "AIM";
		// $METHOD_TO_USE = "DIRECT_POST";         // Uncomment this line to test DPM


		define("AUTHORIZENET_API_LOGIN_ID",$AUTHORIZENET_API_LOGIN_ID);    // Add your API LOGIN ID
		define("AUTHORIZENET_TRANSACTION_KEY",$AUTHORIZENET_TRANSACTION_KEY); // Add your API transaction key
		define("AUTHORIZENET_SANDBOX",$AUTHORIZENET_SANDBOX);       // Set to false to test against production
		define("TEST_REQUEST", $TEST_REQUEST);           // You may want to set to true if testing against production
		
		$basehref = $this->getBaseHref();
		
		$AnetCurrencyCode 	= !empty($_SESSION['usercurrency']) ? $_SESSION['usercurrency'] : 'USD'; //Paypal Currency 
		$AnetReturnURL 		=  $basehref. JRoute::_('index.php?option=com_ejoshop&view=cart&task=anet');
		
		$this->amount = JRequest::getVar('price');
		$currency = new EjoshopRenderCurrency;


		if ($this->METHOD_TO_USE == "AIM") {
			$transaction = new AuthorizeNetAIM;
			$transaction->setSandbox(AUTHORIZENET_SANDBOX);
			
	
			if(!empty($_POST['PID'])) {
				$transaction->setCustomField('pids',serialize($_POST['PID']));
			}
			
			$transaction->setFields(
				array(
				'amount' 	 => $this->amount, 
				'card_num'   => JRequest::getVar('x_card_num',''), 
				'exp_date'   => JRequest::getVar('x_exp_date',''),
				'first_name' => JRequest::getVar('name',''),
				'last_name'  => JRequest::getVar('lastname',''),
				'address'    => JRequest::getVar('address',''),
				'city' 	     => JRequest::getVar('city',''),
				'state' 	 => JRequest::getVar('state',''),
				'country' 	 => JRequest::getVar('country',''),
				'zip' 		 => JRequest::getVar('zipcode',''),
				'email' 	 => JRequest::getVar('email',''),
				'card_code'  => JRequest::getVar('card_code','')
				)
			);
	
			$response = $transaction->authorizeAndCapture();
			if ($response->approved) {
			// Transaction approved! Do your logic here.
				$pids = unserialize($response->pids);
				$userproduct = json_decode($_SESSION['cart']);

				//EjoshopDeveloper::debugPrint($response->amount);
				//EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
				$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');
				$response->amount = (!empty($response->amount)) ? $response->amount : $this->amount;
				$lastpay = $model->processpaidpp('anet',$pids, $response->amount,false, 'USD');
				$payer = (!empty($response->customer_id)) ? $payer : 0;
				$payincompnent = $model->PayFromAnet($payer,$pids,$lastpay);
				

				
				$this->successinfo = '
				<h2>' . JText::_('COM_EJ_THANK_YOU') . '</h2>
				<p>' . JText::_('COM_EJ_YOU_ORDER_IN_PROCESS') . '</p>
				<p>You transaction id: ' . $response->transaction_id . '</p>
				';
				$app->enqueueMessage(JTEXT::_('COM_EG_SUCCESS_FEE_RECEIVED'), 'message');
				$app->enqueueMessage($this->payments->textafterpaysuccess, 'message');
				
			} else {
			
				$app->enqueueMessage($response->response_reason_text . ' (Error code: '.$response->response_code.')', 'error');
				$app->enqueueMessage($this->payments->textafterpayfail, 'message');
				$app->redirect( $AnetReturnURL );
			
			}
		} elseif (count($_POST)) {
			$response = new AuthorizeNetSIM;
			if ($response->isAuthorizeNet()) {
				if ($response->approved) {
					// Transaction approved! Do your logic here.
					// Redirect the user back to your site.
					$return_url = $site_root . 'thank_you_page.php?transaction_id=' .$response->transaction_id;
				} else {
					// There was a problem. Do your logic here.
					// Redirect the user back to your site.
					$return_url = $site_root . 'error_page.php?response_reason_code='.$response->response_reason_code.'&response_code='.$response->response_code.'&response_reason_text=' .$response->response_reason_text;
				}
				echo AuthorizeNetDPM::getRelayResponseSnippet($return_url);
			} else {
				echo "MD5 Hash failed. Check to make sure your MD5 Setting matches the one in config.php";
			}
		}
	}
	
	
    public function yandexmoneyAction()
    {
		
		$this->payments = $this->getPaymentset(1);
		$lmi_mode = $this->payments->sandbox == 1;
		$app = JFactory::getApplication();

		//require_once(dirname(__FILE__) . '/consts.php');
		define ('CLIENT_ID', $this->payments->client_id);
		define ('CLIENT_SECRET', $this->payments->secretkey);
	
		// $_POST['authym'] после подтверждения иначе отобразить корзину
		if(isset($_POST['authym'])) {
			/* все элементы козины */
			$pids = $_POST['item_id'];
			$l = '';
			$i = 0;
			
			/* данные о товарах в корзине передаются в параметрах url */
			foreach($pids as $pid) {
				++$i;
				$l .= '&item_id'.$i.'='.$pid;	
			}

			define('REDIRECT_URI', $this->backtocart.$l);

			$code = JRequest::getVar('code');
			if (!isset($code)) { // If we are just begginig OAuth
			 $scope = "account-info " .
					"payment.to-account(\"".$this->payments->bill."\",\"account\").limit(,".$_POST['LMI_PAYMENT_AMOUNT'].") " 
					."money-source(\"wallet\",\"card\") ";

				
			
				$authUri = EjoshopYandexMoneyNew::authorizeUri(CLIENT_ID, REDIRECT_URI, $scope);

				$app->redirect($authUri);
				
				//return $this->redirect()->toUrl($authUri);
		
	
			} else { // when we recieved a temporary code on redirect
					
			}
		}

    }
	
	/*
	* После авторизации с Яндекс денег
	* выводим сообщение об успешности транзакции
	*
	*/
    
	public function backAction()
    {
		
		EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
		$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');

		ejoshopimport('ejoshop.render.rendercart');
		$isempty = EjoshopRenderCart::isCartEmpty();	
		$app	= JFactory::getApplication();
		if($isempty) {
						
			return false;	
		}
		
		$this->payments = $this->getPaymentset(1);
				$basehref = $this->getBaseHref();
		
		$this->backtocart = JURI::base().'index.php?option=com_ejoshop&view=cart&task=backtocartfromym';
		$this->backtocarterror = JURI::base().'index.php?option=com_ejoshop&view=cart&task=backtocartfromymerror';
		//require_once(dirname(__FILE__) . '/consts.php');
		define ('CLIENT_ID', $this->payments->client_id);
		define ('REDIRECT_URI', $this->backtocart);
		define ('CLIENT_SECRET', $this->payments->secretkey);
		$code = $_GET['code']; // временный токен

				
		$pids = array();
		foreach($_GET as $key => $val) {
			if(strpos($key,'item_id') !== false) {
				$pids[] =	$val;
				}
						
		}
		/*
		echo '<h2>Pids:</h2>';
     	echo '<pre>';
		print_r($pids);
		echo '</pre>';	
		*/
		$ym = new EjoshopYandexMoneyNew(CLIENT_ID);
        $receiveTokenResp = $ym->receiveOAuthToken($code, REDIRECT_URI, CLIENT_SECRET);

        if ($receiveTokenResp->isSuccess()) {
            $token = $receiveTokenResp->getAccessToken();
         //  print "Received token: " . $token;
        } else {
            
			$app->enqueueMessage($receiveTokenResp->getError(), 'error');
			$app->redirect( $this->backtocarterror );
        }

		/* метка в yandex */
		EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
		$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');

		$test = $this->payments->sandbox;
		
        $resp = $ym->requestPaymentP2P($token, $this->payments->bill, $this->sumprice, null,null, null, $test); 
		// 7 - test 

        if ($resp->isSuccess()) {

		} else {
			$app->enqueueMessage($resp->getError(), 'error');
            $app->redirect( $this->backtocarterror );
        }
		
		$requestId = $resp->getRequestId();
        $resp = $ym->processPaymentByWallet($token, $requestId, $test);
		
	

		$amount = $resp->getcreditAmount();
		if ($resp->isSuccess()) {
			
			$lastpay = $model->processpaidpp('yandexmoney',$pids, $amount);
			$payer = $resp->getPayer();
			$payincompnent = $model->PayFromYandexMoney($payer,$pids,$lastpay);

		}
		
	

		
	}
	
			
	/**
	* Looks for unquoted keys in a json string and fixes them ie: {a:"b"} => {"a":"b"}
	* @param string $string A json string that is suspect
	* @return string A valid json string
	*/
	function fix_json($string){
		
		// (no qupte) (word) (no quote) (semicolon)
		$regex = '/(?<!")([a-zA-Z0-9_]+)(?!")(?=:)/i';
		
		$s =  preg_replace($regex, '"$1"', $string);
		
		return $s;
	}
 
	/**
	* Check is enable payments for path to layout
	* 
	* 
	*/
	
	public function checkOnPayments()
	{
		$this->switchpayments = $this->params->get('switchpayments');
		$this->switchyandexmoney = $this->params->get('switchyandexmoney');
		$this->switchwebmoney = $this->params->get('switchwebmoney');
		$this->switchpaypal = $this->params->get('switchpaypal');
		$this->switchpost = $this->params->get('switchpost');
		$this->switchshop = $this->params->get('switchshop');
		$this->switchwritebill = $this->params->get('switchwritebill');
		$this->switchanet = $this->params->get('switchanet');
	}
	
	
	/**
	* Get Payments Settings
	* 
	* 
	*/
	
	public function getPaymentsSettings()
	{

		$l = $this->getLayout();
		
		EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
		$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');

		if($l == 'yandexmoney') {
			$this->payments_settings = $model->getPayments('yandexmoney');
			$this->lmi_mode = $this->payments_settings->sandbox == 1;
		
			if($this->lmi_mode) {
				$app	= JFactory::getApplication();
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_ANET_TEST_MODE'), 'message');
			}
			$this->yandexmoneyAction();
		}

		if($l == 'paypal') {
			$this->payments_settings = $model->getPayments('paypal');
			$this->processppAction();
		}

		if($l == 'anet') {
			$this->payments_settings = $model->getPayments('anet');
			$this->AnetAction();
		}

		if($l == 'processanet') {
			$this->payments_settings = $model->getPayments('anet');
			$this->processanet();
		}

		if($l == 'processpp') {
			$this->payments_settings = $model->getPayments('paypal');
			$this->processppAction();
		}

		if($l == 'webmoney') {
			$this->webmoneyAction();
			$this->payments_settings = $model->getPayments('webmoney');
			$this->lmi_mode = $this->payments_settings->sandbox == 1;
			if($this->lmi_mode) {
				$app	= JFactory::getApplication();
				$app->enqueueMessage(JTEXT::_('COM_EJOSHOP_WHERE_ANET_TEST_MODE'), 'message');
			}
		}

		if($l == 'backtocartfromym') {
			$this->backAction();
		}
		if($l == 'writebillsave') {
			//$this->setLayout($tplphoto);
		}
		
		/* after user infroming admin about post buy method */
		if($l == 'paypostconfirm') {
		
			$this->postadress = JRequest::getVar('postadress', 0);
			$this->payments_settings = $model->getPayments('paywithpost');
			$analytics = new EjoshopAnalytics();
			$analytics->updateUserPurchase();
			EjoshopRenderCart::flushCart();
			EjoshopRenderCart::sendEmail();

		}

	}	
	/**
	* Set all route that we need to cart
	* 
	* 
	*/
	
	public function setRoute()
	{

		$task = $this->task;
		$document = JFactory::getDocument();
		$this->selectcurrencypost = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=setusercurrency');
		if($task == 'confirm') {
			$document->setTitle(JText::_('COM_VIRTUEMART_CART_OVERVIEW'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=payments');
		} else if($task == 'checkout')  {
			$document->setTitle(JText::_('COM_VIRTUEMART_CART_OVERVIEW'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=confirm');
		} else if($task == 'confirm')  {
			$document->setTitle(JText::_('COM_VIRTUEMART_CART_OVERVIEW'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=category&id=1');
		} else if($task == 'yandexmoney')  {
			$document->setTitle(JText::_('COM_EJ_WITH_YANDEXMONEY'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=confirm');
		} else if($task == 'paypost')  {
			$document->setTitle(JText::_('COM_EJ_WITH_POST'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=confirm');
		} else if($task == 'writebill')  {
			$document->setTitle(JText::_('COM_EJ_WITH_BILL'));
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=writebillsave');
		}  else {
			$document->setTitle(JText::_('COM_VIRTUEMART_CART_OVERVIEW'));	
			$this->steptoorder = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=checkout');
		}

	
		$this->yandexmoney = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=yandexmoney');
		$this->webmoney = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=webmoney');
		$this->paypal = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=paypal');
		$this->writebill = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=writebill');
		$this->anet = JRoute::_ ('index.php?option=com_ejoshop&view=cart&task=anet');
	}
	
	
	
	public function getBaseHref()
	{
		$ju = new JUri();
		$ju->parse(JURI::base());
		$sheme = $ju->getScheme();
		$host = $ju->getHost();
		$basehref = $sheme .'://'.$host;
		return $basehref;
	}
	public function getPaymentset($id)
	{
		JError::$legacy = true;
		$this->backtocart = JURI::base().'index.php?option=com_ejoshop&view=cart&task=backtocartfromym';
		$app = JFactory::getApplication(); 
		$db		= JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->from('`#__ejoshop_payments` AS payments');
		$query->select('payments.*');
		$query->where('payments.id = '.$id);
		$limit = JRequest::getVar('limit',$app->getCfg('list_limit'));
		
		$limitstart = JRequest::getVar('limitstart', 0);
		$query = $db->setQuery( $query );

		try {
				
			$result = $db->query();
		} catch(Exception $e) {
			print $e->getMessage();	
		}
		$this->payments = $db->loadObject();
		return $this->payments;	
	}

	
}

?>