<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Component
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');

ejoshopimport('ejoshop.yandexmoney.yandexmoneynew');
ejoshopimport('ejoshop.paypalsdk.sample.bootstrap');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.render.rendercart');

/**
* Foobar View
*/
class EjoshopViewCart extends EjoshopView
{

	/**
	 * View only for write bill
	 * 
	 **/
	function display($tpl = null)
	{
		$app = JFactory::getApplication(); 

		$pathway = $app->getPathway();
		$document = JFactory::getDocument();

		$layoutName = $this->getLayout();
		$tmpl = array();
		JHtml::stylesheet( 'components/com_ejoshop/assets/ejoshop.css' );
		$this->params = $app->getParams();
		$this->switchshop = $this->params->get('switchshop');
		$this->switchwritebill = $this->params->get('switchwritebill');

		if(!$this->switchshop) {
			return;
		}
		$cart = new EjoshopRenderCart();
		$this->cartuser = $cart->getCurrentUserCart();
		if(empty($this->cartuser)) {
			return;
		}
		
		$this->cartitems = $this->get('CartItem');
		
		
		ejoshopimport('ejoshop.getmyform.getmyform');
		ejoshopimport('ejoshop.render.renderjquery');

		
		$app	= JFactory::getApplication();
		$form = new EjoshopGetmyform();
		$getCurencyClass = new EjoshopRenderCurrency();
		$this->sitecurecny = $getCurencyClass->getCurrencyAbbr();
		
		$this->form 	= $form->getForm();
		

		/* convert currency, process value to money format and other */		
		$this->cartitems = $this->processItems($this->cartitems,false,$this->params);
		//EjoshopDeveloper::debugPrint($this->cartitems);
		$isIntl = $getCurencyClass->is_extension_loaded('intl'); /* used as default method to parse money value */
		
		$this->sumpriceItem = 0;
		$this->sumprice = 0;
		$lang = JFactory::getLanguage();
		$this->tag = $lang->getTag();
		$checkcur = array();
		
		/*       */

		if($isIntl) {
			$fmt = new NumberFormatter( $this->tag, NumberFormatter::DECIMAL );
		}	

		for($i = 0; $i < count($this->cartitems); $i++) {
			$checkcur[] = $this->cartitems[$i]->currency;

			if($isIntl) {
				
				$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * $this->cartitems[$i]->qty);	
				//$this->sumpriceItem += ($fmt->parse($this->cartitems[$i]->decimalprice) * $this->cartitems[$i]->qty);	
			} else {
				$this->cartitems[$i]->decimalprice = $getCurencyClass->toInt($this->cartitems[$i]->decimalprice);
				$this->sumpriceItem += ($this->cartitems[$i]->decimalprice * (int)$this->cartitems[$i]->qty);	
			}
		
			$this->sumprice = $this->sumpriceItem;
		}
		/*        */
		if(count(array_unique($checkcur)) == 1 || !empty($_SESSION['usercurrency'])) {
			
			$defcur = $checkcur[0];
			
			if(!empty($_SESSION['usercurrency'])) {
				$defcur = $_SESSION['usercurrency'];
			} else {
				 $_SESSION['usercurrency'] = $defcur; 
			}
			
			$this->sumpricetoshow = $getCurencyClass->getValue($this->sumprice,$defcur); // for user not to payment
			
			//ejoshopimport('ejoshop.developer.developer');
			//EjoshopDeveloper::debugPrint($this->cartitems);
			$this->currencylshow = $_SESSION['usercurrency'];
			
		
		} else {
			$this->selectcurrency = TRUE;
			$this->sumpricetoshow = '';
			$this->currencylshow = '';
		}
		$task = JRequest::getVar( 'task' );	
					
		EjoshopModel::addIncludePath(JPATH_COMPONENT . '/models');
		$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');
		$l = $this->getLayout();

		if($l == 'writebillsave') {
			$this->payments_settings = $model->getPayments('writebill');
		}
		$update = $model->updateStatusAfterPostPay(0,'paywithbill');
		
		if($update) {
			$analytics = new EjoshopAnalytics();
			$analytics->updateUserPurchase();
			EjoshopRenderCart::flushCart();
			EjoshopRenderCart::sendEmail();
		}
		
		parent::display($tpl);
	}
	
	/*
	 * Pperforming data (photo, price, currency) to outout
	 *
	 */

	 function processItems ($items,$sub = false,$params){
	
		$CurencyClass = new EjoshopRenderCurrency();
		$cart = new EjoshopRenderCart();
		$auto_convert_currency = $params->get('convert_currency');
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecurrency = $CurencyClass->getCurrencyAbbr();
		} 
		/* if vaailable only one currency */
		$site_available_currencies = $CurencyClass->getAvailableCurrencies();
		if(count($site_available_currencies) == 1) {
	
			$_SESSION['usercurrency'] = $site_available_currencies[0]['currency_code'];
			$sitecurrency = $_SESSION['usercurrency'];
		}
		
		if(!empty($_SESSION['usercurrency'])) {
			$sitecurrency = $_SESSION['usercurrency'];
			$auto_convert_currency = true;
			// Anet accept only USD
			if($this->task == 'anet') {
				$_SESSION['anetusercurrency'] = $_SESSION['usercurrency'];
				$sitecurrency = $_SESSION['usercurrency'] = 'USD';
				
			}
		} else { // default currency settings
			$sitecurrency = $params->get('currency');
		}
	

		
		/*        */
			
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
		
				if($auto_convert_currency && !$exloadIntl)  {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($sitecurrency);
				} else if(!$auto_convert_currency && !$exloadIntl) {
					$items[$i]->currencyl = $CurencyClass->getCurrencyName($items[$i]->currency);
				} else {

					$items[$i]->currencyl = '';
				}

				$items[$i]->decimalprice = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price,false);
				
				/*           */
				if($items[$i]->currency != $sitecurrency && $auto_convert_currency) {

	
					
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
					
				} else if(!$auto_convert_currency){ /*      */

					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
				} else if($items[$i]->currency == $sitecurrency && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecurrency),$items[$i]->price);
				}

			
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a);
			}

			$items[$i]->photoproduct = $cart->getImageForCartItems($items[$i]);
		}	
		return $items; 
	}
	
  
}








?>