<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component Ejoshop
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
jimport('joomla.user.user');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.render.renderjquery');
ejoshopimport('ejoshop.render.renderinfo');
ejoshopimport('ejoshop.developer.developer');
ejoshopimport('ejoshop.access.access');
ejoshopimport('ejoshop.fields.fields');
		
/**
* Foobar View
*/
class ejoshopViewcategory extends EjoshopView
{
	/**
	 * Hellos view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		$user = JFactory::getUser();
		JHtml::_('jquery.framework');
		$this->id = JRequest::getVar('id', 0, '', 'int');
		require_once JPATH_COMPONENT.'/helpers/category.php';
		$options = array();
		$options['countItems'] = 1;
		$options['published'] = 1;
		$categories = new EjoshopCategories($options);
		//$this->category = $categories->load($this->id);

		
		$app = JFactory::getApplication(); 
		$FieldsClass = new EjoshopFields();
		$jquery = new EjoshopRenderJquery();
		$jquery->EjoshopRenderStyle('category');
		$this->state = $this->get('State');
		
		$jquery->EjoshopUiInit(true,false,TRUE);
		$jquery->hoverItemsForAdmin();
		$pathway = $app->getPathway();
		$document = JFactory::getDocument();
		$tmpl = array();
		JHtml::stylesheet( 'components/com_ejoshop/assets/ejoshop.css' );
		$this->params = $app->getParams();


		$this->items = $this->get('Photos');
		$this->subcat_items = $this->get('SubCategory');
		
		$this->items = $this->processItems($this->items,false,$this->params);
		$this->subcat_items = $this->processItems($this->subcat_items,true, $this->params);
		
		if(empty($this->items)) {
			$app->enqueueMessage('COM_EJ_CAT_IS_EMPTY', 'info');
			return false;
		}
	
		//EjoshopModel::addIncludePath(JPATH_COMPONENT_SITE . '/models');
		require_once JPATH_COMPONENT.'/models/cart.php';
		$model = EjoshopModel::getInstance('Cart', 'EjoshopModel');

		$this->categories = $model->getCategories();
		
		
		
		$classpayd = new EjoshopAccess();
		$checkAccess = $classpayd->checkAccess($this->categories->access,$user->getAuthorisedViewLevels(),$user->getAuthorisedGroups());
	
		$this->_addBreadCrumbs($this->categories, isset($menu->query['id']) ? $menu->query['id'] : 0, 0);
		if(!$checkAccess) {
			JError::raiseNotice(403, JText::_('COM_EJOSHOP_ACCESS_DENIED'));
			return;

		}
		
		

		$document->setTitle($this->categories->title);
		
		$this->pager = $this->get('Pager');
	
		
		$app = JFactory::getApplication();
		$menu = $app->getMenu();
		$active = $menu->getActive();
		$params = new JRegistry();

		
		if ($active) {
			$params->loadString($active->params);
		}

		$this->style = $params->get('style','list');
		$this->numblock = $params->get('numblock',5);
		$this->show_title = $params->get('show_title',1);
		$this->show_desc = $params->get('show_desc',0);
		
		$this->setLayout('default_'.$this->style);
		
		if($this->params->get('fields_show_in_filter')) {
			$this->filterfields = $FieldsClass->getfilterfields($this->items);
		}
		
		if(empty($this->tmpl)) $this->tmpl['action'] = '';
		parent::display($tpl);
	}
	
		/**
	 * Method to add Breadcrubms in Phoca Gallery
	 * @param array $category Object array of Category
	 * @param int $rootId Id of Root Category
	 * @param int $displayStyle Displaying of Breadcrubm - Nothing, Category Name, Menu link with Name
	 * @return string Breadcrumbs
	 */
	function _addBreadCrumbs($category, $rootId, $displayStyle)
	{
		
		
		//EjoshopDeveloper::debugPrint($category);
	    $app = JFactory::getApplication();
		$i = 0;

	    while (isset($category->id))
	    {
			
			$crumbList[$i++] = $category;
				
			if ($category->id == $rootId)
			{
				break;
			}

	        $db = JFactory::getDBO();
	        $query = 'SELECT *' .
	            ' FROM #__ejoshop_categories AS c' .
	            ' WHERE c.id = '.(int) $category->parent_id.
	            ' AND c.published = 1 AND c.id != 1';
	        $db->setQuery($query);
		
	        $rows = $db->loadObjectList('id');
			
			if (!empty($rows))
			{
		
				$category = $rows[$category->parent_id];
			}
			else
			{
				$category = '';
			}
		//	$category = $rows[$category->parent_id];

	    }
		//EjoshopDeveloper::debugPrint($crumbList);
	    $pathway 		= $app->getPathway();
		$pathWayItems 	= $pathway->getPathWay();
		$lastItemIndex 	= count($pathWayItems) - 1;
		$js		= new JSite();
		$menu = $js->getMenu();	
		$item = $menu->getActive();		
	
		
		///EjoshopDeveloper::debugPrint($item);
				$catid = (!empty($item->query['id'])) ? $item->query['id'] : 0;
				$exclude = array();
				if(!empty($item->tree)) {
					foreach($item->tree as $leaf) {
						$l = $menu->getItem($leaf);	
						if(!empty($l->query['id'])) $exclude[] = $l->query['id'];
					}
				}
				
	    for ($i--; $i >= 0; $i--)
	    {

			// special handling of the root category
			if ($crumbList[$i]->id == $rootId) 
			{
				
				switch ($displayStyle) 
				{
					case 0:	// 0 - only menu link
						// do nothing
						break;
					case 1:	// 1 - menu link with category name
						// replace the last item in the breadcrumb (menu link title) with the current value plus the category title
						$pathway->setItemName($lastItemIndex, $pathWayItems[$lastItemIndex]->name . ' - ' . $crumbList[$i]->title);
						break;
					case 2:	// 2 - only category name
						// replace the last item in the breadcrumb (menu link title) with the category title
						$pathway->setItemName($lastItemIndex, $crumbList[$i]->name);
						break;
				}
			} 
			else 
			{
				

			//EjoshopDeveloper::debugPrint($exclude);
					if(!count($exclude)) {
						$pathway->addItem($crumbList[$i]->title, JRoute::_('index.php?option=com_ejoshop&view=category&id='. 			$crumbList[$i]->id.':'.$crumbList[$i]->alias));
					} 
				
			}
	    }
	}
	
	
	function processItems ($items,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$FieldsClass = new EjoshopFields();
		$auto_convert_currency = $params->get('convert_currency');
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		//var_dump($sitecuurecny);

		/* глобальные настройки если не указны отдельные настройки */
		
	
					
		for($i = 0; $i < count($items); $i++) {
	
			if($items[$i]->currency < 0) $items[$i]->currency = $params->get('currency');
			$c = json_decode($items[$i]->color);
			$items[$i]->allimg = '';
			if(!empty($c)) {
				foreach($c as $color) {
	
					$items[$i]->allimg .= JHTML::_('image', 'media/com_ejoshop/assets/color/'.$color.'.jpg','','style="width:19px; height:20px; margin: 0px 0 -5px 2px;"');
				}
			}
		
				
				/* валюта продукта не соответсвует валюте польователя и включена опция авконвертирования */
				if($items[$i]->currency != $sitecuurecny && $auto_convert_currency) {
					
			
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
					
					
				} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */
				
					$items[$i]->price = $CurencyClass->getValue($items[$i]->price,$items[$i]->currency);
						
				} else if($items[$i]->currency == $sitecuurecny && $auto_convert_currency){
					$items[$i]->price = $CurencyClass->currency(strtoupper($items[$i]->currency),strtoupper($sitecuurecny),$items[$i]->price);
				}
			
		
			if($auto_convert_currency && !$exloadIntl)  {
				$items[$i]->price_with_currency = $CurencyClass->getCurrencyName($sitecuurecny,$items[$i]->price);
	
			} else if(!$auto_convert_currency && !$exloadIntl) {
				$items[$i]->price_with_currency = $CurencyClass->getCurrencyName($items[$i]->currency,$items[$i]->price);
			} else {
				$items[$i]->price_with_currency = $items[$i]->price; // all right with NumberFormatter
			}
		
			$catalias = '';
			if(!empty($items[$i]->catalias))	{
				$catalias = $items[$i]->catalias;
			}
			if($sub) {
				$items[$i]->detail = JRoute::_('index.php?option=com_ejoshop&view=category&id='.$items[$i]->catid.':'.$catalias);
			} else {
				(!empty($items[$i]->alias)) ? $a = ':'.$items[$i]->alias : $a = '';
				$routehelper = new EjoshopHelperRoute();
				//echo JRoute::_($routehelper->getArticleRoute($items[$i]->id, $items[$i]->catid));
				//'index.php?option=com_ejoshop&view=detail&catid='.$items[$i]->catid.':'.$catalias.'&id='.$items[$i]->id.$a.'&Itemid=742'
				$items[$i]->detail = JRoute::_($routehelper->getArticleRoute($items[$i]->id, $items[$i]->catid));
			}
			//index.php?option=com_content&view=article&id=35:professionals&catid=19&Itemid=260
			
			/* глобальные настройки если не указны отдельные настройки */
		
			if($items[$i]->showprice < 0) $items[$i]->showprice = $params->get('showprice');
			if($items[$i]->showquanity < 0) $items[$i]->showquanity = $params->get('showquanity');
			if($items[$i]->addtocartshow < 0) $items[$i]->addtocartshow = $params->get('addtocartshow');
			$items[$i]->showsales = $params->get('showsales');
		
			$c = json_decode($items[$i]->color);
			//var_dump(JPATH_COMPONENT_ADMINISTRATOR);
	

			
			$items[$i] = $this->getPhotooutput($items[$i]);
			if($this->params->get('fields_show')) {
				$items[$i] = $FieldsClass->getAllFields($items[$i]);
			}
			
			/*
			print '<pre>';
			print_r($items[$i]);
			print '</pre>';	
			*/
		}
		return $items; 
	}
	
	
	function getPhotooutput($item) {
		$path = JURI::root(false).$item->uri;
			$path_parts = pathinfo($path.$item->filename);
		$ext = $path_parts['extension'];
		
		$newfileimgsrc = $path.'_s.'.$ext;
		$pst = $item->sizethumb;
		$thumb = $path.$path_parts['filename'].'_s.'.$ext;
		
		$imgsrc = $path.$item->filename;

		if(is_file(JPATH_ROOT.'/'.$item->uri.$path_parts['filename'].'_s.'.$ext)) {
			$item->photooutput = '<a rel="colorbox" style="float: left;" title="'.$item->name.'" href="'.$imgsrc.'"><img alt="'.$item->name.'" src="'.$thumb.'"></a>';
		} else {
			$item->photooutput = '<a rel="colorbox" style="float: left;" title="'.$item->name.'" href="'.$link.'"><img  alt="'.$item->name.'"  src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a>';
		}
		
		return $item;
	}	
}

?>
