<?php
/*
 * @package Joomla 3.2
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @component 
 * @copyright Copyright (C) Aleksandr Ermakov ejoshop.com, www.slyweb.ru
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
// import the JView class
jimport('joomla.application.component.view');
ejoshopimport('ejoshop.render.rendermap');
ejoshopimport('ejoshop.render.rendercurrency');
ejoshopimport('ejoshop.render.renderjquery');
ejoshopimport('ejoshop.render.renderdetail');
ejoshopimport('ejoshop.developer.developer');
ejoshopimport('ejoshop.fields.fields');

class EjoshopViewDetail extends EjoshopView
{
	 
	function display($tpl = null)
	{
		JHtml::_('jquery.framework');
		$app = JFactory::getApplication(); 
		/* include js for jquery and colorbox see renderjquery class*/
		$egrj = new EjoshopRenderJquery();
		$ejrd = new EjoshopRenderDetail();
		$detail_id = JRequest::getVar('id');
		$ejrd->updateHit($detail_id);
		
		$egrj->EjoshopRenderStyle('detail');
		$egrj->addJsColorbox(); 
		$egrj->EjoshopUiInit(true,true,0); 
		$egrj->hoverItemsForAdmin(); 
		$egrj->addJsAddComments(); 
		/* include js for jquery and colorbox see renderjquery class*/
		
		$document = JFactory::getDocument();
		$tmpl = array();
		JHtml::stylesheet( 'components/com_ejoshop/assets/ejoshop.css' );
		$this->params = $app->getParams();
		$this->photo = $this->get('Photos');
		
		$this->photo = $this->photo[0];
		
		$this->photo = $this->processItems($this->photo,0,$this->params);
		$c = json_decode($this->photo->color);
		
		$this->photo->allimg = '';
		if(!empty($c)) {
			foreach($c as $color) {
				$this->photo->allimg .= JHTML::_('image', 'media/com_ejoshop/assets/color/'.$color.'.jpg','','style="width:19px; height:20px; margin: 0px 0 -5px 2px;"');
			}
		}
		
		switch($this->photo->currency) {
			case 'rub':
			$this->photo->currency = 'рублей';
			break;
			case 'usd':
			$this->photo->currency = 'долларов';
			break;
			case 'eur':
			$this->photo->currency = 'евро';
			break;
		}		
		$tplphoto = $this->photo->tplonephoto;
		if(empty($tplphoto)) $tplphoto = 'photo1';
		$this->setLayout($tplphoto);
		
		$this->cats = $this->get('Categories');
		

		if(empty($this->photo->name)) $this->photo->name = $this->photo->category_name;

		if(empty($this->photo->description)) $this->photo->description = '';
		if(empty($this->photo->keywords)) $this->photo->keywords = '';

		
		if($this->photo->showmap) {
		$this->map = new EjoshopRenderMap();
		$this->htmlmap=$this->map->createMap('',$this->photo->maptype,$this->photo->latitude.','.$this->photo->longitude);
		}


		$document->setTitle($this->photo->name);
		$document->setDescription ($this->photo->description);
		$document->setMetaData('keywords',$this->photo->keywords);
		
		
		$jsite	= new JSite();
		$menus 	= $jsite->getMenu();
		$menu	= $menus->getActive();
		
		$this->_addBreadCrumbs($this->cats, 0, $this->photo);
		
		
		$this->comments = $this->get('Comments');
		parent::display($tpl);
	}
	
			/**
	 * Method to add Breadcrubms in Phoca Gallery
	 * @param array $category Object array of Category
	 * @param int $rootId Id of Root Category
	 * @param int $displayStyle Displaying of Breadcrubm - Nothing, Category Name, Menu link with Name
	 * @return string Breadcrumbs
	 */
	function _addBreadCrumbs($category, $rootId, $detail)
	{
	
	    $app = JFactory::getApplication();
		$i = 0;
			

			
	    while (isset($category->id))
	    {

			$crumbList[$i++] = $category;
					
			if ($category->id == $rootId)
			{
				break;
			}

	        $db = JFactory::getDBO();
	        $query = 'SELECT *' .
	            ' FROM #__ejoshop_categories AS c' .
	            ' WHERE c.id = '.(int) $category->parent_id.
	            ' AND c.id != 1 AND c.published = 1';
				
	        $db->setQuery($query);
	        $rows = $db->loadObjectList('id');
			if (!empty($rows))
			{
				$category = $rows[$category->parent_id];
			}
			else
			{
				$category = '';
			}
		//	$category = $rows[$category->parent_id];
	    }

	    $pathway 		= $app->getPathway();
		$pathWayItems 	= $pathway->getPathWay();
		$lastItemIndex 	= count($pathWayItems) - 1;
		$js		= new JSite();
		$menu = $js->getMenu();	
		$item = $menu->getActive();	
				$catid = (!empty($item->query['id'])) ? $item->query['id'] : 0;
				$exclude = array();
				if(!empty($item->tree)) {
					foreach($item->tree as $leaf) {
						$l = $menu->getItem($leaf);	
						if(!empty($l->query['id'])) $exclude[] = $l->query['id'];
					}
				}
	    for ($i--; $i >= 0; $i--)
	    {

			// special handling of the root category
			if ($crumbList[$i]->id == $rootId) 
			{
				
				switch ($displayStyle) 
				{
					case 0:	// 0 - only menu link
						// do nothing
						break;
					case 1:	// 1 - menu link with category name
						// replace the last item in the breadcrumb (menu link title) with the current value plus the category title
						$pathway->setItemName($lastItemIndex, $pathWayItems[$lastItemIndex]->title . ' - ' . $crumbList[$i]->title);
						break;
					case 2:	// 2 - only category name
						// replace the last item in the breadcrumb (menu link title) with the category title
						$pathway->setItemName($lastItemIndex, $crumbList[$i]->title);
						break;
				}
				
			} 
			else 
			{
				
		

				
				if(!count($exclude)) {
					$pathway->addItem($crumbList[$i]->title, JRoute::_('index.php?option=com_ejoshop&view=category&id='. 			$crumbList[$i]->id.':'.$crumbList[$i]->alias));
				} 
				
				if(!empty($detail) && $i == 0) {
					$pathway->addItem($detail->name);
				}
				
			}
	    }
	}


	function processItems($item,$sub = false,$params){
		$CurencyClass = new EjoshopRenderCurrency();
		$exloadIntl = $CurencyClass->is_extension_loaded('intl');
		
		$FieldsClass = new EjoshopFields();
		
		$auto_convert_currency = $params->get('convert_currency');
		$defcurrency = $params->get('currency');
		if($auto_convert_currency)  {
			$sitecuurecny = $CurencyClass->getCurrencyAbbr();
		} 
		$sitecuurecny = (!isset($sitecuurecny)) ? 0 : $sitecuurecny; 
		$item->currency = ($item->currency == -1) ? $defcurrency : $item->currency;
		

		
		if($item->currency != $sitecuurecny && $auto_convert_currency) {
		
			$item->price = $CurencyClass->currency(strtoupper($item->currency),strtoupper($sitecuurecny),$item->price);
		
		} else if(!$auto_convert_currency){ /* иначе приводим значение к формату */
				
			$item->price = $CurencyClass->getValue($item->price,$item->currency);
						
		} else if($items->currency == $sitecuurecny && $auto_convert_currency){
			$item->price = $CurencyClass->currency(strtoupper($item->currency),strtoupper($sitecuurecny),$item->price);
		}


		if($auto_convert_currency && !$exloadIntl)  {
			$item->price_with_currency = $CurencyClass->getCurrencyName($sitecuurecny,$item->price);
		} else if(!$auto_convert_currency && !$exloadIntl) {
			$item->price_with_currency = $CurencyClass->getCurrencyName($item->currency,$item->price);
		} else {
			$item->price_with_currency = $item->price; // за нас всё сделал NumberFormatter
		}		
	
		$item = $this->getPhotooutput($item);
		$item = $this->getOtherPhoto($item);
		/* add fields */
		if($this->params->get('fields_show')) {
			$item = $FieldsClass->getAllFields($item);
		}
	
			
		return $item; 
	}
	
	function getPhotooutput($item) {
		
	
		$uri = $item->uri;
		$path = JURI::root(false).$uri;
		$path_parts = pathinfo($path.$item->filename);
		$thumb_s = $path_parts['filename'].'_s.'.$path_parts['extension'];
		$op = $item->onephoto;

		$newfileimgsrc = $path.'_s.png';
	
		if(!empty($op)) {
		
			$thumb = JURI::root(false).$item->onephotouri.$op;
			$uri = $item->onephotouri;
			
			
		} else {
			$thumb = $path.$thumb_s;
		}
		
		$imgsrc = $path.$item->filename;
		/* detail photo */
		if(is_file(JPATH_ROOT.DS.$uri.$op)) {
			$item->photooutput = '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
		/* thumb photo */	
		} else if(is_file(JPATH_ROOT.DS.$uri.$thumb_s)) {
			$item->photooutput = '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
		/* no photo */	
		} else {
			$item->photooutput = '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a>';
		}
		
		return $item;
	}

	function getOtherPhoto($p) {
		$m = $this->getModel();
		$OtherPhotos = $m->getOtherPhotos($p->id);
		//EjoshopDeveloper::debugPrint($OtherPhotos);
		$p->morephoto = '';
		foreach($OtherPhotos as $item) {
			
			$uri = $item->uri;
			$path = JURI::root(false).substr($uri,1);
			$path_parts = pathinfo(JPATH_ROOT.DS.$uri.$item->filename);
			$thumb_s = $path_parts['filename'].'_s.'.$path_parts['extension'];
			
			
			$newfileimgsrc = $path.'_s.png';
	
			$thumb = $path.$thumb_s;
				
			
			$imgsrc = $path.$item->filename;
			/* detail photo */
			if(is_file(JPATH_ROOT.DS.$uri.$thumb_s)) { 
				$p->morephoto .= '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.$thumb.'"></a>';
			/* no photo */	
			} else {
				$p->morephoto .= '<a rel="colorbox" href="'.$imgsrc.'"><img src="'.JURI::root(false).'media/com_ejoshop/files/noimg.png"></a>';
			}
		}

		return $p;
	}
	
}

?>
